

//main

int main_test(int argc,char *argv);
double myrand();
int ranvec(double t[]);
int neighbor(int t,int f );
double tanbranch(double x);
int setorder(struct tt_rec *tt,int n_tts,double traveltime,double ratio,int *order );
int timestamp(char *s);
int count_lines( char *filename );
int make_ttime(char *filename);
int alloc_model_pars(char *filename);
int alloc_model_pars_V(char *filename1, char *filename2);
int make_ttime2(char *filename1, char *filename2);
int mp_inodes(int argc, char *argv[]);
int mp_vnodes(int argc, char *argv[]);
int mp_vnodesavg(int argc, char *argv[]);
int mp_vnodesbase(int argc, char *argv[]);

//main_helper


void main_index_traveltimes(int argc,char *argv[]);
void main_dump_model(int argc,char  *argv[]);
void main_perturb_model(int argc,char *argv[]);
void main_roughen_model(int argc,char *argv[]);
void main_interface_depth(int argc,char *argv[]);
void main_interface_grid(int argc,char *argv[]);
void main_grid(int argc,char *argv[]);
void main_velocity(int argc,char *argv[]);
void main_point(int argc,char *argv[]);
void main_point_list(int argc,char *argv[]);
void main_shootarc(int argc,char *argv[]);
void main_shootarcrefl(int argc,char *argv[]);
void main_shootstar(int argc,char *argv[]);
void main_shootstarrefl(int argc,char *argv[]);
void main_shootturf(int argc,char *argv[]);
void main_shootstarp(int argc,char *argv[]);
void main_stor(int argc,char *argv[]);
void main_storrefl(int argc,char *argv[]);
void main_ttor(int argc,char *argv[]);
void main_locate(int argc,char *argv[]);
void main_invert(int argc,char *argv[]);
void main_Iinvert(int argc,char *argv[]);
void main_qinvert(int argc,char *argv[]);
void main_invert_tele(int argc,char *argv[]);
void main_psinvert(int argc,char *argv[]);
void main_tt_table(int argc,char *argv[]);
void main_tt_surface(int argc,char *argv[]);
void main_jhd_table(int argc,char *argv[]);
void main_jhd_locate(int argc,char *argv[]);
void main_TVinvert(int argc,char *argv[]);
void main_fitmodel(int argc,char *argv[]);
void main_modelpars(int argc,char *argv[]);
int main_make_model(int argc,char *argv[]);
void main_locate_and_invert(int argc, char **argv);
void main_locate_and_PS_invert(int argc, char **argv);
void main_VIinvert(int argc,char *argv[]);

//mark

int mark_tri_prism( double b1[3],double b2[3],double b3[3],double t1[3],double t2[3],double t3[3] );
int mark_tetra_intersection( double *x1, double *x2, double *x3, double *x4 ) ;
int mark_tetra_intersection2( double *x1, double *x2, double *x3, double *x4 );


//shoot

int shoot_to_interface_refl( double x0[3],double t0[3],double x1[3],double t1[3],struct arc_rec arc[],
    int *n_arcs,int nmax,double smax,
	int interface,int rinterface,int *hitflag,double *traveltime,double *qinvint,int *ec );
	
int shoot_to_interface( double x0[3],double t0[3],double x1[3],double t1[3],struct arc_rec arc[],
    int *n_arcs,int nmax,double smax,
	int interface,int *hitflag,double *traveltime,double *qinvint,int *ec );

int shoot_with_max_traveltime( double x0[3],double t0[3],double x1[3],double t1[3],struct arc_rec arc[],
    int *n_arcs,int nmax,double smax,double max_traveltime, double *traveltime,double *qinvint,int *ec );

int shoot_star_refl(double stheta,double ftheta,int n_thetas,double sazi,double fazi,
	int n_azis,double *x0,int interface,int rinterface);
	
int shoot_turf(double xmin,double xmax,int n_x,double ymin,double ymax,int n_y,
	double azi,double v0,double z0,double T0,int interface);

int shoot_to_traveltime( double *x0, double azi, double theta, double traveltime, double *x1, double *t1,
	 struct arc_rec *arc, int *n_arcs);
	 
int shoot_star(double stheta,double ftheta,int n_thetas,double sazi,double fazi,
	int n_azis,double *x0,int interface);


//exn

int velocity_eqn(struct tetra_rec *t );
int qinv_eqn( struct tetra_rec *t );
int velocity_eqn2(double x1[3],double x2[3],double x3[3],double x4[3],double *v[4],double vc[4]);
int qinv_eqn2(double x1[3],double x2[3],double x3[3],double x4[3],double *qinv[4],double qinvc[4]);
int eqn_of_plane(double x1[3],double x2[3],double x3[3],double P[4] );
int eqn_of_plane2(double n[3],double x1[3],double P[4] );
int eqn_of_line(double x0,double y0,double x1,double y1,double L );


//eval

double eval_velocity(struct tetra_rec *t,double x[3]);
double eval_velocity2(double x[3],double vc[4]);
double eval_qinv(struct tetra_rec *t,double x[3]);
double eval_qinv2(double x[3],double qinvc[4]);
double eval_arc_velocity(struct arc_rec *a,double x[3]);
double eval_arc_qinv(struct arc_rec *a,double x[3]);
double eval_plane(double P[4],double x[3] );
double eval_plane2(double x[3],double x1[3],double x2[3],double x3[3]);
double eval_line(double x,double y,double L[3] );


//compare

int compare_int(const void* a,const void* b);
int compare_tt(const void* a,const void* b);
int compare_nodeid(const void* a,const void* b);
int cmpev(const void* a,const void* b);
int cmpjhd(const void* a,const void* b);
int cmpint(const void* a,const void* b);


/*
int compare_int(struct int_rec *a,struct int_rec *b)
int compare_tt(struct tt_rec *a,struct tt_rec *b);
int compare_nodeid(struct nodeid_element_rec *a,struct nodeid_element_rec *b);
int cmpev(struct ev_rec *a,struct ev_rec *b);
int cmpjhd(struct jhd_rec *a,struct jhd_rec *b);
int cmpint(int *a,int *b);
*/

//geometry

int circular_ray_exits_tetra(struct tetra_rec *t,double rx0[3],double rt0[3],double rx1[3],
	double rt1[3],struct arc_rec *arc,double *traveltime,double *S,double *qinvint,int *ef );
int circle_intersects_plane(double R,double x1[3],double x2[3],double x3[3],
	struct int_rec *intersecs,int *nints,int face,double x4[3] );
int in_tetrahedron2(double x1[3],double x2[3],double x3[3],double x4[3],double x[3]);
int in_tetrahedron3(double x1[3],double x2[3],double x3[3],double x4[3],double x[3]);
int in_tetrahedron(double x1[3],double x2[3],double x3[3],double x4[3],double x[3]);
int ray_exits_layer(double P[4],double x[3],double t[3],double normal[3],double xi[3],double *s );
int ray_exits_tetrahedron(double x1[3],double x2[3],double x3[3],double x4[3],double x[3],
	double t[3],double epsilon,double normal[3],double xi[3],double *s,int *face );
int normal_to_plane(double P[4],double n[3]);
double great_circle_azimuth(double lat1,double lon1,double lat2,double lon2 );
double solid_angle(double colata,double lona,double colatb,double lonb,double colatc,double lonc );
double area_of_triagle(double x[3],double y[3],double z[3],double normal[3]);





//matrixmath

int newbasisrot(double b0[3],double b1[3],double b2[3],double s[3][3]);
int rotate3(double c[3],double s[3][3],double c2[3]);
int tvh(double t[3],double v[3],double h[3]);
double dot(double a[3],double b[3]);
int cross(double a[3],double b[3],double c[3]);
int arcstoxyz(struct arc_rec arc[],int n_arcs,double x[],double y[],double z[],int index[],
	double ds,int *n,int maxn );
int unit_vector(double v[]);
int ray_tangent(double th,double az,double t[3] );
int ray_tangentr(double th,double az,double t[3] );
int inv_ray_tangentr(double *th,double *az,double t[3] );
int gjinv(double *a,double *b,int n,int nstore,double test,int *ierror );
double det3x3(double m[3][3]);
int solve2x2( double A[2][2], double b[2], double x[2] );
int invert2x2(double a[2][2],double ai[2][2]);
int mult2x2(double a[2][2],double b[2][2],double c[2][2]);
void gauss(double *a,double vec[],int n,int nstore,double test,int *ierror,int itriag);




//convert

int prism_to_tetra1(int id,int n0,int n1,int n2,int n3,int n4,
	int n5,int n6,int n7,int type );
int prism_to_tetra2(int id,int n0,int n1,int n2,int n3,int n4,
	int n5,int n6,int n7,int type );
int model_to_P( struct PS_node *my_PS_node, struct PS_tetra *my_PS_tetra, int *model_is_P );
int model_to_S( struct PS_node *my_PS_node, struct PS_tetra *my_PS_tetra, int *model_is_P );





//node

int new_node(int id,double x,double y,double z,double v,double qinv,int interface );
int node_in_model_par(int n,int mp);
int perturb_refl_nodes(struct model_par_rec *m,double ds);
int findnode(int id);



//refine

int refine(double x0[3],double xsta,double ysta,int interface,double *th_est,
	double *az_est,struct arc_rec *arc,int *n_arcs,double *traveltime,struct triangle_rec *tri);
int refine_refl(double x0[3],double xsta,double ysta,int interface,double rinterface,double *th_est,
	double *az_est,struct arc_rec *arc,int *n_arcs,double *traveltime,struct triangle_rec *tri);
int refine_turf(double x0[3],double xsta,double ysta,int interface,double *th_est,
	double *az_est,struct arc_rec *arc,int *n_arcs,double *traveltime,struct triangle_rec *tri,
	double azi,double v0,double z0,double T0);
int rayrefine( double *x0, double *x1, double azi, double theta, double T, 
	double *newazi, double *newtheta, double *newT, double *newdTdx);




//inside

int instarbox(int i,int j,int l,double xsta,double ysta,double *th_est,
	double *az_est,struct triangle_rec *tri,double x00[3],int interface,double *gs);
int instarbox_refl(int i,int j,int l,double xsta,double ysta,double *th_est,
	double *az_est,struct triangle_rec *tri,double x00[3],int interface,int rinterface,double *gs);
int inturfbox(int i,int j,int l,double xsta,double ysta,double *x_est,
	double *y_est,struct triangle_rec *tri,double x00[3],int interface,
	double azi,double v0,double z0,double T0,double *gs);
int in_triangle(double x,double y,double x0,double y0,double x1,double y1,double x2,double y2 );
int keep_inside_triangle(double xb,double yb,double *xe,double *ye,double x0,double y0,
	double x1,double y1,double x2,double y2  );
int in_tri_prism(double x[3],double b1[3],double b2[3],double b3[3],double Tb,
	double t1[3],double t2[3],double t3[3],double Tt,double *T,double dTdx[3],
	double *doazth,double *rayazi,double *raytheta,double *azi,double *theta );


//load

int load_prismatic_model1(char *filename);
int load_prismatic_model2(char *filename);
int load_star_file(char *filename);
int load_turf_file(char *filename);
int load_model_pars_V(FILE *mpfile);



//calculus

double ttintegralnew(double v0,double g,double R,double psi,int *method);
double ttintegralold(double v0,double g,double R,double psi,int *method);
double dTdmpnew(int mp,struct arc_rec *arc,int n_arcs,double traveltime );
double dTsdmpp(int mp,struct arc_rec *arc,int n_arcs,double traveltime );
double dTdmpr(int mp,int interface,int rinterface,double xia[3],double psia[3],
	double xib[3],double npsib[3],struct arc_rec *arc,int n_arcs,double traveltime,int ng);
double dTdmprd(int mp,int interface,int rinterface,double xia[3],double psia[3],
	double xib[3],double npsib[3],struct arc_rec *arc,int n_arcs,double traveltime,int ng);
double dTdmpold(int mp,struct arc_rec *arc,int n_arcs,double traveltime);
double dqinvdmp(int mp,struct arc_rec *arc,int n_arcs,double traveltime,double qinvint );
double integral292( double a, double x );
double integral292a( double x );
double inv_integral294a( double x );
double integral294( double a, double x );
double integral294a( double x );
double integral295( double a, double x );
double integral295a( double a, double x );
double integral340( double a, double b, double x );
double integral341( double a, double b, double x );
double integral342( double a, double b, double c, double x );
double qintegral(double qinv0,double qinvx,double qinvz,double R,double vz,double phi );




//tetra

int new_tetra(int id,int n1,int n2,int n3,int n4 );
int find_tetra(double x[3],int *n);
int link_tetras();
int check_tetras(FILE *f);
int print_tetra(FILE *f,struct tetra_rec *t);
int near_tetrahedron(double x1[3],double x2[3],double x3[3],double x4[3],double x[3]);
double tetra_volume(int t);
int x_tetrahedron( double *x1, double *x2, double *x3, double *x4,
		   double *x5, double *x6, double *x7, double *x8 );
int init_tetra_stack();
int zero_tetra_stack();
int destroy_tetra_stack();
int push_tetra( int t );
int pop_tetra();
int point_in_tetra(double x[3],int t );



//write_blerb

int write_model_blerb(FILE *f);
int write_solution_blerb(FILE *f);
int write_model_pars_blerb(FILE *f);
int write_refl_pars_blerb(FILE *f);
int write_traveltime_blerb(FILE *f);
int write_predictions_blerb(FILE *f);
int write_location_blerb(FILE *f);
int write_ray_blerb(FILE *f);
int write_tele_note(FILE *f);
int write_info_blerb(FILE *f);
int print_arc(FILE *f,struct arc_rec *a);
int print_intersec(FILE *f,struct int_rec *i);


































