
int instarbox(int i,int j,int l,double xsta,double ysta,double *th_est,
	double *az_est,struct triangle_rec *tri,double x00[3],int interface,double *gs)
// int i, j, l;
// double xsta, ysta;
// double *th_est, *az_est;
// struct triangle_rec *tri;
// double x00[3];
// int interface;
// double *gs;
{
	int ii, k[3], sa, hitflag, n_arcs, found, ec;
	double x[3], y[3], z[3], a[3], t[3], T[3], temp;
	double aa, bb, L[3];
	double vertex[4][3], *az[4], *th[4], coef[4], x0[3];
	double tmid, amid, x1[3], tan0[3], tan1[3], xmid, ymid, zmid, Tmid;
	double solangle, triarea, trinormal[3], triraycos, raytan[3], qinvint;

	/* view the box as two triangles, do each separately */
	if( l ) {
		k[0]=i+j*m_rays;
		k[1]=(i+1)+j*m_rays;
		k[2]=i+(j+1)*m_rays;
		}
	else {
		k[0]=(i+1)+(j+1)*m_rays;
		k[1]=(i+1)+j*m_rays;
		k[2]=i+(j+1)*m_rays;
		}

	for( ii=0; ii<3; ii++ ) {
		if( !ray[k[ii]].ok ) return(FALSE);
		x[ii]=ray[k[ii]].x;
		y[ii]=ray[k[ii]].y;
		z[ii]=ray[k[ii]].z;
		a[ii]=ray[k[ii]].az;
		t[ii]=ray[k[ii]].th;
		T[ii]=ray[k[ii]].T;
		}

	if( !in_triangle( xsta, ysta, x[0], y[0], x[1], y[1], x[2], y[2] ) )
		return(FALSE);

	/* attempt to refine by repeatedly dicing triangle into 3 pieces*/
	for( ii=0; ii<10; ii++ ) {
		amid=(a[0]+a[1]+a[2])/3.0;
		tmid=(t[0]+t[1]+t[2])/3.0;
		/* bad things may happen if NaN's appear */
		if( (!finite(amid)) || (!finite(tmid)) ) {
			return(FALSE);
			}
		ray_tangent(tmid,amid,tan0);
		sa=shoot_to_interface( x00, tan0, x1, tan1, NULL, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &Tmid, &qinvint, &ec );
		if( (!sa) || (!hitflag) ) break;

		/* geometrical speading calculation */
		raytan[0]=tan1[0]; raytan[1]=tan1[1]; raytan[2]=tan1[2];
		if( ii<3 ) if( gs!=NULL ) {
			solangle=solid_angle( t[0], a[0], t[1], a[1], t[2], a[2] );
			triarea = area_of_triagle( x, y, z, trinormal );
			triraycos = fabs(dot(trinormal,raytan));
			(*gs) = (triarea * triraycos) / solangle;
			}
		xmid=x1[0]; ymid=x1[1]; zmid=x1[2];
		found=FALSE;
		if( in_triangle(xsta,ysta, xmid,ymid, x[1],y[1], x[2],y[2] ) ) {
			found=TRUE;
			x[0]=xmid; y[0]=ymid; z[0]=zmid;
			a[0]=amid; t[0]=tmid, T[0]=Tmid;
			}
		else if( in_triangle(xsta,ysta, x[0],y[0], xmid,ymid, x[2],y[2] ) ) {
			found=TRUE;
			x[1]=xmid; y[1]=ymid; z[1]=zmid;
			a[1]=amid; t[1]=tmid, T[1]=Tmid;
			}
		else if( in_triangle(xsta,ysta, x[0],y[0], x[1],y[1], xmid,ymid ) ) {
			found=TRUE;
			x[2]=xmid; y[2]=ymid; z[2]=zmid;
			a[2]=amid; t[2]=tmid, T[2]=Tmid;
			}
		if( !found ) break;
		}

	/* further refine by linear interpolation within triangle */
	/* augment triangle to tetrahededron to use existing interpolation routine*/
		
	tri->x0=t[0];
	tri->y0=a[0];
	tri->x1=t[1];
	tri->y1=a[1];
	tri->x2=t[2];
	tri->y2=a[2];

	for( ii=0; ii<3; ii++ ) {
		vertex[ii][0]=x[ii];
		vertex[ii][1]=y[ii];
		vertex[ii][2]=0.0;
		az[ii]=(&a[ii]);
		th[ii]=(&t[ii]);
		}

	vertex[3][0]=x[0];
	vertex[3][1]=y[0];
	vertex[3][2]=1.0;
	az[3]=(&a[0]);
	th[3]=(&t[0]);

	x0[0]=xsta;
	x0[1]=ysta;
	x0[2]=0.0;

	velocity_eqn2( vertex[0], vertex[1], vertex[2], vertex[3], az, coef );
	(*az_est)=eval_velocity2( x0, coef );

	velocity_eqn2( vertex[0], vertex[1], vertex[2], vertex[3], th, coef );
	(*th_est)=eval_velocity2( x0, coef );
	
	return(TRUE);
	}




int instarbox_refl(int i,int j,int l,double xsta,double ysta,double *th_est,
	double *az_est,struct triangle_rec *tri,double x00[3],int interface,int rinterface,double *gs)
// int i, j, l;
// double xsta, ysta;
// double *th_est, *az_est;
// struct triangle_rec *tri;
// double x00[3];
// int interface, rinterface;
// double *gs;
{
	int ii, k[3], sa, hitflag, n_arcs, found, ec;
	double x[3], y[3], z[3], a[3], t[3], T[3], temp;
	double aa, bb, L[3];
	double vertex[4][3], *az[4], *th[4], coef[4], x0[3];
	double tmid, amid, x1[3], tan0[3], tan1[3], xmid, ymid, zmid, Tmid;
	double solangle, triarea, trinormal[3], triraycos, raytan[3], qinvint;

	/* view the box as two triangles, do each separately */
	if( l ) {
		k[0]=i+j*m_rays;
		k[1]=(i+1)+j*m_rays;
		k[2]=i+(j+1)*m_rays;
		}
	else {
		k[0]=(i+1)+(j+1)*m_rays;
		k[1]=(i+1)+j*m_rays;
		k[2]=i+(j+1)*m_rays;
		}

	for( ii=0; ii<3; ii++ ) {
		if( !ray[k[ii]].ok ) return(FALSE);
		x[ii]=ray[k[ii]].x;
		y[ii]=ray[k[ii]].y;
		z[ii]=ray[k[ii]].z;
		a[ii]=ray[k[ii]].az;
		t[ii]=ray[k[ii]].th;
		T[ii]=ray[k[ii]].T;
		}

	if( !in_triangle( xsta, ysta, x[0], y[0], x[1], y[1], x[2], y[2] ) )
		return(FALSE);

	/* attempt to refine by repeatedly dicing triangle into 3 pieces*/
	for( ii=0; ii<10; ii++ ) {
		amid=(a[0]+a[1]+a[2])/3.0;
		tmid=(t[0]+t[1]+t[2])/3.0;
		/* bad things may happen if NaN's appear */
		if( (!finite(amid)) || (!finite(tmid)) ) {
			return(FALSE);
			}
		ray_tangent(tmid,amid,tan0);
		sa=shoot_to_interface_refl( x00, tan0, x1, tan1, NULL, &n_arcs,
			MAX_ARCS, 10000.0, interface, rinterface, &hitflag, &Tmid, &qinvint, &ec );
		if( (!sa) || (!hitflag) ) break;

		/* geometrical speading calculation */
		raytan[0]=tan1[0]; raytan[1]=tan1[1]; raytan[2]=tan1[2];
		if( ii<3 ) if( gs!=NULL ) {
			solangle=solid_angle( t[0], a[0], t[1], a[1], t[2], a[2] );
			triarea = area_of_triagle( x, y, z, trinormal );
			triraycos = fabs(dot(trinormal,raytan));
			(*gs) = (triarea * triraycos) / solangle;
			}
		xmid=x1[0]; ymid=x1[1]; zmid=x1[2];
		found=FALSE;
		if( in_triangle(xsta,ysta, xmid,ymid, x[1],y[1], x[2],y[2] ) ) {
			found=TRUE;
			x[0]=xmid; y[0]=ymid; z[0]=zmid;
			a[0]=amid; t[0]=tmid, T[0]=Tmid;
			}
		else if( in_triangle(xsta,ysta, x[0],y[0], xmid,ymid, x[2],y[2] ) ) {
			found=TRUE;
			x[1]=xmid; y[1]=ymid; z[1]=zmid;
			a[1]=amid; t[1]=tmid, T[1]=Tmid;
			}
		else if( in_triangle(xsta,ysta, x[0],y[0], x[1],y[1], xmid,ymid ) ) {
			found=TRUE;
			x[2]=xmid; y[2]=ymid; z[2]=zmid;
			a[2]=amid; t[2]=tmid, T[2]=Tmid;
			}
		if( !found ) break;
		}

	/* further refine by linear interpolation within triangle */
	/* augment triangle to tetrahededron to use existing interpolation routine*/
		
	tri->x0=t[0];
	tri->y0=a[0];
	tri->x1=t[1];
	tri->y1=a[1];
	tri->x2=t[2];
	tri->y2=a[2];

	for( ii=0; ii<3; ii++ ) {
		vertex[ii][0]=x[ii];
		vertex[ii][1]=y[ii];
		vertex[ii][2]=0.0;
		az[ii]=(&a[ii]);
		th[ii]=(&t[ii]);
		}

	vertex[3][0]=x[0];
	vertex[3][1]=y[0];
	vertex[3][2]=1.0;
	az[3]=(&a[0]);
	th[3]=(&t[0]);

	x0[0]=xsta;
	x0[1]=ysta;
	x0[2]=0.0;

	velocity_eqn2( vertex[0], vertex[1], vertex[2], vertex[3], az, coef );
	(*az_est)=eval_velocity2( x0, coef );

	velocity_eqn2( vertex[0], vertex[1], vertex[2], vertex[3], th, coef );
	(*th_est)=eval_velocity2( x0, coef );
	
	return(TRUE);
	}





int inturfbox(int i,int j,int l,double xsta,double ysta,double *th_est,
	double *az_est,struct triangle_rec *tri,double x00[3],int interface,
	double azi,double v0,double z0,double T0,double *gs)
// int i, j, l;
// double xsta, ysta;
// double *x_est, *y_est;
// struct triangle_rec *tri;
// double x00[3];
// int interface;
// double azi;
// double v0;
// double z0;
// double T0;
// double *gs;
{
	int ii, k[3], sa, hitflag, n_arcs, found, ec;
	double x[3], y[3], z[3], x0[3], y0[3], T[3], temp;
	double aa, bb, L[3];
	double vertex[4][3], *X0[4], *Y0[4], coef[4];
	double x0mid, y0mid, x1[3], tan0[3], tan1[3], xmid, ymid, zmid, Tmid, vp;
	double px, py, theta, p0[3];
	int t, my_last_tetra, iii;
	double raytan0[3], raytan1[3], triarea0, triarea1, raycos0, raycos1;
	double trinormal0[3], trinormal1[3], zz0[3], qinvint;

	my_last_tetra=(-1);

	/* view the box as two triangles, do each separately */
	if( l ) {
		k[0]=i+j*m_turf;
		k[1]=(i+1)+j*m_turf;
		k[2]=i+(j+1)*m_turf;
		}
	else {
		k[0]=(i+1)+(j+1)*m_turf;
		k[1]=(i+1)+j*m_turf;
		k[2]=i+(j+1)*m_turf;
		}

	for( ii=0; ii<3; ii++ ) {
		if( !turf[k[ii]].ok ) return(FALSE);
		x[ii]=turf[k[ii]].x;
		y[ii]=turf[k[ii]].y;
		z[ii]=turf[k[ii]].z;
		x0[ii]=turf[k[ii]].x0;
		y0[ii]=turf[k[ii]].y0;
		T[ii]=turf[k[ii]].T;
		}

	if( !in_triangle( xsta, ysta, x[0], y[0], x[1], y[1], x[2], y[2] ) )
		return(FALSE);

	/* attempt to refine by repeatedly dicing triangle into 3 pieces*/
	for( ii=0; ii<10; ii++ ) {
		x0mid=(x0[0]+x0[1]+x0[2])/3.0;
		y0mid=(y0[0]+y0[1]+y0[2])/3.0;
		/* bad things may happen if NaN's appear */
		if( (!finite(x0mid)) || (!finite(y0mid)) ) {
			return(FALSE);
			}
		x00[0]=x0mid;
		x00[1]=y0mid;
		x00[2]=z0;
		last_tetra=my_last_tetra;
		if( find_tetra(x00,&t) ) {
			vp = eval_velocity(&tetra[t],x00);
			}
		else {
			return(FALSE);
			}
		if( vp>=v0 ) return(FALSE);
		my_last_tetra=last_tetra;
		theta = 180.0-RTOD*asin(vp/v0);
		ray_tangent(theta,azi,tan0);
		px = tan0[0]/vp; py=tan0[1]/vp;
		sa=shoot_to_interface( x00, tan0, x1, tan1, NULL, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &Tmid, &qinvint, &ec );
		if( (!sa) || (!hitflag) ) break;
		for( iii=0; iii<3; iii++ ) {
			raytan0[iii]=tan0[iii];
			raytan1[iii]=tan1[iii];
			}


		Tmid += T0 + px*x00[0] + py*x00[1];
		xmid=x1[0]; ymid=x1[1]; zmid=x1[2];
		found=FALSE;
		if( in_triangle(xsta,ysta, xmid,ymid, x[1],y[1], x[2],y[2] ) ) {
			found=TRUE;
			x[0]=xmid; y[0]=ymid; z[0]=zmid;
			x0[0]=x0mid; y0[0]=y0mid, T[0]=Tmid;
			}
		else if( in_triangle(xsta,ysta, x[0],y[0], xmid,ymid, x[2],y[2] ) ) {
			found=TRUE;
			x[1]=xmid; y[1]=ymid; z[1]=zmid;
			x0[1]=x0mid; y0[1]=y0mid, T[1]=Tmid;
			}
		else if( in_triangle(xsta,ysta, x[0],y[0], x[1],y[1], xmid,ymid ) ) {
			found=TRUE;
			x[2]=xmid; y[2]=ymid; z[2]=zmid;
			x0[2]=x0mid; y0[2]=y0mid, T[2]=Tmid;
			}
		if( !found ) break;
		/* geometrical spreading */
		if( ii<3 ) if( gs!=NULL ) {
			zz0[0]=z0; zz0[1]=z0; zz0[2]=z0;
			triarea0=area_of_triagle( x0, y0, zz0, trinormal0 );
			triarea1=area_of_triagle( x, y, z, trinormal1 );
			raycos0 = fabs(dot(trinormal0,raytan0));
			raycos1 = fabs(dot(trinormal1,raytan1));
			(*gs) = (triarea1 * raycos1) / (triarea0 * raycos0);
			}
		}


	/* further refine by linear interpolation within triangle */
	/* augment triangle to tetrahededron to use existing interpolation routine*/
		
	tri->x0=x0[0];
	tri->y0=y0[0];
	tri->x1=x0[1];
	tri->y1=y0[1];
	tri->x2=x0[2];
	tri->y2=y0[2];

	for( ii=0; ii<3; ii++ ) {
		vertex[ii][0]=x[ii];
		vertex[ii][1]=y[ii];
		vertex[ii][2]=0.0;
		X0[ii]=(&(x0[ii]));
		Y0[ii]=(&(y0[ii]));
		}

	vertex[3][0]=x[0];
	vertex[3][1]=y[0];
	vertex[3][2]=1.0;
	X0[3]=(&(x0[0]));
	Y0[3]=(&(y0[0]));

	p0[0]=xsta;
	p0[1]=ysta;
	p0[2]=0.0;

	velocity_eqn2( vertex[0], vertex[1], vertex[2], vertex[3], X0, coef );
	(*x_est)=eval_velocity2( p0, coef );

	velocity_eqn2( vertex[0], vertex[1], vertex[2], vertex[3], Y0, coef );
	(*y_est)=eval_velocity2( p0, coef );

	return(TRUE);
	}







int in_triangle(double x,double y,double x0,double y0,double x1,double y1,double x2,double y2 )
// double x, y, x0, y0, x1, y1, x2, y2;
{
	double aa, bb, L[3];

	/* a point is in a triangle if, for all sides, it is */
	/* on the same side of the side as the opposing vertex */

	/* side 0 */
	eqn_of_line( x1, y1, x2, y2, L );
	aa = eval_line( x, y, L );
	bb = eval_line( x0, y0, L );
	if( (aa*bb) < 0.0 ) return(FALSE);

	/* side 1 */
	eqn_of_line( x0, y0, x2, y2, L );
	aa = eval_line( x, y, L );
	bb = eval_line( x1, y1, L );
	if( (aa*bb) < 0.0 ) return(FALSE);

	/* side 2 */
	eqn_of_line( x0, y0, x1, y1, L );
	aa = eval_line( x, y, L );
	bb = eval_line( x2, y2, L );
	if( (aa*bb) < 0.0 ) return(FALSE);

	return(TRUE);
	}


int keep_inside_triangle(double xb,double yb,double *xe,double *ye,double x0,double y0,
	double x1,double y1,double x2,double y2  )
// double xb,yb, *xe,*ye, x0,y0, x1,y1, x2,y2;
{
	int i;
	double tx, ty, s1, s2, s3, xm, ym;

	if( in_triangle( *xe,*ye, x0,y0, x1,y1, x2,y2 ) )
		return(TRUE);

	if( !in_triangle( xb,yb, x0,y0, x1,y1, x2,y2 ) ) {
		return(TRUE);
		}

	tx = (*xe-xb);
	ty = (*ye-yb);

	s1=0.0;
	s3=1.0;
	for( i=0; i<10; i++ ) {
		s2=0.5*(s1+s3);
		xm = xb+s2*tx;
		ym = yb+s2*ty;
		if( in_triangle( xm,ym, x0,y0, x1,y1, x2,y2 ) ) {
			s1=s2;
			}
		else {
			s3=s2;
			}
		}

	*xe = xb+s1*tx;
	*ye = yb+s1*ty;

	return(FALSE);
	}





int in_tri_prism(double x[3],double b1[3],double b2[3],double b3[3],double Tb,
	double t1[3],double t2[3],double t3[3],double Tt,double *T,double dTdx[3],
	double *doazth,double *rayazi,double *raytheta,double *azi,double *theta )
// double x[3];
// double b1[3], b2[3], b3[3], Tb;
// double t1[3], t2[3], t3[3], Tt;
// double *T, dTdx[3], *rayazi, *raytheta, *azi, *theta;
{
	double *v1, *v2, *v3, *v4;
	double T1, T2, T3, T4;
	double A1, A2, A3, A4;
	double TH1, TH2, TH3, TH4;
	double G[4][4], d[4], test, Gabs;
	int i, j, it, ierror;

	for( it=0; it<3; it++ ) {
		if( it==0 ) {
			v1=b1; v2=b2; v3=b3; v4=t1; T1=Tb; T2=Tb; T3=Tb; T4=Tt;
			if( doazth ) {
				A1=rayazi[0]; A2=rayazi[1]; A3=rayazi[2]; A4=rayazi[0];
				TH1=raytheta[0]; TH2=raytheta[1]; TH3=raytheta[2]; TH4=raytheta[0];
				}
			}
		else if( it==1) {
			v1=b2; v2=b3; v3=t1; v4=t2; T1=Tb; T2=Tb; T3=Tt; T4=Tt;
			if( doazth ) {
				A1=rayazi[1]; A2=rayazi[2]; A3=rayazi[0]; A4=rayazi[1];
				TH1=raytheta[1]; TH2=raytheta[2]; TH3=raytheta[0]; TH4=raytheta[1];
				}
			}
		else {
			v1=b3; v2=t1; v3=t2; v4=t3; T1=Tb; T2=Tt; T3=Tt; T4=Tt;
			if( doazth ) {
				A1=rayazi[2]; A2=rayazi[0]; A3=rayazi[1]; A4=rayazi[2];
				TH1=raytheta[2]; TH2=raytheta[0]; TH3=raytheta[1]; TH4=raytheta[2];
				}
			}
		if( in_tetrahedron( v1, v2, v3, v4, x ) ) {
			for( i=0; i<3; i++ ) {
				G[0][i]=v1[i];
				G[1][i]=v2[i];
				G[2][i]=v3[i];
				G[3][i]=v4[i];
				}
			for( i=0; i<4; i++ ) G[i][3]=1.0;
			d[0]=T1; d[1]=T2; d[2]=T3; d[3]=T4;
			test=fabs(G[0][0]);
			for( i=0; i<4; i++ ) for( j=0; j<4; j++ ) {
				Gabs=fabs(G[i][j]);
				if( test<Gabs ) test=Gabs;
				}
			gauss( G, d, 4, 4, 1.0e-6*test, &ierror, TRUE );
			if( ierror ) return(0);
			*T = d[3]+dot(x,d);
			if( !finite(*T) ) return(0);
			for( i=0; i<3; i++ ) {
				if( !finite(d[i]) ) return(0);
				dTdx[i]=d[i];
				}
			if( (*T) < 0.0 ) return(0);

			if( doazth ) {
				d[0]=A1; d[1]=A2; d[2]=A3; d[3]=A4;
				gauss( G, d, 4, 4, 1.0e-6*test, &ierror, FALSE );
				*azi = d[3]+dot(x,d);

				d[0]=TH1; d[1]=TH2; d[2]=TH3; d[3]=TH4;
				gauss( G, d, 4, 4, 1.0e-6*test, &ierror, FALSE );
				*theta = d[3]+dot(x,d);
				}

			return(1);
			}
		}

	return(0);
	}


