#include <stdio.h>
#include <math.h>
// #include <malloc.h> //malloc is depreciated and linux specific. Use stdlib.h instead
#include <stdlib.h>
// #include "date.h" //pretty sure that this is also depreciated, or custom. Using ctime.h instead
#include <ctime>

#include "all_functions_declaration.h"
#include "structdefs.h"
#include "sparse.h"
#include "mark.h"
#include "shoot.h"
#include "exn.h"
#include "eval.h"
#include "compare.h"
#include "geometry.h"
#include "matrixmath.h"
#include "convert.h"
#include "node.h"
#include "refine.h"
#include "inside.h"
#include "load.h"
#include "calculus.h"
#include "tetra.h"
#include "mainhelper.h"
#include "write_blerb.h"



int main(int argc, char*argv[] )
// int argc; // old syntax?
// char *argv[]; // old syntax?
{
	calls_to_shoot=0;
	PI = 4.0 * atan((double)1.0);
	DTOR = PI/180.0;
	RTOD = 180.0/PI;
	srandom(time(NULL));
	ray=NULL;
	turf=NULL;
	time(&starttime);

	if( argc<2 ) {
		fprintf(stderr,"usage: %s keyword arg1 arg2 ...\n", argv[0] );
		fprintf(stderr,"valid keywords:\n");
		fprintf(stderr,"\tdump_model\n");
		fprintf(stderr,"\tgrid\n");
		fprintf(stderr,"\tinterface_depth\n");
		fprintf(stderr,"\tIinvert\n");
		fprintf(stderr,"\tindex_traveltimes\n");
		fprintf(stderr,"\tinvert\n");
		fprintf(stderr,"\tQinvert\n");
		fprintf(stderr,"\tjhd_table\n");
		fprintf(stderr,"\tlocate\n");
		fprintf(stderr,"\tlocate_and_invert\n");
		fprintf(stderr,"\tmake_model\n");
		fprintf(stderr,"\tmodel_parameters\n");
		fprintf(stderr,"\tperturb_model\n");
		fprintf(stderr,"\tpoint point_list\n");
		fprintf(stderr,"\tPSinvert\n");
		fprintf(stderr,"\troughen_model\n");
		fprintf(stderr,"\tshoot_arc\n");
		fprintf(stderr,"\tshoot_arc_refl\n");
		fprintf(stderr,"\tshoot_star\n");
		fprintf(stderr,"\tshoot_star_refl shoot_star_p shoot_turf\n");
		fprintf(stderr,"\tsource_to_receivers\n");
		fprintf(stderr,"\tsource_to_receivers_refl\n");
		fprintf(stderr,"\tteleseismic_invert\n");
		fprintf(stderr,"teleseism_to_receivers\n");
		fprintf(stderr,"\ttt_surface\n");
		fprintf(stderr,"\ttt_table\n");
		fprintf(stderr,"\tTV_invert\n");
		fprintf(stderr,"\tvelocity\n");
		fprintf(stderr,"\tVinvert\n");
		fprintf(stderr,"\tVIinvert\n");
                write_info_blerb(stderr);
                write_solution_blerb(stderr);
		exit(-1);
		}
	if( !strcmp(argv[1],"shoot_arc") ) 
		main_shootarc(argc-1, argv+1 );
	if( !strcmp(argv[1],"shoot_arc_refl") ) 
		main_shootarcrefl(argc-1, argv+1 );
	else if( !strcmp(argv[1],"shoot_star") ) 
		main_shootstar(argc-1, argv+1 );
	else if( !strcmp(argv[1],"shoot_star_refl") ) 
		main_shootstarrefl(argc-1, argv+1 );
	else if( !strcmp(argv[1],"shoot_star_p") ) 
		main_shootstarp(argc-1, argv+1 );
	else if( !strcmp(argv[1],"point") ) 
		main_point(argc-1, argv+1 );
	else if( !strcmp(argv[1],"point_list") ) 
		main_point_list(argc-1, argv+1 );
	else if( !strcmp(argv[1],"velocity") ) 
		main_velocity(argc-1, argv+1 );
	else if( !strcmp(argv[1],"grid") ) 
		main_grid(argc-1, argv+1 );
	else if( !strcmp(argv[1],"source_to_receivers") ) 
		main_stor(argc-1, argv+1 );
	else if( !strcmp(argv[1],"source_to_receivers_refl") ) 
		main_storrefl(argc-1, argv+1 );
	else if( !strcmp(argv[1],"interface_depth") )
		main_interface_depth(argc-1, argv+1 );
	else if( !strcmp(argv[1],"interface_grid") )
		main_interface_grid(argc-1, argv+1 );
	else if( !strcmp(argv[1],"locate") )
		main_locate(argc-1, argv+1 );
	else if( (!strcmp(argv[1],"invert")) || (!strcmp(argv[1],"Vinvert")) )
		main_invert(argc-1, argv+1 );
	else if( !strcmp(argv[1],"Iinvert") )
		main_Iinvert(argc-1, argv+1 );
	else if( !strcmp(argv[1],"VIinvert") )
		main_VIinvert(argc-1, argv+1 );
	else if( !strcmp(argv[1],"Qinvert") )
		main_qinvert(argc-1, argv+1 );
	else if( !strcmp(argv[1],"PSinvert") )
		main_psinvert(argc-1, argv+1 );
	else if( !strcmp(argv[1],"shoot_turf") ) 
		main_shootturf(argc-1, argv+1 );
	else if( !strcmp(argv[1],"teleseism_to_receivers") ) 
		main_ttor(argc-1, argv+1 );
	else if( (!strcmp(argv[1],"teleseismic_invert")) || (!strcmp(argv[1],"T_invert")) ) 
		main_invert_tele(argc-1, argv+1 );
	else if( !strcmp(argv[1],"TV_invert") ) 
		main_TVinvert(argc-1, argv+1 );
	else if( !strcmp(argv[1],"dump_model") ) 
		main_dump_model(argc-1, argv+1 );
	else if( !strcmp(argv[1],"roughen_model") ) 
		main_roughen_model(argc-1, argv+1 );
	else if( !strcmp(argv[1],"perturb_model") ) 
		main_perturb_model(argc-1, argv+1 );
	else if( !strcmp(argv[1],"tt_table") ) 
		main_tt_table(argc-1, argv+1 );
	else if( !strcmp(argv[1],"tt_surface") ) 
		main_tt_surface(argc-1, argv+1 );
	else if( !strcmp(argv[1],"jhd_table") ) 
		main_jhd_table(argc-1, argv+1 );
	else if( !strcmp(argv[1],"jhd_locate") ) 
		main_jhd_locate(argc-1, argv+1 );
	else if( !strcmp(argv[1],"fit_model") ) 
		main_fitmodel(argc-1, argv+1 );
	else if( !strcmp(argv[1],"model_parameters") ) 
		main_modelpars(argc-1, argv+1 );
	else if( !strcmp(argv[1],"make_model") ) 
		main_make_model(argc-1, argv+1 );
	else if( !strcmp(argv[1],"index_traveltimes") ) 
		main_index_traveltimes(argc-1, argv+1 );
	else if( !strcmp(argv[1],"locate_and_invert") ) 
		main_locate_and_invert(argc-1, argv+1 );
	else if( !strcmp(argv[1],"locate_and_PS_invert") ) 
		main_locate_and_PS_invert(argc-1, argv+1 );
	else if( !strcmp(argv[1],"test") ) 
		main_test(argc-1, argv+1 );
	else {
		fprintf(stderr,"error: %s: bad keyword\n", argv[0] );
		exit(-1);
		}
	exit(0);
	}




main_test(int argc,char *argv)
// int argc; // old syntax
// char *argv[]; // old syntax
{
	double x[3];
	int i, t0, t1, t2, t3, t, tt;

	fprintf(stderr,"test not currently implemented\n");

	exit(0);
	}



double myrand()
{
        double x;
        x=( ((double)(random())) / ((double)2147483647) );
        return(x);
        }

int ranvec(t)
double t[3];
{
	t[0]=myrand();
	t[1]=myrand();
	t[2]=myrand();
	return(TRUE);
	}


int neighbor(int t,int f )
// int t, f; // old syntax
{
	int tn;

	struct tetra_rec *p;
	if( (t<0) || (t>=n_tetras) ) return(-1);

	p = &tetra[t];
	if( f == 0 )      tn=p->t1;
	else if( f == 1 ) tn=p->t2;
	else if( f == 2 ) tn=p->t3;
	else if( f == 3 ) tn=p->t4;
	else tn=(-1);
	return(tn);

	}

double tanbranch(double x)
{
	int i;
	double PI=3.141592653589793;
	i = (int) ( fabs(x) / (PI/2.0) );
	return( copysign( (double)((i+1)/2), x ) );
	}

int setorder(struct tt_rec *tt,int n_tts,double traveltime,double ratio,int *order )
// struct tt_rec *tt; // old syntax
// int n_tts;  // old syntax
// double traveltime; // old syntax
// double ratio; // old syntax
// int *order; // old syntax
{
	int i, j;
	double residual, temp;

	if( n_tts < 1 ) return(1);
	else if (n_tts == 1 ) {
		*order=0;
		return(1);
		}
	else {
		j=0;
		residual=fabs( traveltime - ratio*tt[0].T );

		for( i=0; i<n_tts; i++ ) {
			temp = fabs( traveltime - ratio*tt[i].T );
			if( temp<residual ) {
				residual=temp;
				j=i;
				}
			}
		*order = j;
		return(1);
		}
	}

int timestamp(char *s)
{
	long i;
	time(&i);
	fprintf(stderr,"Time %d seconds: %s\n", i-starttime, s );
	return(1);
	}


int count_lines( char *filename )
{
	FILE *f;
	int i, n, c;

	i=0; n=0;
	if( (f=fopen(filename,"r"))==NULL ) {
		fprintf(stderr,"error: count_lines: cant open file <%s> for read\n", filename);
		return(0);
		}
	while( (c=getc(f)) != EOF ) {
		i++;
		if( c=='\n' ) n++;
		}
	fclose(f);

	return(n);
	}

int make_ttime(char *filename)
{
	int n;

	MAX_TTIMES=count_lines(filename);
	if( MAX_TTIMES==0 ) {
		ttime==NULL;
		}
	else {
		MAX_TTIMES+=10;
		ttime=(struct ttime_rec *)malloc(MAX_TTIMES*sizeof(struct ttime_rec));
		}
	if( ttime==NULL ) {
		fprintf(stderr,"error: out of memory (ttime array)\n");
		exit(-1);
		}
	return(1);
	}
	
	

int alloc_model_pars(char *filename)
{
	int l, n, count;
	FILE *f;
	char line[1024];

	MAX_MODEL_PARS = 0;

	if( (f=fopen(filename,"r")) == NULL ) {
		fprintf(stderr,"error: cant open model file %s\n", filename);
		exit(-1);
		}

	while( fgets(line,1024,f) != NULL ) {
		count=sscanf(line,"%d", &n);
		if( count<1 ) {
			fprintf(stderr,"error: cant read node count for model par\n", n_model_pars );
			exit(-1);
			}
		for( l=0; l<n; l++ ) {
			if( fgets(line,1024,f) == NULL ) {
				fprintf(stderr,"error: %s: cant read node %d model par %d\n",
					l, n_model_pars );
				exit(-1);
				}
			}
		MAX_MODEL_PARS++;
		}
	MAX_MODEL_PARS+=10;

	fclose(f);

	if( (model_par=(struct model_par_rec *)malloc(MAX_MODEL_PARS*sizeof(struct model_par_rec))) == NULL ) {
		fprintf(stderr,"error: out of memory (model pars)\n");
		exit(-1);
		}

	return(1);
	}

int alloc_model_pars_V(char *filename1, char *filename2)
{
	int l, n, count;
	FILE *f;
	char line[1024];

	MAX_MODEL_PARS = 0;

	if( (f=fopen(filename1,"r")) == NULL ) {
		fprintf(stderr,"error: cant open model file %s\n", filename1);
		exit(-1);
		}

	while( fgets(line,1024,f) != NULL ) {
		count=sscanf(line,"%d", &n);
		if( count<1 ) {
			fprintf(stderr,"error: cant read node count for model par\n", n_model_pars );
			exit(-1);
			}
		for( l=0; l<n; l++ ) {
			if( fgets(line,1024,f) == NULL ) {
				fprintf(stderr,"error: %s: cant read node %d model par %d\n",
					l, n_model_pars );
				exit(-1);
				}
			}
		MAX_MODEL_PARS++;
		}
	fclose(f);

	if( (f=fopen(filename2,"r")) == NULL ) {
		fprintf(stderr,"error: cant open model file %s\n", filename2);
		exit(-1);
		}

	while( fgets(line,1024,f) != NULL ) {
		count=sscanf(line,"%d", &n);
		if( count<1 ) {
			fprintf(stderr,"error: cant read node count for model par\n", n_model_pars );
			exit(-1);
			}
		for( l=0; l<n; l++ ) {
			if( fgets(line,1024,f) == NULL ) {
				fprintf(stderr,"error: %s: cant read node %d model par %d\n",
					l, n_model_pars );
				exit(-1);
				}
			}
		MAX_MODEL_PARS++;
		}
	fclose(f);

	MAX_MODEL_PARS+=10;

	if( (model_par=(struct model_par_rec *)malloc(MAX_MODEL_PARS*sizeof(struct model_par_rec))) == NULL ) {
		fprintf(stderr,"error: out of memory (model pars)\n");
		exit(-1);
		}

	return(1);
	}




int make_ttime2(char *filename1, char *filename2)
{
	int n;

	MAX_TTIMES=count_lines(filename1)+count_lines(filename2);
	if( MAX_TTIMES==0 ) {
		ttime==NULL;
		}
	else {
		MAX_TTIMES+=10;
		ttime=(struct ttime_rec *)malloc(MAX_TTIMES*sizeof(struct ttime_rec));
		}
	if( ttime==NULL ) {
		fprintf(stderr,"error: out of memory (ttime array)\n");
		exit(-1);
		}
	return(1);
	}




int mp_inodes(int argc, char *argv[])
{
	double weight;
	int i, N, NX, NY, NZ, interface, count;
	char line[2048], str1[128], str2[128];
	int IX, IY, IZ, INTERFACE;
	double X, Y, Z, V, tx, ty, tz;

	if( argc != 6 ) {
		fprintf(stderr,"error: bad arguments, inodes keyword\n");
		return(0);
		}

	if( sscanf(argv[1], "%d", &interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read interface from command line, argv[0]\n" );
		return(0);
		}
	if( sscanf(argv[2], "%le", &tx) != 1 ) {
		fprintf(stderr,"error: %s: cant read Nx from command line, argv[0]\n" );
		return(0);
		}
	if( sscanf(argv[3], "%le", &ty) != 1 ) {
		fprintf(stderr,"error: %s: cant read Ny from command line, argv[0]\n" );
		return(0);
		}
	if( sscanf(argv[4], "%le", &tz) != 1 ) {
		fprintf(stderr,"error: %s: cant read Nz from command line, argv[0]\n" );
		return(0);
		}
	if( sscanf(argv[5], "%le", &weight) != 1 ) {
		fprintf(stderr,"error: %s: cant read weight from command line, argv[0]\n" );
		return(0);
		}

	line[0]='\0';
	fgets(line,2040,stdin);
	if( sscanf(line,"%d%d%d", &NX, &NY, &NZ ) != 3 ) {
		fprintf(stderr,"error: %s: cant read model size, argv[0]\n" );
		exit(-1);
		}

	N = NX*NY*NZ;

	for( i=0; i<N; i++ ) {
		line[0]='\0';
		fgets(line,2040,stdin);
		if( (count=sscanf(line,"%d%d%d%le%le%le%le%s%s\n", &IX, &IY, &IZ,
			&X, &Y, &Z, &V, str1, str2 )) < 8 ) {
			fprintf(stderr,"error: %s: error reading model!\n", argv[0] );
			return(0);
			}
		if( count==8 ) {
			if( sscanf(str1,"%d", &INTERFACE ) != 1 ) {
				fprintf(stderr,"error: %s: error reading model!\n", argv[0] );
				return(0);
				}
			}
		else if( count==9 ) {
			if( sscanf(str2,"%d", &INTERFACE ) != 1 ) {
				fprintf(stderr,"error: %s: error reading model!\n", argv[0] );
				return(0);
				}
			}
		else {
			fprintf(stderr,"error: %s: error reading model!\n", argv[0] );
			exit(0);
			}
		if( interface==INTERFACE ) {
			printf("1\n");
			printf("%d %d %d %f %f %f %f\n", IX, IY, IZ, tx, ty, tz, weight );
			}
		}

	return(1);
	}

int mp_vnodesavg(int argc, char *argv[])
{
	double weight;
	int i, j, N, NX, NY, NZ, interface, neighbors, count;
	int ix, iy;
	char line[2048], str1[128], str2[128];
	int *IX, *IY, *IZ, *INTERFACE;
	double *X, *Y, *Z, *V;
	int IXt, IYt, IZt, INTERFACEt;
	double Xt, Yt, Zt, Vt;
	double sum, R2, scale;

	if( argc != 5 ) {
		fprintf(stderr,"error: bad arguments, vnodesavg keyword\n");
		return(0);
		}

	if( sscanf(argv[1], "%d", &interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read interface from command line, argv[0]\n" );
		return(0);
		}
	if( sscanf(argv[2], "%d", &neighbors) != 1 ) {
		fprintf(stderr,"error: %s: cant read neighbors from command line, argv[0]\n" );
		return(0);
		}
	if( sscanf(argv[3], "%le", &scale) != 1 ) {
		fprintf(stderr,"error: %s: cant read scale from command line, argv[0]\n" );
		return(0);
		}
	if( sscanf(argv[4], "%le", &weight) != 1 ) {
		fprintf(stderr,"error: %s: cant read weight from command line, argv[0]\n" );
		return(0);
		}

	line[0]='\0';
	fgets(line,2040,stdin);
	if( sscanf(line,"%d%d%d", &NX, &NY, &NZ ) != 3 ) {
		fprintf(stderr,"error: %s: cant read model size, argv[0]\n" );
		exit(-1);
		}

	N = NX*NY*NZ;

	IX = (int *) malloc( N*sizeof(int) );
	if( IX == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};

	IY = (int *) malloc( N*sizeof(int) );
	if( IY == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};

	IZ = (int *) malloc( N*sizeof(int) );
	if( IZ == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};

	INTERFACE = (int *) malloc( N*sizeof(int) );
	if( INTERFACE == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};

	X = (double*) malloc( N*sizeof(double) );
	if( X == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};

	Y = (double*) malloc( N*sizeof(double) );
	if( Y == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};

	Z = (double*) malloc( N*sizeof(double) );
	if( Z == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};

	V = (double*) malloc( N*sizeof(double) );
	if( V == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};


	for( i=0; i<N; i++ ) {
		line[0]='\0';
		fgets(line,2040,stdin);
		if( (count=sscanf(line,"%d%d%d%le%le%le%le%s%s\n", &IXt, &IYt, &IZt,
			&Xt, &Yt, &Zt, &Vt, str1, str2 )) < 8 ) {
			fprintf(stderr,"error: %s: error reading model!\n", argv[0] );
			return(0);
			}
		if( count==8 ) {
			if( sscanf(str1,"%d", &INTERFACEt ) != 1 ) {
				fprintf(stderr,"error: %s: error reading model!\n", argv[0] );
				return(0);
				}
			}
		else if( count==9 ) {
			if( sscanf(str2,"%d", &INTERFACEt ) != 1 ) {
				fprintf(stderr,"error: %s: error reading model!\n", argv[0] );
				return(0);
				}
			}
		j=IXt + IYt*NX + IZt*NY*NY;
		IX[j]=IXt; IY[j]=IYt; IZ[j]=IZt; X[j]=Xt; Y[j]=Yt; Z[j]=Zt; V[j]=Vt;
		INTERFACE[j]=INTERFACEt;
		}

	for( i=0; i<N; i++ ) {
		if( INTERFACE[i]!=interface ) continue;
		count=0;
		sum=0.0;
		for( ix=IX[i]-neighbors; ix<=IX[i]+neighbors; ix++ )
		for( iy=IY[i]-neighbors; iy<=IY[i]+neighbors; iy++ ) {
			if( (ix<0) || (ix>=NX) || (iy<0) || (iy>=NY) ) continue;
			j=ix + iy*NX + IZ[i]*NY*NY;
			if( INTERFACE[j]!=interface ) continue;
			R2 = (X[j]-X[i])*(X[j]-X[i]) + (Y[j]-Y[i])*(Y[j]-Y[i]);
			sum+=exp(-R2/(scale*scale));
			count++;
			}
		printf("%d\n",count);
		for( ix=IX[i]-neighbors; ix<=IX[i]+neighbors; ix++ )
		for( iy=IY[i]-neighbors; iy<=IY[i]+neighbors; iy++ ) {
			if( (ix<0) || (ix>=NX) || (iy<0) || (iy>=NY) ) continue;
			j=ix + iy*NX + IZ[i]*NY*NY;
			if( INTERFACE[j]!=interface ) continue;
			R2 = (X[j]-X[i])*(X[j]-X[i]) + (Y[j]-Y[i])*(Y[j]-Y[i]);
			printf("%d %d %d %e\n", IX[j], IY[j], IZ[j],
				exp(-R2/(scale*scale))*weight/sum );
			}
		}

	return(1);
	}

int mp_vnodesbase(int argc, char *argv[])
{
	double o_weight;
	int i, j, N, NX, NY, NZ, interface, neighbors, count, order, found;
	int ix, iy;
	char line[2048], str1[128], str2[128];
	int *IX, *IY, *IZ, *INTERFACE;
	double *X, *Y, *Z, *V;
	int IXt, IYt, IZt, INTERFACEt;
	double Xt, Yt, Zt, Vt;
	double xmin, xmax, ymin, ymax;
	double xmean, ymean, xscale, yscale;
	double xp, yp, weight, weight_mean;

	if( argc != 4 ) {
		fprintf(stderr,"error: bad arguments, vnodesbase keyword\n");
		return(0);
		}

	if( sscanf(argv[1], "%d", &interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read interface from command line, argv[0]\n" );
		return(0);
		}
	if( sscanf(argv[2], "%d", &order) != 1 ) {
		fprintf(stderr,"error: %s: cant read order from command line, argv[0]\n" );
		return(0);
		}
	if( (order<0) || (order>3) ) {
		fprintf(stderr,"error: %s: order must be between 0 and 3\n", argv[0] );
		return(0);
		}
	if( sscanf(argv[3], "%le", &o_weight) != 1 ) {
		fprintf(stderr,"error: %s: cant read weight from command line, argv[0]\n" );
		return(0);
		}

	line[0]='\0';
	fgets(line,2040,stdin);
	if( sscanf(line,"%d%d%d", &NX, &NY, &NZ ) != 3 ) {
		fprintf(stderr,"error: %s: cant read model size, argv[0]\n" );
		exit(-1);
		}

	N = NX*NY*NZ;

	IX = (int *) malloc( N*sizeof(int) );
	if( IX == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};

	IY = (int *) malloc( N*sizeof(int) );
	if( IY == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};

	IZ = (int *) malloc( N*sizeof(int) );
	if( IZ == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};

	INTERFACE = (int *) malloc( N*sizeof(int) );
	if( INTERFACE == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};

	X = (double*) malloc( N*sizeof(double) );
	if( X == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};

	Y = (double*) malloc( N*sizeof(double) );
	if( Y == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};

	Z = (double*) malloc( N*sizeof(double) );
	if( Z == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};

	V = (double*) malloc( N*sizeof(double) );
	if( V == NULL ) {
		fprintf(stderr,"error: %s: out of memory!\n", argv[0] );
		exit(0);
		};


	for( i=0; i<N; i++ ) {
		line[0]='\0';
		fgets(line,2040,stdin);
		if( (count=sscanf(line,"%d%d%d%le%le%le%le%s%s\n", &IX[i], &IY[i], &IZ[i],
			&X[i], &Y[i], &Z[i], &V[i], str1, str2 )) < 8 ) {
			fprintf(stderr,"error: %s: error reading model!\n", argv[0] );
			exit(0);
			}
		if( count==8 ) {
			if( sscanf(str1,"%d", &INTERFACE[i] ) != 1 ) {
				fprintf(stderr,"error: %s: error reading model!\n", argv[0] );
				exit(0);
				}
			}
		else if( count==9 ) {
			if( sscanf(str2,"%d", &INTERFACE[i] ) != 1 ) {
				fprintf(stderr,"error: %s: error reading model!\n", argv[0] );
				exit(0);
				}
			}
		else {
			fprintf(stderr,"error: %s: error reading model!\n", argv[0] );
			exit(0);
			}

		if( i==0 ) {
			xmin=X[0]; xmax=X[0];
			ymin=Y[0]; ymax=Y[0];
			}
		else {
			if( X[i]<xmin ) xmin=X[i];
			if( X[i]>xmax ) xmax=X[i];
			if( Y[i]<ymin ) ymin=Y[i];
			if( Y[i]>ymax ) ymax=Y[i];
			}
		}
	xmean = 0.5*(xmax+xmin); ymean = 0.5*(ymax+ymin);
	xscale = 0.5*(xmax-xmin); yscale = 0.5*(ymax-ymin);

	count=0;
	for( j=0; j<N; j++ ) if( INTERFACE[j] == interface ) count++;
	if( count == 0 ) {
		fprintf(stderr,"error: %s: interface not in model\n", argv[0] );
		return(0);
		}

	/* one constant term */
	if( order>=0 ) {
		/* constant term */
		printf("%d\n", count );
		for( j=0; j<N; j++ ) {
			if( INTERFACE[j] != interface ) continue;
			weight=1.0; if( weight==0.0 ) weight=1.0e-6;
			printf("%d %d %d %f\n", IX[j], IY[j], IZ[j], weight*o_weight );
			}
		}

	/* two linear terms */
	if( order>=1 ) {
		/* x term */
		weight_mean=0.0;
		printf("%d\n", count );
		for( j=0; j<N; j++ ) {
			if( INTERFACE[j] != interface ) continue;
			xp=(X[j]-xmean)/xscale; yp=(Y[j]-ymean)/yscale;
			weight=xp-weight_mean;  if( weight==0.0 ) weight=1.0e-6;
			printf("%d %d %d %f\n", IX[j], IY[j], IZ[j], weight*o_weight );
			}
		/* y term */
		weight_mean=0.0;
		printf("%d\n", count );
		for( j=0; j<N; j++ ) {
			if( INTERFACE[j] != interface ) continue;
			xp=(X[j]-xmean)/xscale; yp=(Y[j]-ymean)/yscale;
			weight=yp-weight_mean;  if( weight==0.0 ) weight=1.0e-6;
			printf("%d %d %d %f\n", IX[j], IY[j], IZ[j], weight*o_weight );
			}
		}

	/* three quadratic terms */
	if( order>=2 ) {
		/* x*x term */
		weight_mean=4.0/3.0;
		printf("%d\n", count );
		for( j=0; j<N; j++ ) {
			if( INTERFACE[j] != interface ) continue;
			xp=(X[j]-xmean)/xscale; yp=(Y[j]-ymean)/yscale;
			weight=(xp*xp)-weight_mean; if( weight==0.0 ) weight=1.0e-6;
			printf("%d %d %d %f\n", IX[j], IY[j], IZ[j], weight*o_weight );
			}
		/* y*y term */
		weight_mean=4.0/3.0;
		printf("%d\n", count );
		for( j=0; j<N; j++ ) {
			if( INTERFACE[j] != interface ) continue;
			xp=(X[j]-xmean)/xscale; yp=(Y[j]-ymean)/yscale;
			weight=(yp*yp)-weight_mean;  if( weight==0.0 ) weight=1.0e-6;
			printf("%d %d %d %f\n", IX[j], IY[j], IZ[j], weight*o_weight );
			}
		printf("%d\n", count );
		/* x*y term */
		weight_mean=0.0;
		for( j=0; j<N; j++ ) {
			if( INTERFACE[j] != interface ) continue;
			xp=(X[j]-xmean)/xscale; yp=(Y[j]-ymean)/yscale;
			weight=(xp*yp)-weight_mean; if( weight==0.0 ) weight=1.0e-6;
			printf("%d %d %d %f\n", IX[j], IY[j], IZ[j], weight*o_weight );
			}
		}

	/* four cubic terms */
	if( order>=3 ) {
		/* x*x*x term */
		weight_mean=0.0;
		printf("%d\n", count );
		for( j=0; j<N; j++ ) {
			if(  INTERFACE[j] != interface ) continue;
			xp=(X[j]-xmean)/xscale; yp=(Y[j]-ymean)/yscale;
			weight=(xp*xp*xp)-weight_mean; if( weight==0.0 ) weight=1.0e-6;
			printf("%d %d %d %f\n", IX[j], IY[j], IZ[j], weight*o_weight );
			}
		/* y*x*x term */
		weight_mean=0.0;
		printf("%d\n", count );
		for( j=0; j<N; j++ ) {
			if(  INTERFACE[j] != interface ) continue;
			xp=(X[j]-xmean)/xscale; yp=(Y[j]-ymean)/yscale;
			weight=(yp*xp*xp)-weight_mean; if( weight==0.0 ) weight=1.0e-6;
			printf("%d %d %d %f\n", IX[j], IY[j], IZ[j], weight*o_weight );
			}
		/* y*y*x term */
		weight_mean=0.0;
		printf("%d\n", count );
		for( j=0; j<N; j++ ) {
			if(  INTERFACE[j] != interface ) continue;
			xp=(X[j]-xmean)/xscale; yp=(Y[j]-ymean)/yscale;
			weight=(yp*yp*xp)-weight_mean; if( weight==0.0 ) weight=1.0e-6;
			printf("%d %d %d %f\n", IX[j], IY[j], IZ[j], weight*o_weight );
			}
		/* y*y*y term */
		weight_mean=0.0;
		printf("%d\n", count );
		for( j=0; j<N; j++ ) {
			if(  INTERFACE[j] != interface ) continue;
			xp=(X[j]-xmean)/xscale; yp=(Y[j]-ymean)/yscale;
			weight=(yp*yp*yp)-weight_mean;  if( weight==0.0 ) weight=1.0e-6;
			printf("%d %d %d %f\n", IX[j], IY[j], IZ[j], weight*o_weight );
			}
		}


	return(1);
	}



