


int shoot_to_interface_refl( double x0[3],double t0[3],double x1[3],double t1[3],struct arc_rec arc[],
    int *n_arcs,int *nmax,double smax,
	int interface,int rinterface,int*hitflag,double *traveltime,double *qinvint,int *ec )
// double x0[3], t0[3]; // old syntax
// double x1[3], t1[3]; // old syntax
// struct arc_rec arc[]; // old syntax
// int *n_arcs, nmax; // old syntax
// double smax; // old syntax
// int interface, rinterface, *hitflag; // old syntax
// double *traveltime; // old syntax
// double *qinvint; // old syntax
// int *ec; // old syntax
{
	int i, j;
	int status1, hitflag1, ec1, n_arcs1;
	int status2, hitflag2, ec2, n_arcs2;
	double traveltime1, qinvint1;
	double traveltime2, qinvint2;
	double xr[3], tr[3], trp[3], xrp[3];
	double *ptt, *pqi;
	struct arc_rec *par;

	struct tetra_rec *ptetra;
	int face;
	double n[3], v[3], h[3], P[4], s[3][3], st[3][3];
	double epsilon, v1[3], v2[3], v3;

	if( traveltime==NULL ) ptt=NULL; else ptt=(&traveltime1);
	if( qinvint==NULL ) pqi=NULL; else pqi=(&qinvint1);
	if( arc==NULL ) par=NULL; else par=arc;

	/* propagate to reflecting interrface */
	n_arcs1=0;
	status1=shoot_to_interface( x0, t0, xr, tr, par, &n_arcs1,
		nmax, 10000.0, rinterface,&hitflag1, ptt, pqi, &ec1 );
	if( !(status1 && hitflag1) ) {
		*n_arcs=0; *ec=ec1; *hitflag=hitflag1;
		return(status1);
		}

	/* reflect ray tangent */

	/* face and tetra from last arc (if available) */
	if( arc!=NULL ) {
		ptetra=arc[n_arcs1-1].ptetra;
		if( ptetra == NULL ) { *n_arcs=0; *ec=20; *hitflag=FALSE; return(FALSE); }
		face=arc[n_arcs1-1].exit_face;
		}
	else { /* if no last arc, then compute the hard way */
		epsilon=1.0e-6;
		for( i=0; i<3; i++ ) xrp[i]=xr[i]-epsilon*tr[i];
		if( !find_tetra( xrp, &i ) ) { *n_arcs=0; *ec=22; *hitflag=FALSE; return(FALSE); }
		ptetra=tetra+i;
		if( ! ray_exits_tetrahedron( ptetra->x1, ptetra->x2, ptetra->x3, ptetra->x4,
			xrp, tr, epsilon, v1, v2, &v3, &face ) )
			{ *n_arcs=0; *ec=23; *hitflag=FALSE; return(FALSE); }
		face+=1;
		}

	/* normal to exit face */
	if( face==1 )      eqn_of_plane( ptetra->x2, ptetra->x3, ptetra->x4, P );
	else if( face==2 ) eqn_of_plane( ptetra->x1, ptetra->x3, ptetra->x4, P );
	else if( face==3 ) eqn_of_plane( ptetra->x1, ptetra->x2, ptetra->x4, P );
	else if( face==4 ) eqn_of_plane( ptetra->x1, ptetra->x2, ptetra->x3, P );
	else { *n_arcs, *ec=21; *hitflag=FALSE; return(FALSE); }
	normal_to_plane( P, n );

	/* rotate ray tangent to coordinate system of plane */
	/* flip sign of normal-to-plane component           */
	/* rotate back to apply Snell's law of reflection   */
	tvh( n, v, h );
	newbasisrot( n, v, h, s );
	for( i=0; i<3; i++ ) for( j=0; j<3; j++ ) st[i][j]=s[j][i];
	rotate3(tr,s,trp);
	trp[0]=(-trp[0]);
	rotate3(trp,st,tr);

	/* propagate to target interface */
	if( traveltime==NULL ) ptt=NULL; else ptt=(&traveltime2);
	if( qinvint==NULL ) pqi=NULL; else pqi=(&qinvint2);
	if( arc==NULL ) par=NULL; else par=arc+n_arcs1;

	n_arcs2=0;
	status2=shoot_to_interface( xr, tr, x1, t1, par, &n_arcs2,
		nmax-n_arcs1, 10000.0, interface, &hitflag2, ptt, pqi, &ec2 );

	*n_arcs=n_arcs1+n_arcs2;
	if( traveltime!=NULL ) *traveltime=traveltime1+traveltime2;
	if( qinvint!=NULL ) *qinvint=qinvint1+qinvint2;
	*ec=ec2+10;
	*hitflag=hitflag2;
	return(status2);
	}

int shoot_to_interface( double x0[3],double t0[3],double x1[3],double t1[3],struct arc_rec arc[],
    int *n_arcs,int nmax,double smax,
	int interface,int rinterface,int *hitflag,double *traveltime,double *qinvint,int *ec )
// double x0[3], t0[3]; // old syntax
// double x1[3], t1[3]; // old syntax
// struct arc_rec arc[]; // old syntax
// int *n_arcs, nmax; // old syntax
// double smax; // old syntax
// int interface, *hitflag; // old syntax
// double *traveltime; // old syntax
// double *qinvint; // old syntax
// int *ec; // old syntax
{
	int i, myt, ef, hit, exit_face;
	double xx0[3], xx1[3], tt0[3], tt1[3], xe[3], s, S, epsilon=1.0e-6;
	struct tetra_rec *pt;
	double ttt, tt, qinv, qinvt;
	double xm[3];

	calls_to_shoot++;

	(*n_arcs)=0;
	s=0.0;
	ttt=0.0;
	qinvt=0.0;

	for(i=0;i<3;i++) {
		xx0[i]=x0[i];
		tt0[i]=t0[i];
		}

	myt=(-1);
	for(i=0;i<3;i++) xe[i]=xx0[i]+epsilon*tt0[i];
	if( !find_tetra(xe, &myt) ) {
		fprintf(stderr,"error: starting point not in tetra\n");
		*ec=1;
		return(FALSE);
		}

	hit=FALSE;

	while( myt != (-1) ) {

		if( (*n_arcs) >= nmax ) {*ec=2; return(FALSE);}

		if( arc != NULL ) {
			if(!circular_ray_exits_tetra(&(tetra[myt]),xx0,tt0,xx1,tt1,
				&arc[*n_arcs], &tt, &S, &qinv, &exit_face)) {
				*ec=3;
				return(FALSE);
				}
			}
		else {
			if(!circular_ray_exits_tetra(&(tetra[myt]),xx0,tt0,xx1,tt1,
				NULL, &tt, &S, &qinv, &exit_face)) {
				*ec=4;
				return(FALSE);
				}
			}

		s += S;
		ttt += tt;
		qinvt += qinv;
		if( s>smax ) {*ec=5; return(FALSE);}

		for(i=0;i<3;i++) {
			xx0[i]=xx1[i];
			tt0[i]=tt1[i];
			}

		pt=&(tetra[myt]);
		ef=exit_face;
		if( ef == 1 ) myt=pt->t1;
		else if( ef == 2 ) myt=pt->t2;
		else if( ef == 3 ) myt=pt->t3;
		else if( ef == 4 ) myt=pt->t4;
		else {
			fprintf(stderr,"warning: problem with ray\n");
			myt=(-1);
			}

		if( pt->ifc[ef-1] == interface ) {
			hit=TRUE;
			(*n_arcs)++;
			break;
			}

		(*n_arcs)++;

		}

	for(i=0;i<3;i++) {
		x1[i]=xx1[i];
		t1[i]=tt1[i];
		}

	*hitflag = hit;
	if( traveltime != NULL ) *traveltime=ttt;
	if( qinvint != NULL ) *qinvint=qinvt;


	*ec=0;
	return(TRUE);
	}



	
int shoot_with_max_traveltime( double x0[3],double t0[3],double x1[3],double t1[3],struct arc_rec arc[],
    int *n_arcs,int *nmax,double smax,
	int interface,int rinterface,int *hitflag,double *traveltime,double *qinvint,int *ec )
// double x0[3], t0[3];
// double x1[3], t1[3];
// struct arc_rec arc[];
// int *n_arcs, nmax;
// double smax;
// double max_traveltime;
// double *traveltime;
// double *qinvint;
// int *ec;
{
	int i, myt, ef, hit, exit_face;
	double xx0[3], xx1[3], tt0[3], tt1[3], xe[3], s, S, epsilon=1.0e-6;
	struct tetra_rec *pt;
	double ttt, tt, qinv, qinvt;
	double xm[3];

	calls_to_shoot++;

	(*n_arcs)=0;
	s=0.0;
	ttt=0.0;
	qinvt=0.0;

	for(i=0;i<3;i++) {
		xx0[i]=x0[i];
		tt0[i]=t0[i];
		}

	myt=(-1);
	for(i=0;i<3;i++) xe[i]=xx0[i]+epsilon*tt0[i];
	if( !find_tetra(xe, &myt) ) {
		fprintf(stderr,"error: starting point not in tetra\n");
		*ec=1;
		return(FALSE);
		}

	hit=FALSE;

	while( myt != (-1) ) {

		if( (*n_arcs) >= nmax ) {*ec=2; return(FALSE);}

		if( arc != NULL ) {
			if(!circular_ray_exits_tetra(&(tetra[myt]),xx0,tt0,xx1,tt1,
				&arc[*n_arcs], &tt, &S, &qinv, &exit_face)) {
				*ec=3;
				return(FALSE);
				}
			}
		else {
			if(!circular_ray_exits_tetra(&(tetra[myt]),xx0,tt0,xx1,tt1,
				NULL, &tt, &S, &qinv, &exit_face)) {
				*ec=4;
				return(FALSE);
				}
			}

		s += S;
		ttt += tt;
		qinvt += qinv;

		for(i=0;i<3;i++) {
			xx0[i]=xx1[i];
			tt0[i]=tt1[i];
			}

		pt=&(tetra[myt]);
		ef=exit_face;
		if( ef == 1 ) myt=pt->t1;
		else if( ef == 2 ) myt=pt->t2;
		else if( ef == 3 ) myt=pt->t3;
		else if( ef == 4 ) myt=pt->t4;
		else {
			fprintf(stderr,"warning: problem with ray\n");
			myt=(-1);
			}


		(*n_arcs)++;

		if( (ttt>max_traveltime) || (s>smax) ) break;

		}

	for(i=0;i<3;i++) {
		x1[i]=xx1[i];
		t1[i]=tt1[i];
		}

	if( traveltime != NULL ) *traveltime=ttt;
	if( qinvint != NULL ) *qinvint=qinvt;

	*ec=0;
	return(TRUE);
	}
	
	
	
	
int shoot_star_refl(double stheta,double ftheta,int n_thetas,double sazi,double fazi,
	int n_azis,double *x0,int interface,int rinterface)
// double stheta, ftheta, sazi, fazi;
// int n_azis, n_thetas;
// double *x0;
// int interface, rinterface;
{
	int i, j, k;
	double dtheta, dazi, theta, azi, traveltime;
	double t0[3], x1[3], t1[3], qinvint;
	int status, hitflag, n_arcs, ec;

	m_rays=n_thetas;
	n_rays=n_azis;

	dtheta = (ftheta-stheta)/(double)(n_thetas-1);
	dazi = (fazi-sazi)/(double)(n_azis-1);

	if( ray!=NULL ) free(ray);

	if((ray=(struct ray_rec*)malloc((n_rays*m_rays+10)*sizeof(struct ray_rec)))==NULL){
		fprintf(stderr,"error: out of memory\n");
		return(FALSE);
		}

	for( i=0; i<m_rays; i++ ) for( j=0; j<n_rays; j++ ) ray[i+j*m_rays].ok=FALSE;

	for( i=0; i<m_rays; i++ ) for( j=0; j<n_rays; j++ ) {
		theta=stheta+dtheta*(double)i;
		azi=sazi+dazi*(double)j;
		ray_tangent(theta,azi,t0);
		status=shoot_to_interface_refl( x0, t0, x1, t1, NULL, &n_arcs,
			MAX_ARCS, 10000.0, interface, rinterface, (int*) &hitflag, &traveltime, &qinvint, &ec );
		if( status&&hitflag ) {
			k=i+j*m_rays;
			ray[k].ok=TRUE;
			ray[k].az=azi;
			ray[k].th=theta;
			ray[k].x=x1[0];
			ray[k].y=x1[1];
			ray[k].z=x1[2];
			ray[k].T=traveltime;
			}
		if( !status ) {
			fprintf(stderr,"warning: shoot_star: lost ray (%d %d) error code (%d)\n", i, j, ec );
			}
		}
	return(TRUE);
	}


int shoot_turf(double xmin,double xmax,int n_x,double ymin,double ymax,int n_y,
	double azi,double v0,double z0,double T0,int interface)
// double xmin, xmax, ymin, ymax;
// int n_x, n_y;
// double azi, v0, z0, T0;
// int interface;
{
	int i, j, k, t, my_last_tetra;
	double dx, dy, x, y, px, py, traveltime, vp, theta;
	double x0[3], t0[3], x1[3], t1[3], qinvint;
	int status, hitflag, n_arcs, ec;

	m_turf=n_x;
	n_turf=n_y;
	if( turf!=NULL ) free(turf);
	if((turf=(struct turf_rec*)malloc((n_turf*m_turf+10)*sizeof(struct turf_rec)))==NULL){
		fprintf(stderr,"error: out of memory\n");
		return(FALSE);
		}

	for( i=0; i<m_turf; i++ ) for( j=0; j<n_turf; j++ ) turf[i+j*m_turf].ok=FALSE;

	dx = (xmax-xmin)/(double)(n_x-1);
	dy = (ymax-ymin)/(double)(n_y-1);

	my_last_tetra=(-1);

	for( i=0; i<n_x; i++ ) for( j=0; j<n_y; j++ ) {
		x0[0]=xmin+dx*(double)i;
		x0[1]=ymin+dy*(double)j;  /*Bug, dy was dx, fixed 6/6/3 by Menke on advice of Zor */
		x0[2]=z0;
		last_tetra=my_last_tetra;
		if( find_tetra(x0,&t) ) {
			vp = eval_velocity(&tetra[t],x0);
			}
		else continue;
		if( vp>=v0 ) continue;
		my_last_tetra=last_tetra;
		theta = 180.0-RTOD*asin(vp/v0);
		ray_tangent(theta,azi,t0);
		px = t0[0]/vp; py=t0[1]/vp;
		status=shoot_to_interface( x0, t0, x1, t1, NULL, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec );
		if( status&&hitflag ) {
			traveltime += T0 + px*x0[0] + py*x0[1];
			k=i+j*m_turf;
			turf[k].ok=TRUE;
			turf[k].x0=x0[0];
			turf[k].y0=x0[1];
			turf[k].x=x1[0];
			turf[k].y=x1[1];
			turf[k].z=x1[2];
			turf[k].T=traveltime;
			}
		if( !status ) {
			fprintf(stderr,"warning: lost ray (%d %d) error code (%d)\n", i, j, ec );
			}
		}
	return(TRUE);
	}




int shoot_to_traveltime( double *x0, double azi, double theta, double traveltime, double *x1, double *t1,
	 struct arc_rec *arc, int *n_arcs)
{
	int i, l, iarc, status, method, ec;
	double t0[3], xa[3], ta[3], Ta, qinvinta;
	double psi, Tprev, te, r[3];

	ray_tangent(theta,azi,t0);
	*n_arcs=0;
	status=shoot_with_max_traveltime( x0, t0, xa, ta, arc, n_arcs,
			MAX_ARCS, 10000.0, traveltime, &Ta, &qinvinta, &ec );
	if( ! status ) return(0);

	iarc=(*n_arcs)-1;
	Tprev=0.0; for( i=0; i<iarc; i++ ) Tprev+=arc[i].T;

	te = (traveltime-Tprev)
		+ ttintegral(0.0, arc[iarc].ptetra->gs, arc[iarc].R, arc[iarc].psi1, &method);

	psi = inv_integral294a( arc[iarc].ptetra->gs*te );

	/* ray end point */
        r[0] = arc[iarc].R*sin(psi);
        r[1] = 0.0;
        r[2] = arc[iarc].R*cos(psi);
        for( l=0; l<3; l++ ) r[l] += arc[iarc].shift[l];
	rotate3(r,arc[iarc].st,x1);
		
	/* ray end tangent */
	r[0] = cos(psi);
	r[1] = 0.0;
	r[2] = (-sin(psi));
	rotate3(r,arc[iarc].st,t1);

	/* reset last arc to reflect change in endpoint */
	for( l=0; l<3; l++ ) arc[iarc].x1[l]=x1[l];
	for( l=0; l<3; l++ ) arc[iarc].t1[l]=t1[l];
	arc[iarc].psi2 = RTOD*psi;
	arc[iarc].T=traveltime-Tprev;
	arc[iarc].S=DTOR*(arc[iarc].psi2-arc[iarc].psi1)*arc[iarc].R;

	return(1);
	}




int shoot_star(double stheta,double ftheta,int n_thetas,double sazi,double fazi,
	int n_azis,double *x0,int interface)
// double stheta, ftheta, sazi, fazi;
// int n_azis, n_thetas;
// double *x0;
// int interface;
{
	int i, j, k;
	double dtheta, dazi, theta, azi, traveltime;
	double t0[3], x1[3], t1[3], qinvint;
	int status, hitflag, n_arcs, ec;

	m_rays=n_thetas;
	n_rays=n_azis;

	dtheta = (ftheta-stheta)/(double)(n_thetas-1);
	dazi = (fazi-sazi)/(double)(n_azis-1);

	if( ray!=NULL ) free(ray);

	if((ray=(struct ray_rec*)malloc((n_rays*m_rays+10)*sizeof(struct ray_rec)))==NULL){
		fprintf(stderr,"error: out of memory\n");
		return(FALSE);
		}

	for( i=0; i<m_rays; i++ ) for( j=0; j<n_rays; j++ ) ray[i+j*m_rays].ok=FALSE;

	for( i=0; i<m_rays; i++ ) for( j=0; j<n_rays; j++ ) {
		theta=stheta+dtheta*(double)i;
		azi=sazi+dazi*(double)j;
		ray_tangent(theta,azi,t0);
		status=shoot_to_interface( x0, t0, x1, t1, NULL, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec );
		if( status&&hitflag ) {
			k=i+j*m_rays;
			ray[k].ok=TRUE;
			ray[k].az=azi;
			ray[k].th=theta;
			ray[k].x=x1[0];
			ray[k].y=x1[1];
			ray[k].z=x1[2];
			ray[k].T=traveltime;
			}
		if( !status ) {
			fprintf(stderr,"warning: shoot_star: lost ray (%d %d) error code (%d)\n", i, j, ec );
			}
		}
	return(TRUE);
	}

	
	
	
	
	
