


int new_tetra(int id,int n1,int n2,int n3,int n4 )
//int id, n1, n2, n3, n4;
{
	int i, if1, if2, if3, if4;
	double V;

	V=1.0e-9;

	if( (n_tetras+1) > MAX_TETRAS ) return(-1);
	if( (n1>=n_nodes) || (n2>=n_nodes) || (n3>=n_nodes) || (n4>=n_nodes) ) return(-1);
	if( (n1<0) || (n2<0) || (n3<0) || (n4<0) ) return(-1);

	tetra[n_tetras].index=n_tetras;
	tetra[n_tetras].id=id;
	tetra[n_tetras].n1=n1;
	tetra[n_tetras].n2=n2;
	tetra[n_tetras].n3=n3;
	tetra[n_tetras].n4=n4;
	tetra[n_tetras].t1=(-1);
	tetra[n_tetras].t2=(-1);
	tetra[n_tetras].t3=(-1);
	tetra[n_tetras].t4=(-1);
	tetra[n_tetras].ifc[0]=(-1);
	tetra[n_tetras].ifc[1]=(-1);
	tetra[n_tetras].ifc[2]=(-1);
	tetra[n_tetras].ifc[3]=(-1);
	tetra[n_tetras].x1=node[n1].x;
	tetra[n_tetras].x2=node[n2].x;
	tetra[n_tetras].x3=node[n3].x;
	tetra[n_tetras].x4=node[n4].x;
	tetra[n_tetras].v[0]=&(node[n1].v);
	tetra[n_tetras].v[1]=&(node[n2].v);
	tetra[n_tetras].v[2]=&(node[n3].v);
	tetra[n_tetras].v[3]=&(node[n4].v);
	tetra[n_tetras].qinv[0]=&(node[n1].qinv);
	tetra[n_tetras].qinv[1]=&(node[n2].qinv);
	tetra[n_tetras].qinv[2]=&(node[n3].qinv);
	tetra[n_tetras].qinv[3]=&(node[n4].qinv);
	velocity_eqn( &(tetra[n_tetras]) );
	qinv_eqn( &(tetra[n_tetras]) );
	tetra[n_tetras].marked=0;
	tetra[n_tetras].tested=0;

	/* a face is on an interface if all its nodes are on it */
	if1=node[n1].ifc;
	if2=node[n2].ifc;
	if3=node[n3].ifc;
	if4=node[n4].ifc;
	if( (if2==if3) && (if3==if4) ) tetra[n_tetras].ifc[0]=if2;
	if( (if3==if4) && (if4==if1) ) tetra[n_tetras].ifc[1]=if3;
	if( (if1==if2) && (if2==if4) ) tetra[n_tetras].ifc[2]=if1;
	if( (if1==if2) && (if2==if3) ) tetra[n_tetras].ifc[3]=if1;

	if( tetra_volume(n_tetras) < V ) {
		fprintf(stderr,"warning: tetrahedron %d has volume < %e\n", n_tetras, V);
		fprintf(stderr,"         node %d: %f %f %f\n", n1,
			node[n1].x[0], node[n1].x[1], node[n1].x[2] );
		fprintf(stderr,"         node %d: %f %f %f\n", n2,
			node[n2].x[0], node[n2].x[1], node[n2].x[2] );
		fprintf(stderr,"         node %d: %f %f %f\n", n3,
			node[n3].x[0], node[n3].x[1], node[n3].x[2] );
		fprintf(stderr,"         node %d: %f %f %f\n", n4,
			node[n4].x[0], node[n4].x[1], node[n4].x[2] );
		}

	/* add this tetra to the tetra list of all of its nodes */
	node[n1].t[node[n1].nt] = &(tetra[n_tetras]);
	node[n1].nt++; if( node[n1].nt>=MAX_TETRAS_TOUCHING_NODE ) return(-1);

	node[n2].t[node[n2].nt] = &(tetra[n_tetras]);
	node[n2].nt++; if( node[n2].nt>=MAX_TETRAS_TOUCHING_NODE ) return(-1);

	node[n3].t[node[n3].nt] = &(tetra[n_tetras]);
	node[n3].nt++; if( node[n3].nt>=MAX_TETRAS_TOUCHING_NODE ) return(-1);

	node[n4].t[node[n4].nt] = &(tetra[n_tetras]);
	node[n4].nt++; if( node[n4].nt>=MAX_TETRAS_TOUCHING_NODE ) return(-1);

	n_tetras++;
	return(n_tetras-1);
	}




/* find index, n, of tetra containing x */
/* return 1 on success, 0 on failure    */
int find_tetra(double x[3],int *n)
// double x[3];
// int *n;
{
	int i, j, k, l;
	double v1[3], v2[3], normal[3], tv[3], xm[3], dx[3], b[4], bmax;

	(*n)=(-1);

	/* Method 1: */
	/* try to get to x by moving from adjoining tetrahedron to */
	/* adjoining tetrahedron, starting from the last tetrahedron used */
	/* and always choosing the next tetrahedron adjoining the face that */
	/* has a normal closest to the direction toward x */

	if( last_tetra!=(-1) ) i=last_tetra; else i=0;

	for( j=0; j<n_tetras; j++ ) {

		if( i==(-1) ) break;

		if( in_tetrahedron( tetra[i].x1,
			tetra[i].x2,
             		tetra[i].x3,
			tetra[i].x4, x ) ) {
			last_tetra = i;
			*n = i;
			if( j==0 ) find_tetra_hit++;
			if( j==1 ) find_tetra_neighbor++;
			else find_tetra_walk++;
			return(1);
			}

		/* plane 1 */
		for( k=0; k<3; k++ ) {
			xm[k] = (tetra[i].x2[k]+tetra[i].x3[k]+tetra[i].x4[k])/3.0;
			dx[k] = x[k]-xm[k];
			v1[k] = tetra[i].x3[k]-tetra[i].x2[k];
			v2[k] = tetra[i].x4[k]-tetra[i].x2[k];
			tv[k] = tetra[i].x1[k]-tetra[i].x2[k];
			}
		/* outward pointing normal */
		cross( v1, v2, normal );
		unit_vector(normal);
		if( dot(normal,tv)>0.0 ) for( k=0; k<3; k++ ) normal[k]=(-normal[k]);
		unit_vector(dx);
		b[0]=dot(normal,dx);

		/* plane 2 */
		for( k=0; k<3; k++ ) {
			xm[k] = (tetra[i].x1[k]+tetra[i].x3[k]+tetra[i].x4[k])/3.0;
			dx[k] = x[k]-xm[k];
			v1[k] = tetra[i].x3[k]-tetra[i].x1[k];
			v2[k] = tetra[i].x4[k]-tetra[i].x1[k];
			tv[k] = tetra[i].x2[k]-tetra[i].x1[k];
			}
		cross( v1, v2, normal );
		unit_vector(normal);
		if( dot(normal,tv)>0.0 ) for( k=0; k<3; k++ ) normal[k]=(-normal[k]);
		unit_vector(dx);
		b[1]=dot(normal,dx);

		/* plane 3 */
		for( k=0; k<3; k++ ) {
			xm[k] = (tetra[i].x1[k]+tetra[i].x2[k]+tetra[i].x4[k])/3.0;
			dx[k] = x[k]-xm[k];
			v1[k] = tetra[i].x2[k]-tetra[i].x1[k];
			v2[k] = tetra[i].x4[k]-tetra[i].x1[k];
			tv[k] = tetra[i].x3[k]-tetra[i].x1[k];
			}
		cross( v1, v2, normal );
		unit_vector(normal);
		if( dot(normal,tv)>0.0 ) for( k=0; k<3; k++ ) normal[k]=(-normal[k]);
		unit_vector(dx);
		b[2]=dot(normal,dx);

		/* plane 4 */
		for( k=0; k<3; k++ ) {
			xm[k] = (tetra[i].x1[k]+tetra[i].x2[k]+tetra[i].x3[k])/3.0;
			dx[k] = x[k]-xm[k];
			v1[k] = tetra[i].x2[k]-tetra[i].x1[k];
			v2[k] = tetra[i].x3[k]-tetra[i].x1[k];
			tv[k] = tetra[i].x4[k]-tetra[i].x1[k];
			}
		cross( v1, v2, normal );
		unit_vector(normal);
		if( dot(normal,tv)>0.0 ) for( k=0; k<3; k++ ) normal[k]=(-normal[k]);
		unit_vector(dx);
		b[3]=dot(normal,dx);

		bmax=b[0]; l=0;
		for( k=1; k<4; k++ ) if( b[k]>bmax ) { bmax=b[k]; l=k; }
		if( b[l]>0.0 ) {
			if( l==0 )      i=tetra[i].t1;
			else if( l==1 ) i=tetra[i].t2;
			else if( l==2 ) i=tetra[i].t3;
			else if( l==3 ) i=tetra[i].t4;
			}
		else i=(-1);

		}

	/* Method 2: */
	/* brute force search */

	for( i=0; i<n_tetras; i++ ) {
		if( in_tetrahedron( tetra[i].x1,
				    tetra[i].x2,
             			    tetra[i].x3,
				    tetra[i].x4, x ) ) {
			last_tetra = i;
			*n = i;
			find_tetra_search++;
			return(1);
			}
		}
	find_tetra_nofind++;
	return(0);
	}

int link_tetras()
{
	int i, j, k;
	double x[3], xm[3], n[3], P[4], epsilon, a, b;

	epsilon=1.0e-6;

	for( i=0; i<n_tetras; i++ ) {

		/* face 1 */
		eqn_of_plane(tetra[i].x2,tetra[i].x3,tetra[i].x4,P);
		normal_to_plane( P, n );
		for( j=0; j<3; j++ ) {
			xm[j]=(tetra[i].x2[j]+tetra[i].x3[j]+tetra[i].x4[j])/3.0;
			x[j]=xm[j]+epsilon*n[j];
			}
		a=eval_plane( P, x );
		b=eval_plane( P, tetra[i].x1 );
		if( (a*b)>0.0 ) for( j=0; j<3; j++ ) x[j]=xm[j]-epsilon*n[j];
		last_tetra=(-1); find_tetra( x, &k );
		tetra[i].t1 = k;

		/* face 2 */
		eqn_of_plane(tetra[i].x1,tetra[i].x3,tetra[i].x4,P);
		normal_to_plane( P, n );
		for( j=0; j<3; j++ ) {
			xm[j]=(tetra[i].x1[j]+tetra[i].x3[j]+tetra[i].x4[j])/3.0;
			x[j]=xm[j]+epsilon*n[j];
			}
		a=eval_plane( P, x );
		b=eval_plane( P, tetra[i].x2 );
		if( (a*b)>0.0 ) for( j=0; j<3; j++ ) x[j]=xm[j]-epsilon*n[j];
		last_tetra=(-1); find_tetra( x, &k );
		tetra[i].t2 = k; 

		/* face 3 */
		eqn_of_plane(tetra[i].x1,tetra[i].x2,tetra[i].x4,P);
		normal_to_plane( P, n );
		for( j=0; j<3; j++ ) {
			xm[j]=(tetra[i].x1[j]+tetra[i].x2[j]+tetra[i].x4[j])/3.0;
			x[j]=xm[j]+epsilon*n[j];
			}
		a=eval_plane( P, x );
		b=eval_plane( P, tetra[i].x3 );
		if( (a*b)>0.0 ) for( j=0; j<3; j++ ) x[j]=xm[j]-epsilon*n[j];
		last_tetra=(-1); find_tetra( x, &k );
		tetra[i].t3 = k;

		/* face 4 */
		eqn_of_plane(tetra[i].x1,tetra[i].x2,tetra[i].x3,P);
		normal_to_plane( P, n );
		for( j=0; j<3; j++ ) {
			xm[j]=(tetra[i].x1[j]+tetra[i].x2[j]+tetra[i].x3[j])/3.0;
			x[j]=xm[j]+epsilon*n[j];
			}
		a=eval_plane( P, x );
		b=eval_plane( P, tetra[i].x4 );
		if( (a*b)>0.0 ) for( j=0; j<3; j++ ) x[j]=xm[j]-epsilon*n[j];
		last_tetra=(-1); find_tetra( x, &k );
		tetra[i].t4 = k;

		}

	return(1);
	}

int check_tetras(FILE *f)
// FILE *f;
{
	int i, j, k, status;
	double x[3], xm[3], n[3], P[4], epsilon, a, b;

	epsilon=1.0e-6;
	status=1;

	for( i=0; i<n_tetras; i++ ) {

		/* face 1 */
		eqn_of_plane(tetra[i].x2,tetra[i].x3,tetra[i].x4,P);
		normal_to_plane( P, n );
		for( j=0; j<3; j++ ) {
			xm[j]=(tetra[i].x2[j]+tetra[i].x3[j]+tetra[i].x4[j])/3.0;
			x[j]=xm[j]+epsilon*n[j];
			}
		a=eval_plane( P, x );
		b=eval_plane( P, tetra[i].x1 );
		if( (a*b)>0.0 ) for( j=0; j<3; j++ ) x[j]=xm[j]-epsilon*n[j];
		last_tetra=(-1); find_tetra( x, &k );
		if( tetra[i].t1 != k ) {
			fprintf(f,"warning: tetra %d face %d link is %d should be %d; fixed\n", i, 1, tetra[i].t1, k );
			tetra[i].t1 = k;
			status=0;
			}

		/* face 2 */
		eqn_of_plane(tetra[i].x1,tetra[i].x3,tetra[i].x4,P);
		normal_to_plane( P, n );
		for( j=0; j<3; j++ ) {
			xm[j]=(tetra[i].x1[j]+tetra[i].x3[j]+tetra[i].x4[j])/3.0;
			x[j]=xm[j]+epsilon*n[j];
			}
		a=eval_plane( P, x );
		b=eval_plane( P, tetra[i].x2 );
		if( (a*b)>0.0 ) for( j=0; j<3; j++ ) x[j]=xm[j]-epsilon*n[j];
		last_tetra=(-1); find_tetra( x, &k );
		if( tetra[i].t2 != k ) {
			fprintf(f,"error: tetra %d face %d link is %d should be %d; fixed\n", i, 2, tetra[i].t2, k );
			tetra[i].t2 = k;
			status=0;
			}

		/* face 3 */
		eqn_of_plane(tetra[i].x1,tetra[i].x2,tetra[i].x4,P);
		normal_to_plane( P, n );
		for( j=0; j<3; j++ ) {
			xm[j]=(tetra[i].x1[j]+tetra[i].x2[j]+tetra[i].x4[j])/3.0;
			x[j]=xm[j]+epsilon*n[j];
			}
		a=eval_plane( P, x );
		b=eval_plane( P, tetra[i].x3 );
		if( (a*b)>0.0 ) for( j=0; j<3; j++ ) x[j]=xm[j]-epsilon*n[j];
		last_tetra=(-1); find_tetra( x, &k );
		if( tetra[i].t3 != k ) {
			fprintf(f,"error: tetra %d face %d link is %d should be %d; fixed\n", i, 3, tetra[i].t3, k );
			tetra[i].t3 = k;
			status=0;
			}

		/* face 4 */
		eqn_of_plane(tetra[i].x1,tetra[i].x2,tetra[i].x3,P);
		normal_to_plane( P, n );
		for( j=0; j<3; j++ ) {
			xm[j]=(tetra[i].x1[j]+tetra[i].x2[j]+tetra[i].x3[j])/3.0;
			x[j]=xm[j]+epsilon*n[j];
			}
		a=eval_plane( P, x );
		b=eval_plane( P, tetra[i].x4 );
		if( (a*b)>0.0 ) for( j=0; j<3; j++ ) x[j]=xm[j]-epsilon*n[j];
		last_tetra=(-1); find_tetra( x, &k );
		if( tetra[i].t4 != k ) {
			fprintf(f,"error: tetra %d face %d link is %d should be %d; fixed\n", i, 4, tetra[i].t4, k );
			tetra[i].t4 = k;
			status=0;
			}
		}

	return(status);
	}


int print_tetra(FILE *f,struct tetra_rec *t)
// FILE *f;
// struct tetra_rec *t;
{
	fprintf(f,"id %d index %d\n", t->id, t->index);
	fprintf(f,"nodes %d %d %d %d\n", t->n1, t->n2, t->n3, t->n4);
	fprintf(f,"vertice 1: %f %f %f %f\n", t->x1[0], t->x1[1], t->x1[2], *(t->v[0]) );
	fprintf(f,"vertice 2: %f %f %f %f\n", t->x2[0], t->x2[1], t->x2[2], *(t->v[1]) );
	fprintf(f,"vertice 3: %f %f %f %f\n", t->x3[0], t->x3[1], t->x3[2], *(t->v[2]) );
	fprintf(f,"vertice 4: %f %f %f %f\n", t->x4[0], t->x4[1], t->x4[2], *(t->v[3]) );
	fprintf(f,"coeffs %f %f %f %f\n", t->vc[0], t->vc[1], t->vc[2], t->vc[3] );
	fprintf(f,"grad %f %f %f\n", t->g[0], t->g[1], t->g[2] );
	fprintf(f,"gn %f %f %f\n", t->gn[0], t->gn[1], t->gn[2] );
	fprintf(f,"gs %f\n", t->gs );
	fprintf(f,"adjo %d %d %d %d\n", t->t1, t->t2, t->t3, t->t4);
	fprintf(f,"intf %d %d %d %d\n", t->ifc[0], t->ifc[1], t->ifc[2], t->ifc[3]);
	fprintf(f,"\n");
	
	return(1);
	}




int near_tetrahedron(double x1[3],double x2[3],double x3[3],double x4[3],double x[3])
// double x1[3], x2[3], x3[3], x4[3], x[3];
{
	double epsilon, y[3];

	epsilon=1.0e-3;

	if( in_tetrahedron(x1, x2, x3, x4, x) ) return(TRUE);

	y[0]=x[0]+epsilon;
	y[1]=x[1];
	y[2]=x[2];
	if( in_tetrahedron(x1, x2, x3, x4, y) ) return(TRUE);

	y[0]=x[0]-epsilon;
	y[1]=x[1];
	y[2]=x[2];
	if( in_tetrahedron(x1, x2, x3, x4, y) ) return(TRUE);

	y[0]=x[0];
	y[1]=x[1]+epsilon;
	y[2]=x[2];
	if( in_tetrahedron(x1, x2, x3, x4, y) ) return(TRUE);

	y[0]=x[0];
	y[1]=x[1]-epsilon;
	y[2]=x[2];
	if( in_tetrahedron(x1, x2, x3, x4, y) ) return(TRUE);

	y[0]=x[0];
	y[1]=x[1];
	y[2]=x[2]+epsilon;
	if( in_tetrahedron(x1, x2, x3, x4, y) ) return(TRUE);

	y[0]=x[0];
	y[1]=x[1];
	y[2]=x[2]-epsilon;
	if( in_tetrahedron(x1, x2, x3, x4, y) ) return(TRUE);
		
	return(FALSE);
	}


/* see Rektorys p 143 */
double tetra_volume(int t)
// int t;
{
	int i;
	double m[3][3];
	struct tetra_rec *p;

	p = &tetra[t];
	for( i=0; i<3; i++ ) {
		m[0][i] = p->x2[i] - p->x1[i];
		m[1][i] = p->x3[i] - p->x1[i];
		m[2][i] = p->x4[i] - p->x1[i];
		}

	return( fabs(det3x3(m))/6.0 );
	}



/* do two tetrahedra intersect ? returns TRUE if they do, FALSE otherwise */
int x_tetrahedron( double *x1, double *x2, double *x3, double *x4,
		   double *x5, double *x6, double *x7, double *x8 )
{
	/* theory:
		If two tetrahedra are non-intersecting, then there
		exists a set of planes such that all the vertices of one
		tetrahedron are on one side of the plane, and all
		the vertices of the other tetrahedron are on the
		other side of the plane. Furthermore, if such a set
		exists, then at least one plane defined by three of
		the eight vertices of the two tetrahedra is a member
		of the set.  So we simply test all possible groups
		of three vertices.  If the test plane is defined by three
		vertices, xa, xb, xc is then n = (xb-xa) cross (xc-xa) is
		a normal to that plane.  Two test vertices, x1 and x2
		are on the same side of that plane if (x1-xa) dot n
		and (x2-xa) dot n have the same sign.  Some special
		consideration must be given to the case where the test
		vertex is exactly on the plane.  That vertex cannot
		be used in the decision-making, but must rather be
		ignored. Due to round off error, this code may yield
		unpredictable results in this co-planar case, or in
		other cases where the two tetrahedra are extremely close
		to being intersecting or non-intersecting. */

	int i, ii, jj, kk, nn, first, separate_sides;

	double *x[8];      	/* vertices as list */
	double v1[3], v2[3]; 	/* vectors lying in plane */
	double n[3]; 		/* normal to plane */
	double tv[3]; 		/* test vector */
	double a, b;		/* test numbers */

	x[0]=x1; x[1]=x2; x[2]=x3; x[3]=x4; x[4]=x5; x[5]=x6; x[6]=x7; x[7]=x8;

	/* loop over all combinations of 3 vertices */
	for( ii=0; ii<=5; ii++ ) { for( jj=(ii+1); jj<=6; jj++ ) { for( kk=(jj+1); kk<=7; kk++ ) {
		for( i=0; i<3; i++ ) { /* three vertices define two vector */
			v1[i] = x[jj][i]-x[ii][i];
			v2[i] = x[kk][i]-x[ii][i];
			}
		cross( v1, v2, n ); /* two vectors define plane with this normal */
		separate_sides=TRUE; first=TRUE; b=0.0;
		for( nn=0; nn<8; nn++ ) { /* loop over all vertices */
			if( (nn==ii) || (nn==jj) || (nn==kk) ) continue;
				/* ignore vertices that define the test plane */
			for( i=0; i<3; i++ ) tv[i] = x[nn][i]-x[ii][i]; /* test vector */
			a=dot(n,tv); /* signed distance of vertex x[nn] from plane */
			if( nn>3 ) a=(-a); /* flip sign for vertices in second tetra */
					   /* now all a's will have the same sign only */
					   /* when the plane separates the two tetrahedra */
			if( a==0.0 ) continue;
				/* x[nn] is exactly on the plane, so test is ambiguous */
			else if( first ) { b=a; first=FALSE; }
				/* first x[nn], so save side of the plane its on */
			else if( ((a<0.0)&&(b>0.0)) || ((a>0.0)&&(b<0.0)) ) {
				/*  this x[nn] on different side of plane than first */
				separate_sides=FALSE;
				break;
				}
			}
		if( separate_sides ) return(FALSE);
		}}}

	return(TRUE);
	}

int init_tetra_stack() {
	n_tetra_stack=0;
	max_tetra_stack=100;
	tetra_stack=(int*)malloc(max_tetra_stack*sizeof(int));
	if( tetra_stack == NULL ) {
		tetra_stack=NULL;
		return(FALSE);
		}
	return(TRUE);
	}

int zero_tetra_stack() {
	n_tetra_stack=0;
	return(TRUE);
	}

int destroy_tetra_stack() {
	free(tetra_stack);
	tetra_stack=NULL;
	n_tetra_stack=0;
	return(TRUE);
	}

int push_tetra( int t ) {
	if( t == (-1) ) return(TRUE);
	if( tetra[t].tested ) return(TRUE);
	if( (n_tetra_stack+1) == max_tetra_stack ) {
		max_tetra_stack += 100;
		tetra_stack=(int*)realloc(tetra_stack,max_tetra_stack*sizeof(int));
		if( tetra_stack == NULL ) {
			tetra_stack=NULL;
			return(FALSE);
			}
		}
	tetra_stack[n_tetra_stack]=t;
	n_tetra_stack++;
	return(TRUE);
	}

int pop_tetra() {
	int t;
	if( n_tetra_stack == 0 ) t=(-1);
	else {
		t = tetra_stack[n_tetra_stack-1];
		n_tetra_stack--;
		}
	return(t);
	}
		
		
		
int point_in_tetra(double x[3],int t )
// double x[3]; // old syntax
// int t; // old syntax
{
	struct tetra_rec *p;
	if( t>= 0 && t<n_tetras ) {
		p = &tetra[t];
		return( in_tetrahedron( p->x1, p->x2, p->x3, p->x4, x) );
		}
	else return(0);
	}


