


int load_prismatic_model1(char *filename)
// char *filename;
{
	int i, j, k;
	int l, m, n, lm, I, u, mmo, status, count;
	int n1,n2,n3,n4,n5,n6,n7,n8;
	int *nodelist;
	double x, y, z, v, Q, qinv;
	FILE *f;
	int _this, above, below, right, left, front, behind;
	char line[1024], str[1024];

	if( (f=fopen(filename,"r")) == NULL ) {
		fprintf(stderr,"error: cant open model file <%s> for read\n", filename);
		return(FALSE);
		}
	fgets(line,1024,f);
	if( sscanf(line,"%d%d%d", &l, &m, &n ) != 3 ) {
		fprintf(stderr,"error: cant read model size in <%s> \n", filename);
		return(FALSE);
		}

	model_L=l; model_M=m; model_N=n;

	lm = l * m;
	u = (l-1)*(m-1);
	mmo = m-1;
	if( (nodelist=(int *)malloc((l*n*m+10)*sizeof(int))) == NULL ) {
		fprintf(stderr,"error: out of memory (1) \n");
		return(FALSE);
		}
	for( i=0; i<l; i++ ) for( j=0; j<m; j++ ) for( k=0; k<n; k++ ) {
		*(nodelist + k*lm + j*l + i) = (-1);
		}
	MAX_NODES=(l*n*m+10);
	if( (node=(struct node_rec *)malloc(MAX_NODES*sizeof(struct node_rec))) == NULL ) {
		fprintf(stderr,"error: out of memory (2) \n");
		return(FALSE);
		}
	MAX_TETRAS=(5*(l-1)*(n-1)*(m-1)+10);
	if( (tetra=(struct tetra_rec *)malloc(MAX_TETRAS*sizeof(struct tetra_rec))) == NULL ) {
		fprintf(stderr,"error: out of memory (3) \n");
		return(FALSE);
		}

	while( fgets(line,1024,f) != NULL ) {
		
		count=sscanf(line,"%s%s%s%s%s%s%s%s%s",str,str,str,str,str,str,str,str,str);
		if( count==8 ) {
			if( sscanf(line,"%d%d%d%le%le%le%le%d",&i,&j,&k,&x,&y,&z,&v,&I )!=8 ) {
				fprintf(stderr,"error: bad line in model file <%s>\n",filename);
				return(FALSE);
				}
			qinv=0.0;
			}
		else if( count==9 ) {
			if( sscanf(line,"%d%d%d%le%le%le%le%le%d",&i,&j,&k,&x,&y,&z,&v,&Q,&I)!=9) {
				fprintf(stderr,"error: bad line in model file <%s>\n",filename);
				return(FALSE);
				}
			qinv=1.0/Q;
			QDEFINED=TRUE;
			}
		else {
			fprintf(stderr,"error: too few fields in model file <%s>\n",filename);
			return(FALSE);
			}

		if(PERTURBMODEL) {
			if(i>0 && i<(l-1) ) x+=node_x_perturbation*(myrand()-0.5);
			if(j>0 && j<(m-1) ) y+=node_y_perturbation*(myrand()-0.5);
			if(k>0 && k<(n-1) ) z+=node_z_perturbation*(myrand()-0.5);
			v+=node_v_perturbation*(myrand()-0.5);
			}
		*(nodelist + k*lm + j*l + i) = (status=new_node(k*lm+j*l+i,x,y,z,v,qinv,I));
		if( status == (-1) ) {
			fprintf(stderr,"error: failed to make node (%d %d %d) \n",i,j,k);
			return(FALSE);
			}
		}

	fclose(f);

	for( i=0; i<(l-1); i++ ) for( j=0; j<(m-1); j++ ) for( k=0; k<(n-1); k++ ) {
		if( *(nodelist + k*lm + j*l + i) == (-1) ) {
			fprintf(stderr,"error: missing node (%d %d %d)\n", i, j, k );
			return(FALSE);
			}
		}

	for( k=0; k<(n-1); k++ ) for( i=0; i<(l-1); i++ ) for( j=0; j<(m-1); j++ ) {
		n1 = *(nodelist + (k+1)*lm + j*l + i);
		n2 = *(nodelist + (k+1)*lm + j*l + (i+1));
		n3 = *(nodelist + (k+1)*lm + (j+1)*l + (i+1));
		n4 = *(nodelist + (k+1)*lm + (j+1)*l + i);
		n5 = *(nodelist + k*lm + j*l + i);
		n6 = *(nodelist + k*lm + j*l + (i+1));
		n7 = *(nodelist + k*lm + (j+1)*l + (i+1));
		n8 = *(nodelist + k*lm + (j+1)*l + i);
		status=prism_to_tetra1(k*lm+j*l+i, n1,n2,n3,n4,n5,n6,n7,n8 , (i+j+k)%2);
		if( !status ) {
			fprintf(stderr,"error: failed to make tetra from prism (%d %d %d) \n",i,j,k);
			return(FALSE);
			}
		}

	for( k=0; k<(n-1); k++ ) for( i=0; i<(l-1); i++ ) for( j=0; j<(m-1); j++ ) {
		_this=5*(k*u+i*mmo+j);
		if( k>0 )     above=5*((k-1)*u+i*mmo+j);  else above=(-1);
		if( k<(n-2) ) below=5*((k+1)*u+i*mmo+j);  else below=(-1);
		if( i>0 )     left =5*(k*u+(i-1)*mmo+j);  else left =(-1);
		if( i<(l-2) ) right=5*(k*u+(i+1)*mmo+j);  else right=(-1);
		if( j>0 )    behind=5*(k*u+i*mmo+(j-1));  else behind=(-1);
		if( j<(m-2) ) front=5*(k*u+i*mmo+(j+1));  else front=(-1);

		if( (i+j+k)%2 ) {
			if( above!=(-1) ) {
				tetra[_this+4].t1=above+1;
				tetra[_this+3].t1=above+4;
				}
			if( below!=(-1) ) {
				tetra[_this+2].t4=below+2;
				tetra[_this+1].t4=below+3;
				}
			if( right!=(-1) ) {
				tetra[_this+2].t3=right+4;
				tetra[_this+4].t2=right+3;
				}
			if( left!=(-1) ) {
				tetra[_this+3].t3=left+2;
				tetra[_this+1].t2=left+1;
				}
			if( front!=(-1) ) {
				tetra[_this+2].t1=front+1;
				tetra[_this+3].t2=front+3;
				}
			if( behind!=(-1) ) {
				tetra[_this+4].t4=behind+2;
				tetra[_this+1].t3=behind+4;
				}
			}
		else {
			if( above!=(-1) ) {
				tetra[_this+2].t1=above+2;
				tetra[_this+3].t1=above+1;
				}
			if( below!=(-1) ) {
				tetra[_this+1].t4=below+4;
				tetra[_this+4].t4=below+3;
				}
			if( right!=(-1) ) {
				tetra[_this+1].t1=right+1;
				tetra[_this+2].t4=right+3;
				}
			if( left!=(-1) ) {
				tetra[_this+3].t3=left+4;
				tetra[_this+4].t2=left+2;
				}
			if( front!=(-1) ) {
				tetra[_this+4].t1=front+1;
				tetra[_this+2].t2=front+4;
				}
			if( behind!=(-1) ) {
				tetra[_this+1].t3=behind+2;
				tetra[_this+3].t4=behind+3;
				}
			}
		}

	if( m*n*l < (100) ) check_tetras(stderr);

	return(TRUE);
	}

int load_prismatic_model2(char *filename)
// char *filename;
{
	int i, j, k;
	int l, m, n, lm, I, u, mmo, status, count;
	int n1,n2,n3,n4,n5,n6,n7,n8;
	int *nodelist;
	double x, y, z, v, Q, qinv;
	FILE *ff;
	int _this, above, below, right, left, front, behind;
	int a=0, b=1, c=2, d=3, e=4, f=5;
	char line[1024], str[1024];

	if( (ff=fopen(filename,"r")) == NULL ) {
		fprintf(stderr,"error: cant open model file <%s> for read\n", filename);
		return(FALSE);
		}

	fgets(line,1024,ff);
	if( sscanf(line,"%d%d%d", &l, &m, &n ) != 3 ) {
		fprintf(stderr,"error: cant read model size in <%s> \n", filename);
		return(FALSE);
		}

	model_L=l; model_M=m; model_N=n;

	lm = l * m;
	u = (l-1)*(m-1);
	mmo = m-1;
	if( (nodelist=(int *)malloc((l*n*m+10)*sizeof(int))) == NULL ) {
		fprintf(stderr,"error: out of memory (1) \n");
		return(FALSE);
		}
	for( i=0; i<l; i++ ) for( j=0; j<m; j++ ) for( k=0; k<n; k++ ) {
		*(nodelist + k*lm + j*l + i) = (-1);
		}
	MAX_NODES=(l*n*m+10);
	if( (node=(struct node_rec *)malloc(MAX_NODES*sizeof(struct node_rec))) == NULL ) {
		fprintf(stderr,"error: out of memory (2) \n");
		return(FALSE);
		}
	MAX_TETRAS=(6*(l-1)*(n-1)*(m-1)+10);
	if( (tetra=(struct tetra_rec *)malloc(MAX_TETRAS*sizeof(struct tetra_rec))) == NULL ) {
		fprintf(stderr,"error: out of memory (3) \n");
		return(FALSE);
		}

	while( fgets(line,1024,ff) != NULL ) {
		count=sscanf(line,"%s%s%s%s%s%s%s%s%s",str,str,str,str,str,str,str,str,str);
		if( count==8 ) {
			if( sscanf(line,"%d%d%d%le%le%le%le%d",&i,&j,&k,&x,&y,&z,&v,&I )!=8 ) {
				fprintf(stderr,"error: bad line in model file <%s>\n",filename);
				return(FALSE);
				}
			qinv=0.0;
			}
		else if( count==9 ) {
			if( sscanf(line,"%d%d%d%le%le%le%le%le%d",&i,&j,&k,&x,&y,&z,&v,&Q,&I)!=9) {
				fprintf(stderr,"error: bad line in model file <%s>\n",filename);
				return(FALSE);
				}
			qinv=1.0/Q;
			QDEFINED=TRUE;
			}
		else {
			fprintf(stderr,"error: too few fields in model file <%s>\n",filename);
			return(FALSE);
			}

		if(PERTURBMODEL) {
			if(i>0 && i<(l-1) ) x+=node_x_perturbation*(myrand()-0.5);
			if(j>0 && j<(m-1) ) y+=node_y_perturbation*(myrand()-0.5);
			if(k>0 && k<(n-1) ) z+=node_z_perturbation*(myrand()-0.5);
			v+=node_v_perturbation*(myrand()-0.5);
			}
		*(nodelist + k*lm + j*l + i) = (status=new_node(k*lm+j*l+i,x,y,z,v,qinv,I));
		if( status == (-1) ) {
			fprintf(stderr,"error: failed to make node (%d %d %d) \n",i,j,k);
			return(FALSE);
			}
		}

	fclose(ff);

	for( i=0; i<(l-1); i++ ) for( j=0; j<(m-1); j++ ) for( k=0; k<(n-1); k++ ) {
		if( *(nodelist + k*lm + j*l + i) == (-1) ) {
			fprintf(stderr,"error: missing node (%d %d %d)\n", i, j, k );
			return(FALSE);
			}
		}

	for( k=0; k<(n-1); k++ ) for( i=0; i<(l-1); i++ ) for( j=0; j<(m-1); j++ ) {
		n1 = *(nodelist + (k+1)*lm + j*l + i);
		n2 = *(nodelist + (k+1)*lm + j*l + (i+1));
		n3 = *(nodelist + (k+1)*lm + (j+1)*l + (i+1));
		n4 = *(nodelist + (k+1)*lm + (j+1)*l + i);
		n5 = *(nodelist + k*lm + j*l + i);
		n6 = *(nodelist + k*lm + j*l + (i+1));
		n7 = *(nodelist + k*lm + (j+1)*l + (i+1));
		n8 = *(nodelist + k*lm + (j+1)*l + i);
		status=prism_to_tetra2(k*lm+j*l+i, n1,n2,n3,n4,n5,n6,n7,n8 , 0);
		if( !status ) {
			fprintf(stderr,"error: failed to make tetra from prism (%d %d %d) \n",i,j,k);
			return(FALSE);
			}
		}

	for( k=0; k<(n-1); k++ ) for( i=0; i<(l-1); i++ ) for( j=0; j<(m-1); j++ ) {
		_this=6*(k*u+i*mmo+j);
		if( k>0 )     above=6*((k-1)*u+i*mmo+j);  else above=(-1);
		if( k<(n-2) ) below=6*((k+1)*u+i*mmo+j);  else below=(-1);
		if( i>0 )     left =6*(k*u+(i-1)*mmo+j);  else left =(-1);
		if( i<(l-2) ) right=6*(k*u+(i+1)*mmo+j);  else right=(-1);
		if( j>0 )    behind=6*(k*u+i*mmo+(j-1));  else behind=(-1);
		if( j<(m-2) ) front=6*(k*u+i*mmo+(j+1));  else front=(-1);

		if( above!=(-1) ) {
			tetra[_this+a].t1=above+c;
			tetra[_this+d].t1=above+f;
			}
		if( below!=(-1) ) {
			tetra[_this+c].t4=below+a;
			tetra[_this+f].t4=below+d;
			}
		if( right!=(-1) ) {
			tetra[_this+d].t2=right+b;
			tetra[_this+e].t3=right+c;
			}
		if( left!=(-1) ) {
			tetra[_this+b].t1=left+d;
			tetra[_this+c].t2=left+e;
			}
		if( front!=(-1) ) {
			tetra[_this+a].t2=front+e;
			tetra[_this+b].t3=front+f;
			}
		if( behind!=(-1) ) {
			tetra[_this+e].t2=behind+a;
			tetra[_this+f].t3=behind+b;
			}
		}

	if( m*n*l < (100) ) check_tetras(stderr);

	return(TRUE);
	}





int load_star_file(char *filename)
// char *filename;
{
	int i, j, k;
	FILE *f;
	char s0[128], s1[128], s2[128];
	double th, az, x, y, z, T;

	if( (f=fopen(filename,"r")) == NULL ) {
		fprintf(stderr,"error: cant open star file <%s> for read\n", filename);
		return(FALSE);
		}

	if( fscanf(f,"%s%s%s%s%s%s%s%s", s0,s1,s2,s2,s2,s2,s2,s2 ) != 8 ) {
		fprintf(stderr,"error: cant read star header <%s>\n", filename);
		return(FALSE);
		}

	if( sscanf(s0,"th_%d", &m_rays) != 1 ) {
		fprintf(stderr,"error: cant decode header in star file <%s> (1)\n", filename);
		return(FALSE);
		}

	if( sscanf(s1,"az_%d", &n_rays) != 1 ) {
		fprintf(stderr,"error: cant decode header in star file <%s> (2)\n", filename);
		return(FALSE);
		}

	if((ray=(struct ray_rec*)malloc((n_rays*m_rays+10)*sizeof(struct ray_rec)))==NULL){
		fprintf(stderr,"error: out of memory\n");
		return(FALSE);
		}

	for( i=0; i<m_rays; i++ ) for( j=0; j<n_rays; j++ ) ray[i+j*m_rays].ok=FALSE;

	while( fscanf(f,"%d%d%le%le%le%le%le%le",&i,&j,&th,&az,&x,&y,&z,&T)==8 ) {
		if( i<0 || i>m_rays || j<0 || j>n_rays ) {
			fprintf(stderr,"error: bad i,j in star file <%s>\n", filename);
			return(FALSE);
			}
		k=i+j*m_rays;
		ray[k].ok=TRUE;
		ray[k].az=az;
		ray[k].th=th;
		ray[k].x=x;
		ray[k].y=y;
		ray[k].z=z;
		ray[k].T=T;

		}
		
	fclose(f);
	return(TRUE);
	}

int load_turf_file(char *filename)
// char *filename;
{
	int i, j, k, N;
	FILE *f;
	char s0[128], s1[128], s2[128];
	double x0, y0, x, y, z, T;

	if( (f=fopen(filename,"r")) == NULL ) {
		fprintf(stderr,"error: cant open turf file <%s> for read\n", filename);
		return(FALSE);
		}

	if( fscanf(f,"%s%s%s%s%s%s%s%s", s0,s1,s2,s2,s2,s2,s2,s2 ) != 8 ) {
		fprintf(stderr,"error: cant read turf header <%s>\n", filename);
		return(FALSE);
		}

	if( sscanf(s0,"x_%d", &m_turf) != 1 ) {
		fprintf(stderr,"error: cant decode header in turf file <%s> (1)\n", filename);
		return(FALSE);
		}

	if( sscanf(s1,"y_%d", &n_turf) != 1 ) {
		fprintf(stderr,"error: cant decode header in turf file <%s> (2)\n", filename);
		return(FALSE);
		}

	N=n_turf*m_turf;

	if((turf=(struct turf_rec*)malloc((N+10)*sizeof(struct turf_rec)))==NULL){
		fprintf(stderr,"error: out of memory\n");
		return(FALSE);
		}

	for( i=0; i<m_turf; i++ ) for( j=0; j<n_turf; j++ ) {
		k=i+j*m_turf;

		if( k>=N ) {
			fprintf(stderr,"error: bad index (%d %d) in turf file <%s>\n",
				i, j, filename);
			return(FALSE);
			}
		turf[k].ok=FALSE;
		}

	while( fscanf(f,"%d%d%le%le%le%le%le%le",&i,&j,&x0,&y0,&x,&y,&z,&T)==8 ) {
		if( i<0 || i>m_turf || j<0 || j>n_turf ) {
			fprintf(stderr,"error: bad i,j in turf file <%s>\n", filename);
			return(FALSE);
			}
		k=i+j*m_turf;
		if( k>=N ) {
			fprintf(stderr,"error: bad index (%d %d) in turf file <%s>\n",
				i, j, filename);
			return(FALSE);
			}
		turf[k].ok=TRUE;
		turf[k].x0=x0;
		turf[k].y0=y0;
		turf[k].x=x;
		turf[k].y=y;
		turf[k].z=z;
		turf[k].T=T;
		}
		
	fclose(f);
	return(TRUE);
	}
	
	
	
int load_model_pars_V(FILE *mpfile)
// FILE *mpfile;
{
	int count, l, n, i, j, k, nodeid;
	char line[1024];
	double weight;

	while( fgets(line,1024,mpfile) != NULL ) {
		count=sscanf(line,"%d", &n);
		if( count<1 ) {
			fprintf(stderr,"error: cant read node count for model par %d\n", n_model_pars );
			exit(-1);
			}
		if( n_model_pars > (MAX_MODEL_PARS-1) ) {
			fprintf(stderr,"error: maximum model parameters (%d) exceeds limit of %d\n", n_model_pars, MAX_MODEL_PARS-1 );
			exit(-1);
			}

		model_par[n_model_pars].n=n;
		model_par[n_model_pars].node = (int *)
			malloc((model_par[n_model_pars].n+2)*sizeof(int));
		model_par[n_model_pars].weight = (double *)
			malloc((model_par[n_model_pars].n+2)*sizeof(double));
		if(model_par[n_model_pars].node==NULL) {
			fprintf(stderr,"error: out of memory (model_par node)!\n");
			exit(-1);
			}
		if(model_par[n_model_pars].weight==NULL) {
			fprintf(stderr,"error: out of memory (model_par weight)!\n");
			exit(-1);
			}

		for( l=0; l<n; l++ ) {
			if( fgets(line,1024,mpfile) == NULL ) {
				fprintf(stderr,"error: cant read node %d model par %d\n",
					l, n_model_pars );
				exit(-1);
				}
			count=sscanf(line,"%d%d%d%le", &i, &j, &k, &weight);

			if( count < 3 ) {
				fprintf(stderr,"error: cant parse model par %d\n", n_model_pars );
				exit(-1);
				}
			if( i<0 || i>=model_L || j<0 || j>=model_M || k<0 || k>=model_N ) {
				fprintf(stderr,"error: bad node (%d %d %d) in model par %d\n",
					i, j, k, n_model_pars );
				exit(-1);
				}
			nodeid=k*model_L*model_M+j*model_L+i;
			if( (model_par[n_model_pars].node[l]=findnode(nodeid))==(-1) ) {
				fprintf(stderr,"error: couldnt find node (%d %d %d) in model par %d\n",
					i, j, k, n_model_pars );
				exit(-1);
				}

			if( count<4 ) weight=1.0;
			if( weight==0.0 ) {
				fprintf(stderr,"error: weight of 0.0 in model par %d\n", n_model_pars );
				exit(-1);
				}
			model_par[n_model_pars].weight[l]=weight;

			}
		n_model_pars++;
		}

	return(1);
	}

