

int write_model_blerb(FILE *f)
// FILE *f;
{
	fprintf(f,"      (x, y, z) cartesian coordinates, +z is down\n");
	fprintf(f,"      input model_file for prismatic model of LxMxN nodes:\n");
	fprintf(f,"           line 1: L M N\n");
	fprintf(f,"           subsequent lines i j k x y z v interface\n");
	fprintf(f,"               i j k, with 0<=i<L & etc. are node indices\n");
	fprintf(f,"           		in a cartesian grid of LxMxN nodes\n");
	fprintf(f,"               x y z are node positions, in km\n");
	fprintf(f,"                     (need not be regularly spaced)\n");
	fprintf(f,"               v is velocity in km/s\n");
	fprintf(f,"               interface, an integer, associates the nodes with an interface\n");
	fprintf(f,"			(interface numbers are arbitrary)\n");
	fprintf(f,"           or\n");
	fprintf(f,"           subsequent lines i j k x y z v Q interface\n");
	fprintf(f,"               Q is quality factor\n");
	fprintf(f,"           or\n");
	fprintf(f,"           subsequent lines i j k x y z v ratio interface\n");
	fprintf(f,"               ratio is compressional to shear wave velocity ratio (e.g 1.76)\n");
	return(TRUE);
	}
	
int write_solution_blerb(FILE *f)
// FILE *f;
{
	fprintf(f,"\n");
	fprintf(f,"      A note on the method use to solve large, sparse linear systems\n");
	fprintf(f,"           Many raytrace3d functions require the solution of large\n");
	fprintf(f,"           systems of linear equations, i.e. the N by M matrix equation\n");
	fprintf(f,"                          G m = d\n");
	fprintf(f,"           where the matrix G is sparse.  This code uses a pointer-based\n");
	fprintf(f,"           method of storing just the non-zero elements of G.  When the\n");
	fprintf(f,"           damped least-squares solution:\n");
	fprintf(f,"             A m = b, where A=(G-traspose G + e I) and b = G-transpose d\n");
	fprintf(f,"           (where e is the damping parameter) is required, an iterative, \n");
	fprintf(f,"	      biconjugate gradient method is used.  This method starts with\n");
	fprintf(f,"           the solution m=0 and iteratively improves it.  The method only\n");
	fprintf(f,"           needs to compute A v, A-transpose v, and v / diag(A), where v\n");
	fprintf(f,"           is an arbitray vector.  These operations are implemented directly\n");
	fprintf(f,"           from G, so that A is never explicitly computed (e.g. \n");
	fprintf(f,"                     A v = G-transpose ( G v ) + e v).\n");
	return(TRUE);
	}

int write_model_pars_blerb(FILE *f)
// FILE *f;
{
	fprintf(f,"        model_pars_file.txt:\n");
	fprintf(f,"          a model parameter is a group of one or mode nodes\n");
	fprintf(f,"          whose velocity is to be adjusted as a unit\n");
	fprintf(f,"          the file contains any number of groups of:\n");
	fprintf(f,"             number_of_nodes in group\n");
	fprintf(f,"             i j k weight of first node in group (matching model file)\n");
	fprintf(f,"             i j k weight of second node in group\n");
	fprintf(f,"		etc.\n");
	fprintf(f,"          where weight scales the overall motion of that node\n");
	fprintf(f,"          relative to others in the group. As the problem is solved\n");
	fprintf(f,"          via least-squares, overlapping groups are perfectly\n");
	fprintf(f,"          acceptable and will impose overall smoothness on the\n");
	fprintf(f,"          velocity perturbations. Negative weights are fine\n");
	fprintf(f,"          as well and could be used, for example, to implement\n");
	fprintf(f,"          lateral gradients in velocity, by defining three model\n");
	fprintf(f,"          parameters for every interface, each containing all\n");
	fprintf(f,"          the nodes on the interface, one model parameter with\n");
	fprintf(f,"          constant weights, one that scales linearly with the\n");
	fprintf(f,"          x-position of the nodes, the other that scales linearly\n");
	fprintf(f,"          with the y-position of the nodes.\n");
	return(TRUE);
	}

int write_refl_pars_blerb(FILE *f)
// FILE *f;
{
	fprintf(f,"        model_pars_file.txt:\n");
	fprintf(f,"          a model parameter is a group of one or mode nodes on the reflecting\n");
	fprintf(f,"          interface whose position is to be adjusted as a unit\n");
	fprintf(f,"          the file contains any number of groups of\n");
	fprintf(f,"             number_of_nodes in group\n");
	fprintf(f,"             i j k tx xy tz weight\n");
	fprintf(f,"	                                of first node in group\n");
	fprintf(f,"             i j k tx xy tz weight\n");
	fprintf(f,"	                                of first second in group\n");
	fprintf(f,"		etc.\n");
	fprintf(f,"          where i j k are node indices corresponding to the model file\n");
	fprintf(f,"          and where tx xy tz is a unit vector specifying what direction the\n");
	fprintf(f,"              node is to be perturbed (typically, but not necessarily,\n");
	fprintf(f,"              perpendicular to interface \n");
	fprintf(f,"          and where weight scales the overall motion of that node\n");
	fprintf(f,"          relative to others in the group. As the problem is solved\n");
	fprintf(f,"          via least-squares, overlapping groups are perfectly\n");
	fprintf(f,"          acceptable and will impose overall smoothness on the\n");
	fprintf(f,"          node position perturbations. Negative weights are fine\n");
	fprintf(f,"          as well and could be used, for example, to implement\n");
	fprintf(f,"          a best-fitting sloping interface, by defining three model\n");
	fprintf(f,"          parameters for the interface, each containing all\n");
	fprintf(f,"          the nodes on the interface, one model parameter with\n");
	fprintf(f,"          constant weights, one that scales linearly with the\n");
	fprintf(f,"          x-position of the nodes, the other that scales linearly\n");
	fprintf(f,"          with the y-position of the nodes.\n");
	return(TRUE);
	}

int write_traveltime_blerb(FILE *f)
// FILE *f;
{
	fprintf(f,"      output traveltime_file.tsv\n");
	fprintf(f,"           id is ray number\n");
	fprintf(f,"           x0 y0 z0, source location in km\n");
	fprintf(f,"           x1 y1 z1, receiver location in km\n");
	fprintf(f,"	      T, traveltime in s\n");
	fprintf(f,"	      and when Q is defined in model\n");
	fprintf(f,"	      Q, path-averaged quality factor\n");
	return(TRUE);
	}

int write_predictions_blerb(FILE *f)
// FILE *f;
{
	fprintf(f,"      output predicted_tt_file.tsv\n");
	fprintf(f,"           x0 y0 z0, source location in km\n");
	fprintf(f,"           x1 y1 z1, receiver location in km\n");
	fprintf(f,"	      T0, origin time in s\n");
	fprintf(f,"	      TT, traveltime in s\n");
	fprintf(f,"	      T, arrival in s\n");
	fprintf(f,"	      dT, residual in s\n");
	fprintf(f,"	      ratio, velocity ratio\n");
	fprintf(f,"	      obs_order, of observed arrival\n");
	fprintf(f,"	      pre_order, of predicted arrival\n");
	fprintf(f,"	      amplitude, geometrical amplitude of predicted arrival\n");
	fprintf(f,"	      and, when Q is defined in the model\n");
	fprintf(f,"	      Q, path-averaged quality factor\n");
	fprintf(f,"	      n_tts, traveltime number, stating with 0\n");

	return(TRUE);
	}

int write_location_blerb(FILE *f)
// FILE *f;
{
	fprintf(f,"      output location_file.tsv\n");
	fprintf(f,"           xs ys zs, source location in km\n");
	fprintf(f,"	      t0, origin time in s\n");
	fprintf(f,"           sigma-x sigma-y sigma-z, source error in km\n");
	fprintf(f,"           sigma-t, origin time error in s\n");
	fprintf(f,"	      ndata, number of data used in final iteration\n");
	fprintf(f,"	      T, arrival in s\n");
	fprintf(f,"	      dT, residual in s\n");
	fprintf(f,"	      iter, numberof iterations\n");
	fprintf(f,"	      rms, rms traveltime error in s\n");
	return(TRUE);
	}

int write_ray_blerb(FILE *f)
// FILE *f;
{
	fprintf(f,"      output ray_file.tsv (a filename of - indicates stdout)\n");
	fprintf(f,"           id is ray number\n");
	fprintf(f,"           x y z, location of point on ray, km\n");
	fprintf(f,"           tetra, index number of tetrahedra at that point\n");
	return(TRUE);
	}



int write_tele_note(FILE *f)
// FILE *f;
{
	fprintf(f,"Note on methodology:\n");
	fprintf(f,"    Suppose a single teleseism is observed with\n");
	fprintf(f,"      arrival time ti on each of i=1...N stations\n");
	fprintf(f,"    Suppose that the teleseism arrives at a reference\n");
	fprintf(f,"	 depth, z0, at the bottom of the model at time\n");
	fprintf(f,"      t0+pxi*xi+pyi*yi.  The horizontal slownesses, (pxi,pyi),\n");
	fprintf(f,"      are assumed known (say from global traveltime models)\n");
	fprintf(f,"      but t0 is unknown.\n");
	fprintf(f,"    There are two ways to deal with the problem of t0:\n");  
	fprintf(f,"    The first is to explicitly remove t0 from consideration (at a price!): \n");
	fprintf(f,"      The predicted arrival time is t0+pxi*xi+pyi*yi+Ti(m)\n");
	fprintf(f,"        where Ti(m) is the traveltime through model m from\n");
	fprintf(f,"        the reference planewave to station i.  It linearizes to:\n");
	fprintf(f,"        t0+pxi*xi+pyi*yi+Ti(m0)+gradTi(dot)dm. Here m0 is\n");
	fprintf(f,"        a reference model and dm a perturbation.\n");
	fprintf(f,"      We eliminate t0 from the equation ti-pred = ti-obs\n");
	fprintf(f,"        by sutracting out the mean (over i=1..N). The mean l.h.s. is:\n");
	fprintf(f,"        t0+mean[pxi*xi+pyi*yi+Ti(m0)]+mean[gradTi](dot)dm\n");
	fprintf(f,"        so the final equation is:\n");
	fprintf(f,"        (gradTi - mean[gradTi]) (dot) dm = \n");
	fprintf(f,"        ti-mean[ti]-(pxi*xi+pyi*yi+Ti(m0))+mean[pxi*xi+pyi*yi+Ti(m0)] =\n");
	fprintf(f,"        [ti-(pxi*xi+pyi*yi+Ti(m0)] - mean[ti-(pxi*xi+pyi*yi+Ti(m0)]\n");
	fprintf(f,"      Note that the resulting equations are insensitive to the mean\n");
	fprintf(f,"        traveltime through the model, and thus can determine only\n");
	fprintf(f,"        horizontal gradients in the velocity model.\n");
	fprintf(f,"    The second method is to solve for t0. As this is non-unique, we \n");
	fprintf(f,"        must apply weights to favor the t0 model parameters over \n");
	fprintf(f,"        the velocity model parameters. This code uses dt0 as\n");
	fprintf(f,"        model parameters, where t0 = t00 + dt0, and t00=<ta>-<tt>,\n");
	fprintf(f,"        where ta are arrival times and tt are traveltimes and <>\n");
	fprintf(f,"        are averages over the plane wave.  dt0 is then forced to\n");
	fprintf(f,"        zero by applying a weight that is 10 times larger than\n");
	fprintf(f,"        for the velocity model parameters, that is, the elemet of\n");
	fprintf(f,"        G that multiplies dt0 is set to 0.1 time the largest element\n");
	fprintf(f,"        of the part of G that multiplies dv.\n");
	fprintf(f,"    I recommend that the second method be used. It preserves the sparseness\n");
	fprintf(f,"        of G, so generally speaking allows larger problems to be solved.\n");
	fprintf(f,"        (Currently, the telesesimic invert allows you to choose\n");
	fprintf(f,"        between methods, while the joint local/telesismic inversion\n");
	fprintf(f,"        just uses the second).\n");
	fprintf(f,"\n");
	return(TRUE);
	}

int write_info_blerb(FILE *f)
// FILE *f; // old syntax
{
fprintf(f,"\n");
fprintf(f,"Raytrace3d, by William Menke.  Copyright 2000 by Columbia University.\n");
// fprintf(f,"This version complied on %s\n", DATE); // <-------------------------------- too lazy to fix, commented out

fprintf(f,"Warning: This is prototype software intended for research purposes only.\n");
fprintf(f,"Use at your own risk!\n");
fprintf(f,"\n");
fprintf(f,"Raytrace3d implements raytracing in an isotropic medium described by\n");
fprintf(f,"a set of velocity nodes, with the nodes being organized into adjoining\n");
fprintf(f,"tetrahedra. Within any tetrahedron, the velocity varies linearly with\n");
fprintf(f,"position, and the raypaths are therefore arcs of circles.  The traveltime\n");
fprintf(f,"along along the ray is a known, analytic function of arc-length along\n");
fprintf(f,"the ray.  Thus the major effort in raytracing is the bookkeeping necessary\n");
fprintf(f,"to continue rays between adjacent tetrahedra.\n");
fprintf(f,"\n");
fprintf(f,"The basic raytracing methodology used in Raytrace3d works on arbitrary\n");
fprintf(f,"sets of tetrahedra.  However, I have chosen to make the model specification\n");
fprintf(f,"much more restrictive: a warped cartesan grid of LxMxN nodes.  I chose\n");
fprintf(f,"this simplification because it makes the design of a model by a human\n");
fprintf(f,"being easier and more comprehensible.  Furthermore, it allows one to\n");
fprintf(f,"easily name some interesting subhorizontal interface with the model (which\n");
fprintf(f,"can be useful in the raytracing). Internal to Raytrace3d, each rectangular\n");
fprintf(f,"parallelipiped in the warped cartesian grid is subdivided into several\n");
fprintf(f,"tetrahedra.\n");
fprintf(f,"\n");
fprintf(f,"I use a cartesian, right-handed, (x,y,z) coordinate system with z down.\n");
fprintf(f,"Angle of incidence is measured from +z, and azimuth is measured from +x\n");
fprintf(f,"to +y.  You are of course free to align x with whatever geographic direction\n");
fprintf(f,"you choose.  But if you make (x,y,z) = (N,E,Down) then azimuth will be\n");
fprintf(f,"degrees east of north.\n");
fprintf(f,"\n");
fprintf(f,"With one exception, Raytrace3d only permits you to work with a a single\n");
fprintf(f,"velocity model at a time, so there is no mechanism for simultaneously raytracing\n");
fprintf(f,"through distinct compressional and shear wave models.  However, it does provide\n");
fprintf(f,"a method of specifing a compressional-to-shear wave velocity ratio, so that\n");
fprintf(f,"both compressional and shear wave data can be used in, say, earthquake location.\n");
fprintf(f,"\n");
fprintf(f,"The exception is a joint inversion of P and S traveltimes for compressional\n");
fprintf(f,"velocity and compressional-to-shear wave velocity ratio (see below).\n");
fprintf(f,"\n");
fprintf(f,"Point-to-point (and planewave-to-point) raytracing is accomplished in a\n");
fprintf(f,"two-step process.  First, you compute an exhaustive set of rays from\n");
fprintf(f,"a specific point (or planewave) to a specific interface in the model\n");
fprintf(f,"on which the receivers reside.  I call the resulting ray set a star\n");
fprintf(f,"(or, in the case of the planewave, a turf).  A second step uses the\n");
fprintf(f,"star (or turf) to home-in on the ray that hits a specific receiver. The\n");
fprintf(f,"advantage of this approach is that it allows the systematic discovery of\n");
fprintf(f,"the several different rays that might reach a single station.  Raytrace3d\n");
fprintf(f,"thus allows you to work with data from both first and later-arriving\n");
fprintf(f,"waves.  The disadvantage of the two step process is that it is computationally\n");
fprintf(f,"inefficient, especially if only a few rays share a common source point\n");
fprintf(f,"(or planewave).\n");
fprintf(f,"\n");
fprintf(f,"Raytrace3d is a command-line oriented program that uses simple text\n");
fprintf(f,"file for input and output.  It must be combined with a good graphics\n");
fprintf(f,"package (such as the GMT Generic Mapping Tools) to produce comprehensible\n");
fprintf(f,"results. Raytrace3d is implements these functions:\n");
fprintf(f,"\n");
fprintf(f,"Model Examination. You always need to plot the model.\n");
fprintf(f,"     raytrace3d velocity ... evaluates the velocity model along a plane.\n");
fprintf(f,"          The results can be used an input to a program that makes color images.\n");
fprintf(f,"     raytrace3d grid ... samples the boundaries of the tetrahedra along a\n");
fprintf(f,"	  plane.  These data can be overlain onto a color image of the model.\n");
fprintf(f,"     raytrace3d interface_depth ... determines the depth of a named, subhorizontal\n");
fprintf(f,"          interface at a particular horizontal position.\n");
fprintf(f,"     raytrace3d interface_grid ... determines the depth of a named, subhorizontal\n");
fprintf(f,"          interface on a grid of (x,y) points.\n");
fprintf(f,"     raytrace3d point ... evaluates the velocity model a a single point.\n");
fprintf(f,"     raytrace3d point_list ... evaluates the velocity model a list of points.\n");
fprintf(f,"     raytrace3d dump_model ... writes out model tetrahedralization.\n");
fprintf(f,"\n");
fprintf(f,"Point-to-interface raytracing, handy to quickly generate a plot of some rays.\n");
fprintf(f,"     raytrace3d shoot_arc ... shoots rays at a suite of angles of incidence\n");
fprintf(f,"          and a specified azimuth from a specific point to an interface\n");
fprintf(f,"\n");
fprintf(f,"Point-to-point raytracing, from a point source like an earthquake or explosion.\n");
fprintf(f,"     raytrace3d shoot_star ... shoots a suite of rays at a wide range of\n");
fprintf(f,"          angles of incidence and azimuths, from a single source to a single\n");
fprintf(f,"          named interface.  The results, a star file, are the first step in \n");
fprintf(f,"          point-to-point raytracing.\n");
fprintf(f,"     raytrace3d shoot_star_p ... a slighty different version of shoot_star.\n");
fprintf(f,"     raytrace3d source_to_receivers ... Uses the star file to trace rays from\n");
fprintf(f,"          the point source to receivers on the named interface.\n");
fprintf(f,"\n");

fprintf(f,"Point-to-point raytracing with one reflecting interface is implemented with\n");
fprintf(f,"commands analagous to those above.  These commands allow one to work with PmP,\n");
fprintf(f,"PP and pP phases.  Unfortunately, more complicated senarios senarios involving\n");
fprintf(f,"multiple reflectors have not been implemented).\n");
fprintf(f,"     raytrace3d shoot_arc_refl ... shoots an arc of rays\n");
fprintf(f,"     raytrace3d shoot_star_refl ... shoots a star of rays\n");
fprintf(f,"     raytrace3d source_to_receivers_refl ... performs point-to-point raytracing\n");

fprintf(f,"\n");
fprintf(f,"Planewave-to-point raytracing, from a planewave (e.g. a teleseism).\n");
fprintf(f,"     raytrace3d shoot_turf ... shoots a suite of rays at a wide range of starting\n");
fprintf(f,"          locations, from the planewave to a single named interface.  The results,\n");
fprintf(f,"          a turf file, are the first step in planewave-to-point raytracing.\n");
fprintf(f,"     raytrace3d teleseism_to_receivers ... Uses the turf file to trace rays from\n");
fprintf(f,"          the planewave to receivers on the named interface.\n");
fprintf(f,"\n");
fprintf(f,"Inversion using local (point) sources.\n");
fprintf(f,"     raytrace3d invert ... implements one iteration of a linearized inversion.\n");
fprintf(f,"          for perturbations to nodal velocities using turning wave traveltime.\n");
fprintf(f,"          The results are a new model file.\n");
fprintf(f,"          You must run the inversion successive\n");
fprintf(f,"          times to achieve multiple iterations.\n");
fprintf(f,"     raytrace3d Vinvert ... a synonym for invert\n");
fprintf(f,"     raytrace3d Iinvert ... like Vinvert, but for perturbations to reflector position\n");
fprintf(f,"          using traveltimes from reflected waves\n");
fprintf(f,"     raytrace3d Qinvert ... like Vinvert, but for perturbations to Q\n");
fprintf(f,"     raytrace3d VIinvert ... joint nodal velocity and reflector node position inversion\n");
fprintf(f,"          using both truening wave and reflected wave traveltimes\n");
fprintf(f,"     raytrace3d PSinvert ... joint nodal P-velocity and P:S ratio inversion\n");
fprintf(f,"\n");
fprintf(f,"Velocity inversion using teleseismic (planewave) sources.\n");
fprintf(f,"     raytrace3d teleseismic_invert ... implements one iteration of a linearized\n");
fprintf(f,"          inversion, of a type that is insensitive to the origin time of the\n");
fprintf(f,"          teleseism (see usage for more details). The results are a new model\n");
fprintf(f,"          file.  You must run the inversion successive times to achieve multiple\n");
fprintf(f,"          iterations.\n");
fprintf(f,"     raytrace3d T_invert ... synonym for teleseismic_invert\n");
fprintf(f,"     raytrace3d TV_invert ... joint teleseismic and local event inversion\n");
fprintf(f,"\n");
fprintf(f,"Hypocentral location.\n");
fprintf(f,"     raytrace3d locate ... implements Geiger's method.\n");
fprintf(f,"     raytrace3d tt_table ...  creates a station-specific table of traveltimes.\n");
fprintf(f,"     raytrace3d tt_surface ...  extracts a traveltime surface from a tt_table.\n");
fprintf(f,"     raytrace3d index_traveltimes ...  creates a index of traveltimes.\n");
fprintf(f,"     raytrace3d jhd_table ... creates a table of traveltimes and their derivatives\n");
fprintf(f,"     raytrace3d               that can be used for joint hypocentral determinations\n");
fprintf(f,"\n");
fprintf(f,"Utilities.\n");
fprintf(f,"     raytrace3d roughen_model ... roughens a model (e.g. to make it less idealized)\n");
fprintf(f,"     raytrace3d fit_model ... least-squares adjustment of model to velocity data\n");
fprintf(f,"     raytrace3d perturb_model ... adds elliptical perturbations to a model.\n");
fprintf(f,"     raytrace3d make_model ... build a simple model\n");
fprintf(f,"     raytrace3d model_parameters ... build some simple types of model_parameter\n");
fprintf(f,"     	file from a model file.\n");
return(TRUE);
}



int print_arc(FILE *f,struct arc_rec *a)
// FILE *f;
// struct arc_rec *a;
{
	int i;
	if( a->ptetra != NULL ) i=a->ptetra->index; else i=0;
	fprintf(f,"arc t %d f %d R %f psi1 %f psi2 %f dpsi %f T %f S %f\n",
		i, a->exit_face, a->R, a->psi1, a->psi2, a->psi2-a->psi1,
		 a->T, a->S);
	if( a->psi2<a->psi1 ) fprintf(f," *** dpsi<0.0");
	if( a->psi1<(-90.0) || a->psi1>(90.0) ) fprintf(f," *** bad psi1 range");
	if( a->psi2<(-90.0) || a->psi2>(90.0) ) fprintf(f," *** bad psi2 range");
	if( a->T < 0.0 ) fprintf(stderr," *** negative T\n");
	if( a->S < 0.0 ) fprintf(stderr," *** negative S\n");
	return(1);
	}



int print_intersec(FILE *f,struct int_rec *i)
// FILE *f;
// struct int_rec *i;
{

	fprintf(f,"face %d inside %d psi %f dpsi %f\n",
		i->face, i->inside, i->psi, i->dpsi );
	fprintf(f,"x %f %f %f\n", i->x[0], i->x[1], i->x[2]  );
	fprintf(f,"xme %f %f %f\n", i->xme[0], i->xme[1], i->xme[2]  );
	fprintf(f,"epsilon %e R %f val %f\n", i->epsilon, i->R, i->val );
	fprintf(f,"\n");

	return(TRUE);
	}
