
double eval_velocity(struct tetra_rec *t,double x[3])
// struct tetra_rec *t;
// double x[3];
{
	double v;
	v = x[0]*(t->vc[0]) +  x[1]*(t->vc[1]) +  x[2]*(t->vc[2]) + t->vc[3];
	return(v);
	}

double eval_velocity2(double x[3],double vc[4])
// double x[3];
// double vc[4];
{
	double v;
	v = x[0]*vc[0] +  x[1]*vc[1] +  x[2]*vc[2] + vc[3];
	return(v);
	}

double eval_qinv(struct tetra_rec *t,double x[3])
// struct tetra_rec *t;
// double x[3];
{
	double v;
	v = x[0]*(t->qinvc[0]) +  x[1]*(t->qinvc[1]) +  x[2]*(t->qinvc[2]) + t->qinvc[3];
	return(v);
	}

double eval_qinv2(double x[3],double qinvc[4])
// double x[3];
// double qinvc[4];
{
	double v;
	v = x[0]*qinvc[0] +  x[1]*qinvc[1] +  x[2]*qinvc[2] + qinvc[3];
	return(v);
	}

double eval_arc_velocity(struct arc_rec *a,double x[3])
// struct arc_rec *a;
// double x[3];
{
	double v;
	v = x[0]*(a->vc[0]) +  x[1]*(a->vc[1]) +  x[2]*(a->vc[2]) + a->vc[3];
	return(v);
	}

double eval_arc_qinv(struct arc_rec *a,double x[3])
// struct arc_rec *a;
// double x[3];
{
	double v;
	v = x[0]*(a->qinvc[0]) +  x[1]*(a->qinvc[1]) +  x[2]*(a->qinvc[2]) + a->qinvc[3];
	return(v);
	}


/* evaluates equation of plane, Ax + By + Cz + D, for a given x */
/* The coefficients are sent in P=[A,B,C,D]                     */
double eval_plane(double P[4],double x[3] )
// double P[4], x[3];
{
	return( P[0]*x[0] + P[1]*x[1] + P[2]*x[2] + P[3] );
	}

/* evaluates equation of plane, just using 3 points on plane */
/* note: doesnt return same value as eval_plane() because of different normalization */
double eval_plane2(double x[3],double x1[3],double x2[3],double x3[3])
// double x[3], x1[3], x2[3], x3[3];
{
	int i;
	double xmx1[3], x2mx1[3], x3mx1[3], v[3];
	/* eqn is (x-x1) (dot) ( (x2-x1) (cross) (x3-x1) )     */
	/* see Rektorys Survey of Applicable Mathematics p 240 */
	for( i=0; i<3; i++ ) {
		xmx1[i]  = x[i] -x1[i];
		x2mx1[i] = x2[i]-x1[i];
		x3mx1[i] = x3[i]-x1[i];
		}
	cross( x2mx1, x3mx1, v );
	return( dot( xmx1, v ) );
	}

/* returns 1 if x is inside the tetrahedra with vertices x1, x2,
   x3, x4, 0 if its on the surface and -1 if its outside */



double eval_line(double x,double y,double L[3] )
// double x, y, L[3];
{
	return( L[0]*x+L[1]*y+L[2] );
	}
