             



// #include <stdio.h> //redundant
// #include <math.h> // redundant

/* given a unit vector, t, compute two other mutually orthoginal
unit vectors v and h that are perendicular to t.  If t is vertical
then v=[1,0,0] and h=[0,1,0].  Otherwise v will have a positive
3-component and h will have a zero 3-component.  h = t (cross) v  */

double dot();



int newbasisrot(double b0[3],double b1[3],double b2[3],double s[3][3])
// double b0[3], b1[3], b2[3], s[3][3];
{
        int i;

        /* derivation, given a vector [a1, a2, a3]

           let a = c0 b0 + c1 b1 + c2 b2
           then because of orthonoarmality of (b0, b1, b2)
           c0 = b0 (dot) a, c1 = b1 (dot) a, c2 = b2 (dot) a
           which in matric form is

           (c0)   (b0[0] b0[1] b0[2]) (a0)
           (c1) = (b1[0] b1[1] b1[2]) (a1)
           (c2)   (b2[0] b2[1] b2[2]) (a2)                       */

        for(i=0; i<3; i++ ) {
                s[0][i]=b0[i];
                s[1][i]=b1[i];
                s[2][i]=b2[i];
                }

        return(1);
        }

int rotate3(double c[3],double s[3][3],double c2[3])
// double c[3];
// double s[3][3];
// double c2[3];
{
        int i;
        int p;

        for(i=0;i<3;i++) {
                c2[i]=0.0;
                for(p=0;p<3;p++) {
                        c2[i] += s[i][p]*c[p];
                        }
                }
        return(1);
        }



int tvh(double t[3],double v[3],double h[3])
// double t[3], v[3], h[3];
{
	double a;

	if( t[0] == 0.0 && t[1] == 0.0 ) {
		v[0]=1.0; v[1]=0.0; v[2]=0.0;
		}
	else {
		a = t[0]*t[0] + t[1]*t[1];
		v[0] = (-t[0]*t[2]/a);
		v[1] = (-t[1]*t[2]/a);
		v[2] = 1.0;
		unit_vector(v);
		}
	
	cross( t, v, h );
	return(1);
	}

/* dot product between vectors a and b */
double dot(double a[3],double b[3])
// double a[3], b[3];
{
	return( a[0]*b[0] + a[1]*b[1] + a[2]*b[2] );
	}

/* cross product c = a (cross) b */
int cross(double a[3],double b[3],double c[3])
// double a[3], b[3], c[3];
{
	c[0] = a[1]*b[2] - b[1]*a[2];
	c[1] = a[2]*b[0] - b[2]*a[0];
	c[2] = a[0]*b[1] - b[0]*a[1];
	return(1);
	}



int arcstoxyz(struct arc_rec arc[],int n_arcs,double x[],double y[],double z[],int index[],
	double ds,int *n,int maxn )
// struct arc_rec arc[];
// int n_arcs;
// double x[], y[], z[];
// int index[];
// double ds;
// int *n;
// int maxn;
{
	int i, j, k, l;
	double psi, psi1, psi2, r[3], r2[3];

	(*n)=0;

	for( i=0; i<n_arcs; i++ ) {

                k=(int)(0.5+arc[i].S/ds);
                if( k<1 ) k=1;
                for( j=0; j<=k; j++ ) {
                        if( (*n)>(maxn-2) ) return(FALSE);

			/* point in transformed coordinate system */
			psi1 = arc[i].psi1; while( psi1<0.0 ) psi1+=360.0; while( psi1>=360.0 ) psi1-=360.0;
			psi2 = arc[i].psi2; while( psi2<0.0 ) psi2+=360.0; while( psi2>=360.0 ) psi2-=360.0;
			while( psi2<psi1 ) psi1-=360.0;
                        psi = psi1 +
				((double)j) *
				(psi2-psi1)/(double)k;

                        r[0] = arc[i].R*sin(DTOR*psi);
                        r[1] = 0.0;
                        r[2] = arc[i].R*cos(DTOR*psi);

			/* untransform */
			for( l=0; l<3; l++ ) r[l] += arc[i].shift[l];
			rotate3(r,arc[i].st,r2);

			x[*n] = r2[0];
			y[*n] = r2[1];
			z[*n] = r2[2];
			index[*n] = arc[i].ptetra->index;
                        (*n)++;
                        }
		}
	return(TRUE);
	}

int unit_vector(double v[])
// double v[];
{
	double a;
	int i;
	a=sqrt(dot(v,v));
	if( a==0.0 ) {
		for(i=0;i<3;i++) v[i]=0.0;
		return(FALSE);
		}
	else {
		for(i=0;i<3;i++) v[i]/=a;
		return(TRUE);
		}
	}



int ray_tangent(double th,double az,double t[3] )
// double th, az, t[3];
{
	t[0]=sin(DTOR*th)*cos(DTOR*az);
	t[1]=sin(DTOR*th)*sin(DTOR*az);
	t[2]=cos(DTOR*th);
	unit_vector(t);
	return(TRUE);
	}

int ray_tangentr(double th,double az,double t[3] )
// double th, az, t[3];
{
	t[0]=sin(th)*cos(az);
	t[1]=sin(th)*sin(az);
	t[2]=cos(th);
	unit_vector(t);
	return(TRUE);
	}

int inv_ray_tangentr(double *th,double *az,double t[3] )
// double *th, *az, t[3];
{
	*az = atan2( t[1], t[0] );
	*th = atan2( sqrt(t[0]*t[0]+t[1]*t[1]), t[2] );
	return(TRUE);
	}

int gjinv(double *a,double * b,int n,int nstore,double test,int *ierror )
// double *a, *b, test;
// int n, nstore, *ierror;
{

/*
c      a    input matrix
c      b    inverse of a
c      n    size of a and b
c      nstore       dimensioned size of a and b
c      test division by numbers smaller than this generate
c           a divide by zero error
c      ierror       error flag, zero on no error
*/

	double c[MAX_TABLE_COLS];
	int i, icol, itriag, ierror1, ierror2; // j, //unused

	/*   build inverse columnwise by solving AB=I */
	ierror1=0;
	for( icol=0; icol<n; icol++ ) {  
		for( i=0; i<n; i++ ) c[i]=0.0;
		c[icol]=1.0;
		if( icol == 0 ) {   /* triangularize a on first call */
                	itriag = TRUE;
			}
		else {
			itriag = FALSE;
			}
		gauss((double*)a, c, n, nstore, test, &ierror2, itriag );
		if( ierror2!=0 ) ierror1++;

		for( i=0; i<n; i++ ) *(b+i*nstore+icol)=c[i];
		}

	*ierror=ierror1;
	if( ierror1==0 ) return(TRUE); else return(FALSE);

       }

/* determinant of a 3x3 matrix */
double det3x3(double m[3][3])
// double m[3][3];
{
	double d;
	d = 0.0;
	d+=m[0][0]*m[1][1]*m[2][2];
	d+=m[0][1]*m[1][2]*m[2][0];
	d+=m[0][2]*m[2][1]*m[1][0];
	d-=m[0][2]*m[1][1]*m[2][0];
	d-=m[0][1]*m[1][0]*m[2][2];
	d-=m[0][0]*m[2][1]*m[1][2];
	return(d);
    }



int solve2x2( double A[2][2], double b[2], double x[2] )
{
	int i, j;
	double d, AI[2][2];

	d = A[0][0]*A[1][1]-A[0][1]*A[1][0];
	if( d==0.0 ) return(0);
	AI[0][0] = A[1][1]/d;
	AI[1][1] = A[0][0]/d;
	AI[1][0] = (-A[1][0])/d;
	AI[0][1] = (-A[0][1])/d;

	for( i=0; i<2; i++ ) {
		x[i]=0.0;
		for( j=0; j<2; j++ ) {
			x[i] += AI[i][j]*b[j];
			}
		}

	return(1);
	}

int invert2x2(double a[2][2],double ai[2][2])
// double a[2][2], ai[2][2];
{
	double d;
	d = a[0][0]*a[1][1] - a[0][1]*a[1][0];
	if( d==0.0 ) return(0);
	d = 1.0/d;
	ai[0][0]=a[1][1]*d;
	ai[1][1]=a[0][0]*d;
	ai[1][0]=(-a[1][0])*d;
	ai[0][1]=(-a[0][1])*d;
	return(1);
	}

int mult2x2(double a[2][2],double b[2][2],double c[2][2])
// double a[2][2], b[2][2], c[2][2];
{
	int i, j, k;
	for( i=0; i<2; i++ ) for( j=0; j<2; j++ ) {
		c[i][j]=0.0;
		for( k=0; k<2; k++ ) c[i][j]+=a[i][k]*b[k][j];
		}
	return(1);
	}
	
void gauss(double *a,double vec[],int n,int nstore,double test,int *ierror,int itriag)
// double *a, vec[], test;
// int n, nstore, *ierror, itriag;
{
 
/* subroutine gauss, by william menke */
/* july 1978 (modified feb 1983, nov 85) */
 
/* a subroutine to solve a system of n linear equations in n unknowns*/
/* where n doesn't exceed MAX_TABLE_COLS */
/* gaussian reduction with partial pivoting is used */
/* 	a		(sent, destroyed)	n by n matrix		*/
/*	vec		(sent, overwritten)	n vector, replaced w/ solution*/
/* 	nstore		(sent)			dimension of a	*/
/*	test		(sent)			div by zero check number*/
/*	ierror		(returned)		zero on no error*/
/*	itriag		(sent)			matrix triangularized only*/
/*						 on TRUE useful when solving*/
/*						 multiple systems with same a */
	static int isub[MAX_TABLE_COLS], l1;
	int line[MAX_TABLE_COLS], iet, ieb, i, j, k, l, j2;
	double big, testa, b, sum;
	

	iet=0;	/* initial error flags, one for triagularization*/
	ieb=0;	/* one for backsolving */

/* triangularize the matrix a*/
/* replacing the zero elements of the triangularized matrix */
/* with the coefficients needed to transform the vector vec */

	if (itriag) {	/* triangularize matrix */
 
 		for( j=0; j<n; j++ ) {      /*line is an array of flags*/
			line[j]=0; 
			/* elements of a are not moved during pivoting*/
			/* line=0 flags unused lines */
			}    /*end for j*/
			
		for( j=0; j<n-1; j++ ) {
			/*  triangularize matrix by partial pivoting */
                       big = 0.0; /* find biggest element in j-th column*/
				  /* of unused portion of matrix*/
		       for( l1=0; l1<n; l1++ ) {
                               if( line[l1]==0 ) {
                                       testa=(double) fabs(
						(double) (*(a+l1*nstore+j)) );
                                       if (testa>big) {
						i=l1;
						big=testa;
						} /*end if*/
					} /*end if*/
				} /*end for l1*/
                       if( big<=test) {   /* test for div by 0 */
                               iet=1;
                               } /*end if*/
 
                       line[i]=1;  /* selected unused line becomes used line */
                       isub[j]=i;  /* isub points to j-th row of tri. matrix */
 
                       sum=1.0/(*(a+i*nstore+j)); 
				/*reduce matrix towards triangle */
		       for( k=0; k<n; k++ ) {
				if( line[k]==0 ) {
					b=(*(a+k*nstore+j))*sum;
				       	for( l=j+1; l<n; l++ ) {
                                               *(a+k*nstore+l)=
							(*(a+k*nstore+l))
							-b*(*(a+i*nstore+l));
					       } /*end for l*/
                                       *(a+k*nstore+j)=b;
					} /*end if*/
				} /*end for k*/
			} /*end for j*/
 
               for( j=0; j<n; j++ ) {
			/*find last unused row and set its pointer*/
			/*  this row contians the apex of the triangle*/
			if( line[j]==0) {
				l1=j;   /*apex of triangle*/
				isub[n-1]=j;
				break;
				} /*end if*/
			} /*end for j*/
 
		} /*end if itriag true*/
		
	/*start backsolving*/
	
	for( i=0; i<n; i++ ) {	/* invert pointers. line(i) now gives*/
				/* row no in triang matrix of i-th row*/
				/* of actual matrix */
		line[isub[i]] = i;
		} /*end for i*/
 
	for( j=0; j<n-1; j++) { /*transform the vector to match triang. matrix*/
               b=vec[isub[j]];
               for( k=0; k<n; k++ ) {
                      if (line[k]>j) {	/* skip elements outside of triangle*/
                                vec[k]=vec[k]-(*(a+k*nstore+j))*b;
				} /*end if*/
			} /*end for k*/
		} /*end for j*/
 
      b = *(a+l1*nstore+(n-1));   /*apex of triangle*/
      if( ((double)fabs( (double) b))<=test) {
		/*check for div by zero in backsolving*/
		ieb=2;
		} /*end if*/
      vec[isub[n-1]]=vec[isub[n-1]]/b;
 
      for( j=n-2; j>=0; j-- ) {	/* backsolve rest of triangle*/
		sum=vec[isub[j]];
		for( j2=j+1; j2<n; j2++ ) {
			sum = sum - vec[isub[j2]] * (*(a+isub[j]*nstore+j2));
			} /*end for j2*/
			b = *(a+isub[j]*nstore+j);
               if( ((double)fabs((double)b))<=test) {
			/* test for div by 0 in backsolving */
			ieb=2;
			} /*end if*/
		vec[isub[j]]=sum/b;   /*solution returned in vec*/
		} /*end for j*/

/*put the solution vector into the proper order*/

      for( i=0; i<n; i++ ) {    /* reorder solution */
		for( k=i; k<n; k++ ) {  /* search for i-th solution element */
			if( line[k]==i ) {
				j=k;
				break;
				} /*end if*/
			} /*end for k*/
               b = vec[j];       /* swap solution and pointer elements*/
               vec[j] = vec[i];
               vec[i] = b;
               line[j] = line[i];
		} /*end for i*/
 
      *ierror = iet + ieb;   /* set final error flag*/
}

		
		