




void main_index_traveltimes(int argc,char *argv[])
// int argc;
// char *argv[];
{
	FILE *f;
	double x0[3], stheta, ftheta, dtheta, sazi, fazi, dazi, dT;
	int n_thetas, n_azis, iwavemin=1; // , iwavemax; //unused
	int i, j, k, l, count, iwave, tt; // m,t//unused
	struct jhd_table_rec {
		double azi, theta;
		float *X, *Y, *Z;
		int iwave, *tlist, nt, hit;
		};
	struct jhd_table_rec *jhd;
	struct index_rec {
		int j, k, l, i;
		struct index_rec *next;
		};
	struct index_rec **first, **last, *my_index;
	int *icount;
	int buf[4];

	int r1, r2, r3;
	double b1[3], b2[3], b3[3], t1[3], t2[3], t3[3]; // , T, dTdx[3], Tb, Tt, Tmin, Tmax; //unused

	if( argc != 4 ) {
		fprintf(stderr,"purpose: produce a index to speed up traveltime calculations\n");
		fprintf(stderr,"usage: index_traveltimes model_file tt_table_file tt_index\n");
		fprintf(stderr,"       model_file: standard model file\n");
		fprintf(stderr,"       tt_table_file: travetime table produced by tt_table\n");
		fprintf(stderr,"       tt_index_file: index file that is created\n");
		exit(-1);
		}

	if( !init_tetra_stack() ) {
		fprintf(stderr,"error: %s: out of memory (1)\n", argv[0] );
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	/* allocate index */
	first = (struct index_rec **) malloc( n_tetras * sizeof(struct index_rec *) );
	last =  (struct index_rec **) malloc( n_tetras * sizeof(struct index_rec *) );
	icount =  (int *) malloc( n_tetras * sizeof(int) );

	if( (first==NULL) || (last==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (2)\n", argv[0] );
		exit(-1);
		}
	for( i=0; i<n_tetras; i++ ) { first[i]=NULL; last[i]=NULL; icount[i]=0;}


	/* read in tt_table */
	if( (f=fopen(argv[2],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open tt_table file <%s> for read\n",
			argv[0], argv[2] );
		exit(-1);
		}

	count=0;
	count+=fread( x0, sizeof(double), 3, f );

	count+=fread( &stheta, sizeof(double), 1, f );
	count+=fread( &ftheta, sizeof(double), 1, f );
	count+=fread( &dtheta, sizeof(double), 1, f );
	count+=fread( &n_thetas, sizeof(int), 1, f );

	count+=fread( &sazi, sizeof(double), 1, f );
	count+=fread( &fazi, sizeof(double), 1, f );
	count+=fread( &dazi, sizeof(double), 1, f );
	count+=fread( &n_azis, sizeof(int), 1, f );

	count+=fread( &dT, sizeof(double), 1, f );

	if( count!=12 ) {
		fprintf(stderr,"error: %s: cant read tt_table file (1)\n", argv[0]);
		exit(-1);
		}

	jhd = (struct jhd_table_rec *) malloc( n_thetas * n_azis * sizeof(struct jhd_table_rec) );
	if( jhd==NULL ) {
		fprintf(stderr,"error: %s: out of memory (1)\n", argv[0] );
		exit(-1);
		}
	for( j=0; j<n_azis; j++ ) for( k=0; k<n_thetas; k++ ) {
		jhd[j+k*n_azis].iwave=0; jhd[j+k*n_azis].nt=0; jhd[j+k*n_azis].tlist=NULL;
		jhd[j+k*n_azis].X=NULL; jhd[j+k*n_azis].Y=NULL; jhd[j+k*n_azis].Z=NULL;
		}

	while(1) {
		count=0;
		count+=fread( &j, sizeof(int), 1, f );
		count+=fread( &k, sizeof(int), 1, f );
		count+=fread( &iwave, sizeof(int), 1, f );
		if( count == 0 ) break;
		if( iwave == 0 ) continue;
		if( count != 3 ) {
			fprintf(stderr,"error: %s: cant read tt_table file (2)\n", argv[0] );
			exit(-1);
			}
		jhd[j+k*n_azis].azi=sazi+dazi*(double)j;
		jhd[j+k*n_azis].theta=stheta+dtheta*(double)k;
		jhd[j+k*n_azis].iwave=iwave;

		jhd[j+k*n_azis].X = (float *) malloc( sizeof(float)*iwave );
		jhd[j+k*n_azis].Y = (float *) malloc( sizeof(float)*iwave );
		jhd[j+k*n_azis].Z = (float *) malloc( sizeof(float)*iwave );

		if((jhd[j+k*n_azis].X==NULL)||(jhd[j+k*n_azis].X==NULL)||(jhd[j+k*n_azis].X==NULL)){
			fprintf(stderr,"error: %s: out of memory (2)\n", argv[0] );
			exit(-1);
			}

		count=0;
		count+=fread( jhd[j+k*n_azis].X, sizeof(float), iwave, f );
		count+=fread( jhd[j+k*n_azis].Y, sizeof(float), iwave, f );
		count+=fread( jhd[j+k*n_azis].Z, sizeof(float), iwave, f );
		if( count != (3*iwave) ) {
			fprintf(stderr,"error: %s: cant read tt_table file (3)\n", argv[0] );
			exit(-1);
			}

		count=0;
		count+=fread( &(jhd[j+k*n_azis].nt), sizeof(int), 1, f );
		if( count != 1 ) {
			fprintf(stderr,"error: %s: cant read tt_table file (4)\n", argv[0] );
			exit(-1);
			}

		jhd[j+k*n_azis].tlist = (int *) malloc( sizeof(int)*jhd[j+k*n_azis].nt );
		if( jhd[j+k*n_azis].tlist == NULL ) {
			fprintf(stderr,"error: %s: out of memory (3)\n", argv[0] );
			exit(-1);
			}
		count=0;
		count+=fread( jhd[j+k*n_azis].tlist, sizeof(int), jhd[j+k*n_azis].nt, f );
		if( count != jhd[j+k*n_azis].nt ) {
			fprintf(stderr,"error: %s: cant read tt_table file (5)\n", argv[0] );
			exit(-1);
			}
		}
	fclose(f);

fprintf(stderr,"index read in\n");

	/* write out index */
	if( (f=fopen(argv[3],"w")) == NULL ) {
		fprintf(stderr,"error: %s: cant open tt_index file <%s> for write\n",
			argv[0], argv[3] );
		exit(-1);
		}

	/* loop over all triangular-cross-section ray tubes */
	for( j=0; j<(n_azis-1); j++ ) {
	for( k=0; k<(n_thetas-1); k++ ) {
printf("%d %d\n", j, k);
	for( l=0; l<2; l++ ) {
		if( l==0 ) {
			r1 = j+k*n_azis;
			r2 = (j+1)+k*n_azis;
			r3 = j+(k+1)*n_azis;
			}
		else {
			r1 = (j+1)+k*n_azis;
			r2 = (j+1)+(k+1)*n_azis;
			r3 = j+(k+1)*n_azis;
			}

		if( (jhd[r1].iwave==0) || (jhd[r2].iwave==0) || (jhd[r3].iwave==0) ) {
			continue;
			}

		iwave = jhd[r1].iwave;
		if( jhd[r2].iwave < iwave ) iwave=jhd[r2].iwave;
		if( jhd[r3].iwave < iwave ) iwave=jhd[r3].iwave;

		/* loop over all triangular prisms in ray tube */
		iwavemin=1;
		for( i=iwavemin; i<(iwave-1); i++ ) {

			b1[0]=jhd[r1].X[i]; b1[1]=jhd[r1].Y[i]; b1[2]=jhd[r1].Z[i];
			b2[0]=jhd[r2].X[i]; b2[1]=jhd[r2].Y[i]; b2[2]=jhd[r2].Z[i];
			b3[0]=jhd[r3].X[i]; b3[1]=jhd[r3].Y[i]; b3[2]=jhd[r3].Z[i];

			t1[0]=jhd[r1].X[i+1]; t1[1]=jhd[r1].Y[i+1]; t1[2]=jhd[r1].Z[i+1];
			t2[0]=jhd[r2].X[i+1]; t2[1]=jhd[r2].Y[i+1]; t2[2]=jhd[r2].Z[i+1];
			t3[0]=jhd[r3].X[i+1]; t3[1]=jhd[r3].Y[i+1]; t3[2]=jhd[r3].Z[i+1];

			mark_tri_prism( b1,b2,b3, t1,t2,t3 );
			count=0;
			for( tt=0; tt<n_tetras; tt++ ) if( tetra[tt].marked ) {
				my_index=(struct index_rec *)malloc(sizeof(struct index_rec));
				if( my_index==NULL ) {
					fprintf(stderr,"error: %s: out of memory (2)\n", argv[0] );
					exit(-1);
					}
				my_index->j=j; my_index->k=k; my_index->l=l; my_index->i=i; 
				my_index->next=NULL;
				icount[tt]++;
				if( first[tt]==NULL ) {
					first[tt]=my_index;
					last[tt]=my_index;
					}
				else {
					last[tt]->next=my_index;
					last[tt]=my_index;
					}
				count++;
				}
			}
		}}}

	/* write out index */
	for( i=0; i<n_tetras; i++ ) if( icount[i]>0 ) {
		buf[0]=i; buf[1]=icount[i];
		fwrite( buf, sizeof(int), 2, f );
		my_index=first[i];
		while( my_index!=NULL ) {
			buf[0]=my_index->j; buf[1]=my_index->k;
			buf[2]=my_index->l; buf[3]=my_index->i;
			fwrite( buf, sizeof(int), 4, f );
			my_index = my_index->next;
			}
		}

	destroy_tetra_stack();

	exit(0);
	}

void main_dump_model(int argc,char  *argv[])
// int argc;
// char *argv[];
{
	int i;

	if( argc!=3 ) {
		fprintf(stderr,"purpose: writes out model tetrahedralization\n");
		fprintf(stderr,"usage: %s model_file check_flag > output.txt\n",
			argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      output.txt:\n");
		fprintf(stderr,"         number of nodes\n");
		fprintf(stderr,"         index, x, y, z in km, v in km/s, interface of each node\n");
		fprintf(stderr,"         number of tetrahedra\n");
		fprintf(stderr,"         index, node 1, 2, 3, 4, tetrahedron adjoining face 1, 2, 3, 4, interface of face 1, 2, 3, 4, volume in km**3\n");
		fprintf(stderr,"           -1 indicates no adjoining tetrahedron on a face\n");
		fprintf(stderr,"           and no interface of a face\n");
		fprintf(stderr,"      check_flag: checks model if Y or y, doesnt if N or n\n");
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	printf("%d\n", n_nodes);

	for( i=0; i<n_nodes; i++ ) {
		if( QDEFINED ) printf("%d\t%f\t%f\t%f\t%f\t%f\t%d\n", i,
		node[i].x[0], node[i].x[1], node[i].x[2], node[i].v, 1.0/node[i].qinv, node[i].ifc );
		else printf("%d\t%f\t%f\t%f\t%f\t%d\n", i,
		node[i].x[0], node[i].x[1], node[i].x[2], node[i].v, node[i].ifc );
		}

	printf("%d\n", n_tetras);

	for( i=0; i<n_tetras; i++ ) printf("%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%e\n", i,
		tetra[i].n1, tetra[i].n2, tetra[i].n3, tetra[i].n4,
		tetra[i].t1, tetra[i].t2, tetra[i].t3, tetra[i].t4,
		tetra[i].ifc[0], tetra[i].ifc[1], tetra[i].ifc[2], tetra[i].ifc[3],
		tetra_volume(i) );

	if( argv[2][0]=='y' || argv[2][0]=='Y' ) {
		i=check_tetras(stderr);
		if(i) {
			printf("Connectivity of this model is good\n");
			}
		else {
			printf("Connectivity of this model is bad\n");
			}
		}
	else {
		printf("Connectivity of this model not checked\n");
		}

	exit(0);
	}

void main_perturb_model(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, found, nblobs, ninterfaces, k, nx, ny, nz;
	FILE *fblobs, *finterfaces;
#define NBLOBS      (1000)
	double  x[NBLOBS],  y[NBLOBS],  z[NBLOBS];
	double sx[NBLOBS], sy[NBLOBS], sz[NBLOBS];
	double dv[NBLOBS], dq[NBLOBS];
#define NINTERFACES (100)
	int interface[NINTERFACES];
	double r2, e;

	if( argc!=4 ) {
		fprintf(stderr,"purpose: perturbs a model with gaussian blobs\n");
		fprintf(stderr,"usage: %s model_file blobs_file.txt interfaces_file.txt > new_model_file\n",
			argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      blobs_file.txt:\n");
		fprintf(stderr,"         number of blobs\n");
		fprintf(stderr,"         x, y, z in km, sx, sy, sz in km, dv in km/s, dQ\n");
		fprintf(stderr,"      each blob adds a perturbation of\n");
		fprintf(stderr,"      dv*exp(-r^2) and (1.0/dQ)*exp(-r^2)\n");
		fprintf(stderr,"         where r^2 = ((x-xnode)/sx)^2+((y-ynode)/sy)^2+(z-znode)/sz)^2]\n");
		fprintf(stderr,"       to the velocity and 1/Q of the nodes\n");
		fprintf(stderr,"       Q perturbations are ignored in models lacking Q\n");
		fprintf(stderr,"      interfaces_file.txt:\n");
		fprintf(stderr,"         number of interfaces\n");
		fprintf(stderr,"         interface_number\n");
		fprintf(stderr,"         interface_number\n");
		fprintf(stderr,"      perturbations are only applied to nodes with interface\n");
		fprintf(stderr,"      numbers specified in this file\n");
		fprintf(stderr,"      output new_model_file has same format as model file\n");
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( (fblobs=fopen(argv[2],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open blobs file <%s> for read\n", argv[0], argv[2] );
		exit(-1);
		}

	if( fscanf(fblobs,"%d", &nblobs ) !=1 ) {
		fprintf(stderr,"error: %s cant read nblobs from blobs file <%s>\n",
			argv[0], argv[2] );
		exit(-1);
		}

	if( nblobs>NBLOBS ) {
		fprintf(stderr,"error: %s too many blobs\n", argv[0]);
		exit(-1);
		}

	for( i=0; i<nblobs; i++ ) {
		if( fscanf(fblobs,"%le%le%le%le%le%le%le%le\n", &x[i], &y[i], &z[i],
			&sx[i], &sy[i], &sz[i], &dv[i], &dq[i] ) != 8 ) {
			fprintf(stderr,"error: %s cant read blob %d from blobs file <%s>\n",
				argv[0], i, argv[2] );
			exit(-1);
			}
		}

	fclose(fblobs);

	if( (finterfaces=fopen(argv[3],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open interfaces file <%s> for read\n", argv[0], argv[3] );
		exit(-1);
		}

	if( fscanf(finterfaces,"%d", &ninterfaces ) !=1 ) {
		fprintf(stderr,"error: %s cant read ninterfaces from interfaces file <%s>\n",
			argv[0], argv[3] );
		exit(-1);
		}

	if( ninterfaces>NINTERFACES ) {
		fprintf(stderr,"error: too many interfaces\n");
		exit(-1);
		}

	for( i=0; i<ninterfaces; i++ ) {
		if( fscanf(finterfaces,"%d\n", &interface[i] ) != 1 ) {
			fprintf(stderr,"error: %s cant read interface %d from interfaces file <%s>\n",
				argv[0], i, argv[3] );
			exit(-1);
			}
		}

	fclose(finterfaces);
	
	for( i=0; i<n_nodes; i++ ) {
		found=0;
		for( j=0; j<ninterfaces; j++ ) if( node[i].ifc==interface[j] ) {
			found=1;
			break;
			}
		if( found ) {
			for( k=0; k<nblobs; k++ ) {
				r2 = ((node[i].x[0]-x[k])/sx[k]) * ((node[i].x[0]-x[k])/sx[k])
			 	  +  ((node[i].x[1]-y[k])/sy[k]) * ((node[i].x[1]-y[k])/sy[k])
			  	  +  ((node[i].x[2]-z[k])/sz[k]) * ((node[i].x[2]-z[k])/sz[k]);
				e = exp(-r2);
				node[i].v += dv[k]*e;
				if( QDEFINED ) node[i].qinv += (1.0/dq[k])*e;
				}
			}
		}

	/* write out perturbed model */
	printf("%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		if( QDEFINED )
		printf("%d %d %d %f %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, 1.0/node[i].qinv, node[i].ifc );
		else
		printf("%d %d %d %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, node[i].ifc );
		}
	exit(0);
	}

void main_roughen_model(int argc,char *argv[])
// int argc;
// char *argv[];
{

	int i, j, k, nx, ny, nz;

	if( argc!=6 ) {
		fprintf(stderr,"purpose: roughens a model with random perturbations\n");
		fprintf(stderr,"         to node positions and velocities.  Idealized\n");
		fprintf(stderr,"         models should be roughened slightly (say\n");
		fprintf(stderr,"         by a 0.001 km in node position and 0.001 km/s\n");
		fprintf(stderr,"         in velocity) to break symmetries that can\n");
		fprintf(stderr,"         cause the raytracing to fail.\n");
		fprintf(stderr,"usage: %s model_file dx dy dz dv > new_model_file\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"         dx, dy, dz in km, dv in km/s\n");
		fprintf(stderr,"      output new_model_file has same format as model_file\n");
		exit(-1);
		}

	if( sscanf(argv[2],"%le", &node_x_perturbation ) !=1 ) {
		fprintf(stderr,"error: %s cant read node_x_perturbation from cmd line <%s>\n",
			argv[0], argv[2] );
		exit(-1);
		}

	if( sscanf(argv[3],"%le", &node_y_perturbation ) !=1 ) {
		fprintf(stderr,"error: %s cant read node_y_perturbation from cmd line <%s>\n",
			argv[0], argv[3] );
		exit(-1);
		}

	if( sscanf(argv[4],"%le", &node_z_perturbation ) !=1 ) {
		fprintf(stderr,"error: %s cant read node_z_perturbation from cmd line <%s>\n",
			argv[0], argv[4] );
		exit(-1);
		}

	if( sscanf(argv[5],"%le", &node_v_perturbation ) !=1 ) {
		fprintf(stderr,"error: %s cant read node_v_perturbation from cmd line <%s>\n",
			argv[0], argv[5] );
		exit(-1);
		}

	PERTURBMODEL=1;

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	/* write out roughewned model */
	printf("%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		if( QDEFINED )
		printf("%d %d %d %f %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, 1.0/node[i].qinv, node[i].ifc );
		else
		printf("%d %d %d %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, node[i].ifc );
		}
	exit(0);
	}


void main_interface_depth(int argc,char *argv[])
// int argc;
// char *argv[];
{

	double x_interface, y_interface, tangent[3], ntangent[3], xi[3], normal[3], x[3], xs[3], s;
	double epsilon, v, qinv;
	int interface, i, j, t, face; //, tt; //unused
	struct tetra_rec *p;

	epsilon=1.0e-8;

	if( argc!=5 ) {
		fprintf(stderr,"purpose: interrogates the model to find the depth of an interface\n");

		fprintf(stderr,"usage: %s model_file interface x y > output.txt\n",
			argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      interface ... integer matching an interface in the model\n");
		fprintf(stderr,"      x, y ... units in km\n");
		fprintf(stderr,"      output.txt: x_interface, y_interface, z_interface in km, velocity in km/s\n");
		fprintf(stderr,"      or, if Q defined in model\n");
		fprintf(stderr,"      output.txt: x_interface, y_interface, z_interface in km, velocity in km/s, Q\n");
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2], "%d", &interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read interface from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &x_interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read x from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &y_interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read y from command line\n",
			argv[0] );
		exit(-1);
		}

	tangent[0]=0.0; tangent[1]=0.0; tangent[2]=1.0;
	for( i=0; i<3; i++ ) ntangent[i]=(-tangent[i]);
	xs[0]=x_interface;
	xs[1]=y_interface;
	i=0;
	do {
		xs[2]=model_z_min+(model_z_max-model_z_min)*myrand();
		if( i>100 ) {
			fprintf(stderr,"error: cant find a valid starting depth\n");
			exit(-1);
			}
		i++;
		} while( !find_tetra(xs,&t) );
	i=0;
	for( j=0; j<3; j++ ) x[j]=xs[j];
	find_tetra(x,&t);
	while( t!=(-1) ) {
		p = &tetra[t];
		if( !ray_exits_tetrahedron( p->x1, p->x2, p->x3,
			p->x4, x, tangent, epsilon/2.0, normal,
			xi, &s, &face ) ) {
				break;
				}
		if( p->ifc[face]==interface ) {
			v = eval_velocity(p,xi);
			if( QDEFINED ) {
				qinv = eval_qinv(p,xi);
				printf("%f\t%f\t%f\t%f\t%f\n", xi[0], xi[1], xi[2], v, 1.0/qinv);
				}
			else printf("%f\t%f\t%f\t%f\n", xi[0], xi[1], xi[2], v);
			exit(0);
			}
		for( j=0; j<3; j++ ) x[j]=xi[j]+tangent[j]*epsilon;

		if( face == 0 )      t=p->t1;
		else if( face == 1 ) t=p->t2;
		else if( face == 2 ) t=p->t3;
		else if( face == 3 ) t=p->t4;
		else t=(-1);

		if( i>10000 ) {
			fprintf(stderr,"error: too many tetras (1)!\n");
			exit(-1);
			}
		i++;
		}
	i=0;
	for( j=0; j<3; j++ ) x[j]=xs[j];
	find_tetra(x,&t);
	while( t!=(-1) ) {
		p = &tetra[t];
		if( !ray_exits_tetrahedron( p->x1, p->x2, p->x3,
			p->x4, x, ntangent, epsilon/2.0, normal,
			xi, &s, &face ) ) {
				break;
				}
		if( p->ifc[face]==interface ) {
			v = eval_velocity(p,xi);
			if( QDEFINED ) {
				qinv = eval_qinv(p,xi);
				printf("%f\t%f\t%f\t%f\t%f\n", xi[0], xi[1], xi[2], v, 1.0/qinv);
				}
			else printf("%f\t%f\t%f\t%f\n", xi[0], xi[1], xi[2], v);
			exit(0);
			}
		for( j=0; j<3; j++ ) x[j]=xi[j]+ntangent[j]*epsilon;

		if( face == 0 )      t=p->t1;
		else if( face == 1 ) t=p->t2;
		else if( face == 2 ) t=p->t3;
		else if( face == 3 ) t=p->t4;
		else t=(-1);

		if( i>10000 ) {
			fprintf(stderr,"error: too many tetras (2)!\n");
			exit(-1);
			}
		i++;
		}
	fprintf(stderr,"error: cant find interface %d at (%f, %f)\n", interface,
		x_interface, y_interface );

	exit(-1);
	}

void main_interface_grid(int argc,char *argv[])
// int argc;
// char *argv[];
{

	double x_interface, y_interface, z_interface;
	double tangent[3], ntangent[3], xi[3], normal[3], x[3], xs[3], s;
	double epsilon, v;
	int interface, i, j, t, face; //, tt; //unused
	struct tetra_rec *p;
	double xmin, xmax, ymin, ymax, qinv;
	int nx, ny, ix, iy, found, t_save;

	epsilon=1.0e-8;

	if( argc!=9 ) {
		fprintf(stderr,"purpose: interrogates the model to find the depth of an interface\n");

		fprintf(stderr,"usage: %s model_file interface xmin xmax nx ymin ymax ny > output.txt\n",
			argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      interface .... integer matching an interface in the model\n");
		fprintf(stderr,"      xmin, xmax, nx minimum and maximum x, in km, and number of points to sample, an integer\n");
		fprintf(stderr,"      ymin, ymax, ny minimum and maximum y, in km, and number of points to sample, an integer\n");
		fprintf(stderr,"      output.txt: x_interface, y_interface, z_interface in km, velocity in km/s\n");
		fprintf(stderr,"      or, if Q defined in model\n");
		fprintf(stderr,"      output.txt: x_interface, y_interface, z_interface in km, velocity in km/s, Q\n");
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2], "%d", &interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read interface from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &xmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read xmin from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &xmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read xmax from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%d", &nx) != 1 ) {
		fprintf(stderr,"error: %s: cant read nx from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &ymin) != 1 ) {
		fprintf(stderr,"error: %s: cant read ymin from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%le", &ymax) != 1 ) {
		fprintf(stderr,"error: %s: cant read ymax from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%d", &ny) != 1 ) {
		fprintf(stderr,"error: %s: cant read ny from command line\n",
			argv[0] );
		exit(-1);
		}

	printf("x\ty\tz\tv\n");

	z_interface=model_z_min+(model_z_max-model_z_min)/2.0;

	for( ix=0; ix<nx; ix++ ) for( iy=0; iy<ny; iy++ ) {

	found=FALSE;

	x_interface = xmin + (xmax-xmin)*(double)(ix)/((double)(nx-1));
	y_interface = ymin + (ymax-ymin)*(double)(iy)/((double)(ny-1));

	tangent[0]=0.0; tangent[1]=0.0; tangent[2]=1.0;
	for( i=0; i<3; i++ ) ntangent[i]=(-tangent[i]);
	xs[0]=x_interface;
	xs[1]=y_interface;
	xs[2]=z_interface;
	i=0;
	if( !find_tetra(xs,&t) ) {
		do {
			xs[2]=model_z_min+(model_z_max-model_z_min)*myrand();
			if( i>100 ) {
				fprintf(stderr,"error: cant find a valid starting depth (x,y)=(%f, %f)\n", x_interface, y_interface);
				exit(-1);
				}
			i++;
			} while( !find_tetra(xs,&t) );
		}
	t_save=t;
	i=0;
	for( j=0; j<3; j++ ) x[j]=xs[j];
	while( t!=(-1) ) {
		p = &tetra[t];
		if( !ray_exits_tetrahedron( p->x1, p->x2, p->x3,
			p->x4, x, tangent, epsilon/2.0, normal,
			xi, &s, &face ) ) {
				break;
				}
		if( p->ifc[face]==interface ) {
			v = eval_velocity(p,xi);
			if( QDEFINED ) {
				qinv = eval_qinv(p,xi);
				printf("%f\t%f\t%f\t%f\t%f\n", xi[0], xi[1], xi[2], v, 1.0/qinv);
				}
			else printf("%f\t%f\t%f\t%f\n", xi[0], xi[1], xi[2], v);
			z_interface=xi[2];
			found=TRUE;
			break;
			}
		for( j=0; j<3; j++ ) x[j]=xi[j]+tangent[j]*epsilon;

		if( face == 0 )      t=p->t1;
		else if( face == 1 ) t=p->t2;
		else if( face == 2 ) t=p->t3;
		else if( face == 3 ) t=p->t4;
		else t=(-1);

		if( i>10000 ) {
			fprintf(stderr,"error: too many tetras (1)!\n");
			exit(-1);
			}
		i++;
		}
	if( found ) continue;
	i=0;
	t=t_save;
	for( j=0; j<3; j++ ) x[j]=xs[j];
	while( t!=(-1) ) {
		p = &tetra[t];
		if( !ray_exits_tetrahedron( p->x1, p->x2, p->x3,
			p->x4, x, ntangent, epsilon/2.0, normal,
			xi, &s, &face ) ) {
				break;
				}
		if( p->ifc[face]==interface ) {
			v = eval_velocity(p,xi);
			if( QDEFINED ) {
				qinv = eval_qinv(p,xi);
				printf("%f\t%f\t%f\t%f\t%f\n", xi[0], xi[1], xi[2], v, 1.0/qinv );
				}
			else printf("%f\t%f\t%f\t%f\n", xi[0], xi[1], xi[2], v);
			z_interface=xi[2];
			found=TRUE;
			break;
			}
		for( j=0; j<3; j++ ) x[j]=xi[j]+ntangent[j]*epsilon;

		if( face == 0 )      t=p->t1;
		else if( face == 1 ) t=p->t2;
		else if( face == 2 ) t=p->t3;
		else if( face == 3 ) t=p->t4;
		else t=(-1);

		if( i>10000 ) {
			fprintf(stderr,"error: too many tetras (2)!\n");
			exit(-1);
			}
		i++;
		}

	}

	exit(0);
	}

void main_grid(int argc,char *argv[])
// int argc;
// char *argv[];
{

	double a, b, c, d, e, s, x[3], tangent[3], ntangent[3], xi[3], normal[3];
	double epsilon;
	int i, j, n, t, face;
	struct tetra_rec *p;
	int save_tetra=(-1);
	epsilon=1.0e-6;

	if( argc!=9 ) {
		fprintf(stderr,"purpose: interrogates the tetrahedral grid along a plane and produces dots along their faces\n");

		fprintf(stderr,"usage: %s model_file xz xmin xmax zmin zmax y n > output.tsv\n",
			argv[0]);
		fprintf(stderr,"       or\n");
		fprintf(stderr,"usage: %s model_file xy xmin xmax ymin ymax z n > output.tsv\n",
			argv[0]);
		fprintf(stderr,"       or\n");
		fprintf(stderr,"usage: %s model_file yz ymin ymax zmin zmax x n > output.tsv\n",
			argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      xz xy yz are keywords\n");
		fprintf(stderr,"      xmin, xmax ... units in km\n");
		fprintf(stderr,"      n an integer number of rows\n");
		fprintf(stderr,"      output.tsv:\n");
		fprintf(stderr,"      x y z\n");
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( !(     (!strcmp(argv[2],"xz"))
		|| (!strcmp(argv[2],"xy"))
		|| (!strcmp(argv[2],"yz")) ) ) {
		fprintf(stderr,"error: %s: bad keywords. must be xz xy or yz\n", argv[0]);
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &a) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &b) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &c) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &d) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%le", &e) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%d", &n) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	printf("x\ty\tz\n");

	if( !strcmp(argv[2],"xy") ) {
		/* x=(a,b) y=(c,d) z=e */
		/* lines of fixed yz and variable x */
		tangent[0]=1.0; tangent[1]=0.0; tangent[2]=0.0;
		for( i=0; i<3; i++ ) ntangent[i]=(-tangent[i]);
		for( i=0; i<n; i++ ) {
			x[0]=a+epsilon;
			x[1]=(c+epsilon)+(d-c)*(double)(i)/(double)(n-1);
			x[2]=e;
			last_tetra=save_tetra;
			if( find_tetra(x,&t) ) {
				save_tetra=t;
				p = &tetra[t];
				if( ray_exits_tetrahedron( p->x1, p->x2, p->x3,
					p->x4, x, ntangent, epsilon/2.0, normal,
					xi, &s, &face ) ) {
						if( x[0]>(a-epsilon) ) {
							printf("%f\t%f\t%f\n",
							xi[0], xi[1], xi[2] );
							}
						}
					}
			while( t!=(-1) ) {
				if( x[0]>(b+2.0*epsilon) ) break;
				p = &tetra[t];
				if( !ray_exits_tetrahedron( p->x1, p->x2, p->x3,
					p->x4, x, tangent, epsilon/2.0, normal,
					xi, &s, &face ) ) {
						break;
					}
				t=neighbor(t,face);
				for( j=0; j<3; j++ ) x[j]=xi[j]+tangent[j]*epsilon;
				printf("%f\t%f\t%f\n", x[0], x[1], x[2] );
				}
			}
		/* x=(a,b) y=(c,d) z=e */
		/* lines of fixed xz and variable y */
		tangent[0]=0.0; tangent[1]=1.0; tangent[2]=0.0;
		for( i=0; i<3; i++ ) ntangent[i]=(-tangent[i]);
		for( i=0; i<n; i++ ) {
			x[0]=(a+epsilon)+(b-a)*(double)(i)/(double)(n-1);
			x[1]=c+epsilon;
			x[2]=e;
			last_tetra=save_tetra;
			if( find_tetra(x,&t) ) {
				save_tetra=t;
				p = &tetra[t];
				if( ray_exits_tetrahedron( p->x1, p->x2, p->x3,
					p->x4, x, ntangent, epsilon/2.0, normal,
					xi, &s, &face ) ) {
						if( x[1]>(c-epsilon) ) {
							printf("%f\t%f\t%f\n",
							xi[0], xi[1], xi[2] );
							}
						}
					}
			while( t!=(-1) ) {
				if( x[1]>(d+2.0*epsilon) ) break;
				p = &tetra[t];
				if( !ray_exits_tetrahedron( p->x1, p->x2, p->x3,
					p->x4, x, tangent, epsilon/2.0, normal,
					xi, &s, &face ) ) {
						break;
					}
				t=neighbor(t,face);
				for( j=0; j<3; j++ ) x[j]=xi[j]+tangent[j]*epsilon;
				printf("%f\t%f\t%f\n", x[0], x[1], x[2] );
				}
			}
		}
	else if( !strcmp(argv[2],"xz") ) {
		/* x=(a,b) z=(c,d) y=e */
		/* lines of fixed yz and variable x */
		tangent[0]=1.0; tangent[1]=0.0; tangent[2]=0.0;
		for( i=0; i<3; i++ ) ntangent[i]=(-tangent[i]);
		for( i=0; i<n; i++ ) {
			x[0]=a+epsilon;
			x[1]=e;
			x[2]=(c+epsilon)+(d-c)*(double)(i)/(double)(n-1);
			last_tetra=save_tetra;
			if( find_tetra(x,&t) ) {
				save_tetra=t;
				p = &tetra[t];
				if( ray_exits_tetrahedron( p->x1, p->x2, p->x3,
					p->x4, x, ntangent, epsilon/2.0, normal,
					xi, &s, &face ) ) {
						if( x[0]>(a-epsilon) ) {
							printf("%f\t%f\t%f\n",
							xi[0], xi[1], xi[2] );
							}
						}
					}
			while( t!=(-1) ) {
				if( x[0]>(b+2.0*epsilon) ) break;
				p = &tetra[t];
				if( !ray_exits_tetrahedron( p->x1, p->x2, p->x3,
					p->x4, x, tangent, epsilon/2.0, normal,
					xi, &s, &face ) ) {
						break;
					}
				t=neighbor(t,face);
				for( j=0; j<3; j++ ) x[j]=xi[j]+tangent[j]*epsilon;
				printf("%f\t%f\t%f\n", x[0], x[1], x[2] );
				}
			}
		/* x=(a,b) z=(c,d) y=e */
		/* lines of fixed xy and variable z */
		tangent[0]=0.0; tangent[1]=0.0; tangent[2]=1.0;
		for( i=0; i<3; i++ ) ntangent[i]=(-tangent[i]);
		for( i=0; i<n; i++ ) {
			x[0]=(a+epsilon)+(b-a)*(double)(i)/(double)(n-1);
			x[1]=e;
			x[2]=c+epsilon;
			last_tetra=save_tetra;
			if( find_tetra(x,&t) ) {
				save_tetra=t;
				p = &tetra[t];
				if( ray_exits_tetrahedron( p->x1, p->x2, p->x3,
					p->x4, x, ntangent, epsilon/2.0, normal,
					xi, &s, &face ) ) {
						if( x[2]>(c-epsilon) ) {
							printf("%f\t%f\t%f\n",
							xi[0], xi[1], xi[2] );
							}
						}
					}
			while( t!=(-1) ) {
				if( x[2]>(d+2.0*epsilon) ) break;
				p = &tetra[t];
				if( !ray_exits_tetrahedron( p->x1, p->x2, p->x3,
					p->x4, x, tangent, epsilon/2.0, normal,
					xi, &s, &face ) ) {
						break;
					}
				t=neighbor(t,face);
				for( j=0; j<3; j++ ) x[j]=xi[j]+tangent[j]*epsilon;
				printf("%f\t%f\t%f\n", x[0], x[1], x[2] );
				}
			}
		}
	if( !strcmp(argv[2],"yz") ) {
		/* y=(a,b) z=(c,d) x=e */
		/* lines of fixed xz and variable y */
		tangent[0]=0.0; tangent[1]=1.0; tangent[2]=0.0;
		for( i=0; i<3; i++ ) ntangent[i]=(-tangent[i]);
		for( i=0; i<n; i++ ) {
			x[0]=e;
			x[1]=a+epsilon;
			x[2]=(c+epsilon)+(d-c)*(double)(i)/(double)(n-1);
			last_tetra=save_tetra;
			if( find_tetra(x,&t) ) {
				save_tetra=t;
				p = &tetra[t];
				if( ray_exits_tetrahedron( p->x1, p->x2, p->x3,
					p->x4, x, ntangent, epsilon/2.0, normal,
					xi, &s, &face ) ) {
						if( x[1]>(a-epsilon) ) {
							printf("%f\t%f\t%f\n",
							xi[0], xi[1], xi[2] );
							}
						}
					}
			while( t!=(-1) ) {
				if( x[1]>(b+2.0*epsilon) ) break;
				p = &tetra[t];
				if( !ray_exits_tetrahedron( p->x1, p->x2, p->x3,
					p->x4, x, tangent, epsilon/2.0, normal,
					xi, &s, &face ) ) {
						break;
					}
				t=neighbor(t,face);
				for( j=0; j<3; j++ ) x[j]=xi[j]+tangent[j]*epsilon;
				printf("%f\t%f\t%f\n", x[0], x[1], x[2] );
				}
			}
		/* y=(a,b) z=(c,d) x=e */
		/* lines of fixed xy and variable z */
		tangent[0]=0.0; tangent[1]=0.0; tangent[2]=1.0;
		for( i=0; i<3; i++ ) ntangent[i]=(-tangent[i]);
		for( i=0; i<n; i++ ) {
			x[0]=e;
			x[1]=(a+epsilon)+(b-a)*(double)(i)/(double)(n-1);
			x[2]=c+epsilon;
			last_tetra=save_tetra;
			if( find_tetra(x,&t) ) {
				save_tetra=t;
				p = &tetra[t];
				if( ray_exits_tetrahedron( p->x1, p->x2, p->x3,
					p->x4, x, ntangent, epsilon/2.0, normal,
					xi, &s, &face ) ) {
						if( x[2]>(c-epsilon) ) {
							printf("%f\t%f\t%f\n",
							xi[0], xi[1], xi[2] );
							}
						}
					}
			while( t!=(-1) ) {
				if( x[2]>(d+2.0*epsilon) ) break;
				p = &tetra[t];
				if( !ray_exits_tetrahedron( p->x1, p->x2, p->x3,
					p->x4, x, tangent, epsilon/2.0, normal,
					xi, &s, &face ) ) {
						break;
					}
				t=neighbor(t,face);
				for( j=0; j<3; j++ ) x[j]=xi[j]+tangent[j]*epsilon;
				printf("%f\t%f\t%f\n", x[0], x[1], x[2] );
				}
			}
		}

	exit(0);
	}





void main_velocity(int argc,char *argv[])
// int argc;
// char *argv[];
{

	double a, b, c, d, e, x[3], hx1, hx2, hy1, hy2;
	double f1, df, g1, dg, f2, df2, v, epsilon, qinv;
	int i, j, n, m, t;
	int start_t;

	epsilon=1.0e-6;

	if( (argc<3) || ((strcmp(argv[2],"hz"))&&argc!=10) || ((!strcmp(argv[2],"hz"))&&argc!=11) ) {
		fprintf(stderr,"purpose: interrogates the velocity model along a plane\n");

		fprintf(stderr,"usage: %s model_file xz xmin xmax nx zmin zmax nz y > output.tsv\n",
			argv[0]);
		fprintf(stderr,"       or\n");
		fprintf(stderr,"usage: %s model_file xy xmin xmax nx ymin ymax ny z > output.tsv\n",
			argv[0]);
		fprintf(stderr,"       or\n");
		fprintf(stderr,"usage: %s model_file yz ymin ymax ny zmin zmax nz x > output.tsv\n",
			argv[0]);
		fprintf(stderr,"       or\n");
		fprintf(stderr,"usage: %s model_file hz x1 y1 x2 y2 nh zmin zmax nz > output.tsv\n",
			argv[0]);

		write_model_blerb(stderr);
		fprintf(stderr,"      xz xy yz are keywords\n");
		fprintf(stderr,"      xmin, xmax ... units in km\n");
		fprintf(stderr,"      output.tsv:\n");
		fprintf(stderr,"      x y z v index_of_tetrahedron\n");
		fprintf(stderr,"      or\n");
		fprintf(stderr,"      x y z v Q index_of_tetrahedron\n");
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( !(     (!strcmp(argv[2],"xz"))
		|| (!strcmp(argv[2],"xy"))
		|| (!strcmp(argv[2],"yz"))
		|| (!strcmp(argv[2],"hz")) ) ) {
		fprintf(stderr,"error: %s: bad keywords. must be xz xy yz or hz\n", argv[0]);
		exit(-1);
		}

	/* start cases xy, xz, yz */
	if( (!strcmp(argv[2],"xz")) || (!strcmp(argv[2],"xy")) || (!strcmp(argv[2],"yz")) ) {

	if( sscanf(argv[3], "%le", &a) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &b) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%d", &m) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &c) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%le", &d) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%d", &n) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%le", &e) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}



	f1 = a+epsilon; df=(b-a-epsilon)/(double)(m-1);
	g1 = c+epsilon; dg=(d-c-epsilon)/(double)(n-1);

	if( QDEFINED ) printf("x\ty\tz\tv\tQ\ttetra\n");
	else printf("x\ty\tz\tv\ttetra\n");

	if( !strcmp(argv[2],"xz") ) {
		start_t=last_tetra;
		for( i=0; i<m; i++ ) for( j=0; j<n; j++ ) {
			if( j==0 ) last_tetra=start_t;
			x[0]=f1+df*(double)i;
			x[1]=e;
			x[2]=g1+dg*(double)j;
			if( find_tetra(x,&t) ) {
				if( j==0 ) start_t=t;
				v = eval_velocity(&tetra[t],x);
				if( QDEFINED ) {
					qinv = eval_qinv(&tetra[t],x);
					printf("%f\t%f\t%f\t%f\t%f\t%d\n", x[0], x[1], x[2], v, 1.0/qinv, t );
					}
				else printf("%f\t%f\t%f\t%f\t%d\n", x[0], x[1], x[2], v, t );
				}
			}
		}
	else if( !strcmp(argv[2],"xy") ) {
		start_t=last_tetra;
		for( i=0; i<m; i++ ) for( j=0; j<n; j++ ) {
			if( j==0 ) last_tetra=start_t;
			x[0]=f1+df*(double)i;
			x[1]=g1+dg*(double)j;
			x[2]=e;
			if( find_tetra(x,&t) ) {
				if( j==0 ) start_t=t;
				v = eval_velocity(&tetra[t],x);
				if( QDEFINED ) {
					qinv = eval_qinv(&tetra[t],x);
					printf("%f\t%f\t%f\t%f\t%f\t%d\n", x[0], x[1], x[2], v, 1.0/qinv, t );
					}
				else printf("%f\t%f\t%f\t%f\t%d\n", x[0], x[1], x[2], v, t );
				}
			}
		}
	else if( !strcmp(argv[2],"yz") ) {
		start_t=last_tetra;
		for( i=0; i<m; i++ ) for( j=0; j<n; j++ ) {
			if( j==0 ) last_tetra=start_t;
			x[0]=e;
			x[1]=f1+df*(double)i;
			x[2]=g1+dg*(double)j;
			if( find_tetra(x,&t) ) {
				if( j==0 ) start_t=t;
				v = eval_velocity(&tetra[t],x);
				if( QDEFINED ) {
					qinv = eval_qinv(&tetra[t],x);
					printf("%f\t%f\t%f\t%f\t%f\t%d\n", x[0], x[1], x[2], v, 2.0/qinv, t );
				}
				else printf("%f\t%f\t%f\t%f\t%d\n", x[0], x[1], x[2], v, t );
				}
			}
		}
	}

	/* start case hz */
	else {

	if( sscanf(argv[3], "%le", &hx1) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &hy1) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &hx2) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &hy2) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%d", &m) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%le", &c) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%le", &d) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10], "%d", &n) != 1 ) {
		fprintf(stderr,"error: %s: cant read parameter from command line\n",
			argv[0] );
		exit(-1);
		}

	f1 = hx1+epsilon; df=(hx2-hx1-epsilon)/(double)(m-1);
	f2 = hy1+epsilon; df2=(hy2-hy1-epsilon)/(double)(m-1);
	g1 = c+epsilon; dg=(d-c-epsilon)/(double)(n-1);

	if( QDEFINED ) printf("x\ty\tz\tv\tQ\ttetra\n");
	else printf("x\ty\tz\tv\ttetra\n");

	if( !strcmp(argv[2],"hz") ) {
		start_t=last_tetra;
		for( i=0; i<m; i++ ) for( j=0; j<n; j++ ) {
			if( j==0 ) last_tetra=start_t;
			x[0]=f1+df*(double)i;
			x[1]=f2+df2*(double)i;;
			x[2]=g1+dg*(double)j;
			if( find_tetra(x,&t) ) {
				if( j==0 ) start_t=t;
				v = eval_velocity(&tetra[t],x);
				if( QDEFINED ) {
					qinv = eval_qinv(&tetra[t],x);
					printf("%f\t%f\t%f\t%f\t%f\t%d\n", x[0], x[1], x[2], v, 1.0/qinv, t );
					}
				else printf("%f\t%f\t%f\t%f\t%d\n", x[0], x[1], x[2], v, t );
				}
			}
		}



		}

	exit(0);
	}


void main_point(int argc,char *argv[])
// int argc;
// char *argv[];
{

	double x[3], v, qinv;
	int t;

	if( argc!=5 ) {
		fprintf(stderr,"purpose: interrogrates the velocity model at a point\n");
		fprintf(stderr,"usage: %s model_file x y z > output\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      (x, y, z) cartesian coordinates, +z is down\n");
		fprintf(stderr,"      x, y, z in km\n");
		fprintf(stderr,"      output:\n");
		fprintf(stderr,"      x y z v index_of_tetrahedron\n");
		fprintf(stderr,"      or, when Q is defined in the model\n");
		fprintf(stderr,"      x y z v Q index_of_tetrahedron\n");

		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2], "%le", &x[0]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_x from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &x[1]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_y from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &x[2]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_z from command line\n", argv[0] );
		exit(-1);
		}

	if( !find_tetra(x,&t) ) {
		printf("\not in model\n");
		}
	else {
		v = eval_velocity(&tetra[t],x);
		if( QDEFINED ) {
			qinv = eval_qinv(&tetra[t],x);
			printf("%f\t%f\t%f\t%f\t%f\t%d\n", x[0], x[1], x[2], v, 1.0/qinv, t);
			}
		else printf("%f\t%f\t%f\t%f\t%d\n", x[0], x[1], x[2], v, t);
		}

	exit(0);
	}

void main_point_list(int argc,char *argv[])
// int argc;
// char *argv[];
{

	double x[3], v, qinv;
	int t;

	if( argc!=2 ) {
		fprintf(stderr,"purpose: interrogrates the velocity model at a list of points\n");
		fprintf(stderr,"usage: %s model_file < x_y_z.txt > output.txt\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      x_y_z.txt: list of x y z points, one per line\n");
		fprintf(stderr,"          (x, y, z) are cartesian coordinates in km, +z is down\n");
		fprintf(stderr,"      output.txt:\n");
		fprintf(stderr,"          list of x y z v index_of_tetrahedron\n");
		fprintf(stderr,"          or, when Q is defined in the model\n");
		fprintf(stderr,"          x y z v Q index_of_tetrahedron\n");
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	while( scanf("%le%le%le", &x[0], &x[1], &x[2] ) == 3 ) {

		if( !find_tetra(x,&t) ) {
			continue;
			}
		else {
			v = eval_velocity(&tetra[t],x);
			if( QDEFINED ) {
				qinv = eval_qinv(&tetra[t],x);
				printf("%f\t%f\t%f\t%f\t%f\t%d\n", x[0], x[1], x[2], v, 1.0/qinv, t);
				}
			else printf("%f\t%f\t%f\t%f\t%d\n", x[0], x[1], x[2], v, t);
			}

		}

	exit(0);
	}


void main_shootarc(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, interface, hitflag, n_arcs, n, status, nrays, ec;
//	int n1, n2, n3, n4, n5, n6, n7, n8; //unused
	double x0[3], t0[3], x1[3], t1[3], stheta, ftheta, dtheta, theta, azi; // v[4], //unused
	struct arc_rec arc[MAX_ARCS];
	double traveltime, rayx[8000], rayy[8000], rayz[8000], qinvint;
	int tindex[8000];
	FILE *ttfile, *rayfile;

	if( argc!=12 ) {
		fprintf(stderr,"purpose: shoots rays in a arc pattern from a point\n");
		fprintf(stderr,"usage: %s model_file source_x source_y source_z azimuth theta_min theta_max n_thetas target_interface traveltime_file.tsv ray_file.tsv\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      (x, y, z) cartesian coordinates, +z is down\n");
		fprintf(stderr,"      source_x, source_y, source_z in km\n");
		fprintf(stderr,"      azimuth, degrees from +x to +y\n");
		fprintf(stderr,"      theta_min, theta_max, 0-180 degrees from +z\n");
		fprintf(stderr,"      n_thetas n integer, is number of rays\n");
		fprintf(stderr,"      target_interface to shoot for (must match model)\n");
		write_traveltime_blerb(stderr);
		write_ray_blerb(stderr);
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2], "%le", &x0[0]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_x from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &x0[1]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_y from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &x0[2]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_z from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &azi) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimuth from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &stheta) != 1 ) {
		fprintf(stderr,"error: %s: cant read theta_min from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%le", &ftheta) != 1 ) {
		fprintf(stderr,"error: %s: cant read theta_max from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%d", &nrays) != 1 ) {
		fprintf(stderr,"error: %s: cant read n_thetas from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%d", &interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read target_interface from command line\n", argv[0] );
		exit(-1);
		}

	if( (ttfile=fopen(argv[10],"w")) == NULL ) {
		fprintf(stderr,"error: %s: cant open traveltime file <%s> for write\n",
			argv[0], argv[10]);
		exit(-1);
		}

	if( !strcmp(argv[11],"-") ) {
		rayfile=stdout;
		}
	else if( (rayfile=fopen(argv[11],"w")) == NULL ) {
		fprintf(stderr,"error: %s cant open ray file <%s> for write\n",
			argv[0], argv[11] );
		exit(-1);
		}

	if( QDEFINED ) {
		fprintf(ttfile,"id\tx0\ty0\tz0\tx1\ty2\tz1\tT\tQ\n");
		}
	else {
		fprintf(ttfile,"id\tx0\ty0\tz0\tx1\ty2\tz1\tT\n");
		}
	fprintf(rayfile,"id\tx\ty\tz\ttetra\n");

	dtheta = (ftheta-stheta)/(double)(nrays-1);

	for( j=0; j<nrays; j++ ) {

		theta=stheta+dtheta*(double)j;
		ray_tangent(theta,azi,t0);
		status=shoot_to_interface( x0, t0, x1, t1, arc, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec );
		if( status&&hitflag ) {
			if( QDEFINED ) fprintf(ttfile,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n", j,
				x0[0], x0[1], x0[2], x1[0], x1[1], x1[2], traveltime,
				traveltime/qinvint);
			else fprintf(ttfile,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n", j,
				x0[0], x0[1], x0[2], x1[0], x1[1], x1[2], traveltime);
			arcstoxyz( arc, n_arcs, rayx, rayy, rayz, tindex, 1.0, &n, 8000 );
			for( i=0; i<n; i++ ) {
				fprintf(rayfile, "%d\t%f\t%f\t%f\t%d\n",
					j, rayx[i], rayy[i], rayz[i], tindex[i] );
				}
			}
		if( !status ) {
			fprintf(stderr,"warning: lost ray %d (error code %d)\n", j, ec );
			}
		}

	exit(0);
	}

void main_shootarcrefl(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, interface, rinterface, hitflag, n_arcs, n, status, nrays, ec;
//	int n1, n2, n3, n4, n5, n6, n7, n8; //unused
	double x0[3], t0[3], x1[3], t1[3], stheta, ftheta, dtheta, theta, azi; //   v[4],//unused
	struct arc_rec arc[MAX_ARCS];
	double traveltime, rayx[8000], rayy[8000], rayz[8000], qinvint;
	int tindex[8000];
	FILE *ttfile, *rayfile;

	if( argc!=13 ) {
		fprintf(stderr,"purpose: shoots reflected rays in a arc pattern from a point\n");
		fprintf(stderr,"usage: %s model_file source_x source_y source_z azimuth theta_min theta_max n_thetas target_interface reflector_interface traveltime_file.tsv ray_file.tsv\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      (x, y, z) cartesian coordinates, +z is down\n");
		fprintf(stderr,"      source_x, source_y, source_z in km\n");
		fprintf(stderr,"      azimuth, degrees from +x to +y\n");
		fprintf(stderr,"      theta_min, theta_max, 0-180 degrees from +z\n");
		fprintf(stderr,"      n_thetas n integer, is number of rays\n");
		fprintf(stderr,"      target_interface to shoot for (must match model)\n");
		fprintf(stderr,"      reflector_interface to reflect from (must match model)\n");
		write_traveltime_blerb(stderr);
		write_ray_blerb(stderr);
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2], "%le", &x0[0]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_x from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &x0[1]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_y from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &x0[2]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_z from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &azi) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimuth from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &stheta) != 1 ) {
		fprintf(stderr,"error: %s: cant read theta_min from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%le", &ftheta) != 1 ) {
		fprintf(stderr,"error: %s: cant read theta_max from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%d", &nrays) != 1 ) {
		fprintf(stderr,"error: %s: cant read n_thetas from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%d", &interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read target_interface from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10], "%d", &rinterface) != 1 ) {
		fprintf(stderr,"error: %s: cant read reflector_interface from command line\n", argv[0] );
		exit(-1);
		}


	if( (ttfile=fopen(argv[11],"w")) == NULL ) {
		fprintf(stderr,"error: %s: cant open traveltime file <%s> for write\n",
			argv[0], argv[11]);
		exit(-1);
		}

	if( !strcmp(argv[12],"-") ) {
		rayfile=stdout;
		}
	else if( (rayfile=fopen(argv[12],"w")) == NULL ) {
		fprintf(stderr,"error: %s cant open ray file <%s> for write\n",
			argv[0], argv[12] );
		exit(-1);
		}

	if( QDEFINED ) {
		fprintf(ttfile,"id\tx0\ty0\tz0\tx1\ty2\tz1\tT\tQ\n");
		}
	else {
		fprintf(ttfile,"id\tx0\ty0\tz0\tx1\ty2\tz1\tT\n");
		}
	fprintf(rayfile,"id\tx\ty\tz\ttetra\n");

	dtheta = (ftheta-stheta)/(double)(nrays-1);

	for( j=0; j<nrays; j++ ) {

		theta=stheta+dtheta*(double)j;
		ray_tangent(theta,azi,t0);
		status=shoot_to_interface_refl( x0, t0, x1, t1, arc, &n_arcs,
			MAX_ARCS, 10000.0, interface, rinterface, &hitflag, &traveltime,
			&qinvint, &ec );
		if( status&&hitflag ) {
			if( QDEFINED ) fprintf(ttfile,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n", j,
				x0[0], x0[1], x0[2], x1[0], x1[1], x1[2], traveltime,
				traveltime/qinvint);
			else fprintf(ttfile,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n", j,
				x0[0], x0[1], x0[2], x1[0], x1[1], x1[2], traveltime);
			arcstoxyz( arc, n_arcs, rayx, rayy, rayz, tindex, 1.0, &n, 8000 );
			for( i=0; i<n; i++ ) {
				fprintf(rayfile, "%d\t%f\t%f\t%f\t%d\n",
					j, rayx[i], rayy[i], rayz[i], tindex[i] );
				}
			}
		if( !status ) {
			fprintf(stderr,"warning: lost ray %d (error code %d)\n", j, ec );
			}
		}

	exit(0);
	}

void main_shootstar(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int j, k, interface, hitflag, n_arcs, status, n_azis, n_thetas, ec; // i,n //unused
//	int n1, n2, n3, n4, n5, n6, n7, n8; //unused
	double x0[3], t0[3], x1[3], t1[3]; //, v[4]; //unused
	double stheta, ftheta, dtheta, theta, qinvint;
	double sazi, fazi, dazi, azi;
	double traveltime;

	if( argc!=12 ) {
		fprintf(stderr,"purpose: shoots rays in a star pattern from a point\n");
		fprintf(stderr,"	 (constant azimuth and angle of incident increments)\n");

		fprintf(stderr,"usage: %s model_file source_x source_y source_z theta_min theta_max n_thetas azi_min azi_max n_azis target_interface > star_file.tsv\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      source_x, source_y, source_z in km\n");
		fprintf(stderr,"      theta_min, theta_max, 0-180 degrees from +z\n");
		fprintf(stderr,"      azi_min, azi_max, degrees from +x to +y\n");
		fprintf(stderr,"          azi_min<azi_max, but values > 360 allowed\n");
		fprintf(stderr,"      n_thetas, n_azis, integers, control the number of rays\n");
		fprintf(stderr,"      target_interface to shoot for (must match model)\n");
		fprintf(stderr,"      star_file.tsv contains:\n");
		fprintf(stderr,"          theta_index\n");
		fprintf(stderr,"          azi_index\n");
		fprintf(stderr,"          theta in degrees\n");
		fprintf(stderr,"          azimuth in degrees\n");
		fprintf(stderr,"          final x in km\n");
		fprintf(stderr,"          final y in km\n");
		fprintf(stderr,"          final z in km\n");
		fprintf(stderr,"          traveltime in s\n");
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2], "%le", &x0[0]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_x from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &x0[1]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_y from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &x0[2]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_z from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &stheta) != 1 ) {
		fprintf(stderr,"error: %s: cant read theta_min from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &ftheta) != 1 ) {
		fprintf(stderr,"error: %s: cant read theta_max from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%d", &n_thetas) != 1 ) {
		fprintf(stderr,"error: %s: cant read n_thetas from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%le", &sazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read azi_min from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%le", &fazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read azi_max from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10], "%d", &n_azis) != 1 ) {
		fprintf(stderr,"error: %s: cant read n_azis from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[11], "%d", &interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read target_interface from command line\n", argv[0] );
		exit(-1);
		}

	printf("th_%d\taz_%d\ttheta\tazimuth\tx\ty\tz\tT\n", n_thetas, n_azis);

	dtheta = (ftheta-stheta)/(double)(n_thetas-1);
	dazi = (fazi-sazi)/(double)(n_azis-1);

	for( j=0; j<n_azis; j++ ) for( k=0; k<n_thetas; k++ ) {
		azi=sazi+dazi*(double)j;
		theta=stheta+dtheta*(double)k;
		ray_tangent(theta,azi,t0);
		status=shoot_to_interface( x0, t0, x1, t1, NULL, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec );
		if( status&&hitflag ) {
			printf("%d\t%d\t%f\t%f\t%f\t%f\t%f\t%f\n", k, j,
				theta, azi, x1[0], x1[1], x1[2], traveltime);
			}
		if( !status ) {
			fprintf(stderr,"warning: lost ray (%d %d) error code (%d)\n", j, k, ec );
			}
		}

	exit(0);
	}

void main_shootstarrefl(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int j, k, interface, rinterface, hitflag, n_arcs, status, n_azis, n_thetas, ec; // i,n //unused
//	int n1, n2, n3, n4, n5, n6, n7, n8; //unused
	double x0[3], t0[3], x1[3], t1[3]; // , v[4];//unused
	double stheta, ftheta, dtheta, theta, qinvint;
	double sazi, fazi, dazi, azi;
	double traveltime;

	if( argc!=13 ) {
		fprintf(stderr,"purpose: shoots relected rays in a star pattern from a point\n");
		fprintf(stderr,"	 (constant azimuth and angle of incident increments)\n");

		fprintf(stderr,"usage: %s model_file source_x source_y source_z theta_min theta_max n_thetas azi_min azi_max n_azis target_interface reflector_interface > star_file.tsv\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      source_x, source_y, source_z in km\n");
		fprintf(stderr,"      theta_min, theta_max, 0-180 degrees from +z\n");
		fprintf(stderr,"      azi_min, azi_max, degrees from +x to +y\n");
		fprintf(stderr,"          azi_min<azi_max, but values > 360 allowed\n");
		fprintf(stderr,"      n_thetas, n_azis, integers, control the number of rays\n");
		fprintf(stderr,"      target_interface to shoot for (must match model)\n");
		fprintf(stderr,"      reflector_interface to shoot for (must match model)\n");
		fprintf(stderr,"      star_file.tsv contains:\n");
		fprintf(stderr,"          theta_index\n");
		fprintf(stderr,"          azi_index\n");
		fprintf(stderr,"          theta in degrees\n");
		fprintf(stderr,"          azimuth in degrees\n");
		fprintf(stderr,"          final x in km\n");
		fprintf(stderr,"          final y in km\n");
		fprintf(stderr,"          final z in km\n");
		fprintf(stderr,"          traveltime in s\n");
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2], "%le", &x0[0]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_x from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &x0[1]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_y from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &x0[2]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_z from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &stheta) != 1 ) {
		fprintf(stderr,"error: %s: cant read theta_min from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &ftheta) != 1 ) {
		fprintf(stderr,"error: %s: cant read theta_max from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%d", &n_thetas) != 1 ) {
		fprintf(stderr,"error: %s: cant read n_thetas from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%le", &sazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read azi_min from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%le", &fazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read azi_max from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10], "%d", &n_azis) != 1 ) {
		fprintf(stderr,"error: %s: cant read n_azis from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[11], "%d", &interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read target_interface from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[12], "%d", &rinterface) != 1 ) {
		fprintf(stderr,"error: %s: cant read reflector_interface from command line\n", argv[0] );
		exit(-1);
		}

	printf("th_%d\taz_%d\ttheta\tazimuth\tx\ty\tz\tT\n", n_thetas, n_azis);

	dtheta = (ftheta-stheta)/(double)(n_thetas-1);
	dazi = (fazi-sazi)/(double)(n_azis-1);

	for( j=0; j<n_azis; j++ ) for( k=0; k<n_thetas; k++ ) {
		azi=sazi+dazi*(double)j;
		theta=stheta+dtheta*(double)k;
		ray_tangent(theta,azi,t0);
		status=shoot_to_interface_refl( x0, t0, x1, t1, NULL, &n_arcs,
			MAX_ARCS, 10000.0, interface, rinterface,
			&hitflag, &traveltime, &qinvint, &ec );
		if( status&&hitflag ) {
			printf("%d\t%d\t%f\t%f\t%f\t%f\t%f\t%f\n", k, j,
				theta, azi, x1[0], x1[1], x1[2], traveltime);
			}
		if( !status ) {
			fprintf(stderr,"warning: lost ray (%d %d) error code (%d)\n", j, k, ec );
			}
		}

	exit(0);
	}

void main_shootturf(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int j, k, interface, hitflag, n_arcs, status, n_x, n_y, ec; // i,n //unused
// 	int n1, n2, n3, n4, n5, n6, n7, n8; //unused
	double theta, azi, v0, vp, z0, T0, px, py, xmin, xmax, ymin, ymax, dx, dy;
	double x0[3], t0[3], x1[3], t1[3], qinvint; //v[4],  //unused
	double traveltime;
	int t, my_last_tetra;

	my_last_tetra=(-1);

	if( argc!=13 ) {
		fprintf(stderr,"purpose: shoots teleseismic rays in a grid pattern from a plane\n");
		fprintf(stderr,"	 (constant x and y increments)\n");

		fprintf(stderr,"usage: %s model_file azimuth apparent_velocity z0 t0 x_min x_max n_x y_min y_max n_y target_interface > turf_file.tsv\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      teleseismic azimuth in deg\n");
		fprintf(stderr,"      teleseismic apparent velocity in km/s\n");
		fprintf(stderr,"      teleseism crosses point (0,0,z0) at time t0\n");
		fprintf(stderr,"      	(z0 in km, t0 in s)");
		fprintf(stderr,"      x_min, x_max in km; integer n_x\n");
		fprintf(stderr,"      y_min, y_max in km; integer n_y\n");
		fprintf(stderr,"      target_interface to shoot for (must match model)\n");
		fprintf(stderr,"      star_file.tsv contains:\n");
		fprintf(stderr,"          x_index\n");
		fprintf(stderr,"          y_index\n");
		fprintf(stderr,"          x in km\n");
		fprintf(stderr,"          y in km\n");
		fprintf(stderr,"          final x in km\n");
		fprintf(stderr,"          final y in km\n");
		fprintf(stderr,"          final z in km\n");
		fprintf(stderr,"          traveltime in s\n");
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2], "%le", &azi) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimuth from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &v0) != 1 ) {
		fprintf(stderr,"error: %s: cant read apparent velocity from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &z0) != 1 ) {
		fprintf(stderr,"error: %s: cant read z0 from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &T0) != 1 ) {
		fprintf(stderr,"error: %s: cant read t0 from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &xmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read x_min from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%le", &xmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read x_max from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%d", &n_x) != 1 ) {
		fprintf(stderr,"error: %s: cant read n_x from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%le", &ymin) != 1 ) {
		fprintf(stderr,"error: %s: cant read y_min from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10], "%le", &ymax) != 1 ) {
		fprintf(stderr,"error: %s: cant read y_max from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[11], "%d", &n_y) != 1 ) {
		fprintf(stderr,"error: %s: cant read n_y from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[12], "%d", &interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read target_interface from command line\n", argv[0] );
		exit(-1);
		}

	printf("x_%d\ty_%d\tx0\ty0\tx\ty\tz\tT\n", n_x, n_y);

	dx = (xmax-xmin)/(double)(n_x-1);
	dy = (ymax-ymin)/(double)(n_y-1);

	for( j=0; j<n_x; j++ ) for( k=0; k<n_y; k++ ) {

		x0[0]=xmin+dx*(double)j;
		x0[1]=ymin+dy*(double)k; /*Bug; dy was dx; fixed 6/6/3 by Menke on the advice of Zor */
		x0[2]=z0;
		last_tetra=my_last_tetra;
		if( find_tetra(x0,&t) ) {
			vp = eval_velocity(&tetra[t],x0);
			}
		else continue;
		if( vp>=v0 ) continue;
		my_last_tetra=last_tetra;
		theta = 180.0-RTOD*asin(vp/v0);
		ray_tangent(theta,azi,t0);
		px = t0[0]/vp; py=t0[1]/vp;
		status=shoot_to_interface( x0, t0, x1, t1, NULL, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec );
		if( status&&hitflag ) {
			traveltime += T0 + px*x0[0] + py*x0[1];
			/* bug fix; Menke 3/7/01; k, j to j, k in following printf */
			printf("%d\t%d\t%f\t%f\t%f\t%f\t%f\t%f\n", j, k,
				x0[0], x0[1], x1[0], x1[1], x1[2], traveltime);
			}
		if( !status ) {
			fprintf(stderr,"warning: lost ray (%d %d) error code (%d)\n", j, k, ec );
			}
		}

	exit(0);
	}


void main_shootstarp(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int j, k, interface, hitflag, n_arcs, status, n_azis, n_vels, ec; //i,n //unused
//	int n1, n2, n3, n4, n5, n6, n7, n8; //unused
	double x0[3], t0[3], x1[3], t1[3]; //, v[4]; //unused
	double pmin, p, vmin, vmax, dp, theta;
	double sazi, fazi, dazi, azi;
	double traveltime, qinvint;
	double v0;
	int myt;

	if( argc!=12 ) {
		fprintf(stderr,"purpose: shoots rays in a star pattern from a point\n");
		fprintf(stderr,"	 (constant azimuth and hoizontal slowness increments)\n");

		fprintf(stderr,"usage: %s model_file source_x source_y source_z v_min v_max n_thetas azi_min azi_max n_azis target_interface > star.tsv\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      source_x, source_y, source_z in km\n");
		fprintf(stderr,"      v_min, v_max, apparent velocity in km/s\n");
		fprintf(stderr,"          (downgoing rays only)\n");
		fprintf(stderr,"      azi_min, azi_max, degrees from +x to +y\n");
		fprintf(stderr,"          azi_min<azi_max, but values > 360 allowed\n");
		fprintf(stderr,"      n_velocities, n_azis, integers, control the number of rays\n");
		fprintf(stderr,"      target_interface to shoot for (must match model)\n");
		fprintf(stderr,"      star.tsv contains:\n");
		fprintf(stderr,"          theta_index\n");
		fprintf(stderr,"          azi_index\n");
		fprintf(stderr,"          theta in degrees\n");
		fprintf(stderr,"          azimuth in degrees\n");
		fprintf(stderr,"          final x in km\n");
		fprintf(stderr,"          final y in km\n");
		fprintf(stderr,"          final z in km\n");
		fprintf(stderr,"          traveltime in s\n");
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2], "%le", &x0[0]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_x from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &x0[1]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_y from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &x0[2]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_z from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &vmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read v_min from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &vmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read v_max from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%d", &n_vels) != 1 ) {
		fprintf(stderr,"error: %s: cant read n_velocities from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%le", &sazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read azi_min from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%le", &fazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read azi_max from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10], "%d", &n_azis) != 1 ) {
		fprintf(stderr,"error: %s: cant read n_azis from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[11], "%d", &interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read target_interface from command line\n", argv[0] );
		exit(-1);
		}

	if( find_tetra(x0,&myt) ) {
		v0 = eval_velocity(&tetra[myt],x0);
		}
	else {
		fprintf(stderr,"error: %s: cant find velocity at source\n", argv[0] );
		exit(-1);
		}

	printf("th_%d\taz_%d\ttheta\tazimuth\tx\ty\tz\tT\n", n_vels, n_azis);

	dazi = (fazi-sazi)/(double)(n_azis-1);
	pmin = 1.0/vmax;
	dp = ((1.0/vmin)-(1.0/vmax))/(double)(n_vels-1);


	for( j=0; j<n_azis; j++ ) for( k=0; k<n_vels; k++ ) {
		azi=sazi+dazi*(double)j;
		p=pmin+dp*(double)k;
		if( fabs(v0*p)>1.0 ) break;
		theta=RTOD*asin(v0*p); 
		ray_tangent(theta,azi,t0);
		status=shoot_to_interface( x0, t0, x1, t1, NULL, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec );
		if( status&&hitflag ) {
			printf("%d\t%d\t%f\t%f\t%f\t%f\t%f\t%f\n", k, j,
				theta, azi, x1[0], x1[1], x1[2], traveltime);
			}
		if( !status ) {
			fprintf(stderr,"warning: lost ray (%d %d), (error code %d)\n", j, k, ec );
			}
		}

	exit(0);
	}

void main_stor(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, l, interface, hitflag, n_arcs, n, nrays, order, ec, in_count; //  k,status, //unused
//	int n1, n2, n3, n4, n5, n6, n7, n8; //unused
	double x0[3], t0[3], x1[3], t1[3]; //, stheta, ftheta, dtheta, theta, azi, v[4]; //unused
	struct arc_rec arc[MAX_ARCS];
	double traveltime, rayx[8000], rayy[8000], rayz[8000];
	int tindex[8000];
	FILE *stafile, *ttfile, *rayfile;
	char ct[128];
	double xsta, ysta, zsta, ratio, T0, Ta, th_est, az_est, qinvint;
	struct triangle_rec tri;
	double geo_spr;

	if( argc!=10 ) {
		fprintf(stderr,"purpose: point-to-point raytracing from a common source to a set of receivers\n");
		fprintf(stderr,"usage: %s model_file source_x source_y source_z star.tsv target_interface receivers.tsv predicted_tt_file.tsv ray_file.tsv\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      source_x, source_y, source_z in km\n");
		fprintf(stderr,"      star.tsv: previously computed\n");
		fprintf(stderr,"      target_interface to shoot for (must match model)\n");
		fprintf(stderr,"      input receivers.tsv:\n");
		fprintf(stderr,"              x, y, z, location in km\n");
		fprintf(stderr,"                  (but be warned; z not used!)\n");
		fprintf(stderr,"              T0, origin time in s\n");
		fprintf(stderr,"              T,  arival time in s\n");
		fprintf(stderr,"              ratio, 1 for P 1.76 (or whatever) for S\n");
		fprintf(stderr,"	      order, 0 for 1-st arrival, 1 for second, etc; or\n");
		fprintf(stderr,"	          order=(-1) causes program to pick closest arrival\n");
		write_predictions_blerb(stderr);
		write_ray_blerb(stderr);
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2], "%le", &x0[0]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_x from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &x0[1]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_y from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &x0[2]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_z from command line\n", argv[0] );
		exit(-1);
		}

	if( !load_star_file(argv[5]) ) {
		fprintf(stderr,"error: %s: cant load star.tsv <%s>\n", argv[0], argv[5] );
		exit(-1);
		}

	if( sscanf(argv[6], "%d", &interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read target_interface from command line\n", argv[0] );
		exit(-1);
		}

	if( (stafile=fopen(argv[7],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open receivers.tsv <%s> for read\n",
			argv[0], argv[7]);
		exit(-1);
		}
	if( fscanf(stafile,"%s%s%s%s%s%s%s", ct,ct,ct,ct,ct,ct,ct ) != 7 ) {
		fprintf(stderr,"error: %s: cant skip header in receivers.tsv <%s>\n",
			argv[0], argv[7]);
		exit(-1);
		}

	if( (ttfile=fopen(argv[8],"w")) == NULL ) {
		fprintf(stderr,"error: %s: cant open predicted_tt_file.tsv <%s> for write\n",
			argv[0], argv[8]);
		exit(-1);
		}

	if( !strcmp(argv[9],"-") ) {
		rayfile=stdout;
		}
	else if( (rayfile=fopen(argv[9],"w")) == NULL ) {
		fprintf(stderr,"error: %s cant open ray file <%s> for write\n",
			argv[0], argv[9] );
		exit(-1);
		}

	if( QDEFINED ) {
fprintf(ttfile,"id\tx0\ty0\tz0\tx1\ty1\tz1\tT0\tTa\tTT\tT\tdT\tratio\tobs_order\tpre_order\tamplitude\tQ\tntts\n");
		}
	else {
fprintf(ttfile,"id\tx0\ty0\tz0\tx1\ty1\tz1\tT0\tTa\tTT\tT\tdT\tratio\tobs_order\tpre_order\tamplitude\tntts\n");
		}
	fprintf(rayfile,"id\tx\ty\tz\ttetra\n");
	nrays=0; in_count=(-1);
 	while( fscanf(stafile,"%le%le%le%le%le%le%d",&xsta,&ysta,&zsta,&T0,&Ta,&ratio,&order)==7){
		n_tts=0; in_count++;
		for( i=0; i<(m_rays-1); i++ )
		for( j=0; j<(n_rays-1); j++ )
		for( l=0; l<2; l++ ) {
			if( instarbox(i, j, l, xsta, ysta, &th_est,
				&az_est, &tri, x0, interface, &geo_spr) )
			if( refine( x0, xsta, ysta, interface, &th_est, &az_est,
				NULL, &n_arcs, &traveltime, &tri) ) {
			if( (n_tts+2)<MAX_TTS ) {
				tt[n_tts].az=az_est;
				tt[n_tts].th=th_est;
				tt[n_tts].T=traveltime;
				tt[n_tts].gs=geo_spr;
				n_tts++;
				}
			else {
				fprintf(stderr,"error: %s: too many arrivals\n", argv[0]);
				exit(-1);
				}
			}
			}
		qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
		if( order==(-1) ) setorder( tt, n_tts, Ta-T0, ratio, &order );
		for( j=0; j<n_tts; j++ ) {
			ray_tangent(tt[j].th,tt[j].az,t0);
			if( !shoot_to_interface( x0, t0, x1, t1, arc, &n_arcs,
				MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec ) ) {
				continue;
				}
			if( !hitflag ) { continue; }
			if( QDEFINED ) 
			fprintf(ttfile,
			"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%d\t%e\t%f\t%d\n",
			nrays, x0[0], x0[1], x0[2], x1[0], x1[1], x1[2],
			T0, Ta, traveltime*ratio, T0+traveltime*ratio,
		 	Ta-(T0+traveltime*ratio),
			ratio, order, j, 1.0/sqrt(fabs(tt[j].gs)), traveltime/qinvint, in_count );
			else
			fprintf(ttfile,
			"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%d\t%e\t%d\n",
			nrays, x0[0], x0[1], x0[2], x1[0], x1[1], x1[2],
			T0, Ta, traveltime*ratio, T0+traveltime*ratio,
		 	Ta-(T0+traveltime*ratio),
			ratio, order, j, 1.0/sqrt(fabs(tt[j].gs)), in_count );
			n=0;
			arcstoxyz( arc, n_arcs, rayx, rayy, rayz, tindex, 1.0, &n, 8000 );
			for( i=0; i<n; i++ ) {
				fprintf(rayfile, "%d\t%f\t%f\t%f\t%d\n",
					nrays, rayx[i], rayy[i], rayz[i], tindex[i]);
				}
			nrays++;
			}
		}

	exit(0);
	}




void main_storrefl(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, l, interface, rinterface, hitflag, n_arcs, n, nrays, order, ec, in_count; // k, status, //unused
//	int n1, n2, n3, n4, n5, n6, n7, n8; //unused
	double x0[3], t0[3], x1[3], t1[3]; // v[4],  stheta, ftheta, dtheta, theta, azi //unused
	struct arc_rec arc[MAX_ARCS];
	double traveltime, rayx[8000], rayy[8000], rayz[8000];
	int tindex[8000];
	FILE *stafile, *ttfile, *rayfile;
	char ct[128];
	double xsta, ysta, zsta, ratio, T0, Ta, th_est, az_est, qinvint;
	struct triangle_rec tri;
	double geo_spr;

	if( argc!=11 ) {
		fprintf(stderr,"purpose: point-to-point raytracing from a common source to a set of receivers with a single reflection point\n");
		fprintf(stderr,"usage: %s model_file source_x source_y source_z star.tsv target_interface reflector_interface receivers.tsv predicted_tt_file.tsv ray_file.tsv\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      source_x, source_y, source_z in km\n");
		fprintf(stderr,"      star.tsv: previously computed\n");
		fprintf(stderr,"      target_interface to shoot for (must match model)\n");
		fprintf(stderr,"      reflector_interface to reflect from (must match model)\n");
		fprintf(stderr,"      input receivers.tsv:\n");
		fprintf(stderr,"              x, y, z, location in km\n");
		fprintf(stderr,"                  (but be warned; z not used!)\n");
		fprintf(stderr,"              T0, origin time in s\n");
		fprintf(stderr,"              T,  arival time in s\n");
		fprintf(stderr,"              ratio, 1 for P 1.76 (or whatever) for S\n");
		fprintf(stderr,"	      order, 0 for 1-st arrival, 1 for second, etc; or\n");
		fprintf(stderr,"	          order=(-1) causes program to pick closest arrival\n");
		write_predictions_blerb(stderr);
		write_ray_blerb(stderr);
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2], "%le", &x0[0]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_x from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &x0[1]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_y from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &x0[2]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_z from command line\n", argv[0] );
		exit(-1);
		}

	if( !load_star_file(argv[5]) ) {
		fprintf(stderr,"error: %s: cant load star.tsv <%s>\n", argv[0], argv[5] );
		exit(-1);
		}

	if( sscanf(argv[6], "%d", &interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read target_interface from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%d", &rinterface) != 1 ) {
		fprintf(stderr,"error: %s: cant read reflector_interface from command line\n", argv[0] );
		exit(-1);
		}

	if( (stafile=fopen(argv[8],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open receivers.tsv <%s> for read\n",
			argv[0], argv[8]);
		exit(-1);
		}
	if( fscanf(stafile,"%s%s%s%s%s%s%s", ct,ct,ct,ct,ct,ct,ct ) != 7 ) {
		fprintf(stderr,"error: %s: cant skip header in receivers.tsv <%s>\n",
			argv[0], argv[8]);
		exit(-1);
		}

	if( (ttfile=fopen(argv[9],"w")) == NULL ) {
		fprintf(stderr,"error: %s: cant open predicted_tt_file.tsv <%s> for write\n",
			argv[0], argv[9]);
		exit(-1);
		}

	if( !strcmp(argv[10],"-") ) {
		rayfile=stdout;
		}
	else if( (rayfile=fopen(argv[10],"w")) == NULL ) {
		fprintf(stderr,"error: %s cant open ray file <%s> for write\n",
			argv[0], argv[10] );
		exit(-1);
		}

	if( QDEFINED ) {
fprintf(ttfile,"id\tx0\ty0\tz0\tx1\ty1\tz1\tT0\tTa\tTT\tT\tdT\tratio\tobs_order\tpre_order\tamplitude\tQ\ttts\n");
		}
	else {
fprintf(ttfile,"id\tx0\ty0\tz0\tx1\ty1\tz1\tT0\tTa\tTT\tT\tdT\tratio\tobs_order\tpre_order\tamplitude\ttts\n");
		}
	fprintf(rayfile,"id\tx\ty\tz\ttetra\n");
	nrays=0; in_count=(-1);
 	while( fscanf(stafile,"%le%le%le%le%le%le%d",&xsta,&ysta,&zsta,&T0,&Ta,&ratio,&order)==7){
		n_tts=0; in_count++;
		for( i=0; i<(m_rays-1); i++ )
		for( j=0; j<(n_rays-1); j++ )
		for( l=0; l<2; l++ ) {
			if( instarbox_refl(i, j, l, xsta, ysta, &th_est,
				&az_est, &tri, x0, interface, rinterface, &geo_spr) )
			if( refine_refl( x0, xsta, ysta, interface, rinterface, &th_est, &az_est,
				NULL, &n_arcs, &traveltime, &tri) ) {
			if( (n_tts+2)<MAX_TTS ) {
				tt[n_tts].az=az_est;
				tt[n_tts].th=th_est;
				tt[n_tts].T=traveltime;
				tt[n_tts].gs=geo_spr;
				n_tts++;
				}
			else {
				fprintf(stderr,"error: %s: too many arrivals\n", argv[0]);
				exit(-1);
				}
			}
			}
		qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
		if( order==(-1) ) setorder( tt, n_tts, Ta-T0, ratio, &order );
		for( j=0; j<n_tts; j++ ) {
			ray_tangent(tt[j].th,tt[j].az,t0);
			if( !shoot_to_interface_refl( x0, t0, x1, t1, arc, &n_arcs,
				MAX_ARCS, 10000.0, interface, rinterface, &hitflag,
				&traveltime, &qinvint, &ec ) ) {
				continue;
				}
			if( !hitflag ) continue;
			if( QDEFINED ) 
			fprintf(ttfile,
			"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%d\t%e\t%f\t%d\n",
			nrays, x0[0], x0[1], x0[2], x1[0], x1[1], x1[2],
			T0, Ta, traveltime*ratio, T0+traveltime*ratio,
		 	Ta-(T0+traveltime*ratio),
			ratio, order, j, 1.0/sqrt(fabs(tt[j].gs)), traveltime/qinvint, in_count );
			else
			fprintf(ttfile,
			"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%d\t%e\t%d\n",
			nrays, x0[0], x0[1], x0[2], x1[0], x1[1], x1[2],
			T0, Ta, traveltime*ratio, T0+traveltime*ratio,
		 	Ta-(T0+traveltime*ratio),
			ratio, order, j, 1.0/sqrt(fabs(tt[j].gs)), in_count );
			n=0;
			arcstoxyz( arc, n_arcs, rayx, rayy, rayz, tindex, 1.0, &n, 8000 );
			for( i=0; i<n; i++ ) {
				fprintf(rayfile, "%d\t%f\t%f\t%f\t%d\n",
					nrays, rayx[i], rayy[i], rayz[i], tindex[i]);
				}
			nrays++;
			}
		}

	exit(0);
	}


void main_ttor(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, l, interface, hitflag, n_arcs, n, nrays, order, ec, in_count; // status, k, //unused
//	int n1, n2, n3, n4, n5, n6, n7, n8; //unused
	double x0[3], t0[3], x1[3], t1[3], theta, azi, v0, T0, z0, vp; //  v[4],//unused
	struct arc_rec arc[MAX_ARCS];
	double traveltime, rayx[8000], rayy[8000], rayz[8000];
	int tindex[8000];
	FILE *stafile, *ttfile, *rayfile;
	char ct[128];
	double xsta, ysta, zsta, ratio, Ta, x_est, y_est, px, py;
	struct triangle_rec tri;
	int t, my_last_tetra;
	double geo_spr, qinvint;

	if( argc!=11 ) {
		fprintf(stderr,"purpose: plane-wave-to-point raytracing from a common telseismic plane-wave to a set of receivers\n");
		fprintf(stderr,"usage: %s model_file azimuth apparent_velocity z0 t0  turf.tsv target_interface receivers.tsv predicted_tt_file.tsv ray_file.tsv\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      teleseismic azimuth in deg\n");
		fprintf(stderr,"      teleseismic apparent velocity in km/s\n");
		fprintf(stderr,"      teleseism crosses point (0,0,z0) at time t0\n");
		fprintf(stderr,"      	(z0 in km, t0 in s)");
		fprintf(stderr,"      source_x, source_y, source_z in km\n");
		fprintf(stderr,"      star.tsv: previously computed\n");
		fprintf(stderr,"      target_interface to shoot for (must match model)\n");
		fprintf(stderr,"      input receivers.tsv:\n");
		fprintf(stderr,"              x, y, z, location in km\n");
		fprintf(stderr,"                  (but be warned; z not used!)\n");
		fprintf(stderr,"              T,  observed arrival time in s\n");
		fprintf(stderr,"              ratio, 1 for P 1.76 (or whatever) for S\n");
		fprintf(stderr,"                  Ratio provides a means of computing traveltimes\n");
		fprintf(stderr,"                  for a teleseismic S wave through a P wave model,\n");
		fprintf(stderr,"                  by the simple device of raytracing a P wave\n");
		fprintf(stderr,"                  and then multiplying the traveltime by ratio.\n");
		fprintf(stderr,"                  Note however that the apparent velocity of this\n");
		fprintf(stderr,"                  S wave is exactly the P wave apparent velocity,\n");
		fprintf(stderr,"                  as specified on the command line, divided by the ratio.\n");
		fprintf(stderr,"	      order, 0 for 1-st arrival, 1 for second, etc; or\n");
		fprintf(stderr,"	          order=(-1) for program to pick closest arrival\n");

		write_predictions_blerb(stderr);
		write_ray_blerb(stderr);
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2], "%le", &azi) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimuth from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &v0) != 1 ) {
		fprintf(stderr,"error: %s: cant read apparent_velocity from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &z0) != 1 ) {
		fprintf(stderr,"error: %s: cant read z0 from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &T0) != 1 ) {
		fprintf(stderr,"error: %s: cant read t0 from command line\n", argv[0] );
		exit(-1);
		}

	if( !load_turf_file(argv[6]) ) {
		fprintf(stderr,"error: %s: cant load turf.tsv <%s>\n", argv[0], argv[6] );
		exit(-1);
		}

	if( sscanf(argv[7], "%d", &interface) != 1 ) {
		fprintf(stderr,"error: %s: cant read target_interface from command line\n", argv[0] );
		exit(-1);
		}

	if( (stafile=fopen(argv[8],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open receivers.tsv <%s> for read\n",
			argv[0], argv[8]);
		exit(-1);
		}
	if( fscanf(stafile,"%s%s%s%s%s%s", ct,ct,ct,ct,ct,ct ) != 6 ) {
		fprintf(stderr,"error: %s: cant skip header in receivers.tsv <%s>\n",
			argv[0], argv[8]);
		exit(-1);
		}

	if( (ttfile=fopen(argv[9],"w")) == NULL ) {
		fprintf(stderr,"error: %s: cant open predicted_tt_file.tsv <%s> for write\n",
			argv[0], argv[9]);
		exit(-1);
		}

	if( !strcmp(argv[10],"-") ) {
		rayfile=stdout;
		}
	else if( (rayfile=fopen(argv[10],"w")) == NULL ) {
		fprintf(stderr,"error: %s cant open ray file <%s> for write\n",
			argv[0], argv[10] );
		exit(-1);
		}

	if( QDEFINED ) {
	fprintf(ttfile,"id\tx0\ty0\tz0\tx1\ty1\tz1\tT0\tTa\tTT\tT\tdT\tratio\tobs_order\tpre_order\tamplitude\\tQ\tttsn");
		}
else {
fprintf(ttfile,"id\tx0\ty0\tz0\tx1\ty1\tz1\tT0\tTa\tTT\tT\tdT\tratio\tobs_order\tpre_order\tamplitude\ttts\n");
		}
	fprintf(rayfile,"id\tx\ty\tz\ttetra\n");
	nrays=0; in_count=(-1);
 	while( fscanf(stafile,"%le%le%le%le%le%d",&xsta,&ysta,&zsta,&Ta,&ratio,&order)==6){
		n_tts=0; in_count++;
		for( i=0; i<(m_turf-1); i++ )
		for( j=0; j<(n_turf-1); j++ )
		for( l=0; l<2; l++ ) {
			if( inturfbox(i, j, l, xsta, ysta, &x_est,
				&y_est, &tri, x0, interface, azi,v0,z0,T0, &geo_spr) )
			if( refine_turf( x0, xsta, ysta, interface, &x_est, &y_est,
				NULL, &n_arcs, &traveltime, &tri, azi,v0,z0,T0) ) {
			if( (n_tts+2)<MAX_TTS ) {
				tt[n_tts].az=x_est;
				tt[n_tts].th=y_est;
				tt[n_tts].T=traveltime;
				tt[n_tts].gs=geo_spr;
				n_tts++;
				}
			else {
				fprintf(stderr,"error: %s: too many arrivals\n", argv[0]);
				exit(-1);
				}
			}
			}
		qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
		if( order==(-1) ) setorder( tt, n_tts, Ta-T0, ratio, &order );

		for( j=0; j<n_tts; j++ ) {

			x0[0]=tt[j].az;
			x0[1]=tt[j].th;
			x0[2]=z0;
			last_tetra=my_last_tetra;
			if( find_tetra(x0,&t) ) {
				vp = eval_velocity(&tetra[t],x0);
				}
			else continue;
			if( vp>=v0 ) continue;
			my_last_tetra=last_tetra;
			theta = 180.0-RTOD*asin(vp/v0);
			ray_tangent(theta,azi,t0);
			px = t0[0]/vp; py=t0[1]/vp;
			if( !shoot_to_interface( x0, t0, x1, t1, arc, &n_arcs,
				MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec ) ) {
				continue;
				}
			if( !hitflag ) continue;
			traveltime += T0 + px*x0[0] + py*x0[1];
			if( QDEFINED )
			fprintf(ttfile,
			"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%d\t%e\t%f\t%d\n",
				nrays, x0[0], x0[1], x0[2], x1[0], x1[1], x1[2],
				T0, Ta, traveltime*ratio, T0+traveltime*ratio,
		 		Ta-(T0+traveltime*ratio),
				ratio, order, j, 1.0/sqrt(fabs(tt[j].gs)), traveltime/qinvint, in_count );
			else
			fprintf(ttfile,
			"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%d\t%e\t%d\n",
				nrays, x0[0], x0[1], x0[2], x1[0], x1[1], x1[2],
				T0, Ta, traveltime*ratio, T0+traveltime*ratio,
		 		Ta-(T0+traveltime*ratio),
				ratio, order, j, 1.0/sqrt(fabs(tt[j].gs)), in_count );
			n=0;
			arcstoxyz( arc, n_arcs, rayx, rayy, rayz, tindex, 1.0, &n, 8000 );
			for( i=0; i<n; i++ ) {
				fprintf(rayfile, "%d\t%f\t%f\t%f\t%d\n",
					nrays, rayx[i], rayy[i], rayz[i], tindex[i]);
				}
			nrays++;
			}
		}

	exit(0);
	}


void main_locate(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, k, l, interface, n_arcs, nrays, order; //, hitflag,  n, status, ec//unused
	double x0[3], t0[3]; // , x1[3], t1[3], v[4], stheta, ftheta, dtheta, theta, azi; //unused
//	struct arc_rec arc[MAX_ARCS]; //unused
	double traveltime; //, rayx[8000], rayy[8000], rayz[8000]; //unused
//	int tindex[8000]; //unused
	FILE *stafile, *locfile;
	char ct[128];
	double xsta, ysta, zsta, ratio, Ta, th_est, az_est; //T0,  //unused
	struct triangle_rec tri;

#define MAX_LOCTTS (1000)

	double thmin, thmax, azimin, azimax, vs;
	int nth, nazi;
	double G[MAX_LOCTTS][4], GTG[4][4], GTGc[4][4], GTd[4], d[MAX_LOCTTS], maxG;
	int ng, iter, ierror, min_it, min_c_it, max_it;
	double ts, tolerance, rms, GTGi[4][4], sigmat, sigmax, sigmay, sigmaz, dT, dX;
	double damping;

	if( argc!=18 ) {
		fprintf(stderr,"purpose: locate a source given traveltimes to a set of receivers\n");
		fprintf(stderr,"usage: %s model_file xs ys zs thmin thmax nth azimin azimax nazi traveltimes.tsv tolerance location_file.tsv damping min_iterations minimum_constrained_iterations maximum_iterations\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      (x, y, z) cartesian coordinates, +z is down\n");
		fprintf(stderr,"      xs, ys, zs, trial source location in km\n");
		fprintf(stderr,"      arrivals are searched for in a star with\n");
		fprintf(stderr,"         thmin, thmax, min, max angles of incidence, (0-180 deg)\n");
		fprintf(stderr,"         nth, integer number of thetas in star\n");
		fprintf(stderr,"         azimin, azimax, azimuth range (0-360 deg)\n");
		fprintf(stderr,"         nazi, integer number of azimuths in star\n");
		fprintf(stderr,"      input traveltimes.tsv:\n");
		fprintf(stderr,"              x, y, z, location in km\n");
		fprintf(stderr,"                  (but be warned; z not used!)\n");
		fprintf(stderr,"              interface, integer matching model\n");
		fprintf(stderr,"                  (but be warned; sort data by interface!)\n");
		fprintf(stderr,"              T,  arival time in s\n");
		fprintf(stderr,"              ratio, 1 for P 1.76 (or whatever) for S\n");
		fprintf(stderr,"	      order, 0 for 1-st arrival, 1 for second, etc\n");
		fprintf(stderr,"	         Note: order=(-1) not allowed for locate\n");
		fprintf(stderr,"      tolerance, s, iterations stop when rms traveltime error less than tolerance\n");
		fprintf(stderr,"      damping, fraction of maximum GTG value (e.g. 1.0E-6)\n");
		fprintf(stderr,"      min_iterations, minimum number of iterations (must be >0)\n");
		fprintf(stderr,"      min_constrained_iterations, minimum number of iterations with depth held constant (can be 0)\n");
		fprintf(stderr,"      max_iterations, minimum number of iterations (must be >0)\n");

		write_location_blerb(stderr);
		exit(-1);
		}

	fprintf(stderr,"Raytrace3d locate. Model file: %s\n\n", argv[1] );

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2], "%le", &x0[0]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_x from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &x0[1]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_y from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &x0[2]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_z from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &thmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read thmin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &thmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read thmax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%d", &nth) != 1 ) {
		fprintf(stderr,"error: %s: cant read nth from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%le", &azimin) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%le", &azimax) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10], "%d", &nazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read nazi from command line\n", argv[0] );
		exit(-1);
		}

	make_ttime(argv[11]);
	if( (stafile=fopen(argv[11],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open traveltimes.tsv <%s> for read\n",
			argv[0], argv[11]);
		exit(-1);
		}
	if( fscanf(stafile,"%s%s%s%s%s%s%s", ct,ct,ct,ct,ct,ct,ct ) != 7 ) {
		fprintf(stderr,"error: %s: cant skip header in receivers.tsv <%s>\n",
			argv[0], argv[10]);
		exit(-1);
		}
	n_ttimes=0;
	fprintf(stderr,"Input Data\n\n");
	fprintf(stderr,"#\txr\tyr\tzr\tinterface\t\tTa\tratio\torder\n");
 	while( fscanf(stafile,"%le%le%le%d%le%le%d",&xsta,&ysta,&zsta,&interface,&Ta,&ratio,&order)==7){
		if( (n_ttimes>MAX_TTIMES) || (n_ttimes>MAX_LOCTTS) ) {
			fprintf(stderr,"error: %s: too many traveltimes\n", argv[0] );
			exit(-1);
			}
		ttime[n_ttimes].ok=FALSE;
		ttime[n_ttimes].x1[0]=xsta;
		ttime[n_ttimes].x1[1]=ysta;
		ttime[n_ttimes].x1[2]=zsta;
		ttime[n_ttimes].interface=interface;
		ttime[n_ttimes].obsTa=Ta;
		ttime[n_ttimes].preTa=0.0;
		ttime[n_ttimes].preTT=0.0;
		ttime[n_ttimes].ratio=ratio;
		ttime[n_ttimes].obsorder=order;
		ttime[n_ttimes].preorder=order;
		fprintf(stderr,"%d\t%f\t%f\t%f\t%d\t%f\t%f\t%d\n",
			n_ttimes, ttime[n_ttimes].x1[0], ttime[n_ttimes].x1[1],
			ttime[n_ttimes].x1[2], ttime[n_ttimes].interface,
			ttime[n_ttimes].obsTa, ttime[n_ttimes].ratio,
			ttime[n_ttimes].obsorder );
		n_ttimes++;
		}
	fclose(stafile);

	fprintf(stderr,"Total of %d data\n\n", n_ttimes);

	if( sscanf(argv[12], "%le", &tolerance) != 1 ) {
		fprintf(stderr,"error: %s: cant read tolerance from command line\n", argv[0] );
		exit(-1);
		}
	fprintf(stderr,"tolerance: %e\n", tolerance);


	if( (locfile=fopen(argv[13],"w")) == NULL ) {
		fprintf(stderr,"error: %s cant open location_file.tsv <%s> for write\n",
			argv[0], argv[13] );
		exit(-1);
		}

	if( sscanf(argv[14], "%le", &damping) != 1 ) {
		fprintf(stderr,"error: %s: cant read damping from command line\n", argv[0] );
		exit(-1);
		}
	fprintf(stderr,"damping: %e\n", damping);

	if( sscanf(argv[15], "%d", &min_it) != 1 ) {
		fprintf(stderr,"error: %s: cant read minimum_iterations from command line\n", argv[0] );
		exit(-1);
		}
	fprintf(stderr,"minimum_iterations: %d\n", min_it);


	if( sscanf(argv[16], "%d", &min_c_it) != 1 ) {
		fprintf(stderr,"error: %s: cant read minimum_constrained_iterations from command line\n", argv[0] );
		exit(-1);
		}
	fprintf(stderr,"minimum_constrained_iterations: %d\n", min_c_it);


	if( sscanf(argv[17], "%d", &max_it) != 1 ) {
		fprintf(stderr,"error: %s: cant read maximum_iterations from command line\n", argv[0] );
		exit(-1);
		}
	fprintf(stderr,"maximum_iterations: %d\n", max_it);


	for( iter=0; iter<max_it; iter++ ) {

	if( !find_tetra(x0,&i) ) {
		fprintf(stderr,"error: %s: source location (%f, %f, %f) not in model\n", argv[0], x0[0], x0[1], x0[2] );
		exit(-1);
		}
	vs=eval_velocity(&tetra[i],x0);

	fprintf(stderr,"\nIteration %d: source at (%f %f %f) with velocity %f\n\n",
		iter, x0[0], x0[1], x0[2], vs );
	timestamp((char*)"start of this iteration\n");

	interface=ttime[0].interface;
	fprintf(stderr,"Shooting star pattern to interface %d, theta (%f, %f, %d) azi (%f %f %d)\n",
		interface, thmin, thmax, nth, azimin, azimax, nazi );
	shoot_star(thmin, thmax, nth, azimin, azimax, nazi, x0, interface);
	fprintf(stderr,"done with star %d\n", n_ttimes);

	nrays=0;
	ng=0;
	fprintf(stderr,"Linearized traveltime equations:\n");
	fprintf(stderr,"i\tG[i][0]\tG[i][1]\tG[i][2]\tG[i][3]\td[i]\tobsTa\tpreTT\n");
	for( k=0; k<n_ttimes; k++ ) {
		xsta=ttime[k].x1[0];
		ysta=ttime[k].x1[1];
		if( interface!=ttime[k].interface ) {
			fprintf(stderr,"second interace (%d) encountered. ",
				ttime[k].interface);
			fprintf(stderr,"Shooting another star pattern\n");
			interface=ttime[k].interface;
			shoot_star(thmin, thmax, nth, azimin, azimax, nazi,
				x0, interface);
			fprintf(stderr,"Done with star\n\n");
			}
		n_tts=0;
		for( i=0; i<(m_rays-1); i++ )
		for( j=0; j<(n_rays-1); j++ )
		for( l=0; l<2; l++ ) {
			if( instarbox(i, j, l, xsta, ysta, &th_est,
				&az_est, &tri, x0, interface, NULL) )
			if( refine( x0, xsta, ysta, interface, &th_est, &az_est,
				NULL, &n_arcs, &traveltime, &tri) ) {
			if( (n_tts+2)<MAX_TTS ) {
				tt[n_tts].az=az_est;
				tt[n_tts].th=th_est;
				tt[n_tts].T=traveltime;
				n_tts++;
				}
			else {
				fprintf(stderr,"error: %s: too many arrivals\n", argv[0]);
				exit(-1);
				}
			}
			}
		qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );

		if( (j=ttime[k].obsorder) < n_tts ) {
			ttime[k].ok=TRUE;
			ttime[k].preorder=j;
			ttime[k].preTT=tt[j].T*ttime[k].ratio;
			ttime[k].th=tt[j].th;
			ttime[k].az=tt[j].az;
			ray_tangent(tt[j].th,tt[j].az,t0);
			G[ng][0]=1.0/vs;
			G[ng][1]=(-t0[0]/vs);
			G[ng][2]=(-t0[1]/vs);
			G[ng][3]=(-t0[2]/vs);
			d[ng]=ttime[k].obsTa - ttime[k].preTT;
			fprintf(stderr,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n",
				ng, G[ng][0], G[ng][1], G[ng][2], G[ng][3],
				d[ng], ttime[k].obsTa, ttime[k].preTT);

			ng++;
			}
		else {
			ttime[k].ok=FALSE;
			fprintf(stderr,"warning: lost observation %d\n", k);
			}
		}

	if( ng==0 ) {
		fprintf(stderr,"Error: No rays traced in this iteration; iterations terminationg\n");
		exit(-1);
		}

	for( i=0; i<4; i++ ) for( j=0; j<4; j++ ) {
		GTG[i][j]=0.0;
		for( k=0; k<ng; k++ ) {
			GTG[i][j] += G[k][i]*G[k][j];
			}
		}

	maxG=fabs(GTG[0][0]);
	for( i=0; i<4; i++ ) for( j=0; j<4; j++ ) if( maxG<fabs(GTG[i][j]) )
		maxG=fabs(GTG[i][j]);

	for( i=0; i<4; i++ ) GTG[i][i]+=maxG*damping;

	if( iter<min_c_it ) {
		fprintf(stderr,"\nThis iteration has constrained depth\n\n");
		for( i=0; i<3; i++ ) {
			GTG[i][3]=0.0;
			GTG[3][i]=0.0;
			}
		}

	for( i=0; i<4; i++ ) for( j=0; j<4; j++ ) GTGc[i][j]=GTG[i][j];

	for( i=0; i<4; i++ ) {
		GTd[i]=0.0;
		for( k=0; k<ng; k++ ) {
			GTd[i] += G[k][i]*d[k];
			}
		}

	if( iter<2 ) GTd[3]=0.0;

	fprintf(stderr,"\nNormal equations:\n");
	fprintf(stderr,"i\tGTG[i][0]\tGTG[i][1]\tGTG[i][2]\tGTG[i][3]\tGTd[i]\n");
	for( i=0; i<4; i++ ) {
		fprintf(stderr,"%d\t%f\t%f\t%f\t%f\t%f\n", i, GTG[i][0],
			GTG[i][1], GTG[i][2], GTG[i][3], GTd[i] );
		}
	fprintf(stderr,"Absolute maximum of GTG is %f\n\n", maxG );

	gauss((double*)GTG,GTd,4,4,1.0e-10*maxG,&ierror,TRUE);
	if( ierror != 0 ) {
		fprintf(stderr,"warning: singular matrix detected\n");
		}

	dX = sqrt(GTd[1]*GTd[1]+GTd[2]*GTd[2]+GTd[3]*GTd[3]);

	fprintf(stderr,"Estimated origin time %f, location perturbations (%f %f %f) with length %f\n\n",
		GTd[0]/vs, GTd[1], GTd[2], GTd[3], dX );

	ts = GTd[0]/vs;
	x0[0] += GTd[1];
	x0[1] += GTd[2];
	x0[2] += GTd[3];

	rms=0.0;
	for( i=0; i<ng; i++ ) {
		dT=0.0;
		for( j=0; j<4; j++ ) dT += G[i][j]*GTd[j];
		dT-=d[i];
		rms+=dT*dT;
		}
	rms = sqrt(rms/(double)ng);
	fprintf(stderr,"Linearized r.m.s. error estimate: %f\n\n", rms );

	gjinv((double*)GTGc,(double*)GTGi, 4 , 4, 1.0e-14*maxG, &ierror );
	sigmat=rms*sqrt(GTGi[0][0])/vs;
	sigmax=rms*sqrt(GTGi[1][1]);
	sigmay=rms*sqrt(GTGi[2][2]);
	sigmaz=rms*sqrt(GTGi[3][3]);
	fprintf(stderr,
	"xs\tys\tzs\tt0\tsigma-x\tsigma-y\tsigma-z\tsigma-t\tn-data\titer\trms\n");
	fprintf(stderr, "%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%d\t%f\n",
		x0[0], x0[1], x0[2], ts, 
		sigmax, sigmay, sigmaz, sigmat, ng, iter, rms );

	if( ((rms<=tolerance)&&(iter>=min_it)) || (iter==(max_it-1)) ) {
	 fprintf(locfile,
	 "xs\tys\tzs\tt0\tsigma-x\tsigma-y\tsigma-z\tsigma-t\tn-data\titer\trms\n");
	 fprintf(locfile,
	 "%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%d\t%f\n",
		x0[0], x0[1], x0[2], ts, 
		sigmax, sigmay, sigmaz, sigmat, ng, iter, rms );
	 break;
	 }
	}

	exit(0);
	}

void main_invert(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, k, l, interface, hitflag, n_arcs,status, order, ec; // nodeid,  n, //unused
	double x0[3], t0[3], x1[3], t1[3]; //, v[4], stheta, ftheta, dtheta, theta, azi; //unused
	struct arc_rec arc[MAX_ARCS];
	double traveltime; //, rayx[8000], rayy[8000], rayz[8000]; //unused
//	int tindex[8000]; //unused
	FILE *mpfile, *ttfile, *nmfile;
	char ct[128];
	double xsrc, ysrc, zsrc, xsta, ysta, zsta, ratio, T0, Ta, th_est, az_est;
	struct triangle_rec tri;
	struct tetra_rec *pt;
	int biec;

	double thmin, thmax, azimin, azimax, vs;
	int nth, nazi;
	int ng, itt, match; // ierror, //unused
	double *ts, *ts2, rms, rms2; //, dT, dX, tolerance; //unused
	double damping;
	int tnode[4];
	int bracket_status;

	struct sparse_matrix *G, *invert_GTG;

	double *d, *GTd, *dm, maxG, maxd, dv, err, max_dT, qinvint; // Gv, //unused
	int iter, nx, ny, nz;

	double weight;

	char hitsfile[256];

	double new_damping, scx;


	if( argc!=13 ) {
		fprintf(stderr,"purpose: invert local traveltime data for improvements to node velocities\n");
		fprintf(stderr,"usage: %s starting_model_file model_pars_file.txt traveltimes.tsv max_dT damping thmin thmax nth azimin azimax nazi new_model_file\n",argv[0]);
		write_model_blerb(stderr);
		write_model_pars_blerb(stderr);
		fprintf(stderr,"      input traveltimes.tsv:\n");
		fprintf(stderr,"              xs, ys, zs, source location in km\n");
		fprintf(stderr,"                  (but be warned; sort data into groups with common source!\n");
		fprintf(stderr,"              xr, yr, zr, receiver location in km\n");

		fprintf(stderr,"                  (but be warned; z not used!)\n");
		fprintf(stderr,"              receiver interface, integer matching model\n");
		fprintf(stderr,"                  (but be warned; sort data with common source by interface!)\n");
		fprintf(stderr,"              T0,  origin time in s\n");
		fprintf(stderr,"              Ta,  arrival time in s\n");
		fprintf(stderr,"              ratio, 1 for P 1.76 (or whatever) for S\n");
		fprintf(stderr,"              order, 0 for 1-st arrival, 1 for second, etc\n");
		fprintf(stderr,"                 Note: (-1) indicates closest arrival\n");
		fprintf(stderr,"      max_dT: if the absolute value of the traveltime residual, |dT|=|Tobs-Tpred(initial_model)|\n");
		fprintf(stderr,"              is greater than max_dt, that data is ignored\n");

		fprintf(stderr,"      damping: damped least squares parameter  (fraction of largest element of GTG)\n");
		fprintf(stderr,"      arrivals are searched for in a star with\n");
		fprintf(stderr,"         thmin, thmax, min, max angles of incidence, (0-180 deg)\n");
		fprintf(stderr,"         nth, integer number of thetas in star\n");
		fprintf(stderr,"         azimin, azimax, azimuth range (0-360 deg)\n");
		fprintf(stderr,"         nazi, integer number of azimuths in star\n");
		fprintf(stderr,"      output new_model_file: same format as starting model file\n");
		fprintf(stderr,"         also output is new_model_file.hits: same format as starting model file, but with velocity replaced with number of rays\n");
		fprintf(stderr,"         interacting with each node\n");
		exit(-1);
		}

	fprintf(stderr,"Raytrace3d invert. Starting model file: %s\n\n", argv[1] );

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	alloc_model_pars(argv[2]);

	if( (mpfile=fopen(argv[2],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open model_par_file <%s> for read\n", argv[0], argv[2] );
		exit(-1);
		}
	n_model_pars=0;
	load_model_pars_V(mpfile);
	fclose(mpfile);

	if( n_model_pars<=1000 ) {
		for( i=0; i<n_model_pars; i++ ) {
			fprintf(stderr,"Model parameter %d has %d nodes\n", i, model_par[i].n );
			for( j=0; j<model_par[i].n; j++ ) {
				fprintf(stderr,"%d %f\n",model_par[i].node[j],model_par[i].weight[j]);
				}
			}
		}

	make_ttime(argv[3]);
	if( (ttfile=fopen(argv[3],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open traveltime.tsv <%s> for read\n", argv[0], argv[3] );
		exit(-1);
		}
	if( fscanf(ttfile,"%s%s%s%s%s%s%s%s%s%s%s",
			ct,ct,ct,ct,ct,ct,ct,ct,ct,ct,ct ) != 11 ) {
		fprintf(stderr,"error: %s: cant skip header in traveltimess.tsv <%s>\n",
			argv[0], argv[3]);
		exit(-1);
		}

	n_ttimes=0;
	fprintf(stderr,"\nInput Data\n\n");
	fprintf(stderr,"#\txs\tys\tzs\txr\tyr\tzr\tinterface\tT0\tTa\tratio\torder\n");
 	while( fscanf(ttfile,"%le%le%le%le%le%le%d%le%le%le%d", &xsrc,&ysrc,&zsrc,
		&xsta,&ysta,&zsta,&interface,&T0,&Ta,&ratio,&order)==11){
		if( (n_ttimes+2) > MAX_TTIMES ) {
			fprintf(stderr,"error: %s: too many traveltimes\n", argv[0] );
			exit(-1);
			}
		ttime[n_ttimes].ok=FALSE;
		ttime[n_ttimes].x0[0]=xsrc;
		ttime[n_ttimes].x0[1]=ysrc;
		ttime[n_ttimes].x0[2]=zsrc;
		ttime[n_ttimes].x1[0]=xsta;
		ttime[n_ttimes].x1[1]=ysta;
		ttime[n_ttimes].x1[2]=zsta;
		ttime[n_ttimes].interface=interface;
		ttime[n_ttimes].T0=T0;
		ttime[n_ttimes].obsTT=Ta-T0;
		ttime[n_ttimes].obsTa=Ta;
		ttime[n_ttimes].preTa=0.0;
		ttime[n_ttimes].preTT=0.0;
		ttime[n_ttimes].ratio=ratio;
		ttime[n_ttimes].obsorder=order;
		ttime[n_ttimes].preorder=order;
		fprintf(stderr,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%f\t%f\t%f\t%d\n",
			n_ttimes,
			ttime[n_ttimes].x0[0],ttime[n_ttimes].x0[1],ttime[n_ttimes].x0[2],
			ttime[n_ttimes].x1[0],ttime[n_ttimes].x1[1],ttime[n_ttimes].x1[2],
			ttime[n_ttimes].interface,
			ttime[n_ttimes].T0, ttime[n_ttimes].obsTa, 
			ttime[n_ttimes].ratio, ttime[n_ttimes].obsorder );
		n_ttimes++;
		}
	fclose(ttfile);

	fprintf(stderr,"Total of %d data\n\n", n_ttimes);

	if( sscanf(argv[4], "%le", &max_dT) != 1 ) {
		fprintf(stderr,"error: %s: cant read max_dT from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &damping) != 1 ) {
		fprintf(stderr,"error: %s: cant read damping from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &thmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read thmin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%le", &thmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read thmax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%d", &nth) != 1 ) {
		fprintf(stderr,"error: %s: cant read nth from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%le", &azimin) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10], "%le", &azimax) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[11], "%d", &nazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read nazi from command line\n", argv[0] );
		exit(-1);
		}

	if( (nmfile=fopen(argv[12],"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open new_model_file <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}

	sprintf( hitsfile, "%s.hits", argv[12] );

	G=new_sparse_matrix(n_ttimes,n_model_pars,0);
	d=(double*)malloc((n_ttimes+2)*sizeof(double));
	ts=(double*)malloc((n_model_pars+2)*sizeof(double));
	ts2=(double*)malloc((n_ttimes+2)*sizeof(double));
	GTd=(double*)malloc((n_model_pars+2)*sizeof(double));
	dm=(double*)malloc((n_model_pars+2)*sizeof(double));

	if( (G==NULL) || (d==NULL) || (GTd==NULL) ||
		(ts==NULL) || (ts2==NULL) || (dm==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (G, d ...)\n", argv[0] );
		exit(-1);
		}
	ng=0;

	fprintf(stderr,"Starting Point to Point Ray tracing of data\n\n");
	timestamp((char*)"at start of raytracing");
	fprintf(stderr,"#\tobsTT\tpreTT\tres\n");

	for( itt=0; itt<n_ttimes; itt++ ) {

	if( itt==0 ) {
		match=FALSE;
		}
	else {
		if( ttime[itt].x0[0]==x0[0] && ttime[itt].x0[1]==x0[1] &&
			ttime[itt].x0[2]==x0[2] && ttime[itt].interface==interface ) 
			match=TRUE; else match=FALSE;
		}

	if( !match ) {
		for( i=0; i<3; i++ ) x0[i]=ttime[itt].x0[i];
		interface=ttime[itt].interface;
		if( !find_tetra(x0,&i) ) {
			fprintf(stderr,"error: %s: source location (%f %f %f) not in model\n", argv[0], x0[0], x0[1], x0[2] );
			exit(-1);
			}
		vs=eval_velocity(&tetra[i],x0);

		fprintf(stderr,"Shooting star pattern from source (%f %f %f) at velocity %f to interface %d, theta (%f, %f, %d) azi (%f %f %d)\n",
		x0[0], x0[1], x0[2], vs,
		interface, thmin, thmax, nth, azimin, azimax, nazi );
		shoot_star(thmin, thmax, nth, azimin, azimax, nazi, x0, interface);
		fprintf(stderr,"done with star\n\n");
		}
	xsta=ttime[itt].x1[0];
	ysta=ttime[itt].x1[1];
	n_tts=0;
	bracket_status=FALSE;
	for( i=0; i<(m_rays-1); i++ )
	for( j=0; j<(n_rays-1); j++ )
	for( l=0; l<2; l++ ) {
		if( instarbox(i, j, l, xsta, ysta, &th_est,
			&az_est, &tri, x0, interface, NULL) ) {
		bracket_status=TRUE;
		if( refine( x0, xsta, ysta, interface, &th_est, &az_est,
			NULL, &n_arcs, &traveltime, &tri) ) {
			if( (n_tts+2)<MAX_TTS ) {
				tt[n_tts].az=az_est;
				tt[n_tts].th=th_est;
				tt[n_tts].T=traveltime;
				n_tts++;
				}
			else {
				fprintf(stderr,"error: %s: too many arrivals\n", argv[0]);
				exit(-1);
				}
			} }
		}
	qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
	if( order==(-1) ) setorder( tt, n_tts, ttime[itt].obsTa-ttime[itt].T0, ttime[itt].ratio, &ttime[itt].obsorder );

	if( (j=ttime[itt].obsorder) < n_tts ) {
		status=TRUE;
		ray_tangent(tt[j].th,tt[j].az,t0);
		if( !shoot_to_interface( x0, t0, x1, t1, arc, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec ) ) {
			status=FALSE;
			}
		if( !hitflag ) status=FALSE;
		}
	else status=FALSE;

	if( status ) {
		ttime[itt].ok=TRUE;
		ttime[itt].preorder=j;
		ttime[itt].preTT=traveltime*ttime[itt].ratio;
		ttime[itt].th=tt[j].th;
		ttime[itt].az=tt[j].az;
		fprintf(stderr,"%d\t%f\t%f\t%f\n", itt, 
			ttime[itt].obsTT, ttime[itt].preTT,
			ttime[itt].obsTT-ttime[itt].preTT);
		}
	else {
		ttime[itt].ok=FALSE;
		fprintf(stderr,"warning: lost observation %d\n", itt);
		if( !bracket_status ) {
			fprintf(stderr,"         ray was not bracketed\n" );
			}
		else {
			if( refine_star_status==1 ) {
				fprintf(stderr,"         derivative failed in refine\n" );
				}
			if( refine_star_status==2 ) {
				fprintf(stderr,"         ray came this close: %e\n", refine_star_norm );
				}
			}
		continue;
		}

	d[ng]=ttime[itt].obsTT-traveltime*ttime[itt].ratio;

	for( i=0; i<n_nodes; i++ ) node[i].touched=0;
	for( i=0; i<n_arcs; i++ ) {
		node[ arc[i].ptetra->n1 ].touched=1;
		node[ arc[i].ptetra->n2 ].touched=1;
		node[ arc[i].ptetra->n3 ].touched=1;
		node[ arc[i].ptetra->n4 ].touched=1;
		}
	for( i=0; i<n_nodes; i++ ) {
		if( node[i].touched ) node[i].hits++;
		node[i].touched=0;
		}

	for( j=0; j<n_model_pars; j++ ) {
		/* will varying this model parameter change the traveltime ? */
		match=FALSE;
		for( i=0; i<n_arcs; i++ ) {
			pt=arc[i].ptetra;
			tnode[0]=pt->n1; tnode[1]=pt->n2; tnode[2]=pt->n3; tnode[3]=pt->n4;
			for( k=0; k<4; k++ ) {
				if( node_in_model_par(tnode[k],j) ) {
					match=TRUE;
					break;
					}
				}
			if(match) break;
			}
		if( match ) {
			set_sparse_value( G, ng, j,
				dTdmp(j,arc,n_arcs,traveltime)*ttime[itt].ratio );
			}
		else {
			;/* G[ng][j] is zero */
			}
		}

	if( fabs(d[ng]) > max_dT ) {
		fprintf(stderr,"|%f|>%f, so ignoring this data \n", d[ng], max_dT );
		for( j=0; j<n_model_pars; j++ ) set_sparse_value( G, ng, j, 0.0 );
		}
	else {
		ng++;
		}

	} /* next traveltime */

	timestamp((char*)"at end of raytracing");
	
	if( ng<100 && n_model_pars<6 ) {
		fprintf(stderr,"\nG, d:\n");
		for(i=0; i<ng; i++ ) {
			fprintf(stderr,"%d\t", i);
			for( j=0; j<n_model_pars; j++ ) {
				fprintf(stderr,"%f\t", get_sparse_value(G,i,j) );
				}
			fprintf(stderr,"%f\n", d[i] );
			}
		fprintf(stderr,"\n");
		}

	maxG=sparse_absmax(G);
	k=sparse_count(G);

	maxd=0.0;
	for( i=0; i<ng; i++ ) {
		dv=fabs(d[i]);
		if( dv>maxd ) maxd=dv;
		}

	fprintf(stderr,"\nG is %d by %d, is %f percent full, and has abs max of %f\n", ng, n_model_pars, 100.0*(double)k/((double)ng*(double)n_model_pars), maxG );
	fprintf(stderr,"\nd is %d by 1 and  has abs max of %f\n\n", ng, maxd );
	timestamp((char*)"after forming G and d");
	fprintf(stderr,"Damping: %e\n\n", damping );
	
	smt_times_v( G, d, GTd );
	maxd=0.0;
	for( i=0; i<n_model_pars; i++ ) {
		dv=fabs(GTd[i]);
		if( dv>maxd ) maxd=dv;
		}

	fprintf(stderr,
	"GTd is %d by 1, and has absolute maximum of %f\n\n",
	n_model_pars, maxd );
	
	if( EXPLICIT_GTG ) {
	
	timestamp((char*)"starting to form GTG");
	invert_GTG=smt_times_sm(G,G);
	timestamp((char*)"after forming GTG");

	if( invert_GTG==NULL ) {
		fprintf(stderr,"error: %s: out of memory (invert_GTG)\n", argv[0] );
		exit(-1);
		}
	maxG=sparse_absmax(invert_GTG);
	k=sparse_count(invert_GTG);
	sparse_addtodiag(invert_GTG, damping*maxG);

	fprintf(stderr,
	"GTG is %d by %d, is %f percent full, and has absolute maximum of %f\n\n",
	n_model_pars, n_model_pars,
	100.0*(double)k/((double)n_model_pars*(double)n_model_pars), maxG );

	timestamp((char*)"starting to solve linear system");

	for( i=0; i<n_model_pars; i++ ) {
		dm[i]=0.0;
		}
	if( !sparse_biconj( invert_GTG,GTd,dm,1,maxd*B_PREC,n_model_pars+10,&iter,&err,&biec) ) {
		fprintf(stderr,"error: %s: biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
	fprintf(stderr,"Matrix inversion: %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after solving linear system");
	
	if( n_model_pars<1000 ) {
		fprintf(stderr,"\nGTG*dm=GTd\n");
		fprintf(stderr,"#\tobs\tpred\tdifference\n");
		}
	rms=0.0;
	sm_times_v( invert_GTG, dm, ts );
	for( i=0; i<n_model_pars; i++ ) {
		rms+=(GTd[i]-ts[i])*(GTd[i]-ts[i]);
                if( n_model_pars<1000 ) {
                	fprintf(stderr,"%d\t%f\t%f\t%f\n", i, GTd[i], ts[i], GTd[i]-ts[i] );
                	}
		}
	rms = sqrt(rms/(double)n_model_pars);
	fprintf(stderr,"\nrms solution error is %f\n\n", rms);
	
	} /* end of explicit GTG */
	else {
	for( i=0; i<n_model_pars; i++ ) dm[i]=0.0;
	scx = ATAabsmax( G );
	new_damping = damping*scx;
	fprintf(stderr,"Damping: %e abmaxGTG: %e Scaled_damping: %e\n\n",
		damping, scx, new_damping );

	if( !sparse_dls_biconj( G, d, dm, new_damping, 1, maxd*B_PREC, n_model_pars+10, &iter,&err,&biec ) ) {
		fprintf(stderr,"error: %s: dls_biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
		
	fprintf(stderr,"Matrix inversion: %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after implicit solution");
	} /* end of implicit solution */

	if( n_model_pars < 1000 ) {
		fprintf(stderr, "Model parameter perturbations\n");
		fprintf(stderr, "#\tdm\n");
		for( i=0; i<n_model_pars; i++ ) {
			fprintf(stderr,"%i\t%f\n", i, dm[i] );
			}
		fprintf(stderr,"\n");
		}

	fprintf(stderr,"\nG*dm=dt\n");
	fprintf(stderr,"#\tobs_dt\tpred_st\tdifference\n");
	sm_times_v( G, dm, ts2 );

	rms=0.0;
	rms2=0.0;
	for( i=0; i<ng; i++ ) {
		fprintf(stderr,"%d\t%f\t%f\t%f\n", i, d[i], ts2[i], d[i]-ts2[i] );
		rms+=(d[i]-ts2[i])*(d[i]-ts2[i]);
		rms2+=d[i]*d[i];
		}
	rms = sqrt(rms/(double)ng);
	rms2 = sqrt(rms2/(double)ng);
	fprintf(stderr,"\nlinearized rms traveltime error is %f compared to original %f\n", rms, rms2);
	fprintf(stderr,"%f percent reduction\n", 100.0*(1-rms/rms2));
	fprintf(stderr,"(but be warned; actual reduction, after re-raytracing, might be different\n");

	/* update velocity of nodes */
	for( i=0; i<n_model_pars; i++ ) {
		for( j=0; j<model_par[i].n; j++ ) {
			k=model_par[i].node[j];
			weight=model_par[i].weight[j];
			node[k].v += weight*dm[i];
			}
		}
	/* write out perturbed model */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		if( QDEFINED )
		fprintf(nmfile,"%d %d %d %f %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, 1.0/node[i].qinv, node[i].ifc );
		else
		fprintf(nmfile,"%d %d %d %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, node[i].ifc );
		}
	fclose(nmfile);

	if( (nmfile=fopen(hitsfile,"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open hitsfile <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}

	/* write out hits file */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		fprintf(nmfile,"%d %d %d %f %f %f %d %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].hits, node[i].ifc );
		}
	fclose(nmfile);
	timestamp((char*)"final");

		
	exit(0);
	}

void main_Iinvert(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, k, l, nodeid, interface, rinterface, hitflag, n_arcs, status, order, ec; // n//unused
	double x0[3], t0[3], x1[3], t1[3]; //, v[4], stheta, ftheta, dtheta, theta, azi; //unused
	struct arc_rec arc[MAX_ARCS];
	double traveltime; //, rayx[8000], rayy[8000], rayz[8000]; //unused
//	int tindex[8000]; //unused
	FILE *mpfile, *ttfile, *nmfile;
	char ct[128];
	double xsrc, ysrc, zsrc, xsta, ysta, zsta, ratio, T0, Ta, th_est, az_est;
	struct triangle_rec tri;
	struct tetra_rec *pt;

	double thmin, thmax, azimin, azimax, vs;
	int nth, nazi;
	int ng, itt, match; // ierror, //unused
	double *ts, *ts2, rms, rms2; //, tolerance, dT, dX; //unused
	double damping;
	int tnode[4];
	int bracket_status;
	int biec;

	struct sparse_matrix *G, *invert_GTG;

	double *d, *GTd, *dm, maxG, maxd, dv, err, max_dT, qinvint; // Gv, //unused
	int iter, nx, ny, nz;
	double weight, ntan[3];

	double new_damping, scx;

	char hitsfile[256];

	if( argc!=14 ) {
		fprintf(stderr,"purpose: invert local reflected traveltime data for improved position of flecting interface\n");
		fprintf(stderr,"usage: %s starting_model_file model_pars_file.txt traveltimes.tsv max_dT damping thmin thmax nth azimin azimax nazi new_model_file reflector_interface\n",argv[0]);
		write_model_blerb(stderr);
		write_refl_pars_blerb(stderr);
		fprintf(stderr,"      input traveltimes.tsv:\n");
		fprintf(stderr,"              xs, ys, zs, source location in km\n");
		fprintf(stderr,"                  (but be warned; sort data into groups with common source!\n");
		fprintf(stderr,"              xr, yr, zr, receiver location in km\n");

		fprintf(stderr,"                  (but be warned; z not used!)\n");
		fprintf(stderr,"              receiver interface, integer matching model\n");
		fprintf(stderr,"                  (but be warned; sort data with common source by interface!)\n");
		fprintf(stderr,"              T0,  origin time in s\n");
		fprintf(stderr,"              Ta,  arrival time in s\n");
		fprintf(stderr,"              ratio, 1 for P 1.76 (or whatever) for S\n");
		fprintf(stderr,"              order, 0 for 1-st arrival, 1 for second, etc\n");
		fprintf(stderr,"                 Note: (-1) indicates closest arrival\n");
		fprintf(stderr,"                 Note: The traveltimes are for a reflected wave,\n");
		fprintf(stderr,"                 i.e., a wave reflected off a single interface\n");
		fprintf(stderr,"                 specified by the reflector_interface parameter\n");
		fprintf(stderr,"      max_dT: if the absolute value of the traveltime residual, |dT|=|Tobs-Tpred(initial_model)|\n");
		fprintf(stderr,"              is greater than max_dt, that datum is ignored\n");

		fprintf(stderr,"      damping: damped least squares parameter  (fraction of largest element of GTG)\n");
		fprintf(stderr,"      arrivals are searched for in a star with\n");
		fprintf(stderr,"         thmin, thmax, min, max angles of incidence, (0-180 deg)\n");
		fprintf(stderr,"         nth, integer number of thetas in star\n");
		fprintf(stderr,"         azimin, azimax, azimuth range (0-360 deg)\n");
		fprintf(stderr,"         nazi, integer number of azimuths in star\n");
		fprintf(stderr,"      output new_model_file: same format as starting model file\n");
		fprintf(stderr,"         also output is new_model_file.hits: same format as starting model file, but with velocity replaced with number of rays\n");
		fprintf(stderr,"         interacting with each node\n");
		fprintf(stderr,"      reflector_interface: integer number of the reflector interface\n");
		fprintf(stderr,"         Must match an interface in the model file\n");
		exit(-1);
		}

	fprintf(stderr,"Raytrace3d Iinvert.\n\n");

	fprintf(stderr,"Reflecting interface: %s\n\n", argv[13] );
	if( sscanf(argv[13], "%d", &rinterface) != 1 ) {
		fprintf(stderr,"error: %s: cant read reflector_interface from command line\n", argv[0] );
		exit(-1);
		}

	fprintf(stderr,"Starting model file: %s\n\n", argv[1] );
	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	alloc_model_pars(argv[2]);

	if( (mpfile=fopen(argv[2],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open model_par_file <%s> for read\n", argv[0], argv[2] );
		exit(-1);
		}
	n_model_pars=0;
	while( fscanf(mpfile,"%d",&(model_par[n_model_pars].n)) == 1 ) {
		if( n_model_pars > (MAX_MODEL_PARS-1) ) {
			fprintf(stderr,"error: %s: maximum model parameters (%d) exceeds limit of %d\n", argv[0], n_model_pars, MAX_MODEL_PARS-1 );
			exit(-1);
			}
		model_par[n_model_pars].node = (int *)
			malloc((model_par[n_model_pars].n+2)*sizeof(int));
		if(model_par[n_model_pars].node==NULL) {
			fprintf(stderr,"error: out of memory (model_par node)!\n");
			exit(-1);
			}
		model_par[n_model_pars].weight = (double *)
			malloc((model_par[n_model_pars].n+2)*sizeof(double));
		if(model_par[n_model_pars].weight==NULL) {
			fprintf(stderr,"error: out of memory (model_par weight)!\n");
			exit(-1);
			}
		model_par[n_model_pars].t = (double *)
			malloc(3*(model_par[n_model_pars].n+2)*sizeof(double));
		if(model_par[n_model_pars].t==NULL) {
			fprintf(stderr,"error: out of memory (model_par t)!\n");
			exit(-1);
			}
		for( l=0; l<model_par[n_model_pars].n; l++ ) {
			if(fscanf(mpfile,"%d%d%d%le%le%le%le", &i,&j,&k,ntan,ntan+1,ntan+2,&weight)!=7) {
				fprintf(stderr,"error: %s: cant parse model_par_file <%s>\n", argv[0], argv[2] );
				exit(-1);
				}
			if( i<0 || i>=model_L || j<0 || j>=model_M || k<0 || k>=model_N ) {
				fprintf(stderr,"error: %s: bad node (%d %d %d) in model_par_file <%s>\n", argv[0], i, j, k, argv[2] );
				exit(-1);
				}
			nodeid=k*model_L*model_M+j*model_L+i;
			if( (model_par[n_model_pars].node[l]=findnode(nodeid))==(-1) ) {
				fprintf(stderr,"error: %s: couldnt find node (%d %d %d)\n", argv[0], i, j, k );
				exit(-1);
				}
			if( node[model_par[n_model_pars].node[l]].ifc != rinterface ) {
				fprintf(stderr,"error: %s: node (%d %d %d) not on reflector interface %d\n",
				argv[0], i, j, k, rinterface );
				exit(-1);
				}
			if( weight==0.0 ) {
				fprintf(stderr,"error: %s: model parameter %d has 0 weight\n", argv[0], n_model_pars );
				exit(-1);
				}
			model_par[n_model_pars].weight[l]=weight;
			unit_vector(ntan);
			for(i=0;i<3;i++) model_par[n_model_pars].t[3*l+i]=ntan[i];
			}
		n_model_pars++;
		}
	fclose(mpfile);


	if( n_model_pars < 1000 ) for( i=0; i<n_model_pars; i++ ) {
		fprintf(stderr,"Model parameter %d has %d nodes\n", i, model_par[i].n );
		for( j=0; j<model_par[i].n; j++ ) {
			fprintf(stderr,"%d (%f %f %f) %f\n", model_par[i].node[j],
				model_par[i].t[3*j], model_par[i].t[3*j+1], model_par[i].t[3*j+2],
				model_par[i].weight[j]);
			}
		}

	make_ttime(argv[3]);
	if( (ttfile=fopen(argv[3],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open traveltime.tsv <%s> for read\n", argv[0], argv[3] );
		exit(-1);
		}
	if( fscanf(ttfile,"%s%s%s%s%s%s%s%s%s%s%s",
			ct,ct,ct,ct,ct,ct,ct,ct,ct,ct,ct ) != 11 ) {
		fprintf(stderr,"error: %s: cant skip header in traveltimess.tsv <%s>\n",
			argv[0], argv[3]);
		exit(-1);
		}

	n_ttimes=0;
	fprintf(stderr,"\nInput Data\n\n");
	fprintf(stderr,"#\txs\tys\tzs\txr\tyr\tzr\tinterface\tT0\tTa\tratio\torder\n");
 	while( fscanf(ttfile,"%le%le%le%le%le%le%d%le%le%le%d", &xsrc,&ysrc,&zsrc,
		&xsta,&ysta,&zsta,&interface,&T0,&Ta,&ratio,&order)==11){
		if( (n_ttimes+2) > MAX_TTIMES ) {
			fprintf(stderr,"error: %s: too many traveltimes\n", argv[0] );
			exit(-1);
			}
		ttime[n_ttimes].ok=FALSE;
		ttime[n_ttimes].x0[0]=xsrc;
		ttime[n_ttimes].x0[1]=ysrc;
		ttime[n_ttimes].x0[2]=zsrc;
		ttime[n_ttimes].x1[0]=xsta;
		ttime[n_ttimes].x1[1]=ysta;
		ttime[n_ttimes].x1[2]=zsta;
		ttime[n_ttimes].interface=interface;
		ttime[n_ttimes].T0=T0;
		ttime[n_ttimes].obsTT=Ta-T0;
		ttime[n_ttimes].obsTa=Ta;
		ttime[n_ttimes].preTa=0.0;
		ttime[n_ttimes].preTT=0.0;
		ttime[n_ttimes].ratio=ratio;
		ttime[n_ttimes].obsorder=order;
		ttime[n_ttimes].preorder=order;
		fprintf(stderr,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%f\t%f\t%f\t%d\n",
			n_ttimes,
			ttime[n_ttimes].x0[0],ttime[n_ttimes].x0[1],ttime[n_ttimes].x0[2],
			ttime[n_ttimes].x1[0],ttime[n_ttimes].x1[1],ttime[n_ttimes].x1[2],
			ttime[n_ttimes].interface,
			ttime[n_ttimes].T0, ttime[n_ttimes].obsTa, 
			ttime[n_ttimes].ratio, ttime[n_ttimes].obsorder );
		n_ttimes++;
		}
	fclose(ttfile);

	fprintf(stderr,"Total of %d data\n\n", n_ttimes);

	if( sscanf(argv[4], "%le", &max_dT) != 1 ) {
		fprintf(stderr,"error: %s: cant read max_dT from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &damping) != 1 ) {
		fprintf(stderr,"error: %s: cant read damping from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &thmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read thmin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%le", &thmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read thmax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%d", &nth) != 1 ) {
		fprintf(stderr,"error: %s: cant read nth from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%le", &azimin) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10], "%le", &azimax) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[11], "%d", &nazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read nazi from command line\n", argv[0] );
		exit(-1);
		}

	if( (nmfile=fopen(argv[12],"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open new_model_file <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}


	sprintf( hitsfile, "%s.hits", argv[12] );

	G=new_sparse_matrix(n_ttimes,n_model_pars,0);
	d=(double*)malloc((n_ttimes+2)*sizeof(double));
	ts=(double*)malloc((n_model_pars+2)*sizeof(double));
	ts2=(double*)malloc((n_ttimes+2)*sizeof(double));
	GTd=(double*)malloc((n_model_pars+2)*sizeof(double));
	dm=(double*)malloc((n_model_pars+2)*sizeof(double));

	if( (G==NULL) || (d==NULL) || (GTd==NULL) ||
		(ts==NULL) || (ts2==NULL) || (dm==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (G, d ...)\n", argv[0] );
		exit(-1);
		}
	ng=0;

	fprintf(stderr,"Starting Point to Point Ray tracing of data\n\n");
	timestamp((char*)"at start of raytracing");
	fprintf(stderr,"#\tobsTT\tpreTT\tres\n");

	for( itt=0; itt<n_ttimes; itt++ ) {

	if( itt==0 ) {
		match=FALSE;
		}
	else {
		if( ttime[itt].x0[0]==x0[0] && ttime[itt].x0[1]==x0[1] &&
			ttime[itt].x0[2]==x0[2] && ttime[itt].interface==interface ) 
			match=TRUE; else match=FALSE;
		}

	if( !match ) {
		for( i=0; i<3; i++ ) x0[i]=ttime[itt].x0[i];
		interface=ttime[itt].interface;
		if( !find_tetra(x0,&i) ) {
			fprintf(stderr,"error: %s: source location (%f %f %f) not in model\n", argv[0], x0[0], x0[1], x0[2] );
			exit(-1);
			}
		vs=eval_velocity(&tetra[i],x0);

		fprintf(stderr,"Shooting star pattern from source (%f %f %f) at velocity %f to interface %d, theta (%f, %f, %d) azi (%f %f %d)\n",
		x0[0], x0[1], x0[2], vs,
		interface, thmin, thmax, nth, azimin, azimax, nazi );
		shoot_star_refl(thmin, thmax, nth, azimin, azimax, nazi, x0, interface, rinterface);
		fprintf(stderr,"done with star\n\n");
		}
	xsta=ttime[itt].x1[0];
	ysta=ttime[itt].x1[1];
	n_tts=0;
	bracket_status=FALSE;
	for( i=0; i<(m_rays-1); i++ )
	for( j=0; j<(n_rays-1); j++ )
	for( l=0; l<2; l++ ) {
		if( instarbox_refl(i, j, l, xsta, ysta, &th_est,
			&az_est, &tri, x0, interface, rinterface, NULL) ) {
		bracket_status=TRUE;
		if( refine_refl( x0, xsta, ysta, interface, rinterface, &th_est, &az_est,
			NULL, &n_arcs, &traveltime, &tri) ) {
			if( (n_tts+2)<MAX_TTS ) {
				tt[n_tts].az=az_est;
				tt[n_tts].th=th_est;
				tt[n_tts].T=traveltime;
				n_tts++;
				}
			else {
				fprintf(stderr,"error: %s: too many arrivals\n", argv[0]);
				exit(-1);
				}
			} }
		}
	qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
	if( order==(-1) ) setorder( tt, n_tts, ttime[itt].obsTa-ttime[itt].T0, ttime[itt].ratio, &ttime[itt].obsorder );

	if( (j=ttime[itt].obsorder) < n_tts ) {
		status=TRUE;
		ray_tangent(tt[j].th,tt[j].az,t0);
		if( !shoot_to_interface_refl( x0, t0, x1, t1, arc, &n_arcs,
			MAX_ARCS, 10000.0, interface, rinterface, &hitflag, &traveltime, &qinvint, &ec ) ) {
			status=FALSE;
			}
		if( !hitflag ) status=FALSE;
		}
	else status=FALSE;

	if( status ) {
		ttime[itt].ok=TRUE;
		ttime[itt].preorder=j;
		ttime[itt].preTT=traveltime*ttime[itt].ratio;
		ttime[itt].th=tt[j].th;
		ttime[itt].az=tt[j].az;
		fprintf(stderr,"%d\t%f\t%f\t%f\n", itt, 
			ttime[itt].obsTT, ttime[itt].preTT,
			ttime[itt].obsTT-ttime[itt].preTT);
		}
	else {
		ttime[itt].ok=FALSE;
		fprintf(stderr,"warning: lost observation %d\n", itt);
		if( !bracket_status ) {
			fprintf(stderr,"         ray was not bracketed\n" );
			}
		else {
			if( refine_star_status==1 ) {
				fprintf(stderr,"         derivative failed in refine\n" );
				}
			if( refine_star_status==2 ) {
				fprintf(stderr,"         ray came this close: %e\n", refine_star_norm );
				}
			}
		continue;
		}

	d[ng]=ttime[itt].obsTT-traveltime*ttime[itt].ratio;

	for( i=0; i<n_nodes; i++ ) node[i].touched=0;
	for( i=0; i<n_arcs; i++ ) {
		node[ arc[i].ptetra->n1 ].touched=1;
		node[ arc[i].ptetra->n2 ].touched=1;
		node[ arc[i].ptetra->n3 ].touched=1;
		node[ arc[i].ptetra->n4 ].touched=1;
		}
	for( i=0; i<n_nodes; i++ ) {
		if( node[i].touched ) node[i].hits++;
		node[i].touched=0;
		}

	for( j=0; j<n_model_pars; j++ ) {
		/* will varying this model parameter change the traveltime ? */
		match=FALSE;
		for( i=0; i<n_arcs; i++ ) {
			pt=arc[i].ptetra;
			tnode[0]=pt->n1; tnode[1]=pt->n2; tnode[2]=pt->n3; tnode[3]=pt->n4;
			for( k=0; k<4; k++ ) {
				if( node_in_model_par(tnode[k],j) ) {
					match=TRUE;
					break;
					}
				}
			if(match) break;
			}
		if( match ) {
			set_sparse_value( G, ng, j,
				dTdmpr(j,interface,rinterface,x0,t0,x1,t1,arc,n_arcs,traveltime,ng)
				* ttime[itt].ratio );
			}
		else {
			;/* G[ng][j] is zero */
			}
		}

	if( fabs(d[ng]) > max_dT ) {
		fprintf(stderr,"|%f|>%f, so ignoring this data \n", d[ng], max_dT );
		for( j=0; j<n_model_pars; j++ ) set_sparse_value( G, ng, j, 0.0 );
		}
	else {
		ng++;
		}

	} /* next traveltime */

	timestamp((char*)"at end of raytracing");
	
	if( ng<100 && n_model_pars<6 ) {
		fprintf(stderr,"\nG, d:\n");
		for(i=0; i<ng; i++ ) {
			fprintf(stderr,"%d\t", i);
			for( j=0; j<n_model_pars; j++ ) {
				fprintf(stderr,"%f\t", get_sparse_value(G,i,j) );
				}
			fprintf(stderr,"%f\n", d[i] );
			}
		fprintf(stderr,"\n");
		}

	maxG=sparse_absmax(G);
	k=sparse_count(G);

	maxd=0.0;
	for( i=0; i<ng; i++ ) {
		dv=fabs(d[i]);
		if( dv>maxd ) maxd=dv;
		}

	fprintf(stderr,"\nG is %d by %d, is %f percent full, and has abs max of %f\n", ng, n_model_pars, 100.0*(double)k/((double)ng*(double)n_model_pars), maxG );
	fprintf(stderr,"\nd is %d by 1 and  has abs max of %f\n\n", ng, maxd );
	timestamp((char*)"after forming G and d");
	
	smt_times_v( G, d, GTd );
	maxd=0.0;
	for( i=0; i<n_model_pars; i++ ) {
		dv=fabs(GTd[i]);
		if( dv>maxd ) maxd=dv;
		}

	fprintf(stderr,
	"GTd is %d by 1, and has absolute maximum of %f\n\n", n_model_pars, maxd );
	
	fprintf(stderr,"Damping: %e\n\n", damping );

	if( EXPLICIT_GTG ) {
	
	timestamp((char*)"before forming GTG");

	invert_GTG=smt_times_sm(G,G);
	if( invert_GTG==NULL ) {
		fprintf(stderr,"error: %s: out of memory (invert_GTG)\n", argv[0] );
		exit(-1);
		}
	maxG=sparse_absmax(invert_GTG);
	k=sparse_count(invert_GTG);
	sparse_addtodiag(invert_GTG, damping*maxG);

	fprintf(stderr,
	"GTG is %d by %d, is %f percent full, and has absolute maximum of %f\n\n",
	n_model_pars, n_model_pars,
	100.0*(double)k/((double)n_model_pars*(double)n_model_pars), maxG );

	timestamp((char*)"after forming GTG");

	for( i=0; i<n_model_pars; i++ ) {
		dm[i]=0.0;
		}
	if( !sparse_biconj( invert_GTG,GTd,dm,1,maxd*B_PREC,n_model_pars+10,&iter,&err,&biec) ) {
		fprintf(stderr,"error: %s: biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
	fprintf(stderr,"Matrix inversion: %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after solving linear system");


	if( n_model_pars<1000) {
		fprintf(stderr,"\nGTG*dm=GTd\n");
		fprintf(stderr,"#\tobs\tpred\tdifference\n");
		}
	rms=0.0;
	sm_times_v( invert_GTG, dm, ts );
	for( i=0; i<n_model_pars; i++ ) {
		rms+=(GTd[i]-ts[i])*(GTd[i]-ts[i]);
                if( n_model_pars<1000) {
                	fprintf(stderr,"%d\t%f\t%f\t%f\n", i, GTd[i], ts[i], GTd[i]-ts[i] );
                	}
		}
	rms = sqrt(rms/(double)n_model_pars);
	fprintf(stderr,"\nrms solution error is %f\n\n", rms);
	
	} /* end explicit GTG */
	else {

	scx = ATAabsmax( G );
	new_damping = damping*scx;
	fprintf(stderr,"Damping: %e abmaxGTG: %e Scaled_damping: %e\n\n",
		damping, scx, new_damping );
	
	for( i=0; i<n_model_pars; i++ ) dm[i]=0.0;
	if( !sparse_dls_biconj( G, d, dm, new_damping, 1, maxd*B_PREC, n_model_pars+10, &iter,&err,&biec ) ) {
		fprintf(stderr,"error: %s: dls_biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
		
	fprintf(stderr,"Matrix inversion: %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after implicit solution");
	
	} /* end implicit solution */
	
	if( n_model_pars<1000) {
		fprintf(stderr, "Model parameter perturbations\n");
		fprintf(stderr, "#\tdm\n");
		for( i=0; i<n_model_pars; i++ ) {
			fprintf(stderr,"%i\t%f\n", i, dm[i] );
			}
		fprintf(stderr,"\n");
		}

	fprintf(stderr,"\nG*dm=dt\n");
	fprintf(stderr,"#\tobs_dt\tpred_st\tdifference\n");
	sm_times_v( G, dm, ts2 );

	rms=0.0;
	rms2=0.0;
	for( i=0; i<ng; i++ ) {
		fprintf(stderr,"%d\t%f\t%f\t%f\n", i, d[i], ts2[i], d[i]-ts2[i] );
		rms+=(d[i]-ts2[i])*(d[i]-ts2[i]);
		rms2+=d[i]*d[i];
		}
	rms = sqrt(rms/(double)ng);
	rms2 = sqrt(rms2/(double)ng);
	fprintf(stderr,"\nlinearized rms traveltime error is %f compared to original %f\n", rms, rms2);
	fprintf(stderr,"%f percent reduction\n", 100.0*(1-rms/rms2));
	fprintf(stderr,"(but be warned; actual reduction, after re-raytracing, might be different\n");

	/* update position of nodes */
	for( i=0; i<n_model_pars; i++ ) {
		for( j=0; j<model_par[i].n; j++ ) {
			k=model_par[i].node[j];
			for( l=0; l<3; l++ )
				node[k].x[l] += dm[i]*model_par[i].weight[j]*model_par[i].t[3*j+l];
			}
		}
	/* write out perturbed model */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		if( QDEFINED )
		fprintf(nmfile,"%d %d %d %f %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, 1.0/node[i].qinv, node[i].ifc );
		else
		fprintf(nmfile,"%d %d %d %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, node[i].ifc );
		}
	fclose(nmfile);

	if( (nmfile=fopen(hitsfile,"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open hitsfile <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}

	/* write out hits file */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		fprintf(nmfile,"%d %d %d %f %f %f %d %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].hits, node[i].ifc );
		}
	fclose(nmfile);
	timestamp((char*)"final");
		
	exit(0);
	}

void main_qinvert(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, k, l, interface, hitflag, n_arcs, status, order, ec; // nodeid, n, //unused
	double x0[3], t0[3], x1[3], t1[3]; //, v[4], stheta, ftheta, dtheta, theta, azi; //unused
	struct arc_rec arc[MAX_ARCS];
	double traveltime; //, rayx[8000], rayy[8000], rayz[8000]; //unused
//	int tindex[8000]; //unused
	FILE *mpfile, *ttfile, *nmfile;
	char ct[128];
	double xsrc, ysrc, zsrc, xsta, ysta, zsta, th_est, az_est, Q; //ratio, T0, Ta,  //unused
	struct triangle_rec tri;
	struct tetra_rec *pt;

	double thmin, thmax, azimin, azimax, vs;
	int nth, nazi;
	int ng, itt, match; // ierror, //unused
	double *ts, *ts2, rms, rms2; // tolerance,dT, dX, //unused
	double damping;
	int tnode[4];
	int bracket_status;
	int biec;


	struct sparse_matrix *G, *invert_GTG;
	double *d, *GTd, *dm, maxG, maxd, dv, err, qinvint; // Gv, //unused
	int iter, nx, ny, nz;

	double weight;

	char hitsfile[256];

	double new_damping, scx;

	if( argc!=12 ) {
		fprintf(stderr,"purpose: invert local path-averaged quality factor data to improve model\n");
		fprintf(stderr,"usage: %s starting_model_file model_pars_file.txt Qs.tsv damping thmin thmax nth azimin azimax nazi new_model_file\n",argv[0]);
		write_model_blerb(stderr);
		write_model_pars_blerb(stderr);
		fprintf(stderr,"      input traveltimes.tsv:\n");
		fprintf(stderr,"              xs, ys, zs, source location in km\n");
		fprintf(stderr,"                  (but be warned; sort data into groups with common source!\n");
		fprintf(stderr,"              xr, yr, zr, receiver location in km\n");

		fprintf(stderr,"                  (but be warned; z not used!)\n");
		fprintf(stderr,"              receiver interface, integer matching model\n");
		fprintf(stderr,"                  (but be warned; sort data with common source by interface!)\n");
		fprintf(stderr,"              Q,  path-averaged quality factor\n");
		fprintf(stderr,"              order, 0 for 1-st arrival, 1 for second, etc; or\n");
		fprintf(stderr,"                  order=(-1) to have program use closest arrival\n");
		fprintf(stderr,"      damping: damped least squares parameter  (fraction of largest element of GTG)\n");
		fprintf(stderr,"      arrivals are searched for in a star with\n");
		fprintf(stderr,"         thmin, thmax, min, max angles of incidence, (0-180 deg)\n");
		fprintf(stderr,"         nth, integer number of thetas in star\n");
		fprintf(stderr,"         azimin, azimax, azimuth range (0-360 deg)\n");
		fprintf(stderr,"         nazi, integer number of azimuths in star\n");
		fprintf(stderr,"      output new_model_file: same format as starting model file\n");
		fprintf(stderr,"         also output is new_model_file.hits: same format as starting model file, but with velocity replaced with number of rays\n");
		fprintf(stderr,"         interacting with each node\n");
		exit(-1);
		}

	fprintf(stderr,"Raytrace3d Qinvert. Starting model file: %s\n\n", argv[1] );
	timestamp((char*)"at start");


	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( !QDEFINED ) {
		fprintf(stderr,"error: %s: Q must be defined in model file <%s>\n",
		argv[0], argv[1] );
		exit(-1);
		}

	alloc_model_pars(argv[2]);

	if( (mpfile=fopen(argv[2],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open model_par_file <%s> for read\n", argv[0], argv[2] );
		exit(-1);
		}
	n_model_pars=0;
	load_model_pars_V(mpfile);
	fclose(mpfile);

	if( n_model_pars<1000) for( i=0; i<n_model_pars; i++ ) {
		fprintf(stderr,"Model parameter %d has %d nodes\n", i, model_par[i].n );
		for( j=0; j<model_par[i].n; j++ ) {
			fprintf(stderr,"%d %f\n",model_par[i].node[j],model_par[i].weight[j]);
			}
		}

	make_ttime(argv[3]);
	if( (ttfile=fopen(argv[3],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open traveltime.tsv <%s> for read\n", argv[0], argv[3] );
		exit(-1);
		}
	if( fscanf(ttfile,"%s%s%s%s%s%s%s%s%s",
			ct,ct,ct,ct,ct,ct,ct,ct,ct ) != 9 ) {
		fprintf(stderr,"error: %s: cant skip header in traveltimess.tsv <%s>\n",
			argv[0], argv[3]);
		exit(-1);
		}

	n_ttimes=0;
	fprintf(stderr,"\nInput Data\n\n");
	fprintf(stderr,"#\txs\tys\tzs\txr\tyr\tzr\tinterface\tQ\torder\n");
 	while( fscanf(ttfile,"%le%le%le%le%le%le%d%le%d", &xsrc,&ysrc,&zsrc,
		&xsta,&ysta,&zsta,&interface,&Q,&order)==9){
		if( n_ttimes > MAX_TTIMES ) {
			fprintf(stderr,"error: %s: too many Qs\n", argv[0] );
			exit(-1);
			}
		ttime[n_ttimes].ok=FALSE;
		ttime[n_ttimes].x0[0]=xsrc;
		ttime[n_ttimes].x0[1]=ysrc;
		ttime[n_ttimes].x0[2]=zsrc;
		ttime[n_ttimes].x1[0]=xsta;
		ttime[n_ttimes].x1[1]=ysta;
		ttime[n_ttimes].x1[2]=zsta;
		ttime[n_ttimes].interface=interface;
		ttime[n_ttimes].T0=0.0;
		ttime[n_ttimes].obsTT=0.0;
		ttime[n_ttimes].obsTa=0.0;
		ttime[n_ttimes].preTa=0.0;
		ttime[n_ttimes].preTT=0.0;
		ttime[n_ttimes].ratio=1.0;
		ttime[n_ttimes].qinv=1.0/Q;
		ttime[n_ttimes].obsorder=order;
		ttime[n_ttimes].preorder=order;
		fprintf(stderr,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%f\t%d\n",
			n_ttimes,
			ttime[n_ttimes].x0[0], ttime[n_ttimes].x0[1], ttime[n_ttimes].x0[2],
			ttime[n_ttimes].x1[0], ttime[n_ttimes].x1[1], ttime[n_ttimes].x1[2],
			ttime[n_ttimes].interface, 1.0/ttime[n_ttimes].qinv, ttime[n_ttimes].obsorder );
		n_ttimes++;
		}
	fclose(ttfile);

	fprintf(stderr,"Total of %d data\n\n", n_ttimes);

	if( sscanf(argv[4], "%le", &damping) != 1 ) {
		fprintf(stderr,"error: %s: cant read damping from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &thmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read thmin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &thmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read thmax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%d", &nth) != 1 ) {
		fprintf(stderr,"error: %s: cant read nth from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%le", &azimin) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%le", &azimax) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10], "%d", &nazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read nazi from command line\n", argv[0] );
		exit(-1);
		}

	if( (nmfile=fopen(argv[11],"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open new_model_file <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}

	sprintf( hitsfile, "%s.hits", argv[11] );

	G=new_sparse_matrix(n_ttimes,n_model_pars,0);
	ts=(double*)malloc((n_model_pars+2)*sizeof(double));
	ts2=(double*)malloc((n_ttimes+2)*sizeof(double));
	d=(double*)malloc((n_ttimes+2)*sizeof(double));
	GTd=(double*)malloc((n_model_pars+2)*sizeof(double));
	dm=(double*)malloc((n_model_pars+2)*sizeof(double));

	if( (G==NULL) || (d==NULL) || (ts==NULL) || (GTd==NULL) ||
		         (ts2==NULL) || (dm==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (G, d ...)\n", argv[0] );
		exit(-1);
		}
	ng=0;

	fprintf(stderr,"Starting Point to Point Ray tracing of data\n\n");
	fprintf(stderr,"#\tobsQinv\tpreQinv\tobsQ\tpreQ\tQinv_residual\n");

	for( itt=0; itt<n_ttimes; itt++ ) {

	if( itt==0 ) {
		match=FALSE;
		}
	else {
		if( ttime[itt].x0[0]==x0[0] && ttime[itt].x0[1]==x0[1] &&
			ttime[itt].x0[2]==x0[2] && ttime[itt].interface==interface ) 
			match=TRUE; else match=FALSE;
		}

	if( !match ) {
		for( i=0; i<3; i++ ) x0[i]=ttime[itt].x0[i];
		interface=ttime[itt].interface;
		if( !find_tetra(x0,&i) ) {
			fprintf(stderr,"error: %s: source location (%f %f %f) not in model\n", argv[0], x0[0], x0[1], x0[2] );
			exit(-1);
			}
		vs=eval_velocity(&tetra[i],x0);

		fprintf(stderr,"Shooting star pattern from source (%f %f %f) at velocity %f to interface %d, theta (%f, %f, %d) azi (%f %f %d)\n",
		x0[0], x0[1], x0[2], vs,
		interface, thmin, thmax, nth, azimin, azimax, nazi );
		shoot_star(thmin, thmax, nth, azimin, azimax, nazi, x0, interface);
		fprintf(stderr,"done with star\n\n");
		}
	xsta=ttime[itt].x1[0];
	ysta=ttime[itt].x1[1];
	n_tts=0;
	bracket_status=FALSE;
	for( i=0; i<(m_rays-1); i++ )
	for( j=0; j<(n_rays-1); j++ )
	for( l=0; l<2; l++ ) {
		if( instarbox(i, j, l, xsta, ysta, &th_est,
			&az_est, &tri, x0, interface, NULL) ) {
		bracket_status=TRUE;
		if( refine( x0, xsta, ysta, interface, &th_est, &az_est,
			NULL, &n_arcs, &traveltime, &tri) ) {
			if( (n_tts+2)<MAX_TTS ) {
				tt[n_tts].az=az_est;
				tt[n_tts].th=th_est;
				tt[n_tts].T=traveltime;
				n_tts++;
				}
			else {
				fprintf(stderr,"error: %s: too many arrivals\n", argv[0]);
				exit(-1);
				}
			} }
		}
	qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
	if( order==(-1) ) setorder( tt, n_tts, ttime[itt].obsTa-ttime[itt].T0, ttime[itt].ratio, &ttime[itt].obsorder );
	if( (j=ttime[itt].obsorder) < n_tts ) {
		status=TRUE;
		ray_tangent(tt[j].th,tt[j].az,t0);
		if( !shoot_to_interface( x0, t0, x1, t1, arc, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec ) ) {
			status=FALSE;
			}
		if( !hitflag ) status=FALSE;
		}
	else status=FALSE;

	if( status ) {
		ttime[itt].ok=TRUE;
		ttime[itt].preorder=j;
		ttime[itt].preTT=traveltime*ttime[itt].ratio;
		ttime[itt].preqinv=qinvint/traveltime;
		ttime[itt].th=tt[j].th;
		ttime[itt].az=tt[j].az;
		fprintf(stderr,"%d\t%f\t%f\t%f\t%f\t%f\n", itt, 
			ttime[itt].qinv, ttime[itt].preqinv,
			1.0/ttime[itt].qinv, 1.0/ttime[itt].preqinv,
			ttime[itt].qinv-ttime[itt].preqinv);
		}
	else {
		ttime[itt].ok=FALSE;
		fprintf(stderr,"warning: lost observation %d\n", itt);
		if( !bracket_status ) {
			fprintf(stderr,"         ray was not bracketed\n" );
			}
		else {
			if( refine_star_status==1 ) {
				fprintf(stderr,"         derivative failed in refine\n" );
				}
			if( refine_star_status==2 ) {
				fprintf(stderr,"         ray came this close: %e\n", refine_star_norm );
				}
			}
		continue;
		}

	d[ng]=ttime[itt].qinv-ttime[itt].preqinv;

	for( i=0; i<n_nodes; i++ ) node[i].touched=0;
	for( i=0; i<n_arcs; i++ ) {
		node[ arc[i].ptetra->n1 ].touched=1;
		node[ arc[i].ptetra->n2 ].touched=1;
		node[ arc[i].ptetra->n3 ].touched=1;
		node[ arc[i].ptetra->n4 ].touched=1;
		}
	for( i=0; i<n_nodes; i++ ) {
		if( node[i].touched ) node[i].hits++;
		node[i].touched=0;
		}

	for( j=0; j<n_model_pars; j++ ) {
		/* will varying this model parameter change the qinv ? */
		match=FALSE;
		for( i=0; i<n_arcs; i++ ) {
			pt=arc[i].ptetra;
			tnode[0]=pt->n1; tnode[1]=pt->n2; tnode[2]=pt->n3; tnode[3]=pt->n4;
			for( k=0; k<4; k++ ) {
				if( node_in_model_par(tnode[k],j) ) {
					match=TRUE;
					break;
					}
				}
			if(match) break;
			}
		if( match ) {
			set_sparse_value( G, ng, j,
				dqinvdmp(j,arc,n_arcs,traveltime,qinvint) );
			}
		else {
			;/* G[ng][j] is zero */
			}
		}

	ng++;

	} /* next traveltime */
	
	timestamp((char*)"after raytracing");

	if( ng<100 && n_model_pars<6 ) {
		fprintf(stderr,"\nG, d:\n");
		for(i=0; i<ng; i++ ) {
			fprintf(stderr,"%d\t", i);
			for( j=0; j<n_model_pars; j++ ) {
				fprintf(stderr,"%f\t", get_sparse_value(G,i,j) );
				}
			fprintf(stderr,"%f\n", d[i] );
			}
		fprintf(stderr,"\n");
		}

	k=sparse_count(G);
	maxG=sparse_absmax(G);
	maxd=0.0;
	for( i=0; i<ng; i++ ) {
		dv=fabs(d[i]);
		if( dv>maxd ) maxd=dv;
		}
	fprintf(stderr,"\nG is %d by %d, is %f percent full, and has abs max of %f\n", ng, n_model_pars, 100.0*(double)k/((double)ng*(double)n_model_pars), maxG );
	fprintf(stderr,"\nd is %d by 1 and  has abs max of %f\n\n", ng, maxd );
	
	fprintf(stderr,"Damping: %e\n\n", damping );

	smt_times_v( G, d, GTd );
	maxd=0.0;
	for( i=0; i<n_model_pars; i++ ) {
		dv=fabs(GTd[i]);
		if( dv>maxd ) maxd=dv;
		}

	fprintf(stderr, "GTd is %d by 1, and has absolute maximum of %f\n\n", n_model_pars, maxd );
	
	if( EXPLICIT_GTG ) {

	invert_GTG=smt_times_sm(G,G);
	if( invert_GTG==NULL ) {
		fprintf(stderr,"error: %s: out of memory (invert_GTG)\n", argv[0] );
		exit(-1);
		}

	maxG=sparse_absmax(invert_GTG);
	k=sparse_count(invert_GTG);
	sparse_addtodiag(invert_GTG, damping*maxG);

	fprintf(stderr,
	"GTG is %d by %d, is %f percent full, and has absolute maximum of %f\n\n",
	n_model_pars, n_model_pars,
	100.0*(double)k/((double)n_model_pars*(double)n_model_pars), maxG );
	timestamp((char*)"after forming GTG");

	
	for( i=0; i<n_model_pars; i++ ) {
		dm[i]=0.0;
		}
	if( !sparse_biconj( invert_GTG,GTd,dm,1,maxd*B_PREC,n_model_pars+10,&iter,&err,&biec) ) {
		fprintf(stderr,"error: %s: biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
	fprintf(stderr,"Matrix inversion (explicit): %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after explicit solution");
	
	sm_times_v( invert_GTG, dm, ts );
	if( n_model_pars < 1000 ) {
		fprintf(stderr,"\nGTG*dm=GTd\n");
		fprintf(stderr,"#\tobs\tpred\tdifference\n");
		}
	rms=0.0;
	for( i=0; i<n_model_pars; i++ ) {
		if( n_model_pars < 1000 ) fprintf(stderr,"%d\t%f\t%f\t%f\n", i, GTd[i], ts[i], GTd[i]-ts[i] );
		rms+=(GTd[i]-ts[i])*(GTd[i]-ts[i]);
		}
	rms = sqrt(rms/(double)n_model_pars);
	fprintf(stderr,"\nrms solution error is %f\n\n", rms);
	

	} /* end explicit GTG */
	else {
	
	scx = ATAabsmax( G );
	new_damping = damping*scx;
	fprintf(stderr,"Damping: %e abmaxGTG: %e Scaled_damping: %e\n\n",
		damping, scx, new_damping );

	for( i=0; i<n_model_pars; i++ ) dm[i]=0.0;
	if( !sparse_dls_biconj( G, d, dm, new_damping, 1, maxd*B_PREC, n_model_pars+10, &iter,&err,&biec ) ) {
		fprintf(stderr,"error: %s: dls_biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
		
	fprintf(stderr,"Matrix inversion (implicit): %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after implicit solution");
	} /* end implicit GTG */
		
	if( n_model_pars < 1000 ) {
		fprintf(stderr, "Model parameter perturbations\n");
		fprintf(stderr, "#\tdm\n");
		for( i=0; i<n_model_pars; i++ ) {
			fprintf(stderr,"%i\t%f\n", i, dm[i] );
			}
		fprintf(stderr,"\n");
		}

	sm_times_v( G, dm, ts2 );
	fprintf(stderr,"\nG*dm=dt\n");
	fprintf(stderr,"#\tobs_dQinv\tpred_dQinv\tdifference\n");
	rms=0.0;
	rms2=0.0;
	for( i=0; i<ng; i++ ) {
		fprintf(stderr,"%d\t%f\t%f\t%f\n", i, d[i], ts2[i], d[i]-ts2[i] );
		rms+=(d[i]-ts2[i])*(d[i]-ts2[i]);
		rms2+=d[i]*d[i];
		}
	rms = sqrt(rms/(double)ng);
	rms2 = sqrt(rms2/(double)ng);
	fprintf(stderr,"\nlinearized rms Qinv error is %f compared to original %f\n", rms, rms2);
	fprintf(stderr,"%f percent reduction\n", 100.0*(1-rms/rms2));

	/* update velocity of nodes */
	for( i=0; i<n_model_pars; i++ ) {
		for( j=0; j<model_par[i].n; j++ ) {
			k=model_par[i].node[j];
			weight=model_par[i].weight[j];
			node[k].qinv += weight*dm[i];
			}
		}
	/* write out perturbed model */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		if( QDEFINED )
		fprintf(nmfile,"%d %d %d %f %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, 1.0/node[i].qinv, node[i].ifc );
		else
		fprintf(nmfile,"%d %d %d %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, node[i].ifc );
		}

	fclose(nmfile);

	if( (nmfile=fopen(hitsfile,"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open hitsfile <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}

	/* write out hits file */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		fprintf(nmfile,"%d %d %d %f %f %f %d %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].hits, node[i].ifc );
		}
	fclose(nmfile);

	timestamp((char*)"finish");

	exit(0);
	}



void main_invert_tele(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, k, l, interface, hitflag, n_arcs, status, order, ec, dot0; // nodeid, n, //unused
	double x0[3], t0[3], x1[3], t1[3], theta, azi; // v[4], //unused
	struct arc_rec arc[MAX_ARCS];
	double traveltime; //, rayx[8000], rayy[8000], rayz[8000]; //unused
//	int tindex[8000]; //unused
	FILE *mpfile, *ttfile, *nmfile;
	char ct[128];
	double xsta, ysta, zsta, ratio, Ta; // xsrc, ysrc, zsrc, T0,//unused
	struct triangle_rec tri;
	struct tetra_rec *pt;
	double *blocksum, *blockones;

	double xmin, xmax, ymin, ymax, vapp, z0, x_est, y_est, vp, px, py; // vs, //unused
	int nx, ny, t, my_last_tetra;
	int ng, itt, match, index; // ierror, //unused
	double *ts, *ts2, rms, rms2; //, tolerance, dT, dX //unused
	double damping, qinvint;
	int tnode[4];
	int biec;

	struct sparse_matrix *G, *invert_GTG;

	double *d, *GTd, *dm, maxG, maxd, dv, err, mean; // , Gv//unused
	int iter, nz, *dindex, *dptr;

	double weight, t0weight;

	char hitsfile[256];

	double new_damping, scx;
	
	timestamp((char*)"at start");


	my_last_tetra=(-1);

	if( (argc!=13) && (argc!=14) ) {
		fprintf(stderr,"purpose: invert telseismic traveltime data to improve model\n");
		fprintf(stderr,"usage: %s starting_model_file model_pars_file.txt traveltimes.tsv damping xmin xmax nx ymin ymax ny z0 new_model_file\n",argv[0]);
		fprintf(stderr,"or\n");
		fprintf(stderr,"       %s starting_model_file model_pars_file.txt traveltimes.tsv damping xmin xmax nx ymin ymax ny z0 new_model_file flag\n",argv[0]);
		write_tele_note(stderr);
		write_model_blerb(stderr);
		write_model_pars_blerb(stderr);
		fprintf(stderr,"      input traveltimes.tsv:\n");
		fprintf(stderr,"              index: an integer that is the same for\n");
		fprintf(stderr,"                  all observations of a single teleseismic plane wave\n");
		fprintf(stderr,"                  (but be warned; sort data into groups with common index!\n");
		fprintf(stderr,"              azimuth, in deg, of plane wave\n");
		fprintf(stderr,"              apparent-velocity, in km/s, of plane wave\n");
		fprintf(stderr,"                  (but be warned;  azimuth and apparent-velocity ought to be the same for common index!\n");
		fprintf(stderr,"              xr, yr, zr, receiver location in km\n");
		fprintf(stderr,"                  (but be warned; z not used!)\n");
		fprintf(stderr,"              receiver interface, integer matching model\n");
		fprintf(stderr,"                  (but be warned; sort data with common index by interface!)\n");
		fprintf(stderr,"              Ta,  arrival time in s\n");
		fprintf(stderr,"              ratio, 1 for P 1.76 (or whatever) for S\n");
		fprintf(stderr,"                  Note: The ratio allows S wave traveltimes\n");
		fprintf(stderr,"                  to be used in conjunction with a P wave\n");
		fprintf(stderr,"                  model inversion.  S wave apparent velocities\n");
		fprintf(stderr,"                  are specified in the traveltime file, along\n");
		fprintf(stderr,"                  with an appropriate P:S velocity ratio.  The\n");
		fprintf(stderr,"                  S wave apparent velocity is scaled to a P wave\n");
		fprintf(stderr,"                  apparent velocity prior to raytracing, and then\n");
		fprintf(stderr,"                  the final traveltime is scaled back to an S wave\n");
		fprintf(stderr,"                  traveltime after raytracing. All traveltimes\n");
		fprintf(stderr,"                  in a planewave group must have the same ratio.\n");
		fprintf(stderr,"              order, 0 for 1-st arrival, 1 for second, etc\n");
		fprintf(stderr,"                 Note: Closest arrival option (-1) cannot\n");
		fprintf(stderr,"                 be used since the arrival time at the bottom\n");
		fprintf(stderr,"                 of the model is presumed unknown.  It will\n");
		fprintf(stderr,"                 be reset to 0.\n");
		fprintf(stderr,"      damping: damped least squares parameter  (fraction of largest element of GTG)\n");
		fprintf(stderr,"      arrivals are searched for in a turf with\n");
		fprintf(stderr,"         xmin, xmax, min, max x values, km\n");
		fprintf(stderr,"         nx, integer number of x values in turf\n");
		fprintf(stderr,"         ymin, ymax, min, max y values, km\n");
		fprintf(stderr,"         ny, integer number of y values in turf\n");
		fprintf(stderr,"      z0, in km, reference depth for plane wave\n");
		fprintf(stderr,"         (rays shot from this depth, so it should\n");
		fprintf(stderr,"         be within the model but near its bottom)\n");
		fprintf(stderr,"      output new_model_file: same format as starting model file\n");
		fprintf(stderr,"         also output is new_model_file.hits: same format as starting model file, but with velocity replaced with number of rays\n");
		fprintf(stderr,"         interacting with each node\n");
		fprintf(stderr,"      flag: either y or n to either, whether or not to estimate\n");
		fprintf(stderr,"         plane wave arrival times. Default is n\n");
		exit(-1);
		}
	if( argc==13 ) {
		dot0=FALSE;
		}
	else if ( (argv[13][0]=='y') || (argv[13][0]=='Y') ) {
		dot0=TRUE;
		}
	else if ( (argv[13][0]=='n') || (argv[13][0]=='N') ) {
		dot0=FALSE;
		}
	else {
		fprintf(stderr,"error: %s: bad flag <%s>. Must be y or n\n", argv[0], argv[13] );
		exit(-1);
		}

	if( dot0 ) fprintf(stderr,"Raytrace3d teleseismic_invert with t0. Starting model file: %s\n\n", argv[1] );
	else fprintf(stderr,"Raytrace3d teleseismic_invert without t0. Starting model file: %s\n\n", argv[1] );

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	alloc_model_pars(argv[2]);

	if( (mpfile=fopen(argv[2],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open model_par_file <%s> for read\n", argv[0], argv[2] );
		exit(-1);
		}
	n_model_pars=0;
	load_model_pars_V(mpfile);
	fclose(mpfile);

	if( n_model_pars<100 ) for( i=0; i<n_model_pars; i++ ) {
		fprintf(stderr,"Model parameter %d has %d nodes\n", i, model_par[i].n );
		for( j=0; j<model_par[i].n; j++ ) {
			fprintf(stderr,"%d %f\n",model_par[i].node[j],model_par[i].weight[j]);
			}
		}

	make_ttime(argv[3]);
	if( (ttfile=fopen(argv[3],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open traveltime.tsv <%s> for read\n", argv[0], argv[3] );
		exit(-1);
		}
	if( fscanf(ttfile,"%s%s%s%s%s%s%s%s%s%s",
			ct,ct,ct,ct,ct,ct,ct,ct,ct,ct ) != 10 ) {
		fprintf(stderr,"error: %s: cant skip header in traveltimess.tsv <%s>\n",
			argv[0], argv[3]);
		exit(-1);
		}

	n_ttimes=0;

 	while( fscanf(ttfile,"%d%le%le%le%le%le%d%le%le%d", &index,&azi,&vapp,
		&xsta,&ysta,&zsta,&interface,&Ta,&ratio,&order)==10){
		if( (n_ttimes+2) > MAX_TTIMES ) {
			fprintf(stderr,"error: %s: too many traveltimes\n", argv[0] );
			exit(-1);
			}
		if( order==(-1) ) order=0;
		ttime[n_ttimes].ok=FALSE;
		ttime[n_ttimes].index=index;
		ttime[n_ttimes].az=azi;
		ttime[n_ttimes].vapp=vapp;
		ttime[n_ttimes].x1[0]=xsta;
		ttime[n_ttimes].x1[1]=ysta;
		ttime[n_ttimes].x1[2]=zsta;
		ttime[n_ttimes].interface=interface;
		ttime[n_ttimes].obsTa=Ta;
		ttime[n_ttimes].ratio=ratio;
		ttime[n_ttimes].obsorder=order;
		ttime[n_ttimes].preorder=order;
		/* assign planewave group index */
		if( n_ttimes==0 ) {
			n_pwg=0;
			}
		else if( ttime[n_ttimes].index!=ttime[n_ttimes-1].index ) {
			n_pwg++;
			}
		ttime[n_ttimes].pwg=n_pwg;
		n_ttimes++;
		}
	n_pwg++;
	fclose(ttfile);
	
	if( n_ttimes < 1000 ) {
		fprintf(stderr,"\nInput Data\n\n");
		fprintf(stderr,"#\tindex\tazi\tappvel\txr\tyr\tzr\tinterface\tTa\tratio\torder\tpwg\n");
		for( i=0; i<n_ttimes; i++ ) {
			fprintf(stderr,"%d\t%d\t%f\t%f\t%f\t%f\t%f\t%d\t%f\t%f\t%d\t%d\n",
				i,
				ttime[i].index,ttime[i].az,ttime[i].vapp,
				ttime[i].x1[0],ttime[i].x1[1],ttime[i].x1[2],
				ttime[i].interface,
				ttime[i].obsTa, 
				ttime[i].ratio, ttime[i].obsorder, ttime[i].pwg );
			}
		}

	fprintf(stderr,"Total of %d data in %d planewave groups\n\n", n_ttimes, n_pwg);

	if( sscanf(argv[4], "%le", &damping) != 1 ) {
		fprintf(stderr,"error: %s: cant read damping from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &xmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read xmin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &xmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read xmax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%d", &nx) != 1 ) {
		fprintf(stderr,"error: %s: cant read nx from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%le", &ymin) != 1 ) {
		fprintf(stderr,"error: %s: cant read ymin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%le", &ymax) != 1 ) {
		fprintf(stderr,"error: %s: cant read ymax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10], "%d", &ny) != 1 ) {
		fprintf(stderr,"error: %s: cant read nazi from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[11], "%le", &z0) != 1 ) {
		fprintf(stderr,"error: %s: cant read z0 from command line\n", argv[0] );
		exit(-1);
		}

	if( (nmfile=fopen(argv[12],"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open new_model_file <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}

	sprintf( hitsfile, "%s.hits", argv[12] );

	if( dot0 ) {
		G=new_sparse_matrix(n_ttimes,n_model_pars+n_pwg,0);
		ts=(double*)malloc((n_model_pars+n_pwg+2)*sizeof(double));
		ts2=(double*)malloc((n_ttimes+2)*sizeof(double));
		d=(double*)malloc((n_ttimes+2)*sizeof(double));
		dindex=(int*)malloc((n_ttimes+2)*sizeof(int));
		dptr=(int*)malloc((n_ttimes+2)*sizeof(int));
		GTd=(double*)malloc((n_model_pars+n_pwg+2)*sizeof(double));
		dm=(double*)malloc((n_model_pars+n_pwg+2)*sizeof(double));
		}
	else {
		G=new_sparse_matrix(n_ttimes,n_model_pars,0);
		ts=(double*)malloc((n_model_pars+2)*sizeof(double));
		ts2=(double*)malloc((n_ttimes+2)*sizeof(double));
		d=(double*)malloc((n_ttimes+2)*sizeof(double));
		dindex=(int*)malloc((n_ttimes+2)*sizeof(int));
		dptr=(int*)malloc((n_ttimes+2)*sizeof(int));
		GTd=(double*)malloc((n_model_pars+2)*sizeof(double));
		dm=(double*)malloc((n_model_pars+2)*sizeof(double));
		}

	if( (G==NULL) || (d==NULL) || (dindex==NULL) || (dptr==NULL) ||(ts==NULL) ||
		(ts2==NULL) || (GTd==NULL) || (dm==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (G, d ...)\n", argv[0] );
		exit(-1);
		}

	blocksum=(double*)malloc((n_model_pars+2)*sizeof(double));;
	blockones=(double*)malloc((n_ttimes+2)*sizeof(double));
	if( (blocksum==NULL) || (blockones==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (blocksum ...)\n", argv[0] );
		exit(-1);
		}
	ng=0;

	fprintf(stderr,"Starting Plane-Wave to Point Ray tracing of data\n\n");
	timestamp((char*)"starting raytrace");

	fprintf(stderr,"#\tobsTa\tT-predicted\n");

	for( itt=0; itt<n_ttimes; itt++ ) {

	if( itt==0 ) {
		match=FALSE;
		}
	else {
		if( ttime[itt].index==index && ttime[itt].interface==interface ) 
			match=TRUE; else match=FALSE;
		}

	if( !match ) {
		index=ttime[itt].index;
		azi=ttime[itt].az;
		vapp=ttime[itt].vapp;
		interface=ttime[itt].interface;
		ratio=ttime[itt].ratio;
		fprintf(stderr,"Shooting turf pattern from reference depth %f at azimuth %f and app-velocity %f and ratio %f to interface %d\n",
		z0, azi, vapp, ratio, interface);
		fprintf(stderr,"Turf ranges: x (%f %f %d) y (%f %f %d)\n",
		xmin, xmax, nx, ymin, ymax, ny );
		shoot_turf(xmin, xmax, nx, ymin, ymax, ny, azi, vapp*ratio, z0, 0.0, interface);
		fprintf(stderr,"done with turf\n\n");
		}
	xsta=ttime[itt].x1[0];
	ysta=ttime[itt].x1[1];
	n_tts=0;
	for( i=0; i<(m_turf-1); i++ )
	for( j=0; j<(n_turf-1); j++ )
	for( l=0; l<2; l++ ) {
			if( inturfbox(i, j, l, xsta, ysta, &x_est,
				&y_est, &tri, x0, interface, azi,vapp*ratio,z0,0.0,NULL) )
			if( refine_turf( x0, xsta, ysta, interface, &x_est, &y_est,
				NULL, &n_arcs, &traveltime, &tri, azi,vapp*ratio,z0,0.0) ) {
			if( (n_tts+2)<MAX_TTS ) {
				tt[n_tts].az=x_est;
				tt[n_tts].th=y_est;
				tt[n_tts].T=traveltime;
				n_tts++;
				}
			else {
				fprintf(stderr,"error: %s: too many arrivals\n", argv[0]);
				exit(-1);
				}
			}
		}
	qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
	if( order==(-1) ) setorder( tt, n_tts, ttime[itt].obsTa-ttime[itt].T0, ttime[itt].ratio, &ttime[itt].obsorder );

	if( (j=ttime[itt].obsorder) < n_tts ) {
			status=TRUE;
			x0[0]=tt[j].az;
			x0[1]=tt[j].th;
			x0[2]=z0;
			last_tetra=my_last_tetra;
			if( find_tetra(x0,&t) ) {
				vp = eval_velocity(&tetra[t],x0);
				}
			else status=FALSE;
			if( vp>=(vapp*ratio) ) status=FALSE;
			my_last_tetra=last_tetra;
			theta = 180.0-RTOD*asin(vp/(vapp*ratio));
			ray_tangent(theta,azi,t0);
			px = t0[0]/vp; py=t0[1]/vp;
		if( status) if( !shoot_to_interface( x0, t0, x1, t1, arc, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec ) ) {
			status=FALSE;
			}
		if( status) if( !hitflag ) status=FALSE;
		}
	else status=FALSE;
	if( status ) {
		ttime[itt].ok=TRUE;
		ttime[itt].preorder=j;
		ttime[itt].x0[0]=tt[j].az;
		ttime[itt].x0[1]=tt[j].th;
		ttime[itt].x0[2]=z0;
		ttime[itt].preTa=ratio*(
			traveltime + px*ttime[itt].x0[0] + py*ttime[itt].x0[1] );
		fprintf(stderr,"%d\t%f\t%f\n", itt, ttime[itt].obsTa, ttime[itt].preTa );
		}
	else {
		ttime[itt].ok=FALSE;
		fprintf(stderr,"warning: lost observation %d\n", itt);
		continue;
		}

	d[ng]=ttime[itt].obsTa-ttime[itt].preTa;
	dindex[ng]=ttime[itt].index;
	dptr[ng]=itt;

	for( i=0; i<n_nodes; i++ ) node[i].touched=0;
	for( i=0; i<n_arcs; i++ ) {
		node[ arc[i].ptetra->n1 ].touched=1;
		node[ arc[i].ptetra->n2 ].touched=1;
		node[ arc[i].ptetra->n3 ].touched=1;
		node[ arc[i].ptetra->n4 ].touched=1;
		}
	for( i=0; i<n_nodes; i++ ) {
		if( node[i].touched ) node[i].hits++;
		node[i].touched=0;
		}

	for( j=0; j<n_model_pars; j++ ) {
		/* will varying this model parameter change the traveltime ? */
		match=FALSE;
		for( i=0; i<n_arcs; i++ ) {
			pt=arc[i].ptetra;
			tnode[0]=pt->n1; tnode[1]=pt->n2; tnode[2]=pt->n3; tnode[3]=pt->n4;
			for( k=0; k<4; k++ ) {
				if( node_in_model_par(tnode[k],j) ) {
					match=TRUE;
					break;
					}
				}
			if(match) break;
			}
		if( match ) {
			set_sparse_value( G, ng, j,
				dTdmp(j,arc,n_arcs,traveltime)*ttime[itt].ratio );
			}
		else {
			/* G[ng][j] = 0.0; */
			;
			}
		}

	ng++;

	} /* next traveltime */
	
	timestamp((char*)"after raytracing");


	if( ng<100 && n_model_pars<6 ) {
		fprintf(stderr,"\nG, d before demean:\n");
		for(i=0; i<ng; i++ ) {
			fprintf(stderr,"%d\t", i);
			for( j=0; j<n_model_pars; j++ ) {
				fprintf(stderr,"%f\t", get_sparse_value(G,i,j) );
				}
			fprintf(stderr,"%f\n", d[i] );
			}
		fprintf(stderr,"\n");
		}

	maxG=sparse_absmax(G);
	t0weight=maxG/10.0;
	k=sparse_count(G);
	fprintf(stderr,"\nBefore adjustment for t0\n");
	fprintf(stderr,"G is %d by %d, is %f percent full, and has abs max of %f\n", ng, n_model_pars, 100.0*(double)k/((double)ng*(double)n_model_pars), maxG );
	maxd=0.0;
	for( i=0; i<ng; i++ ) {
		dv=fabs(d[i]);
		if( dv>maxd ) maxd=dv;
		}
	fprintf(stderr,"d is %d by 1 and has abs max of %f\n\n", ng, maxd );

	if (dot0 ) {
		/* add elements of G associate with dt0 model parameters */
		for( i=0; i<ng; i++ ) {
			j = ttime[dptr[i]].pwg;
			set_sparse_value( G, i, n_model_pars+j, t0weight );
			}
		/* subtract <ta> - <tt> from d */	
		i=0;
		while( i<ng ) {
			j=i;
			while( (j<ng) && (dindex[j]==dindex[i]) ) j++;
			mean=0.0;
			for( k=i; k<j; k++ ) mean+=d[k];
			mean /= (double)(j-i);
			for( k=i; k<j; k++ ) d[k]-=mean;
			i=j;
			}		
		}
	else {
		/* planewave-wide demean of equations */
		fprintf(stderr,"rows of G that are in same planewave group\n");
		i=0;
		while( i<ng ) {
			j=i;
			while( (j<ng) && (dindex[j]==dindex[i]) ) j++;
			fprintf(stderr,"%d to %d\n", i, j-1); fflush(stderr);
			for( k=0; k<ng; k++ ) blockones[k]=0.0;
			mean=1.0/(double)(j-i);
			for( k=i; k<j; k++ ) blockones[k]=mean;
			smt_times_v( G, blockones, blocksum );
			for( l=0; l<n_model_pars; l++ ) {
				for( k=i; k<j; k++ ) blockones[k]=(-blocksum[l]);
				sparse_add_to_col( G, l, blockones );
				}
			mean=0.0;
			for( k=i; k<j; k++ ) mean+=d[k];
			mean /= (double)(j-i);
			for( k=i; k<j; k++ ) d[k]-=mean;
			i=j;
			}
		fprintf(stderr,"\n");
		}

	if( ng<100 && n_model_pars<6 ) {
		fprintf(stderr,"\nG, d after demean:\n");
		for(i=0; i<ng; i++ ) {
			fprintf(stderr,"%d\t", i);
			for( j=0; j<n_model_pars; j++ ) {
				fprintf(stderr,"%f\t", get_sparse_value(G,i,j) );
				}
			fprintf(stderr,"%f\n", d[i] );
			}
		fprintf(stderr,"\n");
		}

	maxG=sparse_absmax(G);
	k=sparse_count(G);

	maxd=0.0;
	for( i=0; i<ng; i++ ) {
		dv=fabs(d[i]);
		if( dv>maxd ) maxd=dv;
		}

	fprintf(stderr,"\nAfter adjustment for t0\n");
	timestamp((char*)"after adjustment");

	if( dot0 )
		fprintf(stderr,"G is %d by %d, is %f percent full, and has abs max of %f\n", ng, n_model_pars+n_pwg, 100.0*(double)k/((double)ng*(double)n_model_pars), maxG );
	else
		fprintf(stderr,"G is %d by %d, is %f percent full, and has abs max of %f\n", ng, n_model_pars, 100.0*(double)k/((double)ng*(double)n_model_pars), maxG );

		
	fprintf(stderr,"d is %d by 1 and  has abs max of %f\n\n", ng, maxd );
	
	smt_times_v( G, d, GTd );

	if( dot0 ) {
		maxd=0.0;
		for( i=0; i<n_model_pars+n_pwg; i++ ) {
			dv=fabs(GTd[i]);
			if( dv>maxd ) maxd=dv;
			}
		fprintf(stderr, "GTd is %d by 1, and has absolute maximum of %f\n\n", n_model_pars+n_pwg, maxd );
		}
	else {
		maxd=0.0;
		for( i=0; i<n_model_pars; i++ ) {
			dv=fabs(GTd[i]);
			if( dv>maxd ) maxd=dv;
			}
		fprintf(stderr, "GTd is %d by 1, and has absolute maximum of %f\n\n", n_model_pars, maxd );
		}
	
	if( EXPLICIT_GTG ) { /* start of explicit GTG part */

	invert_GTG = smt_times_sm(G,G);
	if( invert_GTG==NULL ) {
		fprintf(stderr,"error: %s: out of memory (invert_GTG)\n", argv[0] );
		exit(-1);
		}
	maxG=sparse_absmax(invert_GTG);
	k=sparse_count(invert_GTG);
	sparse_addtodiag(invert_GTG, damping*maxG);
	fprintf(stderr,"Damping: %e\n\n", damping );
	timestamp((char*)"after explicitly forming GTG");

	if( dot0 ) {
		fprintf(stderr,
		"GTG is %d by %d, is %f percent full, and has absolute maximum of %f\n\n",
		n_model_pars+n_pwg, n_model_pars+n_pwg,
		100.0*(double)k/((double)(n_model_pars+n_pwg)*(double)(n_model_pars+n_pwg)), maxG );
		}
	else {
		fprintf(stderr,
		"GTG is %d by %d, is %f percent full, and has absolute maximum of %f\n\n",
		n_model_pars, n_model_pars,
		100.0*(double)k/((double)n_model_pars*(double)n_model_pars), maxG );
		}

	if( dot0 ) {
		for( i=0; i<n_model_pars+n_pwg; i++ ) dm[i]=0.0;
		if( !sparse_biconj( invert_GTG,GTd,dm,1,maxd*B_PREC,n_model_pars+n_pwg+10,&iter,&err,&biec) ) {
			fprintf(stderr,"error: %s: biconj fails\n",argv[0]);
			if(biec>0)exit(-1);
			}
		}
	else {
		for( i=0; i<n_model_pars; i++ ) dm[i]=0.0;
		if( !sparse_biconj( invert_GTG,GTd,dm,1,maxd*B_PREC,n_model_pars+10,&iter,&err,&biec) ) {
			fprintf(stderr,"error: %s: biconj fails\n",argv[0]);
			if(biec>0)exit(-1);
			}
		}
		
	fprintf(stderr,"Matrix inversion: %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after explicit solution");
	
	sm_times_v( invert_GTG, dm, ts );

	if( n_model_pars<1000) fprintf(stderr,"\nGTG*dm=GTd\n");
	rms=0.0;
	for( i=0; i<n_model_pars; i++ ) {
		if( n_model_pars<1000) fprintf(stderr,"%d\t%f\t%f\t%f\n", i, GTd[i], ts[i], GTd[i]-ts[i] );
		rms+=(GTd[i]-ts[i])*(GTd[i]-ts[i]);
		}
	rms = sqrt(rms/(double)n_model_pars);
	fprintf(stderr,"\nrms solution error is %f\n\n", rms);
	
	} /* end of explicit GTG part */
	
	else { /* start of implicit GTG part */
	
	fprintf(stderr,"Damping: %e\n\n", damping );
			
	if( dot0 ) {
		scx = ATAabsmax( G );
		new_damping = damping*scx;
		fprintf(stderr,"Damping: %e abmaxGTG: %e Scaled_damping: %e\n\n",
			damping, scx, new_damping );
		for( i=0; i<n_model_pars+n_pwg; i++ ) dm[i]=0.0;
		if( !sparse_dls_biconj( G, d, dm, new_damping, 1, maxd*B_PREC, n_model_pars+n_pwg+10, &iter,&err,&biec ) ) {
			fprintf(stderr,"error: %s: dls_biconj fails\n",argv[0]);
			if(biec>0)exit(-1);
			}
		}
	else {
		scx = ATAabsmax( G );
		new_damping = damping*scx;
		fprintf(stderr,"Damping: %e abmaxGTG: %e Scaled_damping: %e\n\n",
			damping, scx, new_damping );
		for( i=0; i<n_model_pars; i++ ) dm[i]=0.0;
		if( !sparse_dls_biconj( G, d, dm, new_damping, 1, maxd*B_PREC, n_model_pars+10, &iter,&err,&biec ) ) {
			fprintf(stderr,"error: %s: dls_biconj fails\n",argv[0]);
			if(biec>0)exit(-1);
			}
		}
		
	fprintf(stderr,"Matrix inversion: %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after implicit solution");


	} /* end of implicit GTG part */

	if( n_model_pars<1000 ) {
		fprintf(stderr, "Velocity Model parameter perturbations\n");
		fprintf(stderr, "#\tdm\n");
		for( i=0; i<n_model_pars; i++ ) {
			fprintf(stderr,"%i\t%f\n", i, dm[i] );
			}
		fprintf(stderr,"\n");
		}
		
	if( dot0 ) {
		mean=fabs(dm[n_model_pars]);
		for( i=n_model_pars; i<n_model_pars+n_pwg; i++ ) {
			maxd=fabs(dm[i]);
			if( maxd>mean ) mean=maxd;
			}
		fprintf(stderr,"The largest dt0 is %e\n", mean*t0weight );
		}

	

	sm_times_v( G, dm, ts2 );
	fprintf(stderr,"\nG*dm=dt\n");
	fprintf(stderr,"#\tobs_dt\tpred_st\tdifference\n");
	rms=0.0;
	rms2=0.0;
	for( i=0; i<ng; i++ ) {
		fprintf(stderr,"%d\t%f\t%f\t%f\n", i, d[i], ts2[i], d[i]-ts2[i] );
		rms+=(d[i]-ts2[i])*(d[i]-ts2[i]);
		rms2+=d[i]*d[i];
		}
	rms = sqrt(rms/(double)ng);
	rms2 = sqrt(rms2/(double)ng);
	fprintf(stderr,"\nlinearized rms traveltime error is %f compared to original %f\n", rms, rms2);
	fprintf(stderr,"%f percent reduction\n", 100.0*(1-rms/rms2));
	fprintf(stderr,"(but be warned; actual reduction, after re-raytracing, might be different\n");

	/* update velocity of nodes */
	for( i=0; i<n_model_pars; i++ ) {
		for( j=0; j<model_par[i].n; j++ ) {
			k=model_par[i].node[j];
			weight=model_par[i].weight[j];
			node[k].v += weight*dm[i];
			}
		}
	/* write out perturbed model */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		if( QDEFINED )
		fprintf(nmfile,"%d %d %d %f %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, 1.0/node[i].qinv, node[i].ifc );
		else
		fprintf(nmfile,"%d %d %d %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, node[i].ifc );
		}

	fclose(nmfile);

	if( (nmfile=fopen(hitsfile,"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open hitsfile <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}

	/* write out hits file */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		fprintf(nmfile,"%d %d %d %f %f %f %d %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].hits, node[i].ifc );
		}
	fclose(nmfile);
	timestamp((char*)"at end");

		
	exit(0);
	}




void main_psinvert(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, k, l, interface, hitflag, n_arcs, status, order, ec; // nodeid, n, //unused
	double x0[3], t0[3], x1[3], t1[3]; //, v[4], stheta, ftheta, dtheta, theta, azi; //unused
	struct arc_rec arc[MAX_ARCS];
	double traveltime; //, rayx[8000], rayy[8000], rayz[8000]; //unused
//	int tindex[8000]; //unused
	FILE *mpfile, *ttfile, *nmfile;
	char ct[128];
	double xsrc, ysrc, zsrc, xsta, ysta, zsta, ratio, T0, Ta, th_est, az_est;
	struct triangle_rec tri;
	struct tetra_rec *pt;
	struct model_par_rec *ratio_model_par, *P_model_par;
	int ratio_n_model_pars, P_n_model_pars;
	struct ttime_rec *P_ttime, *S_ttime;
	int P_n_ttimes, S_n_ttimes;

	double thmin, thmax, azimin, azimax, vs;
	int nth, nazi;
	int ng, itt, match; // ierror, //unused
	double *ts, *ts2, rms, rms2; // tolerance, , dT, dX//unused
	double damping;
	int tnode[4];
	int bracket_status;
	int total_n_model_pars, total_n_ttimes;

	struct sparse_matrix *G, *invert_GTG;

	double *d, *GTd, *dm, maxG, maxd, dv, err, qinvint; // Gv, //unused
	double P_max_dT, S_max_dT;
	int iter, nx, ny, nz;

	double weight, relative_weight;
	int biec;

	char hitsfile[256];
	double new_damping, scx;


	if( argc!=17 ) {
		fprintf(stderr,"purpose: invert local P & S traveltime data\n");
		fprintf(stderr,"         for improvements to node P velocities and P:S velocity ratio\n");
		fprintf(stderr,"usage: %s starting_model_file P_model_pars_file.txt ratio_model_pars_file.txt P_traveltimes.tsv S_traveltimes.tsv P_max_dT S_max_dT damping relative_weight thmin thmax nth azimin azimax nazi new_model_file\n",argv[0]);
		fprintf(stderr,"      Note: model file must define both P velocity and P:S velocity ratio\n");
		write_model_blerb(stderr);
		fprintf(stderr,"      Note: Two sets of model parameters, one for P-velocities, one for velocity ratios\n");
		write_model_pars_blerb(stderr);
		fprintf(stderr,"      Note: Two sets of traveltimes.  The ratio field is ignored\n");
		fprintf(stderr,"      input traveltimes.tsv:\n");
		fprintf(stderr,"              xs, ys, zs, source location in km\n");
		fprintf(stderr,"                  (but be warned; sort data into groups with common source!\n");
		fprintf(stderr,"              xr, yr, zr, receiver location in km\n");

		fprintf(stderr,"                  (but be warned; z not used!)\n");
		fprintf(stderr,"              receiver interface, integer matching model\n");
		fprintf(stderr,"                  (but be warned; sort data with common source by interface!)\n");
		fprintf(stderr,"              T0,  origin time in s\n");
		fprintf(stderr,"              Ta,  arrival time in s\n");
		fprintf(stderr,"              ratio, 1 for P 1.76 (or whatever) for S\n");
		fprintf(stderr,"                   (but this field is ignored)\n");
		fprintf(stderr,"              order, 0 for 1-st arrival, 1 for second, etc\n");
		fprintf(stderr,"                 Note: (-1) indicates closest arrival\n");
		fprintf(stderr,"                 Note: both first ariving P, S have order 0\n");
		fprintf(stderr,"      P_max_dT, S_max_dt: if the absolute value of the traveltime residual, |dT|=|Tobs-Tpred(initial_model)|\n");
		fprintf(stderr,"              is greater than max_dt, that data is ignored\n");
		fprintf(stderr,"      damping: damped least squares parameter  (fraction of largest element of GTG)\n");
		fprintf(stderr,"      relative_weight: of velocity and ratio purturbations\n");
		fprintf(stderr,"              (In other words, how much is a km/s of velocity perturbation, dVp worth\n");
		fprintf(stderr,"              relative to a P:S ratio perturbation, d-ratio?  The dTs/d-ratio\n");
		fprintf(stderr,"              derivatives in the normal equations G dm = dT are\n");
		fprintf(stderr,"              multipled by relative_weight prior to the damped\n");
		fprintf(stderr,"              least-squares solution.  Thus the damping tends to\n");
		fprintf(stderr,"              drive ||dvP||**2+||d-ratio/relative_weight||**2 to zero.\n");
		fprintf(stderr,"              A relative_weigth>1 thus reduces the penalty of d-ratio\n");
		fprintf(stderr,"              relative to dvP - so large d-ratios's are favored over\n");
		fprintf(stderr,"              large dvP's\n");
		fprintf(stderr,"      arrivals are searched for in a star with\n");
		fprintf(stderr,"         thmin, thmax, min, max angles of incidence, (0-180 deg)\n");
		fprintf(stderr,"         nth, integer number of thetas in star\n");
		fprintf(stderr,"         azimin, azimax, azimuth range (0-360 deg)\n");
		fprintf(stderr,"         nazi, integer number of azimuths in star\n");
		fprintf(stderr,"      output new_model_file: same format as starting model file\n");
		fprintf(stderr,"         also output is new_model_file.hits: same format as starting model file, but with velocity replaced with number of rays\n");
		fprintf(stderr,"         interacting with each node\n");
		exit(-1);
		}

	fprintf(stderr,"Raytrace3d PSinvert. Starting model file: %s\n\n", argv[1] );

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	model_par=NULL; n_model_pars=0;
	alloc_model_pars(argv[2]);
	if( (mpfile=fopen(argv[2],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open P_model_par_file <%s> for read\n", argv[0], argv[2] );
		exit(-1);
		}
	load_model_pars_V(mpfile);
	fclose(mpfile);
	P_model_par=model_par;
	P_n_model_pars=n_model_pars;
	fprintf(stderr,"P model parameters from file %s:\n", argv[2]);
	if( P_n_model_pars < 1000 ) for( i=0; i<n_model_pars; i++ ) {
		fprintf(stderr,"Model parameter %d has %d nodes\n", i, model_par[i].n );
		for( j=0; j<model_par[i].n; j++ ) {
			fprintf(stderr,"%d %f\n",model_par[i].node[j],model_par[i].weight[j]);
			}
		}
	fprintf(stderr,"\n\n");

	model_par=NULL; n_model_pars=0;
	alloc_model_pars(argv[3]);
	if( (mpfile=fopen(argv[3],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open ratio_model_par_file <%s> for read\n", argv[0], argv[2] );
		exit(-1);
		}
	load_model_pars_V(mpfile);
	fclose(mpfile);
	ratio_model_par=model_par;
	ratio_n_model_pars=n_model_pars;
	fprintf(stderr,"ratio model parameters from file %s:\n", argv[3]);
	if( ratio_n_model_pars < 1000 ) for( i=0; i<n_model_pars; i++ ) {
		fprintf(stderr,"Model parameter %d has %d nodes\n", i, model_par[i].n );
		for( j=0; j<model_par[i].n; j++ ) {
			fprintf(stderr,"%d %f\n",model_par[i].node[j],model_par[i].weight[j]);
			}
		}
	fprintf(stderr,"\n\n");

	model_par=P_model_par; n_model_pars=P_n_model_pars;

	make_ttime(argv[4]);
	if( (ttfile=fopen(argv[4],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open P_traveltime.tsv <%s> for read\n", argv[0], argv[3] );
		exit(-1);
		}
	if( fscanf(ttfile,"%s%s%s%s%s%s%s%s%s%s%s",
			ct,ct,ct,ct,ct,ct,ct,ct,ct,ct,ct ) != 11 ) {
		fprintf(stderr,"error: %s: cant skip header in traveltimess.tsv <%s>\n",
			argv[0], argv[3]);
		exit(-1);
		}

	n_ttimes=0;
	fprintf(stderr,"\nInput P Data\n\n");
	fprintf(stderr,"#\txs\tys\tzs\txr\tyr\tzr\tinterface\tT0\tTa\tratio\torder\n");
 	while( fscanf(ttfile,"%le%le%le%le%le%le%d%le%le%le%d", &xsrc,&ysrc,&zsrc,
		&xsta,&ysta,&zsta,&interface,&T0,&Ta,&ratio,&order)==11){
		if( (n_ttimes+2) > MAX_TTIMES ) {
			fprintf(stderr,"error: %s: too many traveltimes\n", argv[0] );
			exit(-1);
			}
		ttime[n_ttimes].ok=FALSE;
		ttime[n_ttimes].x0[0]=xsrc;
		ttime[n_ttimes].x0[1]=ysrc;
		ttime[n_ttimes].x0[2]=zsrc;
		ttime[n_ttimes].x1[0]=xsta;
		ttime[n_ttimes].x1[1]=ysta;
		ttime[n_ttimes].x1[2]=zsta;
		ttime[n_ttimes].interface=interface;
		ttime[n_ttimes].T0=T0;
		ttime[n_ttimes].obsTT=Ta-T0;
		ttime[n_ttimes].obsTa=Ta;
		ttime[n_ttimes].preTa=0.0;
		ttime[n_ttimes].preTT=0.0;
		ttime[n_ttimes].ratio=ratio;
		ttime[n_ttimes].obsorder=order;
		ttime[n_ttimes].preorder=order;
		fprintf(stderr,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%f\t%f\t%f\t%d\n",
			n_ttimes,
			ttime[n_ttimes].x0[0],ttime[n_ttimes].x0[1],ttime[n_ttimes].x0[2],
			ttime[n_ttimes].x1[0],ttime[n_ttimes].x1[1],ttime[n_ttimes].x1[2],
			ttime[n_ttimes].interface,
			ttime[n_ttimes].T0, ttime[n_ttimes].obsTa, 
			ttime[n_ttimes].ratio, ttime[n_ttimes].obsorder );
		n_ttimes++;
		}
	fclose(ttfile);
	fprintf(stderr,"Total of %d P data\n\n", n_ttimes);
	P_ttime = ttime; P_n_ttimes=n_ttimes;

	make_ttime(argv[5]);
	if( (ttfile=fopen(argv[5],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open S_traveltime.tsv <%s> for read\n", argv[0], argv[3] );
		exit(-1);
		}
	if( fscanf(ttfile,"%s%s%s%s%s%s%s%s%s%s%s",
			ct,ct,ct,ct,ct,ct,ct,ct,ct,ct,ct ) != 11 ) {
		fprintf(stderr,"error: %s: cant skip header in traveltimess.tsv <%s>\n",
			argv[0], argv[3]);
		exit(-1);
		}

	n_ttimes=0;
	fprintf(stderr,"\nInput S Data\n\n");
	fprintf(stderr,"#\txs\tys\tzs\txr\tyr\tzr\tinterface\tT0\tTa\tratio\torder\n");
 	while( fscanf(ttfile,"%le%le%le%le%le%le%d%le%le%le%d", &xsrc,&ysrc,&zsrc,
		&xsta,&ysta,&zsta,&interface,&T0,&Ta,&ratio,&order)==11){
		if( (n_ttimes+2) > MAX_TTIMES ) {
			fprintf(stderr,"error: %s: too many traveltimes\n", argv[0] );
			exit(-1);
			}
		ttime[n_ttimes].ok=FALSE;
		ttime[n_ttimes].x0[0]=xsrc;
		ttime[n_ttimes].x0[1]=ysrc;
		ttime[n_ttimes].x0[2]=zsrc;
		ttime[n_ttimes].x1[0]=xsta;
		ttime[n_ttimes].x1[1]=ysta;
		ttime[n_ttimes].x1[2]=zsta;
		ttime[n_ttimes].interface=interface;
		ttime[n_ttimes].T0=T0;
		ttime[n_ttimes].obsTT=Ta-T0;
		ttime[n_ttimes].obsTa=Ta;
		ttime[n_ttimes].preTa=0.0;
		ttime[n_ttimes].preTT=0.0;
		ttime[n_ttimes].ratio=ratio;
		ttime[n_ttimes].obsorder=order;
		ttime[n_ttimes].preorder=order;
		fprintf(stderr,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%f\t%f\t%f\t%d\n",
			n_ttimes,
			ttime[n_ttimes].x0[0],ttime[n_ttimes].x0[1],ttime[n_ttimes].x0[2],
			ttime[n_ttimes].x1[0],ttime[n_ttimes].x1[1],ttime[n_ttimes].x1[2],
			ttime[n_ttimes].interface,
			ttime[n_ttimes].T0, ttime[n_ttimes].obsTa, 
			ttime[n_ttimes].ratio, ttime[n_ttimes].obsorder );
		n_ttimes++;
		}
	fclose(ttfile);
	fprintf(stderr,"Total of %d P data\n\n", n_ttimes);
	S_ttime = ttime; S_n_ttimes=n_ttimes;

	ttime=P_ttime; n_ttimes=P_n_ttimes;

	if( sscanf(argv[6], "%le", &P_max_dT) != 1 ) {
		fprintf(stderr,"error: %s: cant read P_max_dT from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%le", &S_max_dT) != 1 ) {
		fprintf(stderr,"error: %s: cant read S_max_dT from command line\n", argv[0] );
		exit(-1);
		}


	if( sscanf(argv[8], "%le", &damping) != 1 ) {
		fprintf(stderr,"error: %s: cant read damping from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%le", &relative_weight) != 1 ) {
		fprintf(stderr,"error: %s: cant read relative_weight from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10], "%le", &thmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read thmin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[11], "%le", &thmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read thmax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[12], "%d", &nth) != 1 ) {
		fprintf(stderr,"error: %s: cant read nth from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[13], "%le", &azimin) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[14], "%le", &azimax) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[15], "%d", &nazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read nazi from command line\n", argv[0] );
		exit(-1);
		}

	if( (nmfile=fopen(argv[16],"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open new_model_file <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}

	sprintf( hitsfile, "%s.hits", argv[16] );

	total_n_model_pars = P_n_model_pars+ratio_n_model_pars;
	total_n_ttimes = P_n_ttimes+S_n_ttimes;
	G=new_sparse_matrix(total_n_ttimes,total_n_model_pars,0);
	d=(double*)malloc((total_n_ttimes+2)*sizeof(double));
	ts=(double*)malloc((total_n_model_pars+2)*sizeof(double));
	ts2=(double*)malloc((total_n_ttimes+2)*sizeof(double));
	GTd=(double*)malloc((total_n_model_pars+2)*sizeof(double));
	dm=(double*)malloc((total_n_model_pars+2)*sizeof(double));

	if( (G==NULL) || (d==NULL) || (GTd==NULL) ||
		(ts==NULL) || (ts2==NULL) || (dm==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (G, d ...)\n", argv[0] );
		exit(-1);
		}
	ng=0;

	fprintf(stderr,"Starting P-wave Point to Point Ray tracing of data\n\n");
	timestamp((char*)"at start of P-wave raytracing");
	fprintf(stderr,"#\tobsTT\tpreTT\tres\n");

	ttime=P_ttime; n_ttimes=P_n_ttimes;
	model_par=P_model_par; n_model_pars=P_n_model_pars;

	for( itt=0; itt<n_ttimes; itt++ ) {

	if( itt==0 ) {
		match=FALSE;
		}
	else {
		if( ttime[itt].x0[0]==x0[0] && ttime[itt].x0[1]==x0[1] &&
			ttime[itt].x0[2]==x0[2] && ttime[itt].interface==interface ) 
			match=TRUE; else match=FALSE;
		}

	if( !match ) {
		for( i=0; i<3; i++ ) x0[i]=ttime[itt].x0[i];
		interface=ttime[itt].interface;
		if( !find_tetra(x0,&i) ) {
			fprintf(stderr,"error: %s: source location (%f %f %f) not in model\n", argv[0], x0[0], x0[1], x0[2] );
			exit(-1);
			}
		vs=eval_velocity(&tetra[i],x0);

		fprintf(stderr,"Shooting star pattern from source (%f %f %f) at velocity %f to interface %d, theta (%f, %f, %d) azi (%f %f %d)\n",
		x0[0], x0[1], x0[2], vs,
		interface, thmin, thmax, nth, azimin, azimax, nazi );
		shoot_star(thmin, thmax, nth, azimin, azimax, nazi, x0, interface);
		fprintf(stderr,"done with star\n\n");
		}
	xsta=ttime[itt].x1[0];
	ysta=ttime[itt].x1[1];
	n_tts=0;
	bracket_status=FALSE;
	for( i=0; i<(m_rays-1); i++ )
	for( j=0; j<(n_rays-1); j++ )
	for( l=0; l<2; l++ ) {
		if( instarbox(i, j, l, xsta, ysta, &th_est,
			&az_est, &tri, x0, interface, NULL) ) {
		bracket_status=TRUE;
		if( refine( x0, xsta, ysta, interface, &th_est, &az_est,
			NULL, &n_arcs, &traveltime, &tri) ) {
			if( (n_tts+2)<MAX_TTS ) {
				tt[n_tts].az=az_est;
				tt[n_tts].th=th_est;
				tt[n_tts].T=traveltime;
				n_tts++;
				}
			else {
				fprintf(stderr,"error: %s: too many arrivals\n", argv[0]);
				exit(-1);
				}
			} }
		}
	qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
	if( order==(-1) ) setorder( tt, n_tts, ttime[itt].obsTa-ttime[itt].T0, 1.0, &ttime[itt].obsorder );

	if( (j=ttime[itt].obsorder) < n_tts ) {
		status=TRUE;
		ray_tangent(tt[j].th,tt[j].az,t0);
		if( !shoot_to_interface( x0, t0, x1, t1, arc, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec ) ) {
			status=FALSE;
			}
		if( !hitflag ) status=FALSE;
		}
	else status=FALSE;

	if( status ) {
		ttime[itt].ok=TRUE;
		ttime[itt].preorder=j;
		ttime[itt].preTT=traveltime;
		ttime[itt].th=tt[j].th;
		ttime[itt].az=tt[j].az;
		fprintf(stderr,"%d\t%f\t%f\t%f\n", itt, 
			ttime[itt].obsTT, ttime[itt].preTT,
			ttime[itt].obsTT-ttime[itt].preTT);
		}
	else {
		ttime[itt].ok=FALSE;
		fprintf(stderr,"warning: lost observation %d\n", itt);
		if( !bracket_status ) {
			fprintf(stderr,"         ray was not bracketed\n" );
			}
		else {
			if( refine_star_status==1 ) {
				fprintf(stderr,"         derivative failed in refine\n" );
				}
			if( refine_star_status==2 ) {
				fprintf(stderr,"         ray came this close: %e\n", refine_star_norm );
				}
			}
		continue;
		}

	d[ng]=ttime[itt].obsTT-traveltime;

	for( i=0; i<n_nodes; i++ ) node[i].touched=0;
	for( i=0; i<n_arcs; i++ ) {
		node[ arc[i].ptetra->n1 ].touched=1;
		node[ arc[i].ptetra->n2 ].touched=1;
		node[ arc[i].ptetra->n3 ].touched=1;
		node[ arc[i].ptetra->n4 ].touched=1;
		}
	for( i=0; i<n_nodes; i++ ) {
		if( node[i].touched ) node[i].hits++;
		node[i].touched=0;
		}

	for( j=0; j<n_model_pars; j++ ) {
		/* will varying this model parameter change the traveltime ? */
		match=FALSE;
		for( i=0; i<n_arcs; i++ ) {
			pt=arc[i].ptetra;
			tnode[0]=pt->n1; tnode[1]=pt->n2; tnode[2]=pt->n3; tnode[3]=pt->n4;
			for( k=0; k<4; k++ ) {
				if( node_in_model_par(tnode[k],j) ) {
					match=TRUE;
					break;
					}
				}
			if(match) break;
			}
		if( match ) {
			set_sparse_value( G, ng, j,
				dTdmp(j,arc,n_arcs,traveltime) );
			}
		else {
			;/* G[ng][j] is zero */
			}
		}
	/* note also that the block of G corresponding to ratio model pars is zero */

	if( fabs(d[ng]) > P_max_dT ) {
		fprintf(stderr,"|%f|>%f, so ignoring this data \n", d[ng], P_max_dT );
		for( j=0; j<n_model_pars; j++ ) set_sparse_value( G, ng, j, 0.0 );
		}
	else {
		ng++;
		}

	} /* next traveltime */

	timestamp((char*)"at end of P raytracing");
	fprintf(stderr,"\n");

	fprintf(stderr,"Starting S-wave Point to Point Ray tracing of data\n\n");
	timestamp((char*)"at start of S-wave raytracing");
	fprintf(stderr,"#\tobsTT\tpreTT\tres\n");

	ttime=S_ttime; n_ttimes=S_n_ttimes;

	/* Change to S model */
	for( i=0; i<n_nodes; i++ ) node[i].v /= node[i].ratio;
	for( i=0; i<n_tetras; i++ ) velocity_eqn( &tetra[i] );

	for( itt=0; itt<n_ttimes; itt++ ) {

	if( itt==0 ) {
		match=FALSE;
		}
	else {
		if( ttime[itt].x0[0]==x0[0] && ttime[itt].x0[1]==x0[1] &&
			ttime[itt].x0[2]==x0[2] && ttime[itt].interface==interface ) 
			match=TRUE; else match=FALSE;
		}

	if( !match ) {
		for( i=0; i<3; i++ ) x0[i]=ttime[itt].x0[i];
		interface=ttime[itt].interface;
		if( !find_tetra(x0,&i) ) {
			fprintf(stderr,"error: %s: source location (%f %f %f) not in model\n", argv[0], x0[0], x0[1], x0[2] );
			exit(-1);
			}
		vs=eval_velocity(&tetra[i],x0);

		fprintf(stderr,"Shooting star pattern from source (%f %f %f) at velocity %f to interface %d, theta (%f, %f, %d) azi (%f %f %d)\n",
		x0[0], x0[1], x0[2], vs,
		interface, thmin, thmax, nth, azimin, azimax, nazi );
		shoot_star(thmin, thmax, nth, azimin, azimax, nazi, x0, interface);
		fprintf(stderr,"done with star\n\n");
		}
	xsta=ttime[itt].x1[0];
	ysta=ttime[itt].x1[1];
	n_tts=0;
	bracket_status=FALSE;
	for( i=0; i<(m_rays-1); i++ )
	for( j=0; j<(n_rays-1); j++ )
	for( l=0; l<2; l++ ) {
		if( instarbox(i, j, l, xsta, ysta, &th_est,
			&az_est, &tri, x0, interface, NULL) ) {
		bracket_status=TRUE;
		if( refine( x0, xsta, ysta, interface, &th_est, &az_est,
			NULL, &n_arcs, &traveltime, &tri) ) {
			if( (n_tts+2)<MAX_TTS ) {
				tt[n_tts].az=az_est;
				tt[n_tts].th=th_est;
				tt[n_tts].T=traveltime;
				n_tts++;
				}
			else {
				fprintf(stderr,"error: %s: too many arrivals\n", argv[0]);
				exit(-1);
				}
			} }
		}
	qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
	if( order==(-1) ) setorder( tt, n_tts, ttime[itt].obsTa-ttime[itt].T0, 1.0, &ttime[itt].obsorder );

	if( (j=ttime[itt].obsorder) < n_tts ) {
		status=TRUE;
		ray_tangent(tt[j].th,tt[j].az,t0);
		if( !shoot_to_interface( x0, t0, x1, t1, arc, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec ) ) {
			status=FALSE;
			}
		if( !hitflag ) status=FALSE;
		}
	else status=FALSE;

	if( status ) {
		ttime[itt].ok=TRUE;
		ttime[itt].preorder=j;
		ttime[itt].preTT=traveltime;
		ttime[itt].th=tt[j].th;
		ttime[itt].az=tt[j].az;
		fprintf(stderr,"%d\t%f\t%f\t%f\n", itt, 
			ttime[itt].obsTT, ttime[itt].preTT,
			ttime[itt].obsTT-ttime[itt].preTT);
		}
	else {
		ttime[itt].ok=FALSE;
		fprintf(stderr,"warning: lost observation %d\n", itt);
		if( !bracket_status ) {
			fprintf(stderr,"         ray was not bracketed\n" );
			}
		else {
			if( refine_star_status==1 ) {
				fprintf(stderr,"         derivative failed in refine\n" );
				}
			if( refine_star_status==2 ) {
				fprintf(stderr,"         ray came this close: %e\n", refine_star_norm );
				}
			}
		continue;
		}

	d[ng]=ttime[itt].obsTT-traveltime;

	for( i=0; i<n_nodes; i++ ) node[i].touched=0;
	for( i=0; i<n_arcs; i++ ) {
		node[ arc[i].ptetra->n1 ].touched=1;
		node[ arc[i].ptetra->n2 ].touched=1;
		node[ arc[i].ptetra->n3 ].touched=1;
		node[ arc[i].ptetra->n4 ].touched=1;
		}
	for( i=0; i<n_nodes; i++ ) {
		if( node[i].touched ) node[i].hits++;
		node[i].touched=0;
		}

	/* first the dTs/dVp Frechet derivatives */
	model_par=P_model_par; n_model_pars=P_n_model_pars;
	for( j=0; j<n_model_pars; j++ ) {
		/* will varying this model parameter change the traveltime ? */
		match=FALSE;
		for( i=0; i<n_arcs; i++ ) {
			pt=arc[i].ptetra;
			tnode[0]=pt->n1; tnode[1]=pt->n2; tnode[2]=pt->n3; tnode[3]=pt->n4;
			for( k=0; k<4; k++ ) {
				if( node_in_model_par(tnode[k],j) ) {
					match=TRUE;
					break;
					}
				}
			if(match) break;
			}
		if( match ) {
			set_sparse_value( G, ng, j,
				dTsdmpp(j,arc,n_arcs,traveltime) );
			}
		else {
			;/* G[ng][j] is zero */
			}
		}

	/* next the dTs/d-ratio Frechet derivatives */
	model_par=ratio_model_par; n_model_pars=ratio_n_model_pars;
	for( j=0; j<n_model_pars; j++ ) {
		/* will varying this model parameter change the traveltime ? */
		match=FALSE;
		for( i=0; i<n_arcs; i++ ) {
			pt=arc[i].ptetra;
			tnode[0]=pt->n1; tnode[1]=pt->n2; tnode[2]=pt->n3; tnode[3]=pt->n4;
			for( k=0; k<4; k++ ) {
				if( node_in_model_par(tnode[k],j) ) {
					match=TRUE;
					break;
					}
				}
			if(match) break;
			}
		if( match ) {
			set_sparse_value( G, ng, j+P_n_model_pars,
				relative_weight*dTsdmpr(j,arc,n_arcs,traveltime) );
			}
		else {
			;/* G[ng][j] is zero */
			}
		}

	if( fabs(d[ng]) > S_max_dT ) {
		fprintf(stderr,"|%f|>%f, so ignoring this data \n", d[ng], S_max_dT );
		for( j=0; j<total_n_model_pars; j++ ) set_sparse_value( G, ng, j, 0.0 );
		}
	else {
		ng++;
		}

	} /* next traveltime */

	timestamp((char*)"at end of S raytracing");
	
	if( ng<100 && total_n_model_pars<6 ) {
		fprintf(stderr,"\nG, d:\n");
		for(i=0; i<ng; i++ ) {
			fprintf(stderr,"%d\t", i);
			for( j=0; j<total_n_model_pars; j++ ) {
				fprintf(stderr,"%f\t", get_sparse_value(G,i,j) );
				}
			fprintf(stderr,"%f\n", d[i] );
			}
		fprintf(stderr,"\n");
		}

	maxG=sparse_absmax(G);
	k=sparse_count(G);

	maxd=0.0;
	for( i=0; i<ng; i++ ) {
		dv=fabs(d[i]);
		if( dv>maxd ) maxd=dv;
		}

	fprintf(stderr,"\nG is %d by %d, is %f percent full, and has abs max of %f\n", ng, total_n_model_pars, 100.0*(double)k/((double)ng*(double)total_n_model_pars), maxG );
	fprintf(stderr,"\nd is %d by 1 and  has abs max of %f\n\n", ng, maxd );
	timestamp((char*)"after forming G and d");
	fprintf(stderr,"Damping: %e Relative weight: %e\n\n", damping, relative_weight );

	smt_times_v( G, d, GTd );
	maxd=0.0;
	for( i=0; i<total_n_model_pars; i++ ) {
		dv=fabs(GTd[i]);
		if( dv>maxd ) maxd=dv;
		}

	fprintf(stderr,
	"GTd is %d by 1, and has absolute maximum of %f\n\n",
	total_n_model_pars, maxd );
	
	if( EXPLICIT_GTG ) {

	invert_GTG=smt_times_sm(G,G);
	if( invert_GTG==NULL ) {
		fprintf(stderr,"error: %s: out of memory (invert_GTG)\n", argv[0] );
		exit(-1);
		}
	maxG=sparse_absmax(invert_GTG);
	k=sparse_count(invert_GTG);
	sparse_addtodiag(invert_GTG, damping*maxG);

	fprintf(stderr,
	"GTG is %d by %d, is %f percent full, and has absolute maximum of %f\n\n",
	total_n_model_pars, total_n_model_pars,
	100.0*(double)k/((double)total_n_model_pars*(double)total_n_model_pars), maxG );


	timestamp((char*)"after forming GTG ");

	for( i=0; i<total_n_model_pars; i++ ) {
		dm[i]=0.0;
		}
	if( !sparse_biconj( invert_GTG,GTd,dm,1,maxd*B_PREC,total_n_model_pars+10,&iter,&err,&biec) ) {
		fprintf(stderr,"error: %s: biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
	fprintf(stderr,"Matrix inversion (explicit): %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after solving linear system");
	
	if( total_n_model_pars < 1000 ) {
		fprintf(stderr,"\nGTG*dm=GTd\n");
		fprintf(stderr,"#\tobs\tpred\tdifference\n");
		}
	rms=0.0;
	sm_times_v( invert_GTG, dm, ts );
	for( i=0; i<total_n_model_pars; i++ ) {
		rms+=(GTd[i]-ts[i])*(GTd[i]-ts[i]);
                if( total_n_model_pars < 1000 ) {
                	fprintf(stderr,"%d\t%f\t%f\t%f\n", i, GTd[i], ts[i], GTd[i]-ts[i] );
                		}
		}
	rms = sqrt(rms/(double)total_n_model_pars);
	fprintf(stderr,"\nrms solution error is %f\n\n", rms);

	
	} /* end explicit GTG */
	else {
		scx = ATAabsmax( G );
		new_damping = damping*scx;
		fprintf(stderr,"Damping: %e abmaxGTG: %e Scaled_damping: %e\n\n",
		damping, scx, new_damping );
		for( i=0; i<total_n_model_pars; i++ ) dm[i]=0.0;
		if( !sparse_dls_biconj(G,d,dm,new_damping,1,maxd*B_PREC,total_n_model_pars+10,&iter,&err,&biec ) ) {
		fprintf(stderr,"error: %s: dls_biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
		
	fprintf(stderr,"Matrix inversion (implicit): %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after implicit solution");
	} /* end implicit GTG */

	if( total_n_model_pars < 1000 ) {
		fprintf(stderr, "Model parameter perturbations\n");
		fprintf(stderr, "#\tdm\n");
		for( i=0; i<total_n_model_pars; i++ ) {
			fprintf(stderr,"%i\t%f\n", i, dm[i] );
			}
		fprintf(stderr,"\n");
		}

	fprintf(stderr,"\nG*dm=dt\n");
	fprintf(stderr,"#\tobs_dt\tpred_st\tdifference\n");
	sm_times_v( G, dm, ts2 );

	rms=0.0;
	rms2=0.0;
	for( i=0; i<ng; i++ ) {
		fprintf(stderr,"%d\t%f\t%f\t%f\n", i, d[i], ts2[i], d[i]-ts2[i] );
		rms+=(d[i]-ts2[i])*(d[i]-ts2[i]);
		rms2+=d[i]*d[i];
		}
	rms = sqrt(rms/(double)ng);
	rms2 = sqrt(rms2/(double)ng);
	fprintf(stderr,"\nlinearized rms traveltime error is %f compared to original %f\n", rms, rms2);
	fprintf(stderr,"%f percent reduction\n", 100.0*(1-rms/rms2));
	fprintf(stderr,"(but be warned; actual reduction, after re-raytracing, might be different\n");

	/* reset nodes to original values */
	for( i=0; i<n_nodes; i++ ) {
		node[i].v=node[i].v_orig;
		node[i].ratio=node[i].ratio_orig;
		}

	/* update P velocity of nodes */
	model_par=P_model_par; n_model_pars=P_n_model_pars;
	for( i=0; i<n_model_pars; i++ ) {
		for( j=0; j<model_par[i].n; j++ ) {
			k=model_par[i].node[j];
			weight=model_par[i].weight[j];
			node[k].v += weight*dm[i];
			}
		}

	/* update P:S ratio of nodes */
	model_par=ratio_model_par; n_model_pars=ratio_n_model_pars;
	for( i=0; i<n_model_pars; i++ ) {
		for( j=0; j<model_par[i].n; j++ ) {
			k=model_par[i].node[j];
			weight=model_par[i].weight[j];
			node[k].ratio += relative_weight*weight*dm[i+P_n_model_pars];
			}
		}

	/* reset nodal qinv, since that's what's written out */
	for( i=0; i<n_nodes; i++ ) {
		node[i].qinv=1.0/node[i].ratio;
		}

	/* write out perturbed model */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		if( QDEFINED )
		fprintf(nmfile,"%d %d %d %f %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, 1.0/node[i].qinv, node[i].ifc );
		else
		fprintf(nmfile,"%d %d %d %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, node[i].ifc );
		}
	fclose(nmfile);

	if( (nmfile=fopen(hitsfile,"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open hitsfile <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}

	/* write out hits file */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		fprintf(nmfile,"%d %d %d %f %f %f %d %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].hits, node[i].ifc );
		}
	fclose(nmfile);
	timestamp((char*)"final");

		
	exit(0);
	}


#define MAX_WAVEFRONTS (10000)
void main_tt_table(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, k, n_arcs, status, n_azis, n_thetas, ec; // n, //unused
//	int n1, n2, n3, n4, n5, n6, n7, n8; //unused
	double x0[3], t0[3], x1[3], t1[3]; //, v[4]; //unused
	double stheta, ftheta, dtheta, theta, qinvint;
	double sazi, fazi, dazi, azi;
	double traveltime, max_traveltime, dT, te; //, tb; //unused
	struct arc_rec arc[MAX_ARCS];
	float X[MAX_WAVEFRONTS], Y[MAX_WAVEFRONTS], Z[MAX_WAVEFRONTS];
	double T[MAX_WAVEFRONTS];
	int TE[MAX_WAVEFRONTS], iarc, iwave, l, method;
	double r[3], r2[3], psi, Tprev; // psi1, psi2, //unused

	int do_P;

	if( (argc!=13) && (argc!=14) ) {
		fprintf(stderr,"purpose: constructs station-specific traveltime table file\n");
		fprintf(stderr,"	 (The table is organized by rays radiating out from)\n");
		fprintf(stderr,"	 the station at constant azimuths and angles of incidence)\n");
		fprintf(stderr,"usage: %s model_file source_x source_y source_z theta_min theta_max n_thetas azi_min azi_max n_azis dT max_traveltime > tt_table_file\n",argv[0]);
		fprintf(stderr,"or\n");
		fprintf(stderr,"usage: %s model_file source_x source_y source_z theta_min theta_max n_thetas azi_min azi_max n_azis dT max_traveltime P_S_flag > tt_table_file\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      source_x, source_y, source_z in km\n");
		fprintf(stderr,"      theta_min, theta_max, 0-180 degrees from +z\n");
		fprintf(stderr,"      azi_min, azi_max, degrees from +x to +y\n");
		fprintf(stderr,"          azi_min<azi_max, but values > 360 allowed\n");
		fprintf(stderr,"      n_thetas, n_azis, integers, control the number of rays\n");
		fprintf(stderr,"      dT between successive wavefronts in s\n");
		fprintf(stderr,"      max_traveltime in s\n");
		fprintf(stderr,"      P_S_flag: P (default) or S traveltimes\n");
		fprintf(stderr,"      the tt_table_file is a binary file\n");
		fprintf(stderr,"         (other keywords use it, no provision is made for\n");
		fprintf(stderr,"         external use)\n");
		exit(-1);
		}

	if( argc==13 ) {
		do_P=1;
		}
	else if( (argv[13][0]=='P') || (argv[13][0]=='p') ) {
		do_P=1;
		}
	else if( (argv[13][0]=='S') || (argv[13][0]=='s') ) {
		do_P=0;
		}
	else {
		fprintf(stderr,"error: bad P_S_flag (must be P or S)\n");
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	/* Change to S model */
	if( !do_P ) {
		if( !QDEFINED ) {
			fprintf(stderr,"error: %s: velocity model must define ratio %s\n", argv[0], argv[1] );
			exit(-1);
			}
		for( i=0; i<n_nodes; i++ ) node[i].v =  node[i].v_orig/node[i].ratio_orig;
		for( i=0; i<n_tetras; i++ ) velocity_eqn( &tetra[i] );
		}

	if( sscanf(argv[2], "%le", &x0[0]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_x from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[3], "%le", &x0[1]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_y from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[4], "%le", &x0[2]) != 1 ) {
		fprintf(stderr,"error: %s: cant read source_z from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[5], "%le", &stheta) != 1 ) {
		fprintf(stderr,"error: %s: cant read theta_min from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &ftheta) != 1 ) {
		fprintf(stderr,"error: %s: cant read theta_max from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%d", &n_thetas) != 1 ) {
		fprintf(stderr,"error: %s: cant read n_thetas from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%le", &sazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read azi_min from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%le", &fazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read azi_max from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10], "%d", &n_azis) != 1 ) {
		fprintf(stderr,"error: %s: cant read n_azis from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[11], "%le", &dT) != 1 ) {
		fprintf(stderr,"error: %s: cant read dT from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[12], "%le", &max_traveltime) != 1 ) {
		fprintf(stderr,"error: %s: cant read max_traveltime from command line\n", argv[0] );
		exit(-1);
		}

	dtheta = (ftheta-stheta)/(double)(n_thetas-1);
	dazi = (fazi-sazi)/(double)(n_azis-1);

	fwrite( x0, sizeof(double), 3, stdout );

	fwrite( &stheta, sizeof(double), 1, stdout );
	fwrite( &ftheta, sizeof(double), 1, stdout );
	fwrite( &dtheta, sizeof(double), 1, stdout );
	fwrite( &n_thetas, sizeof(int), 1, stdout );

	fwrite( &sazi, sizeof(double), 1, stdout );
	fwrite( &fazi, sizeof(double), 1, stdout );
	fwrite( &dazi, sizeof(double), 1, stdout );
	fwrite( &n_azis, sizeof(int), 1, stdout );

	fwrite( &dT, sizeof(double), 1, stdout );

	for( j=0; j<n_azis; j++ ) for( k=0; k<n_thetas; k++ ) {
		azi=sazi+dazi*(double)j;
		theta=stheta+dtheta*(double)k;
		ray_tangent(theta,azi,t0);
		n_arcs=0.0;
		status=shoot_with_max_traveltime( x0, t0, x1, t1, arc, &n_arcs,
			MAX_ARCS, 10000.0, max_traveltime, &traveltime, &qinvint, &ec );
		for( i=1; i<n_arcs; i++ ) arc[i].T+=arc[i-1].T;
		if( status ) {
			X[0]=x0[0]; Y[0]=x0[1]; Z[0]=x0[2]; T[0]=0.0; iarc=0, iwave=1;
			do {
				T[iwave]=T[iwave-1]+dT;
				if( T[iwave] > arc[n_arcs-1].T ) {
					break;
					}
				while( iarc<n_arcs ) if( T[iwave]>arc[iarc].T ) iarc++; else break;
				if( iarc > 0 ) Tprev=arc[iarc-1].T; else Tprev=0.0;
				te = (T[iwave]-Tprev)
				   + ttintegral(0.0, arc[iarc].ptetra->gs, arc[iarc].R,
					 arc[iarc].psi1, &method);

				psi = inv_integral294a( arc[iarc].ptetra->gs*te );

                       		r[0] = arc[iarc].R*sin(psi);
                       		r[1] = 0.0;
                        	r[2] = arc[iarc].R*cos(psi);

				/* untransform */
				for( l=0; l<3; l++ ) r[l] += arc[iarc].shift[l];
				rotate3(r,arc[iarc].st,r2);

				X[iwave] = r2[0];
				Y[iwave] = r2[1];
				Z[iwave] = r2[2];
				TE[iwave] = arc[iarc].ptetra->index;

				if( (iwave+1) > MAX_WAVEFRONTS ) {
					fprintf(stderr,"Error: %s: too many wavefronts\n", argv[0] );
					exit(-1);
					}
				iwave++;
				} while( T[iwave]<=max_traveltime );
			fwrite( &j, sizeof(int), 1, stdout );
			fwrite( &k, sizeof(int), 1, stdout );
			fwrite( &iwave, sizeof(int), 1, stdout );
			fwrite( X, sizeof(float), iwave, stdout );
			fwrite( Y, sizeof(float), iwave, stdout );
			fwrite( Z, sizeof(float), iwave, stdout );
			for( i=0; i<n_tetras; i++ ) tetra[i].marked=0;
			for( i=0; i<n_arcs; i++ ) arc[i].ptetra->marked=1;
			l=0; for( i=0; i<n_tetras; i++ ) if( tetra[i].marked ) l++;
			fwrite( &l, sizeof(int), 1, stdout );
			for( i=0; i<n_tetras; i++ ) if( tetra[i].marked ) {
				fwrite( &i, sizeof(int), 1, stdout );
				}
			}
		else {
			iwave=0;
			fwrite( &j, sizeof(int), 1, stdout );
			fwrite( &k, sizeof(int), 1, stdout );
			fwrite( &iwave, sizeof(int), 1, stdout );
			fprintf(stderr,"warning: lost ray (%d %d) error code (%d)\n", j, k, ec );
			}
		}

	exit(0);
	}




void main_tt_surface(int argc,char *argv[])
// int argc;
// char *argv[];
{

	FILE *f;
	int j, k, count, iwave, nTT; // i, //unused
	double TT;
	double x0[3], stheta, ftheta, dtheta, sazi, fazi, dazi, dT;
	int n_thetas, n_azis;


	struct jhd_table_rec {
		double azi, theta;
		float *X, *Y, *Z;
		int iwave, *tlist, nt, hit;
		};
	struct jhd_table_rec *jhd;

	if( argc!=3 ) {
		fprintf(stderr,"purpose: compute travetime surface \n");
		fprintf(stderr,"method: interrogates tt_table file\n");
		fprintf(stderr,"usage:  %s tt_table_file traveltime > tt_surface.txt\n", argv[0]);
		fprintf(stderr,"        traveltime: in seconds\n");
		fprintf(stderr,"        note: rounds off to whatever accuracy is in tt_table\n");
		fprintf(stderr,"        tt_surrface.txt file: header line followed by\n");
		fprintf(stderr,"           one (x, y, z, theta, azi) per line\n");
		exit(-1);
		}

	if( (f=fopen(argv[1],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open tt_table file <%s> for read\n",
			argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2],"%lf",&TT) !=1 ) {
		fprintf(stderr,"error: %s: cant read traveltime from cmd line\n",
			argv[0] );
		exit(-1);
		}

	count=0;
	count+=fread( x0, sizeof(double), 3, f );

	count+=fread( &stheta, sizeof(double), 1, f );
	count+=fread( &ftheta, sizeof(double), 1, f );
	count+=fread( &dtheta, sizeof(double), 1, f );
	count+=fread( &n_thetas, sizeof(int), 1, f );

	count+=fread( &sazi, sizeof(double), 1, f );
	count+=fread( &fazi, sizeof(double), 1, f );
	count+=fread( &dazi, sizeof(double), 1, f );
	count+=fread( &n_azis, sizeof(int), 1, f );

	count+=fread( &dT, sizeof(double), 1, f );

	if( count!=12 ) {
		fprintf(stderr,"error: %s: cant read tt_table file (1)\n", argv[0]);
		exit(-1);
		}

	nTT = (int) (0.5+TT/dT);
	if( nTT<0 ) {
		fprintf(stderr,"error: %s: negative traveltime not allowed\n", argv[0]);
		exit(-1);
		}

	jhd = (struct jhd_table_rec *) malloc( n_thetas * n_azis * sizeof(struct jhd_table_rec) );
	if( jhd==NULL ) {
		fprintf(stderr,"error: %s: out of memory (1)\n", argv[0] );
		exit(-1);
		}
	for( j=0; j<n_azis; j++ ) for( k=0; k<n_thetas; k++ ) {
		jhd[j+k*n_azis].iwave=0; jhd[j+k*n_azis].nt=0; jhd[j+k*n_azis].tlist=NULL;
		jhd[j+k*n_azis].X=NULL; jhd[j+k*n_azis].Y=NULL; jhd[j+k*n_azis].Z=NULL;
		}

	while(1) {
		count=0;
		count+=fread( &j, sizeof(int), 1, f );
		count+=fread( &k, sizeof(int), 1, f );
		count+=fread( &iwave, sizeof(int), 1, f );
		if( count == 0 ) break;
		if( iwave == 0 ) continue;
		if( count != 3 ) {
			fprintf(stderr,"error: %s: cant read tt_table file (2)\n", argv[0] );
			exit(-1);
			}
		jhd[j+k*n_azis].azi=sazi+dazi*(double)j;
		jhd[j+k*n_azis].theta=stheta+dtheta*(double)k;
		jhd[j+k*n_azis].iwave=iwave;

		jhd[j+k*n_azis].X = (float *) malloc( sizeof(float)*iwave );
		jhd[j+k*n_azis].Y = (float *) malloc( sizeof(float)*iwave );
		jhd[j+k*n_azis].Z = (float *) malloc( sizeof(float)*iwave );

		if((jhd[j+k*n_azis].X==NULL)||(jhd[j+k*n_azis].X==NULL)||(jhd[j+k*n_azis].X==NULL)){
			fprintf(stderr,"error: %s: out of memory (2)\n", argv[0] );
			exit(-1);
			}

		count=0;
		count+=fread( jhd[j+k*n_azis].X, sizeof(float), iwave, f );
		count+=fread( jhd[j+k*n_azis].Y, sizeof(float), iwave, f );
		count+=fread( jhd[j+k*n_azis].Z, sizeof(float), iwave, f );
		if( count != (3*iwave) ) {
			fprintf(stderr,"error: %s: cant read tt_table file (3)\n", argv[0] );
			exit(-1);
			}

		count=0;
		count+=fread( &(jhd[j+k*n_azis].nt), sizeof(int), 1, f );
		if( count != 1 ) {
			fprintf(stderr,"error: %s: cant read tt_table file (4)\n", argv[0] );
			exit(-1);
			}

		jhd[j+k*n_azis].tlist = (int *) malloc( sizeof(int)*jhd[j+k*n_azis].nt );
		if( jhd[j+k*n_azis].tlist == NULL ) {
			fprintf(stderr,"error: %s: out of memory (3)\n", argv[0] );
			exit(-1);
			}
		count=0;
		count+=fread( jhd[j+k*n_azis].tlist, sizeof(int), jhd[j+k*n_azis].nt, f );
		if( count != jhd[j+k*n_azis].nt ) {
			fprintf(stderr,"error: %s: cant read tt_table file (5)\n", argv[0] );
			exit(-1);
			}
		}
	fclose(f);

	printf("x\ty\tz\ttheta\tazi\n");
	for( j=0; j<n_azis; j++ ) for( k=0; k<n_thetas; k++ ) {
		iwave = jhd[j+k*n_azis].iwave;
		if( iwave>nTT ) printf("%f\t%f\t%f\t%f\t%f\n",
			jhd[j+k*n_azis].X[nTT],
			jhd[j+k*n_azis].Y[nTT],
			jhd[j+k*n_azis].Z[nTT],
			stheta+dtheta*(double)k, 
			sazi+dazi*(double)j );
		}

	exit(0);
	}

void main_jhd_table(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, k, l, count, iwave, t, ic, quick; // m, //unused
	struct jhd_table_rec {
		double azi, theta;
		float *X, *Y, *Z;
		int iwave, *tlist, nt, *hit; // <------------------------------------ was 'hit' instead of '*hit'  ; works assuming null=0
		};
	struct jhd_table_rec *jhd;

	double x0[3], stheta, ftheta, dtheta, sazi, fazi, dazi, dT;
	int n_thetas, n_azis, iwavemin, iwavemax;

	FILE *f;

	double x1[3], v;
	int nev;

	int r1, r2, r3;
	double b1[3], b2[3], b3[3], t1[3], t2[3], t3[3], T, dTdx[3], Tb, Tt, Tmin, Tmax;
	double rayazi[3], raytheta[3], azi, theta;

	int *cindex, **jindex, **kindex, **lindex, **iindex, buf[4];
	int *itmp, *jtmp, *ktmp, *ltmp, doazth;

	double newazi, newtheta, newT, newdTdx[3];

	int do_P;

	if( !((argc==4) || (argc==5) || (argc==6) ) ) {
		fprintf(stderr,"purpose: output information for joint hypocenter relocation\n");
		fprintf(stderr,"method: Uses a station-specific traveltime table file to construct an\n");
		fprintf(stderr,"        ensemble of ray tubes extending outward from that station.\n");
		fprintf(stderr,"        Finds all the ray tubes that enclose a given station,\n");
		fprintf(stderr,"        and estimates the traveltime and its derivative by\n");
		fprintf(stderr,"        linear interpolation within the ray tube.\n");
		fprintf(stderr,"usage: %s model_file tt_table_file accuracy_flag < events.txt > jhd_table.txt\n", argv[0]);
		fprintf(stderr,"       or\n");
		fprintf(stderr,"       %s model_file tt_table_file accuracy_flag index_file < events.txt > jhd_table.txt\n", argv[0]);
		fprintf(stderr,"       or\n");
		fprintf(stderr,"       %s model_file tt_table_file accuracy_flag index_file P_S_flag < events.txt > jhd_table.txt\n", argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"       tt_table_file, for a specific station\n");
		fprintf(stderr,"       accuracy_flag, e for exhaustice search (all ray tubes\n");
		fprintf(stderr,"                        in the tt_file are examined to see if\n");
		fprintf(stderr,"                        they contain the event)\n");
		fprintf(stderr,"                      i for indexed search, where the index_file\n");
		fprintf(stderr,"                        has been computed separately via the\n");
		fprintf(stderr,"                        index_traveltime keyword\n");
		fprintf(stderr,"                        (i prefered over e only when there are a hunge number\n");
		fprintf(stderr,"                        of events, since computation of the index file\n");
		fprintf(stderr,"                        is time-consuming)\n");
		fprintf(stderr,"                      q for quick search that may miss arrivals\n");
		fprintf(stderr,"                        (The quick search uses the tetrahedra of\n");
		fprintf(stderr,"                        the model as a hash index, and will fail\n");
		fprintf(stderr,"                        if none of the three rays that constitute\n");
		fprintf(stderr,"                        the ray tube touch the tetrahedron containing\n");
		fprintf(stderr,"                        the event.)\n");
		fprintf(stderr,"       index_file: file produced by index_traveltime keyword\n");
		fprintf(stderr,"       		(include only for accuracy_flag = i)\n");
		fprintf(stderr,"       P_S_flag: P (default) for P traveltimes, S for S\n");
		fprintf(stderr,"                (model must derine ratio for S wave times\n");
		fprintf(stderr,"       events.txt file: one event per line\n");
		fprintf(stderr,"		event_no: arbitrary integer event number\n");
		fprintf(stderr,"		event_x: event x position, km\n");
		fprintf(stderr,"		event_y: event y position, km\n");
		fprintf(stderr,"		event_z: event z position, km\n");
		fprintf(stderr,"		Tmin: minimum traveltime bound, s\n");
		fprintf(stderr,"		Tmax: maximum traveltime bound, s\n");
		fprintf(stderr,"       jdh_table.txt file: one traveltime per line\n");
		fprintf(stderr,"		event_no: arbitrary integer event number\n");
		fprintf(stderr,"		arrival_no: 0=first arrival\n");
		fprintf(stderr,"		event_x: event x position, km\n");
		fprintf(stderr,"		event_y: event y position, km\n");
		fprintf(stderr,"		event_z: event z position, km\n");
		fprintf(stderr,"		T: traveltime in s\n");
		fprintf(stderr,"		dT/dx: derivative in s/km\n");
		fprintf(stderr,"		dT/dy: derivative in s/km\n");
		fprintf(stderr,"		dT/dz: derivative in s/km\n");
		fprintf(stderr,"		v: velocity at (x,y,z) in m/s\n");
		fprintf(stderr,"		tetra: tetrahedron index\n");
		fprintf(stderr,"		theta: takeoff angle of incidence in deg\n");
		fprintf(stderr,"		azimuth: takeoff azimuth in deg\n");
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( (f=fopen(argv[2],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open tt_table file <%s> for read\n",
			argv[0], argv[1] );
		exit(-1);
		}

	if( (argv[3][0]=='q') || (argv[3][0]=='Q') )  quick=1;
	else if( (argv[3][0]=='e') || (argv[3][0]=='E') )  quick=0;
	else if( (argv[3][0]=='i') || (argv[3][0]=='I') )  quick=2;
	else {
		fprintf(stderr,"error: %s: bad accuracy_flag\n", argv[0] );
		}

	if( quick!=2 ) {
		if( argc<5 ) do_P=1;
		else if( (argv[4][0]=='P') || (argv[4][0]=='p') ) do_P=1;
		else if( (argv[4][0]=='S') || (argv[4][0]=='s') ) do_P=0;
		else {
			fprintf(stderr,"error: %s: bad P_S_flag (must be P or S)\n", argv[0] );
			exit(0);
			}
		}
	else {
		if( argc<6 ) do_P=1;
		else if( (argv[5][0]=='P') || (argv[5][0]=='p') ) do_P=1;
		else if( (argv[5][0]=='S') || (argv[5][0]=='s') ) do_P=0;
		else {
			fprintf(stderr,"error: %s: bad P_S_flag (must be P or S)\n", argv[0] );
			exit(0);
			}
		}

	if( !do_P ) {
		for( i=0; i<n_nodes; i++ ) node[i].v = node[i].v_orig/node[i].ratio_orig;
		for( i=0; i<n_tetras; i++ ) velocity_eqn( &tetra[i] );
		}

	count=0;
	count+=fread( x0, sizeof(double), 3, f );

	count+=fread( &stheta, sizeof(double), 1, f );
	count+=fread( &ftheta, sizeof(double), 1, f );
	count+=fread( &dtheta, sizeof(double), 1, f );
	count+=fread( &n_thetas, sizeof(int), 1, f );

	count+=fread( &sazi, sizeof(double), 1, f );
	count+=fread( &fazi, sizeof(double), 1, f );
	count+=fread( &dazi, sizeof(double), 1, f );
	count+=fread( &n_azis, sizeof(int), 1, f );

	count+=fread( &dT, sizeof(double), 1, f );

	if( count!=12 ) {
		fprintf(stderr,"error: %s: cant read tt_table file (1)\n", argv[0]);
		exit(-1);
		}

	jhd = (struct jhd_table_rec *) malloc( n_thetas * n_azis * sizeof(struct jhd_table_rec) );
	if( jhd==NULL ) {
		fprintf(stderr,"error: %s: out of memory (1)\n", argv[0] );
		exit(-1);
		}
	for( j=0; j<n_azis; j++ ) for( k=0; k<n_thetas; k++ ) {
		jhd[j+k*n_azis].iwave=0; jhd[j+k*n_azis].nt=0; jhd[j+k*n_azis].tlist=NULL;
		jhd[j+k*n_azis].X=NULL; jhd[j+k*n_azis].Y=NULL; jhd[j+k*n_azis].Z=NULL;
		}

	while(1) {
		count=0;
		count+=fread( &j, sizeof(int), 1, f );
		count+=fread( &k, sizeof(int), 1, f );
		count+=fread( &iwave, sizeof(int), 1, f );
		if( count == 0 ) break;
		if( iwave == 0 ) continue;
		if( count != 3 ) {
			fprintf(stderr,"error: %s: cant read tt_table file (2)\n", argv[0] );
			exit(-1);
			}
		jhd[j+k*n_azis].azi=sazi+dazi*(double)j;
		jhd[j+k*n_azis].theta=stheta+dtheta*(double)k;
		jhd[j+k*n_azis].iwave=iwave;

		jhd[j+k*n_azis].X = (float *) malloc( sizeof(float)*iwave );
		jhd[j+k*n_azis].Y = (float *) malloc( sizeof(float)*iwave );
		jhd[j+k*n_azis].Z = (float *) malloc( sizeof(float)*iwave );

		if((jhd[j+k*n_azis].X==NULL)||(jhd[j+k*n_azis].X==NULL)||(jhd[j+k*n_azis].X==NULL)){
			fprintf(stderr,"error: %s: out of memory (2)\n", argv[0] );
			exit(-1);
			}

		count=0;
		count+=fread( jhd[j+k*n_azis].X, sizeof(float), iwave, f );
		count+=fread( jhd[j+k*n_azis].Y, sizeof(float), iwave, f );
		count+=fread( jhd[j+k*n_azis].Z, sizeof(float), iwave, f );
		if( count != (3*iwave) ) {
			fprintf(stderr,"error: %s: cant read tt_table file (3)\n", argv[0] );
			exit(-1);
			}

		count=0;
		count+=fread( &(jhd[j+k*n_azis].nt), sizeof(int), 1, f );
		if( count != 1 ) {
			fprintf(stderr,"error: %s: cant read tt_table file (4)\n", argv[0] );
			exit(-1);
			}

		jhd[j+k*n_azis].tlist = (int *) malloc( sizeof(int)*jhd[j+k*n_azis].nt );
		if( jhd[j+k*n_azis].tlist == NULL ) {
			fprintf(stderr,"error: %s: out of memory (3)\n", argv[0] );
			exit(-1);
			}
		count=0;
		count+=fread( jhd[j+k*n_azis].tlist, sizeof(int), jhd[j+k*n_azis].nt, f );
		if( count != jhd[j+k*n_azis].nt ) {
			fprintf(stderr,"error: %s: cant read tt_table file (5)\n", argv[0] );
			exit(-1);
			}
		}
	fclose(f);


	if( quick == 2 ) { /* read in index */
		if( (argc<5) || (f=fopen(argv[4],"r"))==NULL ) {
			fprintf(stderr,"error: %s: cant open tt_index file <%s> for read\n",
				argv[0], argv[4] );
			exit(-1);
			}
		
		cindex = (int *) malloc( n_tetras * sizeof(int) );
		jindex = (int **) malloc( n_tetras * sizeof(int*) );
		kindex = (int **) malloc( n_tetras * sizeof(int*) );
		lindex = (int **) malloc( n_tetras * sizeof(int*) );
		iindex = (int **) malloc( n_tetras * sizeof(int*) );
		if( (cindex==NULL) || (jindex==NULL) || (kindex==NULL) ||
		                      (lindex==NULL) || (iindex==NULL) ) {
			fprintf(stderr,"error: %s: out of memory (1)\n", argv[0] );
			exit(-1);
			}

		for( i=0; i<n_tetras; i++ ) {
			cindex[i]=0;
			jindex[i]=NULL; kindex[i]=NULL; lindex[i]=NULL; iindex[i]=NULL;
			}
		while( (count=fread( buf, sizeof(int), 2, f )) > 0 ) {
			if( count!=2 ) {
				fprintf(stderr,"error: %s: failed to read index (1)\n", argv[0] );
				exit(-1);
				}
			j=buf[0]; k=buf[1];
			cindex[j]=k;
			jtmp = (int *)malloc( k * sizeof(int) );
			ktmp = (int *)malloc( k * sizeof(int) );
			ltmp = (int *)malloc( k * sizeof(int) );
			itmp = (int *)malloc( k * sizeof(int) );
			if( (jtmp==NULL) || (ktmp==NULL) || (ltmp==NULL) || (itmp==NULL) ) {
				fprintf(stderr,"error: %s: out of memory (2)\n", argv[0] );
				exit(-1);
				}
			jindex[j]=jtmp; kindex[j]=ktmp; lindex[j]=ltmp; iindex[j]=itmp;
			for( i=0; i<k; i++ ) {
				count=fread( buf, sizeof(int), 4, f );
				if( count!=4 ) {
					fprintf(stderr,"error: %s: failed to read index (2)\n", argv[0] );
					exit(-1);
					}
				jtmp[i]=buf[0]; ktmp[i]=buf[1]; ltmp[i]=buf[2]; itmp[i]=buf[3]; 
				}
			}

		fclose(f);
		}

	if( (quick==0) || (quick==1) ) {
	while( scanf("%d%le%le%le%le%le", &nev, &(x1[0]), &(x1[1]), &(x1[2]), &Tmin, &Tmax )==6 ) {
		iwavemin = (int)(Tmin/dT)-1; if( iwavemin<1 ) iwavemin=1;
		iwavemax = (int)(Tmax/dT)+1;
		n_tts=0;
		if( !find_tetra(x1,&t) ) {
			fprintf(stderr,"warning: %s: event %d not in model; skipping\n", argv[0], nev );
			continue;
			}
		v = eval_velocity(&tetra[t],x1);
		if( quick ) {
			for( j=0; j<n_azis; j++ ) for( k=0; k<n_thetas; k++ ) {
				i=j+k*n_azis;
				jhd[i].hit = 0;
				if( jhd[i].tlist != NULL ) {
					jhd[i].hit = (int*) bsearch(&t, jhd[i].tlist, jhd[i].nt, sizeof(int), cmpint);
					}
				}
			}
		for( j=0; j<(n_azis-1); j++ ) {
		for( k=0; k<(n_thetas-1); k++ ) {
		for( l=0; l<2; l++ ) {
			if( l==0 ) {
				r1 = j+k*n_azis;
				r2 = (j+1)+k*n_azis;
				r3 = j+(k+1)*n_azis;
				}
			else {
				r1 = (j+1)+k*n_azis;
				r2 = (j+1)+(k+1)*n_azis;
				r3 = j+(k+1)*n_azis;
				}

			if( (jhd[r1].iwave==0) || (jhd[r2].iwave==0) || (jhd[r3].iwave==0) ) {
				continue;
				}

			if( quick ) {
				if( !( jhd[r1].hit || jhd[r2].hit || jhd[r3].hit ) ) {
					continue;
					}
				}
	
			iwave = jhd[r1].iwave;
			if( jhd[r2].iwave < iwave ) iwave=jhd[r2].iwave;
			if( jhd[r3].iwave < iwave ) iwave=jhd[r3].iwave;
			if( iwave>iwavemax ) iwave=iwavemax;
			if( iwavemin>=(iwave-1) ) continue;
			for( i=iwavemin; i<(iwave-1); i++ ) {

				b1[0]=jhd[r1].X[i]; b1[1]=jhd[r1].Y[i]; b1[2]=jhd[r1].Z[i];
				b2[0]=jhd[r2].X[i]; b2[1]=jhd[r2].Y[i]; b2[2]=jhd[r2].Z[i];
				b3[0]=jhd[r3].X[i]; b3[1]=jhd[r3].Y[i]; b3[2]=jhd[r3].Z[i];
				Tb = dT*(double)i;

				t1[0]=jhd[r1].X[i+1]; t1[1]=jhd[r1].Y[i+1]; t1[2]=jhd[r1].Z[i+1];
				t2[0]=jhd[r2].X[i+1]; t2[1]=jhd[r2].Y[i+1]; t2[2]=jhd[r2].Z[i+1];
				t3[0]=jhd[r3].X[i+1]; t3[1]=jhd[r3].Y[i+1]; t3[2]=jhd[r3].Z[i+1];
				Tt = dT*(double)(i+1);

				raytheta[0]=jhd[r1].theta; rayazi[0]=jhd[r1].azi;
				raytheta[1]=jhd[r2].theta; rayazi[1]=jhd[r2].azi;
				raytheta[2]=jhd[r3].theta; rayazi[2]=jhd[r3].azi;

				doazth=1;
				if( in_tri_prism( x1, b1,b2,b3,Tb, t1,t2,t3,Tt, &T, dTdx, doazth, rayazi, raytheta, &azi, &theta ) ) {
					tt[n_tts].T = T;
					tt[n_tts].dTdx[0]=dTdx[0];
					tt[n_tts].dTdx[1]=dTdx[1];
					tt[n_tts].dTdx[2]=dTdx[2];
					tt[n_tts].th = theta;
					tt[n_tts].az = azi;

					if( rayrefine( x0, x1, azi, theta, T, &newazi, &newtheta, &newT, newdTdx) ) {
						tt[n_tts].T = newT;
						tt[n_tts].dTdx[0] = newdTdx[0];
						tt[n_tts].dTdx[1] = newdTdx[1];
						tt[n_tts].dTdx[2] = newdTdx[2];
						tt[n_tts].th = theta;
						tt[n_tts].az = azi;
						}

					if( (n_tts+1) >= MAX_TTS ) {
						fprintf(stderr,"error: %s: too many arrivals, event=%d\n", argv[0],nev);
						exit(-1);
						}
					n_tts++;
					}

				}

			}}}

			if( n_tts > 0 ) {
				qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
				for( i=0; i<n_tts; i++ ) {
					printf("%d\t%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%f\t%f\n",
						nev, i, x1[0],x1[1],x1[2], tt[i].T,
						tt[i].dTdx[0], tt[i].dTdx[1], tt[i].dTdx[2],
						v, t, tt[i].th, tt[i].az );
					}
				}
			else {
				fprintf(stderr, "warning: no arrivals for event %d at %f %f %f\n",
					nev, x1[0], x1[1], x1[2] );
				}
		}
		} /* end if quick 0 1 */
	else {
	while( scanf("%d%le%le%le%le%le", &nev, &(x1[0]), &(x1[1]), &(x1[2]), &Tmin, &Tmax )==6 ) {
		iwavemin = (int)(Tmin/dT)-1; if( iwavemin<1 ) iwavemin=1;
		iwavemax = (int)(Tmax/dT)+1;
		n_tts=0;
		if( !find_tetra(x1,&t) ) {
			fprintf(stderr,"warning: %s: event %d not in model; skipping\n", argv[0], nev );
			continue;
			}
		v = eval_velocity(&tetra[t],x1);
		for( ic=0; ic<cindex[t]; ic++ ) {
			j = jindex[t][ic];
			k = kindex[t][ic];
			l = lindex[t][ic];
			i = iindex[t][ic];
			if( l==0 ) {
				r1 = j+k*n_azis;
				r2 = (j+1)+k*n_azis;
				r3 = j+(k+1)*n_azis;
				}
			else {
				r1 = (j+1)+k*n_azis;
				r2 = (j+1)+(k+1)*n_azis;
				r3 = j+(k+1)*n_azis;
				}

			if( (jhd[r1].iwave==0) || (jhd[r2].iwave==0) || (jhd[r3].iwave==0) ) {
				continue;
				}

			b1[0]=jhd[r1].X[i]; b1[1]=jhd[r1].Y[i]; b1[2]=jhd[r1].Z[i];
			b2[0]=jhd[r2].X[i]; b2[1]=jhd[r2].Y[i]; b2[2]=jhd[r2].Z[i];
			b3[0]=jhd[r3].X[i]; b3[1]=jhd[r3].Y[i]; b3[2]=jhd[r3].Z[i];
			Tb = dT*(double)i;

			t1[0]=jhd[r1].X[i+1]; t1[1]=jhd[r1].Y[i+1]; t1[2]=jhd[r1].Z[i+1];
			t2[0]=jhd[r2].X[i+1]; t2[1]=jhd[r2].Y[i+1]; t2[2]=jhd[r2].Z[i+1];
			t3[0]=jhd[r3].X[i+1]; t3[1]=jhd[r3].Y[i+1]; t3[2]=jhd[r3].Z[i+1];
			Tt = dT*(double)(i+1);

			raytheta[0]=jhd[r1].theta; rayazi[0]=jhd[r1].azi;
			raytheta[1]=jhd[r2].theta; rayazi[1]=jhd[r2].azi;
			raytheta[2]=jhd[r3].theta; rayazi[2]=jhd[r3].azi;

			doazth=1;
			if( in_tri_prism( x1, b1,b2,b3,Tb, t1,t2,t3,Tt, &T, dTdx,
				doazth, rayazi, raytheta, &azi, &theta ) ) {
				tt[n_tts].T = T;
				tt[n_tts].dTdx[0]=dTdx[0];
				tt[n_tts].dTdx[1]=dTdx[1];
				tt[n_tts].dTdx[2]=dTdx[2];
				tt[n_tts].th = theta;
				tt[n_tts].az = azi;

				if( rayrefine( x0, x1, azi, theta, T, &newazi, &newtheta, &newT, newdTdx) ) {
					tt[n_tts].T = newT;
					tt[n_tts].dTdx[0] = newdTdx[0];
					tt[n_tts].dTdx[1] = newdTdx[1];
					tt[n_tts].dTdx[2] = newdTdx[2];
					tt[n_tts].th = theta;
					tt[n_tts].az = azi;
					}

				if( (n_tts+1) >= MAX_TTS ) {
					fprintf(stderr,"error: %s: too many arrivals, event=%d\n", argv[0],nev);
					exit(-1);
					}
				if( (T<Tmin) || (T>Tmax) ) continue;
				n_tts++;
				}

			} /* end for ic */

		if( n_tts > 0 ) {
			qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
			for( i=0; i<n_tts; i++ ) {
				printf("%d\t%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%f\t%f\n",
					nev, i, x1[0],x1[1],x1[2], tt[i].T,
					tt[i].dTdx[0], tt[i].dTdx[1], tt[i].dTdx[2],
					v, t, tt[i].th, tt[i].az );
				}
			}
		else {
			fprintf(stderr, "warning: no arrivals for event %d at %f %f %f\n",
				nev, x1[0], x1[1], x1[2] );
			}

		} /*end while */

		} /* end quick 2 */
	
	exit(0);
	}



void main_jhd_locate(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, k, l, m, n, ngood, status, iter, biec, irms, line; // ii, //unused
	char str[1024];

	FILE *fsta;
	int *stanum;
	char **jhdfilename;
	int n_sta;
	double x,y,z,t0,c;
	double T, dTdx, dTdy, dTdz;

	FILE *fev;
	struct ev_rec *ev, evkey, *myev;
	int n_ev;

	FILE *fph;
	struct ph_rec *ph;
	int n_ph;

	FILE *fjhd;
	struct jhd_rec *jhd;
	int n_jhd;
	struct jhd_rec jhdkey, *myjhd;

	int verbose=0;

	struct sparse_matrix *G; //, *GTG; //unused
	double *d, *dp, *GTd, *dm, tscale=TSCALEVALUE, maxG, maxd, damping, err, res, rms1, rms2;
	double *starms;
	double new_damping, scx;
	int *stacount;
		
	if( argc!=5 ) {
		fprintf(stderr,"purpose: joint hypocenter relocation\n");
		fprintf(stderr,"method: The user provides a set of observations, where\n");
		fprintf(stderr,"        each observation is assumed to be a linear combination\n");
		fprintf(stderr,"        of traveltimes:\n");
		fprintf(stderr,"           observation = (sum i=1 to n) coefficient[i] * traveltime[i]\n");
		fprintf(stderr,"        A phase file tabulates the observations and the\n");
		fprintf(stderr,"        n coefficients and the station, event and order\n");
		fprintf(stderr,"        of each of the traveltimes.  The observations are\n");
		fprintf(stderr,"        combined with traveltime and traveltime derivatives\n");
		fprintf(stderr,"        to produce an updated estimated of the event locations.\n");
		fprintf(stderr,"usage: %s station_file.txt event_file.txt phase_file.txt damping > updated_event_file.txt\n", argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"       station_file.txt: one station per line, with fields\n");
		fprintf(stderr,"               station_number: arbitrary integer\n");
		fprintf(stderr,"               jhd_table: path of station-specific jhd-table\n");
		fprintf(stderr,"       event_file.txt: one event per line, with fields\n");
		fprintf(stderr,"               event_number: arbitrary integer\n");
		fprintf(stderr,"               x, y, z: preliminary location, km\n");
		fprintf(stderr,"               t0: preliminary origin time, s\n");
		fprintf(stderr,"       phase_file.txt: one group of lines per observation\n");
		fprintf(stderr,"               first line, with fields\n");
		fprintf(stderr,"                     n_phases: number of phases in observation\n");
		fprintf(stderr,"                     observation: a differetial traveltime, s\n");
		fprintf(stderr,"                     weight: weight of observation\n");
		fprintf(stderr,"                     maxres: observation thrown out if weighted residual > maxres, s\n");
		fprintf(stderr,"               subsequent lines in group, with fields\n");
		fprintf(stderr,"                     station_number, corresponding to station_file.txt\n");
		fprintf(stderr,"                     event_number, corresponding to event_file.txt\n");
		fprintf(stderr,"                     order, interger arrival number of phase\n");
		fprintf(stderr,"                     ratio, computed traveltimes multiplied by this\n");
		fprintf(stderr,"                            (i.e. use 1.o for P 1.76 for S)\n");
		fprintf(stderr,"                     coefficient, of phase in observation\n");
		fprintf(stderr,"       damping: damping factor, fraction of max of GTG\n");
		fprintf(stderr,"Note: In the inversion, origin time perturbations are scaled\n");
		fprintf(stderr,"to units of distance using a nominal velocity of %f km/s\n",
				1.0/TSCALEVALUE);
		exit(-1);
		}

	if( sscanf(argv[4],"%le",&damping) != 1 ) {
		fprintf(stderr,"error: %s: cant read damping from command line\n", argv[0] );
		exit(-1);
		}

	/* station file */
	n_sta=count_lines(argv[1]);
	stanum=(int *)malloc(n_sta*sizeof(int));
	stacount=(int *)malloc(n_sta*sizeof(int));
	starms=(double *)malloc(n_sta*sizeof(double));
	jhdfilename = (char**)malloc(n_sta*sizeof(char*));

	if( (stanum==NULL) || (jhdfilename==NULL) || (starms==NULL) || (stacount==NULL)) {
		fprintf(stderr,"error: %s: out of memory (1)\n", argv[0] );
		exit(-1);
		}
	if( (fsta=fopen(argv[1],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open station file <%s> for read\n",argv[0],argv[1]);
		exit(-1);
		}
	n_sta=0;
	while( fscanf(fsta,"%d%s",&i,str)==2 ) {
		stanum[n_sta]=i;
		jhdfilename[n_sta]=(char*)malloc( (strlen(str)+1)*sizeof(char) );
		if( jhdfilename[n_sta]==NULL ) {
			fprintf(stderr,"error: %s: out of memory (2)\n", argv[0] );
			exit(-1);
			}
		strcpy(jhdfilename[n_sta],str);
		starms[n_sta]=0.0; stacount[n_sta]=0;
		n_sta++;
		}
	fclose(fsta);
	fprintf(stderr,"Stations: %d\n", n_sta);
	if( verbose ) {
		for( i=0; i<n_sta; i++ ) {
			fprintf(stderr,"%d %s\n", stanum[i], jhdfilename[i] );
			}
		fprintf(stderr,"\n");
		}

	/* event file */
	n_ev=count_lines(argv[2]);
	ev=(struct ev_rec *)malloc(n_ev*sizeof(struct ev_rec));
	if( ev==NULL ) {
		fprintf(stderr,"error: %s: out of memory (3)\n", argv[0] );
		exit(-1);
		}
	if( (fev=fopen(argv[2],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open event file <%s> for read\n",argv[0],argv[2]);
		exit(-1);
		}
	n_ev=0;
	while( fscanf(fev,"%d%le%le%le%le",&i,&x,&y,&z,&t0)==5 ) {
		ev[n_ev].nev = i;
		ev[n_ev].x=x; ev[n_ev].y=y; ev[n_ev].z=z; ev[n_ev].t0=t0;
		ev[n_ev].rms=0.0; ev[n_ev].count=0;
		n_ev++;
		}
	fclose(fev);
	qsort( ev, n_ev, sizeof(struct ev_rec), cmpev );
	for( i=0; i<n_ev; i++ ) ev[i].index=i;
	fprintf(stderr,"Events: %d\n", n_ev);
	if( verbose ) {
		for( i=0; i<n_ev; i++ ) {
			fprintf(stderr,"%d %f %f %f %f\n", ev[i].nev, ev[i].x, ev[i].y, ev[i].z, ev[i].t0 );
			}
		fprintf(stderr,"\n");
		}

	/* phase file */
	if( (fph=fopen(argv[3],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open phase file <%s> for read\n",argv[0],argv[3]);
		exit(-1);
		}
	n_ph=0;
	while( fscanf(fph,"%d%le%le%le",&i,&x,&y,&z)==4 ) {
		for( j=0; j<i; j++ ) {
			if( fscanf(fph,"%d%d%d%le%le",&k,&k,&k,&x,&x)!=5 ) {
				fprintf(stderr,"error: %s: reading phase file, record %d\n",
					argv[0], n_ph );
				exit(-1);
				}
			}
		n_ph++;
		}
	rewind(fph);
	ph=(struct ph_rec *)malloc(n_ph*sizeof(struct ph_rec));
	if( ph==NULL ) {
		fprintf(stderr,"error: %s: out of memory (4)\n", argv[0] );
		exit(-1);
		}
	n_ph=0; line=0;
	while( fscanf(fph,"%d%le%le%le",&i,&x,&y,&z)==4 ) {
		line++; ph[n_ph].line=line;
		ph[n_ph].n=i; ph[n_ph].obs=x; ph[n_ph].weight=y; ph[n_ph].maxres=z;
		ph[n_ph].good=0; ph[n_ph].row=(-1);
		ph[n_ph].sta=(int*)malloc(i*sizeof(int));
		ph[n_ph].ev=(int*)malloc(i*sizeof(int));
		ph[n_ph].order=(int*)malloc(i*sizeof(int));
		ph[n_ph].hit=(int*)malloc(i*sizeof(int));
		ph[n_ph].ratio=(double*)malloc(i*sizeof(double));
		ph[n_ph].coeff=(double*)malloc(i*sizeof(double));
		ph[n_ph].T=(double*)malloc(i*sizeof(double));
		ph[n_ph].dTdx=(double*)malloc(i*sizeof(double));
		ph[n_ph].dTdy=(double*)malloc(i*sizeof(double));
		ph[n_ph].dTdz=(double*)malloc(i*sizeof(double));
		if( (ph[n_ph].sta==NULL) || (ph[n_ph].ev==NULL) || (ph[n_ph].order==NULL) || (ph[n_ph].hit==NULL) ||
		    (ph[n_ph].ratio==NULL) || (ph[n_ph].coeff==NULL) || (ph[n_ph].T==NULL) ||
		    (ph[n_ph].dTdx==NULL) || (ph[n_ph].dTdy==NULL) || (ph[n_ph].dTdz==NULL) ) {
			fprintf(stderr,"error: %s: out of memory (5)\n", argv[0] );
			exit(-1);
			}
		for( j=0; j<i; j++ ) {
			if( fscanf(fph,"%d%d%d%le%le",&k,&l,&m,&x,&y)!=5 ) {
				fprintf(stderr,"error: %s: reading phase file, record %d\n",
					argv[0], n_ph );
				exit(-1);
				}
			line++;
			ph[n_ph].sta[j]=k; ph[n_ph].ev[j]=l; ph[n_ph].order[j]=m; ph[n_ph].hit[j]=0;
			ph[n_ph].ratio[j]=x; ph[n_ph].coeff[j]=y; ph[n_ph].T[j]=0.0;
			ph[n_ph].dTdx[j]=0.0; ph[n_ph].dTdy[j]=0.0;ph[n_ph].dTdz[j]=0.0;
			}
		n_ph++;
		}
	fclose(fph);
	fprintf(stderr,"Observations: %d\n", n_ph);

	for( i=0; i<n_sta; i++ ) {
		n_jhd=count_lines(jhdfilename[i]);
		jhd=(struct jhd_rec *)malloc(n_jhd*sizeof(struct jhd_rec));
		if( jhd==NULL ) {
			fprintf(stderr,"error: %s: out of memory (6)\n", argv[0] );
			exit(-1);
			}
		if( (fjhd=fopen(jhdfilename[i],"r")) == NULL ) {
			fprintf(stderr,"error: %s: cant open jhd_table <%s> for read\n",
				argv[0], jhdfilename[i] );
			exit(-1);
			}
		n_jhd=0;
		while( fscanf(fjhd,"%d%d%le%le%le%le%le%le%le%le%d%le%le",&j,&k,&x,&x,&x,
			&T, &dTdx, &dTdy, &dTdz, &x, &l, &x, &x ) == 13 ) {
			jhd[n_jhd].nev=j;
			jhd[n_jhd].order=k;
			jhd[n_jhd].T = T;
			jhd[n_jhd].dTdx=dTdx; jhd[n_jhd].dTdy=dTdy; jhd[n_jhd].dTdz=dTdz;
			n_jhd++;
			}
		fclose(fjhd);
		fprintf(stderr,"jhd_table %s has %d records\n", jhdfilename[i], n_jhd );
		if( verbose ) {
			for( j=0; j<n_jhd; j++ ) {
				fprintf(stderr,"%d %d %f %f %f %f\n", jhd[j].nev, jhd[j].order,
					jhd[j].T, jhd[j].dTdx, jhd[j].dTdy, jhd[j].dTdz );
				}
			fprintf(stderr,"\n");
			}
		qsort( jhd, n_jhd, sizeof(struct jhd_rec), cmpjhd );
		for( j=0; j<n_ph; j++ ) for( k=0; k<ph[j].n; k++ ) {
			if( stanum[i] != ph[j].sta[k] ) continue;
			jhdkey.nev = ph[j].ev[k];
			jhdkey.order = ph[j].order[k];
			myjhd=(struct jhd_rec *)
				bsearch(&jhdkey, jhd, n_jhd, sizeof(struct jhd_rec), cmpjhd );
			if( myjhd == NULL ) continue;
			ph[j].hit[k]=1;
			ph[j].T[k] = myjhd->T;
			ph[j].dTdx[k] = myjhd->dTdx;
			ph[j].dTdy[k] = myjhd->dTdy;
			ph[j].dTdz[k] = myjhd->dTdz;
			}
		free(jhd);
		}

	ngood=0;
	for( j=0; j<n_ph; j++ ) {
		l=0;
		for( k=0; k<ph[j].n; k++ ) l+=ph[j].hit[k];
		if( l==ph[j].n ) {
			ph[j].good=1;
			ngood++;
			}
		}
	fprintf(stderr,"Usable Observations: %d\n", ngood);
	if( ngood==0 ) {
		fprintf(stderr,"warning: no good observations\n");
		for( i=0; i<n_ev; i++ ) {
			x=ev[i].x; y=ev[i].y; z=ev[i].z; t0=ev[i].t0;
			printf("%d\t%f\t%f\t%f\t%f\n", ev[i].nev, x, y, z, t0 );
			}
		exit(0);
		}

	if( verbose ) {
		for( j=0; j<n_ph; j++ ) {
			fprintf(stderr,"%d %d %f %f %f %d\n",
				j, ph[j].n, ph[j].obs, ph[j].weight, ph[j].maxres, ph[j].good);
			l=0;
			for( k=0; k<ph[j].n; k++ ) {
				fprintf(stderr, "\t%d %d %d %f %f %f %f %f %f %d\n",
					ph[j].sta[k], ph[j].ev[k], ph[j].order[k], ph[j].ratio[k],
					ph[j].coeff[k], ph[j].T[k], ph[j].dTdx[k], ph[j].dTdy[k],
					ph[j].dTdz[k], ph[j].hit[k] );
				}
			}
		}

	n = ngood;
	m = 4*n_ev;
	G=new_sparse_matrix(n,m,0);
	d=(double*)malloc(n*sizeof(double));
	dp=(double*)malloc(n*sizeof(double));
	dm=(double*)malloc(m*sizeof(double));
	GTd=(double*)malloc(m*sizeof(double));
	if( (G==NULL) || (d==NULL) || (dp==NULL) || (dm==NULL) || (GTd==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (7)\n", argv[1] );
		exit(-1);
		}

	/* Theory                                                                              */
	/* let ta = T0 + T(x,y,z)                                                              */
        /*        = t0 + dt + T(x0,y0,z0) + gradT dot dx                                       */
        /* then (sum i) ci tai = obs =                                                         */
        /*      (sum i) ci t0i + (sum i) ci dt + (sum i) ci T + (sum i) ci gradT dot dx        */
	/* and                                                                                 */
	/*     (sum i) ci gradT dot dx +  (sum i) ci dt = obs - (sum i) ci (t0i+T)             */
	/*                                                                                     */
	/* then note that every row of the equation is multiplied by the weight, x             */
	/*           and every instance of T and gradT is mutliplied by the ratio, y           */
	/*                                                                                     */
	/*     (sum i) x ci y gradT dot dx +  (sum i) x ci dt = obs - (sum i) x ci (t0i+y T)   */
	/*                                                                                     */
	/* finally, we introduce a time scaling, ts, such that dt = ts dtp.  This scaling      */
	/* is chosen to make the units and typical size of dx and dt the same.  A              */
	/* reasonbable choice is ts = 1/mean_velocity.                                         */
	/*                                                                                     */
	/* (sum i) x ci y gradT dot dx +  (sum i) x ci ts dt = obs - (sum i) x ci (t0i+y T)    */
	/*                                                                                     */

	i=0; irms=0; rms1=0.0;
	for( j=0; j<n_ph; j++ ) {
		if( !ph[j].good ) continue;
		x = ph[j].weight;
		d[i]=0.0;
		for( k=0; k<ph[j].n; k++ ) {
			y = ph[j].ratio[k];
			c = ph[j].coeff[k];
			evkey.nev = ph[j].ev[k];
			myev=(struct ev_rec *)
				bsearch(&evkey, ev, n_ev, sizeof(struct ev_rec), cmpev );
			if( myev==NULL ) {
				fprintf(stderr,"error: %s: cant find event %d in event file\n", argv[0], evkey.nev);
				exit(-1);
				}
			l=myev->index;

			d[i] -= x * c * ( y * ph[j].T[k] + myev->t0 );

			status=1;
			z=get_sparse_value(G,i,4*l);
			z += x * c * y * ph[j].dTdx[k];
			status *= set_sparse_value(G,i,4*l,z);

			z=get_sparse_value(G,i,4*l+1);
			z += x * c * y * ph[j].dTdy[k];
			status *= set_sparse_value(G,i,4*l+1,z);

			z=get_sparse_value(G,i,4*l+2);
			z += x * c * y * ph[j].dTdz[k];
			status *= set_sparse_value(G,i,4*l+2,z);

			z=get_sparse_value(G,i,4*l+3);
			z += x * c * tscale;
			status *= set_sparse_value(G,i,4*l+3,z);
			if( !status ) {
				fprintf(stderr,"error: %s: out of memory (8)\n", argv[1] );
				exit(-1);
				}
			}
		if( verbose ) {
			fprintf(stderr,"weighted observation %d (row %d) obs=%f pred=%f res=%f\n",
			j, i, -x*ph[j].obs, d[i], x*ph[j].obs+d[i] );
			}

		res = fabs(x*ph[j].obs+d[i]);
		if(  res > ph[j].maxres ) {
			fprintf(stderr,"observation %d (row %d) thrown out, residual %f > %f\n", j, i,
				res, ph[j].maxres );
			for( l=0; l<m; l++ ) set_sparse_value(G,i,l,0.0);
			d[i]=0.0;
			}
		else {
			rms1 += res*res; irms++;
			d[i]+=x*ph[j].obs;
			ph[j].row=i;
			}

		i++;
		}

	rms1 = sqrt( rms1 / (double) irms );

	maxG=sparse_absmax(G);
	k=sparse_count(G);
	fprintf(stderr,
		"G is %d by %d, is %f percent full, and has absolute maximum of %f\n",
		n, m, 100.0*(double)k/((double)n*(double)m), maxG );

	maxd=0.0;
	for( i=0; i<n; i++ ) {
		x=fabs(d[i]);
		if( x>maxd ) maxd=x;
		}
	fprintf(stderr, "d is %d by 1, and has absolute maximum of %f\n", n, maxd );

	smt_times_v( G, d, GTd );
	maxd=0.0;
	for( i=0; i<m; i++ ) {
		x=fabs(GTd[i]);
		if( x>maxd ) maxd=x;
		}
	fprintf(stderr,
	"GTd is %d by 1, and has absolute maximum of %f\n", m, maxd );

	scx = ATAabsmax( G );
	new_damping = damping*scx;
	fprintf(stderr,"Damping: %e abmaxGTG: %e Scaled_damping: %e\n\n",
		damping, scx, new_damping );

	for( i=0; i<n_model_pars; i++ ) dm[i]=0.0;
	if( !sparse_dls_biconj( G, d, dm, new_damping, 1, maxd*B_PREC, m+10, &iter,&err,&biec ) ) {
		fprintf(stderr,"error: %s: dls_biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
		
	fprintf(stderr,"Matrix inversion (implicit): %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after implicit solution");
	
	for( i=0; i<n_ev; i++ ) {
		x=ev[i].x+dm[4*i];
		y=ev[i].y+dm[4*i+1];
		z=ev[i].z+dm[4*i+2];
		t0=ev[i].t0+tscale*dm[4*i+3];
		printf("%d\t%f\t%f\t%f\t%f\n", ev[i].nev, x, y, z, t0 );
		}

	sm_times_v( G, dm, dp );

	for( i=0; i<n_ph; i++ ) {
		if( (!ph[i].good) || (ph[i].row==(-1)) ) continue;
		res =  d[ph[i].row] - dp[ ph[i].row ];
		for( j=0; j<ph[i].n; j++ ) {
			for( k=0; k<n_sta; k++ ) if( stanum[k]==ph[i].sta[j] ) {
				stacount[k]++;
				starms[k]+= res*res;
				break;
				}
			}
		}
	fprintf(stderr,"station statistics:\n");
	fprintf(stderr,"sta\tcount\trms\n");
	for( i=0; i<n_sta; i++ ) {
		fprintf(stderr,"%d\t%d\t%f\n", stanum[i], stacount[i], sqrt(starms[i]/(double)stacount[i]) );
		}
	fprintf(stderr,"\n");

	for( i=0; i<n_ph; i++ ) {
		if( (!ph[i].good) || (ph[i].row==(-1)) ) continue;
		res = d[ph[i].row] - dp[ ph[i].row ];
		for( j=0; j<ph[i].n; j++ ) {
			evkey.nev = ph[i].ev[j];
			myev=(struct ev_rec *)
				bsearch(&evkey, ev, n_ev, sizeof(struct ev_rec), cmpev );
			if( myev==NULL ) continue;
			myev->count++;
			myev->rms += res*res;
			}
		}
	fprintf(stderr,"event statistics:\n");
	fprintf(stderr,"event\tcount\trms\n");
	for( i=0; i<n_ev; i++ ) {
		fprintf(stderr,"%d\t%d\t%f\n",
			ev[i].nev, ev[i].count, sqrt(ev[i].rms/(double)ev[i].count) );
		}
	fprintf(stderr,"\n");

	fprintf(stderr,"phase statistics:\n");
	fprintf(stderr,"phase\tline\terror\n");
	for( i=0; i<n_ph; i++ ) {
		j=ph[i].row;
		if( (!ph[i].good) || (j==(-1)) ) continue;
		res = d[j]-dp[j];
		fprintf(stderr,"%d\t%d\t%f\n", i, ph[i].line, res );
		}
	fprintf(stderr,"\n");

	rms2=0.0;
	for( i=0; i<n_ph; i++ ) {
		j=ph[i].row;
		if( (!ph[i].good) || (j==(-1)) ) continue;
		res = d[j]-dp[j];
		rms2 += res*res;
		}
	rms2 = sqrt( rms2 / (double)irms );
	fprintf(stderr,"rms weighted residual original: %f final %f for %f percent reduction\n",
		rms1, rms2, 100.0-100.0*rms2/rms1 );


	exit(0);
	}

void main_TVinvert(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, k, l, interface, hitflag, n_arcs, status, order, ec; //  nodeid, n,//unused
	double x0[3], t0[3], x1[3], t1[3], theta, azi; // v[4], //unused 
	struct arc_rec arc[MAX_ARCS];
	double traveltime;
	FILE *mpfile, *ttfile, *nmfile;
	char ct[128];
	double xsrc, ysrc, zsrc, xsta, ysta, zsta, ratio, T0, Ta;
	struct triangle_rec tri;
	struct tetra_rec *pt;
	double *blocksum, *blockones;

	double xmin, xmax, ymin, ymax, vapp, z0, vs, x_est, y_est, vp, px, py, max_dT;
	int nx, ny, t, my_last_tetra;
	int ng, itt, match, index; // ierror, //unused
	double *ts, *ts2, rms, rms2; //, dT, dX tolerance, //unused
	double damping, qinvint;
	int tnode[4];
	int biec;

	double thmin, thmax, azimin, azimax;
	int nth, nazi;

	struct sparse_matrix *G, *invert_GTG;

	double *d, *GTd, *dm, maxG, maxd, dv, err, mean; // Gv, //unused
	int iter, nz, *dindex, *dptr, bracket_status;

	double weight, relative_weight, t0weight, th_est, az_est;
	struct ttime_rec *T_ttime, *V_ttime;
	int n_T_ttimes, n_V_ttimes, n_total_ttimes;

	char hitsfile[256];
	double new_damping, scx;

	
	my_last_tetra=(-1);

	if( argc!=22 ) {
		fprintf(stderr,"purpose: invert telseismic and local traveltime data to improve model\n");
		fprintf(stderr,"usage: %s starting_model_file model_pars_file.txt teleseismic_traveltimes.tsv local_traveltimes.tsv max_dT relative_weight damping xmin xmax nx ymin ymax ny z0 thmin thmax nth azimin azimax nazi new_model_file\n",argv[0]);
		write_tele_note(stderr);
		write_model_blerb(stderr);
		write_model_pars_blerb(stderr);
		fprintf(stderr,"      input teleseismic_traveltimes.tsv:\n");
		fprintf(stderr,"              index: an integer that is the same for\n");
		fprintf(stderr,"                  all observations of a single teleseismic plane wave\n");
		fprintf(stderr,"                  (but be warned; sort data into groups with common index!\n");
		fprintf(stderr,"              azimuth, in deg, of plane wave\n");
		fprintf(stderr,"              apparent-velocity, in km/s, of plane wave\n");
		fprintf(stderr,"                  (but be warned;  azimuth and apparent-velocity ought to be the same for common index!\n");
		fprintf(stderr,"              xr, yr, zr, receiver location in km\n");
		fprintf(stderr,"                  (but be warned; z not used!)\n");
		fprintf(stderr,"              receiver interface, integer matching model\n");
		fprintf(stderr,"                  (but be warned; sort data with common index by interface!)\n");
		fprintf(stderr,"              Ta,  arrival time in s\n");
		fprintf(stderr,"              ratio, 1 for P 1.76 (or whatever) for S\n");
		fprintf(stderr,"                  Note: The ratio allows S wave traveltimes\n");
		fprintf(stderr,"                  to be used in conjunction with a P wave\n");
		fprintf(stderr,"                  model inversion.  S wave apparent velocities\n");
		fprintf(stderr,"                  are specified in the traveltime file, along\n");
		fprintf(stderr,"                  with an appropriate P:S velocity ratio.  The\n");
		fprintf(stderr,"                  S wave apparent velocity is scaled to a P wave\n");
		fprintf(stderr,"                  apparent velocity prior to raytracing, and then\n");
		fprintf(stderr,"                  the final traveltime is scaled back to an S wave\n");
		fprintf(stderr,"                  traveltime after raytracing. All traveltimes\n");
		fprintf(stderr,"                  in a planewave group must have the same ratio.\n");
		fprintf(stderr,"              order, 0 for 1-st arrival, 1 for second, etc\n");
		fprintf(stderr,"                 Note: Closest arrival option (-1) cannot\n");
		fprintf(stderr,"                 be used since the arrival time at the bottom\n");
		fprintf(stderr,"                 of the model is presumed unknown.  It will\n");
		fprintf(stderr,"                 be reset to 0.\n");
		fprintf(stderr,"      input local_traveltimes.tsv:\n");
		fprintf(stderr,"              xs, ys, zs, source location in km\n");
		fprintf(stderr,"                  (but be warned; sort data into groups with common source!\n");
		fprintf(stderr,"              xr, yr, zr, receiver location in km\n");

		fprintf(stderr,"                  (but be warned; z not used!)\n");
		fprintf(stderr,"              receiver interface, integer matching model\n");
		fprintf(stderr,"                  (but be warned; sort data with common source by interface!)\n");
		fprintf(stderr,"              T0,  origin time in s\n");
		fprintf(stderr,"              Ta,  arrival time in s\n");
		fprintf(stderr,"              ratio, 1 for P 1.76 (or whatever) for S\n");
		fprintf(stderr,"              order, 0 for 1-st arrival, 1 for second, etc\n");
		fprintf(stderr,"                 Note: (-1) indicates closest arrival\n");
		fprintf(stderr,"      max_dT: if the absolute value of the traveltime residual, |dT|=|Tobs-Tpred(initial_model)|\n");
		fprintf(stderr,"              is greater than max_dt, that data is ignored\n");
		fprintf(stderr,"      relative_weight: How much are teleseismic errors worth\n");
		fprintf(stderr,"              relative to local errors (i.e. telseismic rows of\n");
		fprintf(stderr,"              G multiplied by relative weight)\n");
		fprintf(stderr,"      damping: damped least squares parameter  (fraction of largest element of GTG)\n");
		fprintf(stderr,"      arrivals are searched for in a turf with\n");
		fprintf(stderr,"         xmin, xmax, min, max x values, km\n");
		fprintf(stderr,"         nx, integer number of x values in turf\n");
		fprintf(stderr,"         ymin, ymax, min, max y values, km\n");
		fprintf(stderr,"         ny, integer number of y values in turf\n");
		fprintf(stderr,"      z0, in km, reference depth for plane wave\n");
		fprintf(stderr,"         (rays shot from this depth, so it should\n");
		fprintf(stderr,"         be within the model but near its bottom)\n");
		fprintf(stderr,"      output new_model_file: same format as starting model file\n");
		fprintf(stderr,"         also output is new_model_file.hits: same format as starting model file, but with velocity replaced with number of rays\n");
		fprintf(stderr,"         interacting with each node\n");
		exit(-1);
		}

	fprintf(stderr,"Raytrace3d TV_invert. Starting model file: %s\n\n", argv[1] );
	timestamp((char*)"at start of program");

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	alloc_model_pars(argv[2]);

	if( (mpfile=fopen(argv[2],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open model_par_file <%s> for read\n", argv[0], argv[2] );
		exit(-1);
		}
	n_model_pars=0;
	load_model_pars_V(mpfile);
	fclose(mpfile);
	
	fprintf(stderr,"Total of %d velocity node model parameters\n", n_model_pars);

	if( n_model_pars < 1000 ) for( i=0; i<n_model_pars; i++ ) {
		fprintf(stderr,"Model parameter %d has %d nodes\n", i, model_par[i].n );
		for( j=0; j<model_par[i].n; j++ ) {
			fprintf(stderr,"%d %f\n",model_par[i].node[j],model_par[i].weight[j]);
			}
		}

	make_ttime(argv[3]);
	if( (ttfile=fopen(argv[3],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open telseismic_traveltime.tsv <%s> for read\n", argv[0], argv[3] );
		exit(-1);
		}
	if( fscanf(ttfile,"%s%s%s%s%s%s%s%s%s%s",
			ct,ct,ct,ct,ct,ct,ct,ct,ct,ct ) != 10 ) {
		fprintf(stderr,"error: %s: cant skip header in teleseismic_traveltimess.tsv <%s>\n",
			argv[0], argv[3]);
		exit(-1);
		}

	n_ttimes=0;
	fprintf(stderr,"\nInput Teleseismic Data\n\n");
	fprintf(stderr,"#\tindex\tazi\tappvel\txr\tyr\tzr\tinterface\tTa\tratio\torder\tpwg\n");
 	while( fscanf(ttfile,"%d%le%le%le%le%le%d%le%le%d", &index,&azi,&vapp,
		&xsta,&ysta,&zsta,&interface,&Ta,&ratio,&order)==10){
		if( (n_ttimes+2) > MAX_TTIMES ) {
			fprintf(stderr,"error: %s: too many traveltimes\n", argv[0] );
			exit(-1);
			}
		if( order==(-1) ) order=0;
		ttime[n_ttimes].ok=FALSE;
		ttime[n_ttimes].index=index;
		ttime[n_ttimes].az=azi;
		ttime[n_ttimes].vapp=vapp;
		ttime[n_ttimes].x1[0]=xsta;
		ttime[n_ttimes].x1[1]=ysta;
		ttime[n_ttimes].x1[2]=zsta;
		ttime[n_ttimes].interface=interface;
		ttime[n_ttimes].obsTa=Ta;
		ttime[n_ttimes].ratio=ratio;
		ttime[n_ttimes].obsorder=order;
		ttime[n_ttimes].preorder=order;
		/* assign planewave group index */
                if( n_ttimes==0 ) {
                        n_pwg=0;
                        }
                else if( ttime[n_ttimes].index!=ttime[n_ttimes-1].index ) {
                        n_pwg++;
                        }
                ttime[n_ttimes].pwg=n_pwg;

		fprintf(stderr,"%d\t%d\t%f\t%f\t%f\t%f\t%f\t%d\t%f\t%f\t%d\t%d\n",
			n_ttimes,
			ttime[n_ttimes].index,ttime[n_ttimes].az,ttime[n_ttimes].vapp,
			ttime[n_ttimes].x1[0],ttime[n_ttimes].x1[1],ttime[n_ttimes].x1[2],
			ttime[n_ttimes].interface,
			ttime[n_ttimes].obsTa, 
			ttime[n_ttimes].ratio, ttime[n_ttimes].obsorder, ttime[n_ttimes].pwg );
		n_ttimes++;
		}
	n_pwg++;
	fclose(ttfile);
	T_ttime=ttime; n_T_ttimes=n_ttimes;
	fprintf(stderr,"Total of %d teleseismic data in %d planewave groups\n\n", n_ttimes, n_pwg);

	make_ttime(argv[4]);
	if( (ttfile=fopen(argv[4],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open local_traveltime.tsv <%s> for read\n", argv[0], argv[4] );
		exit(-1);
		}
	if( fscanf(ttfile,"%s%s%s%s%s%s%s%s%s%s%s",
			ct,ct,ct,ct,ct,ct,ct,ct,ct,ct,ct ) != 11 ) {
		fprintf(stderr,"error: %s: cant skip header in local_traveltimess.tsv <%s>\n",
			argv[0], argv[4]);
		exit(-1);
		}

	n_ttimes=0;
	fprintf(stderr,"\nInput Local Data\n\n");
	fprintf(stderr,"#\txs\tys\tzs\txr\tyr\tzr\tinterface\tT0\tTa\tratio\torder\n");
 	while( fscanf(ttfile,"%le%le%le%le%le%le%d%le%le%le%d", &xsrc,&ysrc,&zsrc,
		&xsta,&ysta,&zsta,&interface,&T0,&Ta,&ratio,&order)==11){
		if( (n_ttimes+2) > MAX_TTIMES ) {
			fprintf(stderr,"error: %s: too many traveltimes\n", argv[0] );
			exit(-1);
			}
		ttime[n_ttimes].ok=FALSE;
		ttime[n_ttimes].x0[0]=xsrc;
		ttime[n_ttimes].x0[1]=ysrc;
		ttime[n_ttimes].x0[2]=zsrc;
		ttime[n_ttimes].x1[0]=xsta;
		ttime[n_ttimes].x1[1]=ysta;
		ttime[n_ttimes].x1[2]=zsta;
		ttime[n_ttimes].interface=interface;
		ttime[n_ttimes].T0=T0;
		ttime[n_ttimes].obsTT=Ta-T0;
		ttime[n_ttimes].obsTa=Ta;
		ttime[n_ttimes].preTa=0.0;
		ttime[n_ttimes].preTT=0.0;
		ttime[n_ttimes].ratio=ratio;
		ttime[n_ttimes].obsorder=order;
		ttime[n_ttimes].preorder=order;
		fprintf(stderr,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%f\t%f\t%f\t%d\n",
			n_ttimes,
			ttime[n_ttimes].x0[0],ttime[n_ttimes].x0[1],ttime[n_ttimes].x0[2],
			ttime[n_ttimes].x1[0],ttime[n_ttimes].x1[1],ttime[n_ttimes].x1[2],
			ttime[n_ttimes].interface,
			ttime[n_ttimes].T0, ttime[n_ttimes].obsTa, 
			ttime[n_ttimes].ratio, ttime[n_ttimes].obsorder );
		n_ttimes++;
		}
	fclose(ttfile);
	V_ttime = ttime; n_V_ttimes=n_ttimes;
	fprintf(stderr,"Total of %d local data\n\n", n_ttimes);

	if( sscanf(argv[5], "%le", &max_dT) != 1 ) {
		fprintf(stderr,"error: %s: cant read max_dT from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[6], "%le", &relative_weight) != 1 ) {
		fprintf(stderr,"error: %s: cant read relative_weight from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%le", &damping) != 1 ) {
		fprintf(stderr,"error: %s: cant read damping from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%le", &xmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read xmin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9], "%le", &xmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read xmax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10], "%d", &nx) != 1 ) {
		fprintf(stderr,"error: %s: cant read nx from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[11], "%le", &ymin) != 1 ) {
		fprintf(stderr,"error: %s: cant read ymin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[12], "%le", &ymax) != 1 ) {
		fprintf(stderr,"error: %s: cant read ymax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[13], "%d", &ny) != 1 ) {
		fprintf(stderr,"error: %s: cant read nazi from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[14], "%le", &z0) != 1 ) {
		fprintf(stderr,"error: %s: cant read z0 from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[15], "%le", &thmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read thmin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[16], "%le", &thmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read thmax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[17], "%d", &nth) != 1 ) {
		fprintf(stderr,"error: %s: cant read nth from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[18], "%le", &azimin) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[19], "%le", &azimax) != 1 ) {
		fprintf(stderr,"error: %s: cant read azimax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[20], "%d", &nazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read nazi from command line\n", argv[0] );
		exit(-1);
		}


	if( (nmfile=fopen(argv[21],"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open new_model_file <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}

	sprintf( hitsfile, "%s.hits", argv[21] );

	n_total_ttimes = n_T_ttimes + n_V_ttimes;
	G=new_sparse_matrix(n_total_ttimes,n_model_pars+n_pwg,0);
	ts=(double*)malloc((n_model_pars+n_pwg+2)*sizeof(double));
	ts2=(double*)malloc((n_total_ttimes+2)*sizeof(double));
	d=(double*)malloc((n_total_ttimes+2)*sizeof(double));
	dindex=(int*)malloc((n_total_ttimes+2)*sizeof(int));
	dptr=(int*)malloc((n_total_ttimes+2)*sizeof(int));
	GTd=(double*)malloc((n_model_pars+n_pwg+2)*sizeof(double));
	dm=(double*)malloc((n_model_pars+n_pwg+2)*sizeof(double));

	if( (G==NULL) || (d==NULL) || (dindex==NULL) || (ts==NULL) ||
		(dptr==NULL) || (ts2==NULL) || (GTd==NULL) || (dm==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (G, d ...)\n", argv[0] );
		exit(-1);
		}

	blocksum=(double*)malloc((n_model_pars+2)*sizeof(double));;
	blockones=(double*)malloc((n_total_ttimes+2)*sizeof(double));
	if( (blocksum==NULL) || (blockones==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (blocksum ...)\n", argv[0] );
		exit(-1);
		}
	ng=0;

	ttime=T_ttime; n_ttimes=n_T_ttimes;
	timestamp((char*)"at start of plane-wave-to-point raytracing");

	fprintf(stderr,"Starting Plane-Wave to Point Ray tracing of data\n\n");
	fprintf(stderr,"#\tobsTa\tT-predicted\n");

	for( itt=0; itt<n_ttimes; itt++ ) {

	if( itt==0 ) {
		match=FALSE;
		}
	else {
		if( ttime[itt].index==index && ttime[itt].interface==interface ) 
			match=TRUE; else match=FALSE;
		}

	if( !match ) {
		index=ttime[itt].index;
		azi=ttime[itt].az;
		vapp=ttime[itt].vapp;
		interface=ttime[itt].interface;
		ratio=ttime[itt].ratio;
		fprintf(stderr,"Shooting turf pattern from reference depth %f at azimuth %f and app-velocity %f and ratio %f to interface %d\n",
		z0, azi, vapp, ratio, interface);
		fprintf(stderr,"Turf ranges: x (%f %f %d) y (%f %f %d)\n",
		xmin, xmax, nx, ymin, ymax, ny );
		shoot_turf(xmin, xmax, nx, ymin, ymax, ny, azi, vapp*ratio, z0, 0.0, interface);
		fprintf(stderr,"done with turf\n\n");
		}
	xsta=ttime[itt].x1[0];
	ysta=ttime[itt].x1[1];
	n_tts=0;
	for( i=0; i<(m_turf-1); i++ )
	for( j=0; j<(n_turf-1); j++ )
	for( l=0; l<2; l++ ) {
			if( inturfbox(i, j, l, xsta, ysta, &x_est,
				&y_est, &tri, x0, interface, azi,vapp*ratio,z0,0.0,NULL) )
			if( refine_turf( x0, xsta, ysta, interface, &x_est, &y_est,
				NULL, &n_arcs, &traveltime, &tri, azi,vapp*ratio,z0,0.0) ) {
			if( (n_tts+2)<MAX_TTS ) {
				tt[n_tts].az=x_est;
				tt[n_tts].th=y_est;
				tt[n_tts].T=traveltime;
				n_tts++;
				}
			else {
				fprintf(stderr,"error: %s: too many arrivals\n", argv[0]);
				exit(-1);
				}
			}
		}
	qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
	if( order==(-1) ) setorder( tt, n_tts, ttime[itt].obsTa-ttime[itt].T0, ttime[itt].ratio, &ttime[itt].obsorder );

	if( (j=ttime[itt].obsorder) < n_tts ) {
			status=TRUE;
			x0[0]=tt[j].az;
			x0[1]=tt[j].th;
			x0[2]=z0;
			last_tetra=my_last_tetra;
			if( find_tetra(x0,&t) ) {
				vp = eval_velocity(&tetra[t],x0);
				}
			else status=FALSE;
			if( vp>=(vapp*ratio) ) status=FALSE;
			my_last_tetra=last_tetra;
			theta = 180.0-RTOD*asin(vp/(vapp*ratio));
			ray_tangent(theta,azi,t0);
			px = t0[0]/vp; py=t0[1]/vp;
		if( status) if( !shoot_to_interface( x0, t0, x1, t1, arc, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec ) ) {
			status=FALSE;
			}
		if( status) if( !hitflag ) status=FALSE;
		}
	else status=FALSE;
	if( status ) {
		ttime[itt].ok=TRUE;
		ttime[itt].preorder=j;
		ttime[itt].x0[0]=tt[j].az;
		ttime[itt].x0[1]=tt[j].th;
		ttime[itt].x0[2]=z0;
		ttime[itt].preTa=ratio*(
			traveltime + px*ttime[itt].x0[0] + py*ttime[itt].x0[1] );
		fprintf(stderr,"%d\t%f\t%f\n", itt, ttime[itt].obsTa, ttime[itt].preTa );
		}
	else {
		ttime[itt].ok=FALSE;
		fprintf(stderr,"warning: lost observation %d\n", itt);
		continue;
		}

	d[ng]=relative_weight*(ttime[itt].obsTa-ttime[itt].preTa);
	dindex[ng]=ttime[itt].index;
	dptr[ng]=itt;

	for( i=0; i<n_nodes; i++ ) node[i].touched=0;
	for( i=0; i<n_arcs; i++ ) {
		node[ arc[i].ptetra->n1 ].touched=1;
		node[ arc[i].ptetra->n2 ].touched=1;
		node[ arc[i].ptetra->n3 ].touched=1;
		node[ arc[i].ptetra->n4 ].touched=1;
		}
	for( i=0; i<n_nodes; i++ ) {
		if( node[i].touched ) node[i].hits++;
		node[i].touched=0;
		}

	for( j=0; j<n_model_pars; j++ ) {
		/* will varying this model parameter change the traveltime ? */
		match=FALSE;
		for( i=0; i<n_arcs; i++ ) {
			pt=arc[i].ptetra;
			tnode[0]=pt->n1; tnode[1]=pt->n2; tnode[2]=pt->n3; tnode[3]=pt->n4;
			for( k=0; k<4; k++ ) {
				if( node_in_model_par(tnode[k],j) ) {
					match=TRUE;
					break;
					}
				}
			if(match) break;
			}
		if( match ) {
			set_sparse_value( G, ng, j,
				dTdmp(j,arc,n_arcs,traveltime)*ttime[itt].ratio*relative_weight );
			}
		else {
			/* G[ng][j] = 0.0; */
			;
			}
		}

	ng++;

	} /* next traveltime */

	timestamp((char*)"at end of plane-wave-to-point raytracing");

	if( ng<100 && n_model_pars<6 ) {
		fprintf(stderr,"\nG, d before demean:\n");
		for(i=0; i<ng; i++ ) {
			fprintf(stderr,"%d\t", i);
			for( j=0; j<n_model_pars; j++ ) {
				fprintf(stderr,"%f\t", get_sparse_value(G,i,j) );
				}
			fprintf(stderr,"%f\n", d[i] );
			}
		fprintf(stderr,"\n");
		}

	maxG=sparse_absmax(G);
	t0weight=maxG/10.0;
	k=sparse_count(G);
	fprintf(stderr,"\nBefore adjustment for t0 of planewaves\n");
	fprintf(stderr,"Top part of G is %d by %d, is %f percent full, and has abs max of %f\n", ng, n_model_pars, 100.0*(double)k/((double)ng*(double)n_model_pars), maxG );

        /* add elements of G associate with dt0 model parameters */
        for( i=0; i<ng; i++ ) {
        	j = ttime[dptr[i]].pwg;
        	set_sparse_value( G, i, n_model_pars+j, t0weight );
        	}
        /* subtract <ta> - <tt> from d */
       	i=0;
        while( i<ng ) {
        	j=i;
        	while( (j<ng) && (dindex[j]==dindex[i]) ) j++;
        	mean=0.0;
        	for( k=i; k<j; k++ ) mean+=d[k];
        	mean /= (double)(j-i);
        	for( k=i; k<j; k++ ) d[k]-=mean;
        	i=j;
        	}
        	
        maxG=sparse_absmax(G);
	k=sparse_count(G);

	maxd=0.0;
	for( i=0; i<ng; i++ ) {
		dv=fabs(d[i]);
		if( dv>maxd ) maxd=dv;
		}

        fprintf(stderr,"\nAfter adjustment for t0 of planewaves\n");
	fprintf(stderr,"Top part of G is %d by %d, is %f percent full, and has abs max of %f\n", ng, n_model_pars+n_pwg,
		100.0*(double)k/((double)ng*(double)n_model_pars), maxG );
	fprintf(stderr,"\nd is %d by 1 and  has abs max of %f\n\n", ng, maxd );

	timestamp((char*)"after adjustment for t0 of planewaves");

	if( ng<100 && n_model_pars<6 ) {
		fprintf(stderr,"\nG, d after adjustment:\n");
		for(i=0; i<ng; i++ ) {
			fprintf(stderr,"%d\t", i);
			for( j=0; j<n_model_pars; j++ ) {
				fprintf(stderr,"%f\t", get_sparse_value(G,i,j) );
				}
			fprintf(stderr,"%f\n", d[i] );
			}
		fprintf(stderr,"\n");
		}

	ttime=V_ttime; n_ttimes=n_V_ttimes;

	fprintf(stderr,"Starting Point to Point Ray tracing of data\n\n");
	timestamp((char*)"at start of point-to-point raytracing");
	fprintf(stderr,"#\tobsTT\tpreTT\tres\n");

	for( itt=0; itt<n_ttimes; itt++ ) {

	if( itt==0 ) {
		match=FALSE;
		}
	else {
		if( ttime[itt].x0[0]==x0[0] && ttime[itt].x0[1]==x0[1] &&
			ttime[itt].x0[2]==x0[2] && ttime[itt].interface==interface ) 
			match=TRUE; else match=FALSE;
		}

	if( !match ) {
		for( i=0; i<3; i++ ) x0[i]=ttime[itt].x0[i];
		interface=ttime[itt].interface;
		if( !find_tetra(x0,&i) ) {
			fprintf(stderr,"error: %s: source location (%f %f %f) not in model\n", argv[0], x0[0], x0[1], x0[2] );
			exit(-1);
			}
		vs=eval_velocity(&tetra[i],x0);

		fprintf(stderr,"Shooting star pattern from source (%f %f %f) at velocity %f to interface %d, theta (%f, %f, %d) azi (%f %f %d)\n",
		x0[0], x0[1], x0[2], vs,
		interface, thmin, thmax, nth, azimin, azimax, nazi );
		shoot_star(thmin, thmax, nth, azimin, azimax, nazi, x0, interface);
		fprintf(stderr,"done with star\n\n");
		}
	xsta=ttime[itt].x1[0];
	ysta=ttime[itt].x1[1];
	n_tts=0;
	bracket_status=FALSE;
	for( i=0; i<(m_rays-1); i++ )
	for( j=0; j<(n_rays-1); j++ )
	for( l=0; l<2; l++ ) {
		if( instarbox(i, j, l, xsta, ysta, &th_est,
			&az_est, &tri, x0, interface, NULL) ) {
		bracket_status=TRUE;
		if( refine( x0, xsta, ysta, interface, &th_est, &az_est,
			NULL, &n_arcs, &traveltime, &tri) ) {
			if( (n_tts+2)<MAX_TTS ) {
				tt[n_tts].az=az_est;
				tt[n_tts].th=th_est;
				tt[n_tts].T=traveltime;
				n_tts++;
				}
			else {
				fprintf(stderr,"error: %s: too many arrivals\n", argv[0]);
				exit(-1);
				}
			} }
		}
	qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
	if( order==(-1) ) setorder( tt, n_tts, ttime[itt].obsTa-ttime[itt].T0, ttime[itt].ratio, &ttime[itt].obsorder );

	if( (j=ttime[itt].obsorder) < n_tts ) {
		status=TRUE;
		ray_tangent(tt[j].th,tt[j].az,t0);
		if( !shoot_to_interface( x0, t0, x1, t1, arc, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec ) ) {
			status=FALSE;
			}
		if( !hitflag ) status=FALSE;
		}
	else status=FALSE;

	if( status ) {
		ttime[itt].ok=TRUE;
		ttime[itt].preorder=j;
		ttime[itt].preTT=traveltime*ttime[itt].ratio;
		ttime[itt].th=tt[j].th;
		ttime[itt].az=tt[j].az;
		fprintf(stderr,"%d\t%f\t%f\t%f\n", itt, 
			ttime[itt].obsTT, ttime[itt].preTT,
			ttime[itt].obsTT-ttime[itt].preTT);
		}
	else {
		ttime[itt].ok=FALSE;
		fprintf(stderr,"warning: lost observation %d\n", itt);
		if( !bracket_status ) {
			fprintf(stderr,"         ray was not bracketed\n" );
			}
		else {
			if( refine_star_status==1 ) {
				fprintf(stderr,"         derivative failed in refine\n" );
				}
			if( refine_star_status==2 ) {
				fprintf(stderr,"         ray came this close: %e\n", refine_star_norm );
				}
			}
		continue;
		}

	d[ng]=ttime[itt].obsTT-traveltime*ttime[itt].ratio;

	for( i=0; i<n_nodes; i++ ) node[i].touched=0;
	for( i=0; i<n_arcs; i++ ) {
		node[ arc[i].ptetra->n1 ].touched=1;
		node[ arc[i].ptetra->n2 ].touched=1;
		node[ arc[i].ptetra->n3 ].touched=1;
		node[ arc[i].ptetra->n4 ].touched=1;
		}
	for( i=0; i<n_nodes; i++ ) {
		if( node[i].touched ) node[i].hits++;
		node[i].touched=0;
		}

	for( j=0; j<n_model_pars; j++ ) {
		/* will varying this model parameter change the traveltime ? */
		match=FALSE;
		for( i=0; i<n_arcs; i++ ) {
			pt=arc[i].ptetra;
			tnode[0]=pt->n1; tnode[1]=pt->n2; tnode[2]=pt->n3; tnode[3]=pt->n4;
			for( k=0; k<4; k++ ) {
				if( node_in_model_par(tnode[k],j) ) {
					match=TRUE;
					break;
					}
				}
			if(match) break;
			}
		if( match ) {
			set_sparse_value( G, ng, j,
				dTdmp(j,arc,n_arcs,traveltime)*ttime[itt].ratio );
			}
		else {
			;/* G[ng][j] is zero */
			}
		}

	if( fabs(d[ng]) > max_dT ) {
		fprintf(stderr,"|%f|>%f, so ignoring this data \n", d[ng], max_dT );
		for( j=0; j<n_model_pars; j++ ) set_sparse_value( G, ng, j, 0.0 );
		}
	else {
		ng++;
		}

	} /* next traveltime */

	timestamp((char*)"at end of point_to_point raytracing");

	maxG=sparse_absmax(G);
	k=sparse_count(G);

	maxd=0.0;
	for( i=0; i<ng; i++ ) {
		dv=fabs(d[i]);
		if( dv>maxd ) maxd=dv;
		}

	fprintf(stderr,"\nAfter point-to-point raytracing\n");
	fprintf(stderr,"\nG is %d by %d, is %f percent full, and has abs max of %f\n", ng, n_model_pars, 100.0*(double)k/((double)ng*(double)n_model_pars), maxG );
	fprintf(stderr,"\nd is %d by 1 and  has abs max of %f\n\n", ng, maxd );
	fprintf(stderr,"Damping: %e\n\n", damping );
	
	smt_times_v( G, d, GTd );
	maxd=0.0;
	for( i=0; i<n_model_pars; i++ ) {
		dv=fabs(GTd[i]);
		if( dv>maxd ) maxd=dv;
		}
	fprintf(stderr,"GTd is %d by 1, and has absolute maximum of %f\n\n", n_model_pars, maxd );
	
	if( EXPLICIT_GTG ) {

	timestamp((char*)"before forming GTG");
	invert_GTG = smt_times_sm(G,G);
	if( invert_GTG==NULL ) {
		fprintf(stderr,"error: %s: out of memory (invert_GTG)\n", argv[0] );
		exit(-1);
		}
	maxG=sparse_absmax(invert_GTG);
	sparse_addtodiag(invert_GTG, damping*maxG);
	k=sparse_count(invert_GTG);

	fprintf(stderr,
	"GTG is %d by %d, is %f percent full, and has absolute maximum of %f\n\n",
	n_model_pars, n_model_pars,
	100.0*(double)k/((double)n_model_pars*(double)n_model_pars), maxG );

	timestamp((char*)"after forming GTG");

	for( i=0; i<n_model_pars; i++ ) {
		dm[i]=0.0;
		}
	if( !sparse_biconj( invert_GTG,GTd,dm,1,maxd*B_PREC,n_model_pars+10,&iter,&err,&biec) ) {
		fprintf(stderr,"error: %s: biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
	fprintf(stderr,"Matrix inversion (explicit): %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after solving equations");
	
	sm_times_v( invert_GTG, dm, ts );

	if( n_model_pars < 1000 ) {
		fprintf(stderr,"\nGTG*dm=GTd\n");
		fprintf(stderr,"#\tobs\tpred\tdifference\n");
		}
	rms=0.0;
	for( i=0; i<n_model_pars; i++ ) {
		if( n_model_pars < 1000 ) fprintf(stderr,"%d\t%f\t%f\t%f\n", i, GTd[i], ts[i], GTd[i]-ts[i] );
		rms+=(GTd[i]-ts[i])*(GTd[i]-ts[i]);
		}
	rms = sqrt(rms/(double)n_model_pars);
	fprintf(stderr,"\nrms solution error is %f\n\n", rms);

	} /* end explicit GTG */
	else {

	scx = ATAabsmax( G );
	new_damping = damping*scx;
	fprintf(stderr,"Damping: %e abmaxGTG: %e Scaled_damping: %e\n\n",
		damping, scx, new_damping );
	
	for( i=0; i<n_model_pars+n_pwg; i++ ) dm[i]=0.0;
	if( !sparse_dls_biconj( G, d, dm, new_damping, 1, maxd*B_PREC, n_model_pars+n_pwg+10, &iter,&err,&biec ) ) {
		fprintf(stderr,"error: %s: dls_biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
		
	fprintf(stderr,"Matrix inversion: %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after implicit solution");
	
	} /* end implicit GTG */

	if( n_model_pars < 1000 ) {
		fprintf(stderr, "Model parameter perturbations\n");
		fprintf(stderr, "#\tdm\n");
		for( i=0; i<n_model_pars; i++ ) {
			fprintf(stderr,"%i\t%f\n", i, dm[i] );
			}
		fprintf(stderr,"\n");
		}
		
	mean=fabs(dm[n_model_pars]);
	for( i=n_model_pars; i<n_model_pars+n_pwg; i++ ) {
		maxd=fabs(dm[i]);
		if( maxd>mean ) mean=maxd;
		}
	fprintf(stderr,"The largest dt0 is %e\n", mean*t0weight );
	
	sm_times_v( G, dm, ts2 );
	fprintf(stderr,"\nG*dm=dt\n");
	fprintf(stderr,"#\tobs_dt\tpred_st\tdifference\n");
	rms=0.0;
	rms2=0.0;
	for( i=0; i<ng; i++ ) {
		fprintf(stderr,"%d\t%f\t%f\t%f\n", i, d[i], ts2[i], d[i]-ts2[i] );
		rms+=(d[i]-ts2[i])*(d[i]-ts2[i]);
		rms2+=d[i]*d[i];
		}
	rms = sqrt(rms/(double)ng);
	rms2 = sqrt(rms2/(double)ng);
	fprintf(stderr,"\nlinearized rms traveltime error is %f compared to original %f\n", rms, rms2);
	fprintf(stderr,"%f percent reduction\n", 100.0*(1-rms/rms2));
	fprintf(stderr,"(but be warned; actual reduction, after re-raytracing, might be different\n");

	/* update velocity of nodes */
	for( i=0; i<n_model_pars; i++ ) {
		for( j=0; j<model_par[i].n; j++ ) {
			k=model_par[i].node[j];
			weight=model_par[i].weight[j];
			node[k].v += weight*dm[i];
			}
		}
	/* write out perturbed model */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		if( QDEFINED )
		fprintf(nmfile,"%d %d %d %f %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, 1.0/node[i].qinv, node[i].ifc );
		else
		fprintf(nmfile,"%d %d %d %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, node[i].ifc );
		}

	fclose(nmfile);

	if( (nmfile=fopen(hitsfile,"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open hitsfile <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}

	/* write out hits file */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		fprintf(nmfile,"%d %d %d %f %f %f %d %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].hits, node[i].ifc );
		}
	fclose(nmfile);

	timestamp((char*)"at end");
		
	exit(0);
	}

void main_fitmodel(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, k, nv, nvmax, ng, t, nd[4];
	int nx, ny, nz;
	double x, y, z, vs, dv, damping, dvdn; // v1, v2, v3, v4, //unused
	struct v_rec {
		double x[3];
		double v;
		};
	struct v_rec *v;
	char ct[128];
	struct sparse_matrix *G, *GTG;
	double *d, *GTd, *dm, maxG, maxd, err;
	int biec, iter;
	double new_damping, scx;

	if( argc!=3 ) {
		fprintf(stderr,"purpose: adjust nodal velocities to fit v(x,y,z) values\n");
		fprintf(stderr,"usage: %s model_file damping < velocity_data.tsv > new_model_file\n",argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"      damping: damped least squares parameter  (fraction of largest element of GTG)\n");
		fprintf(stderr,"      velocity_data.tsv:\n");
		fprintf(stderr,"          first line: field names (skipped)\n");
		fprintf(stderr,"          subsequent lines: velocity data, one per line, with fields\n");
		fprintf(stderr,"          	x, in km\n");
		fprintf(stderr,"          	y, in km\n");
		fprintf(stderr,"          	z, in km\n");
		fprintf(stderr,"          	v, in km/s\n");
		fprintf(stderr,"      new_model_file: same format as model_file\n");
		exit(-1);
		}

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	if( sscanf(argv[2],"%le",&damping) != 1 ) {
		fprintf(stderr,"error: %s: cant read damping from command line\n", argv[0] );
		exit(-1);
		}

	nvmax=1000;
	if( (v=(struct v_rec *)malloc((nvmax+2)*sizeof(struct v_rec)))==NULL ) {
		fprintf(stderr,"error: %s: out of memory (1)\n", argv[0] );
		exit(-1);
		}

	if( scanf("%s%s%s%s", ct,ct,ct,ct ) != 4 ) {
		fprintf(stderr,"error: %s: cant skip header in input\n",argv[0]);
		exit(-1);
		}

	nv=0;
 	while( scanf("%le%le%le%le", &x, &y, &z, &vs) == 4) {
		v[nv].x[0]=x; v[nv].x[1]=y; v[nv].x[2]=z; v[nv].v=vs;
		if( (nv+2) > nvmax ) {
			nvmax+=1000;
			if( (v=(struct v_rec *)realloc(v,(nvmax+2)*sizeof(struct v_rec)))==NULL ) {
				fprintf(stderr,"error: %s: out of memory (2)\n", argv[0] );
				exit(-1);
				}
			}
			nv++;
		}
	fprintf(stderr,"%d v(x,y,z) data input\n", nv);

	G=new_sparse_matrix(nv,n_nodes,0);
	d=(double*)malloc((nv+2)*sizeof(double));
	GTd=(double*)malloc((n_nodes+2)*sizeof(double));
	dm=(double*)malloc((n_nodes+2)*sizeof(double));

	if( (G==NULL) || (d==NULL) || (GTd==NULL) || (dm==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (G, d ...)\n", argv[0] );
		exit(-1);
		}

	ng=0; dv=1.0e-4;
	for( i=0; i<nv; i++ ) if( find_tetra(v[i].x,&t) ) {
		vs=eval_velocity(&tetra[t],v[i].x);
		d[ng]=v[i].v-vs;
		nd[0]=tetra[t].n1; nd[1]=tetra[t].n2; nd[2]=tetra[t].n3; nd[3]=tetra[t].n4;
		for( j=0; j<4; j++ ) {
			node[nd[j]].v += dv;
			velocity_eqn( &(tetra[t]) );
			dvdn=(eval_velocity(&tetra[t],v[i].x)-vs)/dv;
			node[nd[j]].v = node[nd[j]].v_orig;
			if( !set_sparse_value(G,ng,nd[j],dvdn) ) {
				fprintf(stderr,"error: %s: out of memory (2)\n", argv[0] );
				exit(-1);
				}
			}
		for( j=0; j<4; j++ ) node[nd[j]].v = node[nd[j]].v_orig;
		velocity_eqn( &(tetra[t]) );
		ng++;
		}

	if( ng!=nv ) fprintf(stderr,"warning: %s: %d data not within the model\n", argv[0], nv-ng );

	maxG=sparse_absmax(G);
	k=sparse_count(G);

	maxd=0.0;
	for( i=0; i<ng; i++ ) {
		dv=fabs(d[i]);
		if( dv>maxd ) maxd=dv;
		}

	fprintf(stderr,"\nG is %d by %d, is %f percent full, and has abs max of %f\n",
	ng, n_nodes, 100.0*(double)k/((double)ng*(double)n_nodes), maxG );
	fprintf(stderr,"\nd is %d by 1 and  has abs max of %f\n\n", ng, maxd );
	
	fprintf(stderr,"Damping: %e\n\n", damping );

	smt_times_v( G, d, GTd );

	maxd=0.0;
	for( i=0; i<n_nodes; i++ ) {
		dv=fabs(GTd[i]);
		if( dv>maxd ) maxd=dv;
		}

	fprintf(stderr,
	"GTd is %d by 1, and has absolute maximum of %f\n\n",
	n_nodes, maxd );
	
	if( EXPLICIT_GTG ) {

	GTG = smt_times_sm(G,G);
	if( GTG==NULL ) {
		fprintf(stderr,"error: %s: out of memory (GTG)\n", argv[0] );
		exit(-1);
		}
	maxG=sparse_absmax(GTG);
	sparse_addtodiag(GTG, damping*maxG);
	k=sparse_count(GTG);

	fprintf(stderr,
	"GTG is %d by %d, is %f percent full, and has absolute maximum of %f\n\n",
	n_nodes, n_nodes,
	100.0*(double)k/((double)n_nodes*(double)n_nodes), maxG );

	for( i=0; i<n_model_pars; i++ ) dm[i]=0.0;
	if( !sparse_biconj(GTG,GTd,dm,1,maxd*B_PREC,n_nodes+10,&iter,&err,&biec) ) {
		fprintf(stderr,"error: %s: biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
	fprintf(stderr,"Matrix inversion (explicit): %d iterations; rms %f\n\n", iter, err );
	
	}
	else {
	
	scx = ATAabsmax( G );
	new_damping = damping*scx;
	fprintf(stderr,"Damping: %e abmaxGTG: %e Scaled_damping: %e\n\n",
		damping, scx, new_damping );

	for( i=0; i<n_model_pars; i++ ) dm[i]=0.0;
	if( !sparse_dls_biconj(G,d,dm,new_damping,1,maxd*B_PREC,n_nodes+10,&iter,&err,&biec ) ) {
		fprintf(stderr,"error: %s: dls_biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
		
	fprintf(stderr,"Matrix inversion (implicit): %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after implicit solution");
	} /* after implicit solution */

	/* write out updated model */
	printf("%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		if( QDEFINED )
		printf("%d %d %d %f %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v+dm[i], 1.0/node[i].qinv, node[i].ifc );
		else
		printf("%d %d %d %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v+dm[i], node[i].ifc );
		}


	exit(0);
	}

void main_modelpars(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int status;

	if( argc<2 ) {
		fprintf(stderr,"purpose: generate model parameter file from model file,\n");
		fprintf(stderr,"         for certain commonly used types of model parameters\n");
		fprintf(stderr,"usage: %s keyword parameter_1 ... < model_file > model_parameter_file\n", argv[0] );
		fprintf(stderr,"       with the following keywords and parameters:\n");
		fprintf(stderr,"       vnodes interface weight\n");
		fprintf(stderr,"           one velocity model parameter for each node on\n");
		fprintf(stderr,"           the specified interface. All model parameters on\n");
		fprintf(stderr,"           that interface have the same weight. Suggest weight=1.\n");
		fprintf(stderr,"       vnodesavg interface neighbors scale weight\n");
		fprintf(stderr,"           one velocity model parameter for each node on\n");
		fprintf(stderr,"           the specified interface, consisting of a localized\n");
		fprintf(stderr,"           average of nearest neighbor nodes. Setting neighbors=1\n");
		fprintf(stderr,"           creates a model parameters with 9 nodes, neighbors=2\n");
		fprintf(stderr,"           25 nodes, etc. The averaging is gaussian in horizontal\n");
		fprintf(stderr,"           distance, R, from the central node, that is,\n");
		fprintf(stderr,"           exp(-R^2/scale^2).  An overall weight is also\n");
		fprintf(stderr,"           supplied. It is the same for all nodes on the\n");
		fprintf(stderr,"           interface. Suggest weight=1. Warning: Does not\n");
		fprintf(stderr,"           correctly handle case where interface lies on multiple\n");
		fprintf(stderr,"           layers in the model.\n");
		fprintf(stderr,"       vnodesbase interface order weight\n");
		fprintf(stderr,"           implements model parameters in which all nodes\n");
		fprintf(stderr,"           on an interface vary according to a low order\n");
		fprintf(stderr,"           (0<=order<=3) polynomial in horizontal distance:\n");
		fprintf(stderr,"         v(i) =  m0 + m1*x' + m2*y'\n");
		fprintf(stderr,"         	+  m3*(x'**2-4/3)\n");
		fprintf(stderr,"         	+  m4*(y'**2-4/3)\n");
		fprintf(stderr,"         	+  m5*y'*x'\n");
		fprintf(stderr,"         	+  m6*x'**3'\n");
		fprintf(stderr,"         	+  m7*y'*x'**2\n");
		fprintf(stderr,"         	+  m8*y'**2'*x'\n");
		fprintf(stderr,"         	+  m9*y'**3\n");
		fprintf(stderr,"         where the (x',y') coordinates are in the\n");
		fprintf(stderr,"         horizontal plane, centered on the center of\n");
		fprintf(stderr,"         of the model and reach +/-1 at its edges.\n");
		fprintf(stderr,"         The factor of 4/3 is added so that all higher\n");
		fprintf(stderr,"         order terms have zero mean on [-1,+1].\n");
		fprintf(stderr,"       inodes interface Nx Ny Nz weight\n");
		fprintf(stderr,"           one interface position model parameter for each node on\n");
		fprintf(stderr,"           the specified interface. All model parameters on\n");
		fprintf(stderr,"           that interface have the same unit vector and the\n");
		fprintf(stderr,"           same weight. Suggest Nx=0, Ny=0, Nz=1, weight=1.\n");
		fprintf(stderr,"Note: you can build up a model parameter file by concatenating\n");
		fprintf(stderr,"      the output of several calls to this software (e.g. one\n");
		fprintf(stderr,"      call per interface)\n");
		exit(-1);
		}

	if( !strcmp(argv[1],"vnodes") ) {
		status=mp_vnodes(argc-1,argv+1);
		}
	else if( !strcmp(argv[1],"vnodesavg") ) {
		status=mp_vnodesavg(argc-1,argv+1);
		}
	else if( !strcmp(argv[1],"vnodesbase") ) {
		status=mp_vnodesbase(argc-1,argv+1);
		}
	else if( !strcmp(argv[1],"inodes") ) {
		status=mp_inodes(argc-1,argv+1);
		}
	else {
		fprintf(stderr,"Error: %s: no such keyword %s\n", argv[0], argv[1] );
		exit(-1);
		}
	if(status) exit(0); else exit(-1);
	}



int main_make_model(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, k;
	int nx, ny, nz;
	double xmin, xmax, ymin, ymax, zmin, zmax, A, B, C, D;
	double v, dx, dy, dz, x, y, z;

	if( argc<14 ) {
		fprintf(stderr,"purpose: generate a simple, vertically stratified earth model\n");
		fprintf(stderr,"         with equally-spaced nodes parallel to the x,y,z axes.\n");
		fprintf(stderr,"         (This software makes only the simplist of models. To\n");
		fprintf(stderr,"         make more complicated ones, use some scripting software\n");
		fprintf(stderr,"         like awk, perl, MATLAB, etc.)\n");

		fprintf(stderr,"usage: %s xmin xmax nx ymin ymax ny zmin zmax nz A B C D > model_file\n",
				argv[0] );
		fprintf(stderr,"       xmin, xmax, in km, minimum and maximum value of x\n");
		fprintf(stderr,"       nx, number of nodes in x direction\n");
		fprintf(stderr,"       ymin, ymax, in km, minimum and maximum value of y\n");
		fprintf(stderr,"       ny, number of nodes in x direction\n");
		fprintf(stderr,"       zmin, zmax, in km, minimum and maximum value of z\n");
		fprintf(stderr,"       nz, number of nodes in x direction\n");
		fprintf(stderr,"       A, B, C, D coefficients to the velocity equation,\n");
		fprintf(stderr,"       v=A+Bz+C*sqrt(z/D), where v is velocity in km/s\n");
		exit(-1);
		}

	if( sscanf(argv[1], "%le", &xmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read xmin from command line\n", argv[0] );
		return(0);
		}
	if( sscanf(argv[2], "%le", &xmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read xmax from command line\n", argv[0] );
		return(0);
		}
	if( sscanf(argv[3], "%de", &nx) != 1 ) {
		fprintf(stderr,"error: %s: cant read nx from command line\n", argv[0] );
		return(0);
		}

	if( sscanf(argv[4], "%le", &ymin) != 1 ) {
		fprintf(stderr,"error: %s: cant read ymin from command line\n", argv[0] );
		return(0);
		}
	if( sscanf(argv[5], "%le", &ymax) != 1 ) {
		fprintf(stderr,"error: %s: cant read ymax from command line\n", argv[0] );
		return(0);
		}
	if( sscanf(argv[6], "%de", &ny) != 1 ) {
		fprintf(stderr,"error: %s: cant read ny from command line\n", argv[0] );
		return(0);
		}

	if( sscanf(argv[7], "%le", &zmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read zmin from command line\n", argv[0] );
		return(0);
		}
	if( sscanf(argv[8], "%le", &zmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read zmax from command line\n", argv[0] );
		return(0);
		}
	if( sscanf(argv[9], "%de", &nz) != 1 ) {
		fprintf(stderr,"error: %s: cant read nz from command line\n", argv[0] );
		return(0);
		}

	if( sscanf(argv[10], "%le", &A) != 1 ) {
		fprintf(stderr,"error: %s: cant read A from command line\n", argv[0] );
		return(0);
		}
	if( sscanf(argv[11], "%le", &B) != 1 ) {
		fprintf(stderr,"error: %s: cant read B from command line\n", argv[0] );
		return(0);
		}
	if( sscanf(argv[12], "%le", &C) != 1 ) {
		fprintf(stderr,"error: %s: cant read C from command line\n", argv[0] );
		return(0);
		}
	if( sscanf(argv[13], "%le", &D) != 1 ) {
		fprintf(stderr,"error: %s: cant read D from command line\n", argv[0] );
		return(0);
		}

	printf("%d %d %d\n", nx, ny, nz );
	dx = (xmax-xmin)/(double)(nx-1);
	dy = (ymax-ymin)/(double)(ny-1);
	dz = (zmax-zmin)/(double)(nz-1);
	for( i=0; i<nx; i++ ) { x=xmin+dx*(double)i;
	for( j=0; j<ny; j++ ) { y=ymin+dy*(double)j;
	for( k=0; k<nz; k++ ) { z=zmin+dz*(double)k;
		v=A+B*z+C*sqrt(z/D);
		printf("%d %d %d %f %f %f %f %d\n", i, j, k, x, y, z, v, k );
		}}}

	exit(0);
	}



		
void main_locate_and_invert(int argc, char **argv)
{
	int i, j, k, l, m, n, ngood, status, iter, biec, irms, line, match;
	int ii, jj, kk;
	char str[1024], hitsfile[1024];
	double x0[3], x1[3], t1[3];
        int tnode[4];
	int nx, ny, nz;

	struct arc_rec arc[MAX_ARCS];
	int n_arcs;

        struct tetra_rec *pt;

	FILE *fsta, *nmfile;
	int *stanum;
	double *stax, *stay, *staz;
	char **jhdfilename;
	int n_sta;
	double x,y,z,t0,c,azi,theta,weight;
	double T, dTdx, dTdy, dTdz;

	FILE *fev;
	struct ev_rec *ev, evkey, *myev;
	int n_ev;

	FILE *fph;
	struct ph_rec *ph;
	int n_ph;

	FILE *fjhd, *mpfile;
	struct jhd_rec *jhd;
	int n_jhd;
	struct jhd_rec jhdkey, *myjhd;

	int verbose=0;

	struct sparse_matrix *G; //, *GTG; //unused
	double *d, *dp, *GTd, *dm, tscale=TSCALEVALUE, maxG, maxd, damping, rw, err, res, rms1, rms2;
	double *starms, *stamean;
	int *stacount;
	double *Grow;

	double new_damping, scx;

	if( argc!=9 ) {
		fprintf(stderr,"purpose: joint hypocenter relocation and velocity tomography\n");
		fprintf(stderr,"method: The user provides a set of observations, where\n");
		fprintf(stderr,"        each observation is assumed to be a linear combination\n");
		fprintf(stderr,"        of traveltimes:\n");
		fprintf(stderr,"           observation = (sum i=1 to n) coefficient[i] * traveltime[i]\n");
		fprintf(stderr,"        A phase file tabulates the observations and the\n");
		fprintf(stderr,"        n coefficients and the station, event and order\n");
		fprintf(stderr,"        of each of the traveltimes.  The observations are\n");
		fprintf(stderr,"        used to produce an updated estimate of the event\n");
		fprintf(stderr,"        locations and the velocity model.\n");
		fprintf(stderr,"usage: %s model_file.txt model_parameter_file.txt station_file.txt event_file.txt phase_file.txt new_model_file damping relative_weight > updated_event_file.txt\n", argv[0]);
		write_model_blerb(stderr);
		fprintf(stderr,"       model_file.txt: standard velocity model file\n");
		fprintf(stderr,"       model_parameter_file.txt: standard velocity node model parameter file\n");
		fprintf(stderr,"       station_file.txt: one station per line, with fields\n");
		fprintf(stderr,"               station_number: arbitrary integer\n");
		fprintf(stderr,"               x, y, z: station location, km\n");
		fprintf(stderr,"               jhd_table: path of station-specific jhd-table\n");
		fprintf(stderr,"       event_file.txt: one event per line, with fields\n");
		fprintf(stderr,"               event_number: arbitrary integer\n");
		fprintf(stderr,"               x, y, z: preliminary location, km\n");
		fprintf(stderr,"               t0: preliminary origin time, s\n");
		fprintf(stderr,"       phase_file.txt: one group of lines per observation\n");
		fprintf(stderr,"               first line, with fields\n");
		fprintf(stderr,"                     n_phases: number of phases in observation\n");
		fprintf(stderr,"                     observation: a differetial traveltime, s\n");
		fprintf(stderr,"                     weight: weight of observation\n");
		fprintf(stderr,"                     maxres: observation thrown out if weighted residual > maxres, s\n");
		fprintf(stderr,"               subsequent lines in group, with fields\n");
		fprintf(stderr,"                     station_number, corresponding to station_file.txt\n");
		fprintf(stderr,"                     event_number, corresponding to event_file.txt\n");
		fprintf(stderr,"                     order, interger arrival number of phase\n");
		fprintf(stderr,"                     ratio, computed traveltimes multiplied by this\n");
		fprintf(stderr,"                            (i.e. use 1.o for P 1.76 for S)\n");
		fprintf(stderr,"                     coefficient, of phase in observation\n");
		fprintf(stderr,"       new_model_file.txt: updated model file. A corresponding\n");
		fprintf(stderr,"       		hits file, with suffix .hits, is also created\n");
		fprintf(stderr,"       damping: damping factor, fraction of max of GTG\n");
		fprintf(stderr,"       relative_weight: relative weight of event and velocity model parameters\n");
		fprintf(stderr,"               relative_weigth>1 favors large of velocity model perturbations\n");
		fprintf(stderr,"               relative_weigth<1 favors large of event location perturbations\n");
		fprintf(stderr,"Note: In the inversion, origin time perturbations are scaled\n");
		fprintf(stderr,"to units of distance using a nominal velocity of %f km/s\n",
			1.0/TSCALEVALUE );
		exit(-1);
		}

	if( sscanf(argv[7],"%le",&damping) != 1 ) {
		fprintf(stderr,"error: %s: cant read damping from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8],"%le",&rw) != 1 ) {
		fprintf(stderr,"error: %s: cant read relative weight from command line\n", argv[0] );
		exit(-1);
		}

	fprintf(stderr,"Raytrace3d locate_and_invert\n");
	fprintf(stderr,"\tdamping %e\n", damping);
	fprintf(stderr,"\trelative weight %e\n", rw);
	fprintf(stderr,"\tstarting model %s\n", argv[1] );

	/* model file */
	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	/* model parameter file */
	alloc_model_pars(argv[2]);
	if( (mpfile=fopen(argv[2],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open model_par_file <%s> for read\n", argv[0], argv[2] );
		exit(-1);
		}
	n_model_pars=0;
	load_model_pars_V(mpfile);
	fclose(mpfile);
	fprintf(stderr,"\tmodel parameters %s with %d parameters\n", argv[2], n_model_pars );

	if( (nmfile=fopen(argv[6],"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open new_model_file <%s> for write\n", argv[0], argv[6] );
		exit(-1);
		}

	/* station file */
	n_sta=count_lines(argv[3]);
	stanum=(int *)malloc(n_sta*sizeof(int));
	stacount=(int *)malloc(n_sta*sizeof(int));
	starms=(double *)malloc(n_sta*sizeof(double));
	stamean=(double *)malloc(n_sta*sizeof(double));
	stax=(double *)malloc(n_sta*sizeof(double));
	stay=(double *)malloc(n_sta*sizeof(double));
	staz=(double *)malloc(n_sta*sizeof(double));
	jhdfilename = (char**)malloc(n_sta*sizeof(char*));
	if( (stanum==NULL) || (jhdfilename==NULL) || (starms==NULL) ||
	    (stacount==NULL) || (stamean==NULL) || (stax==NULL) ||
	    (stay==NULL) || (staz==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (1)\n", argv[0] );
		exit(-1);
		}
	if( (fsta=fopen(argv[3],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open station file <%s> for read\n",argv[0],argv[3]);
		exit(-1);
		}
	n_sta=0;
	while( fscanf(fsta,"%d%le%le%le%s",&i,&x,&y,&z,str)==5 ) {
		stanum[n_sta]=i;
		stax[n_sta]=x; stay[n_sta]=y; staz[n_sta]=z;
		jhdfilename[n_sta]=(char*)malloc( (strlen(str)+1)*sizeof(char) );
		if( jhdfilename[n_sta]==NULL ) {
			fprintf(stderr,"error: %s: out of memory (2)\n", argv[0] );
			exit(-1);
			}
		strcpy(jhdfilename[n_sta],str);
		starms[n_sta]=0.0; stacount[n_sta]=0; stamean[n_sta]=0.0;
		n_sta++;
		}
	fclose(fsta);
	fprintf(stderr,"\tstations: %d\n", n_sta);
	if( verbose ) {
		for( i=0; i<n_sta; i++ ) {
			fprintf(stderr,"%d %s\n", stanum[i], jhdfilename[i] );
			}
		fprintf(stderr,"\n");
		}

	/* event file */
	n_ev=count_lines(argv[4]);
	ev=(struct ev_rec *)malloc(n_ev*sizeof(struct ev_rec));
	if( ev==NULL ) {
		fprintf(stderr,"error: %s: out of memory (3)\n", argv[0] );
		exit(-1);
		}
	if( (fev=fopen(argv[4],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open event file <%s> for read\n",argv[0],argv[4]);
		exit(-1);
		}
	n_ev=0;
	while( fscanf(fev,"%d%le%le%le%le",&i,&x,&y,&z,&t0)==5 ) {
		ev[n_ev].nev = i;
		ev[n_ev].x=x; ev[n_ev].y=y; ev[n_ev].z=z; ev[n_ev].t0=t0;
		ev[n_ev].rms=0.0; ev[n_ev].count=0; ev[n_ev].mean=0.0; 
		n_ev++;
		}
	fclose(fev);
	qsort( ev, n_ev, sizeof(struct ev_rec), cmpev );
	for( i=0; i<n_ev; i++ ) ev[i].index=i;
	fprintf(stderr,"\tevents: %d\n", n_ev);
	if( verbose ) {
		for( i=0; i<n_ev; i++ ) {
			fprintf(stderr,"%d %f %f %f %f\n", ev[i].nev, ev[i].x, ev[i].y, ev[i].z, ev[i].t0 );
			}
		fprintf(stderr,"\n");
		}

	/* phase file */
	if( (fph=fopen(argv[5],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open phase file <%s> for read\n",argv[0],argv[5]);
		exit(-1);
		}
	n_ph=0;
	while( fscanf(fph,"%d%le%le%le",&i,&x,&y,&z)==4 ) {
		for( j=0; j<i; j++ ) {
			if( fscanf(fph,"%d%d%d%le%le",&k,&k,&k,&x,&x)!=5 ) {
				fprintf(stderr,"error: %s: reading phase file, record %d\n",
					argv[0], n_ph );
				exit(-1);
				}
			}
		n_ph++;
		}
	rewind(fph);
	ph=(struct ph_rec *)malloc(n_ph*sizeof(struct ph_rec));
	if( ph==NULL ) {
		fprintf(stderr,"error: %s: out of memory (4)\n", argv[0] );
		exit(-1);
		}
	n_ph=0; line=0;
	while( fscanf(fph,"%d%le%le%le",&i,&x,&y,&z)==4 ) {
		line++; ph[n_ph].line=line;
		ph[n_ph].n=i; ph[n_ph].obs=x; ph[n_ph].weight=y; ph[n_ph].maxres=z;
		ph[n_ph].good=0; ph[n_ph].row=(-1);
		ph[n_ph].sta=(int*)malloc(i*sizeof(int));
		ph[n_ph].ev=(int*)malloc(i*sizeof(int));
		ph[n_ph].order=(int*)malloc(i*sizeof(int));
		ph[n_ph].hit=(int*)malloc(i*sizeof(int));
		ph[n_ph].ratio=(double*)malloc(i*sizeof(double));
		ph[n_ph].coeff=(double*)malloc(i*sizeof(double));
		ph[n_ph].T=(double*)malloc(i*sizeof(double));
		ph[n_ph].dTdx=(double*)malloc(i*sizeof(double));
		ph[n_ph].dTdy=(double*)malloc(i*sizeof(double));
		ph[n_ph].dTdz=(double*)malloc(i*sizeof(double));
		ph[n_ph].azi=(double*)malloc(i*sizeof(double));
		ph[n_ph].theta=(double*)malloc(i*sizeof(double));
		ph[n_ph].stax=(double*)malloc(i*sizeof(double));
		ph[n_ph].stay=(double*)malloc(i*sizeof(double));
		ph[n_ph].staz=(double*)malloc(i*sizeof(double));
		if( (ph[n_ph].sta==NULL) || (ph[n_ph].ev==NULL) ||
			(ph[n_ph].order==NULL) || (ph[n_ph].hit==NULL) ||
		    	(ph[n_ph].ratio==NULL) || (ph[n_ph].coeff==NULL) ||
			(ph[n_ph].T==NULL) || (ph[n_ph].dTdx==NULL) ||
			(ph[n_ph].dTdy==NULL) || (ph[n_ph].dTdz==NULL) ||
		    	(ph[n_ph].azi==NULL) || (ph[n_ph].theta==NULL) ||
			(ph[n_ph].stax==NULL) || (ph[n_ph].stay==NULL) || (ph[n_ph].staz==NULL) ) {
			fprintf(stderr,"error: %s: out of memory (5)\n", argv[0] );
			exit(-1);
			}
		for( j=0; j<i; j++ ) {
			if( fscanf(fph,"%d%d%d%le%le",&k,&l,&m,&x,&y)!=5 ) {
				fprintf(stderr,"error: %s: reading phase file, record %d\n",
					argv[0], n_ph );
				exit(-1);
				}
			line++;
			ph[n_ph].sta[j]=k; ph[n_ph].ev[j]=l; ph[n_ph].order[j]=m; ph[n_ph].hit[j]=0;
			ph[n_ph].ratio[j]=x; ph[n_ph].coeff[j]=y; ph[n_ph].T[j]=0.0;
			ph[n_ph].dTdx[j]=0.0; ph[n_ph].dTdy[j]=0.0;ph[n_ph].dTdz[j]=0.0;
			ph[n_ph].azi[j]=0.0; ph[n_ph].theta[j]=0.0;
			ph[n_ph].stax[j]=0.0; ph[n_ph].stay[j]=0.0; ph[n_ph].staz[j]=0.0;
			}
		n_ph++;
		}
	fclose(fph);
	fprintf(stderr,"\tobservations: %d\n", n_ph);

	for( i=0; i<n_sta; i++ ) {
		n_jhd=count_lines(jhdfilename[i]);
		jhd=(struct jhd_rec *)malloc(n_jhd*sizeof(struct jhd_rec));
		if( jhd==NULL ) {
			fprintf(stderr,"error: %s: out of memory (6)\n", argv[0] );
			exit(-1);
			}
		if( (fjhd=fopen(jhdfilename[i],"r")) == NULL ) {
			fprintf(stderr,"error: %s: cant open jhd_table <%s> for read\n",
				argv[0], jhdfilename[i] );
			exit(-1);
			}
		n_jhd=0;
		while( fscanf(fjhd,"%d%d%le%le%le%le%le%le%le%le%d%le%le",&j,&k,&x,&x,&x,
			&T, &dTdx, &dTdy, &dTdz, &x, &l, &theta, &azi ) == 13 ) {
			jhd[n_jhd].nev=j;
			jhd[n_jhd].order=k;
			jhd[n_jhd].T = T;
			jhd[n_jhd].dTdx=dTdx; jhd[n_jhd].dTdy=dTdy; jhd[n_jhd].dTdz=dTdz;
			jhd[n_jhd].azi=azi; jhd[n_jhd].theta=theta;
			n_jhd++;
			}
		fclose(fjhd);
		fprintf(stderr,"\tjhd_table %s has %d records\n", jhdfilename[i], n_jhd );
		if( verbose ) {
			for( j=0; j<n_jhd; j++ ) {
				fprintf(stderr,"%d %d %f %f %f %f %f %f\n", jhd[j].nev, jhd[j].order,
					jhd[j].T, jhd[j].dTdx, jhd[j].dTdy, jhd[j].dTdz,
					jhd[j].theta, jhd[j].azi);
				}
			fprintf(stderr,"\n");
			}
		qsort( jhd, n_jhd, sizeof(struct jhd_rec), cmpjhd );
		for( j=0; j<n_ph; j++ ) for( k=0; k<ph[j].n; k++ ) {
			if( stanum[i] != ph[j].sta[k] ) continue;
			jhdkey.nev = ph[j].ev[k];
			jhdkey.order = ph[j].order[k];
			myjhd=(struct jhd_rec *)
				bsearch(&jhdkey, jhd, n_jhd, sizeof(struct jhd_rec), cmpjhd );
			if( myjhd == NULL ) continue;
			ph[j].hit[k]=1;
			ph[j].T[k] = myjhd->T;
			ph[j].dTdx[k] = myjhd->dTdx;
			ph[j].dTdy[k] = myjhd->dTdy;
			ph[j].dTdz[k] = myjhd->dTdz;
			ph[j].azi[k]  = myjhd->azi;
			ph[j].theta[k]= myjhd->theta;
			ph[j].stax[k]=stax[i];
			ph[j].stay[k]=stay[i];
			ph[j].staz[k]=staz[i];
			}
		free(jhd);
		} /* next sta */

	ngood=0;
	for( j=0; j<n_ph; j++ ) {
		l=0;
		for( k=0; k<ph[j].n; k++ ) l+=ph[j].hit[k];
		if( l==ph[j].n ) {
			ph[j].good=1;
			ngood++;
			}
		}
	fprintf(stderr,"\tusable observations: %d\n", ngood);
	if( ngood==0 ) {
		fprintf(stderr,"warning: no good observations\n");
		for( i=0; i<n_ev; i++ ) {
			x=ev[i].x; y=ev[i].y; z=ev[i].z; t0=ev[i].t0;
			printf("%d\t%f\t%f\t%f\t%f\n", ev[i].nev, x, y, z, t0 );
			}
		exit(0);
		}

	if( verbose ) {
		for( j=0; j<n_ph; j++ ) {
			fprintf(stderr,"%d %d %f %f %f %d\n",
				j, ph[j].n, ph[j].obs, ph[j].weight, ph[j].maxres, ph[j].good);
			l=0;
			for( k=0; k<ph[j].n; k++ ) {
				fprintf(stderr, "\t%d %d %d %f %f %f %f %f %f %f %f %d\n",
					ph[j].sta[k], ph[j].ev[k], ph[j].order[k], ph[j].ratio[k],
					ph[j].coeff[k], ph[j].T[k], ph[j].dTdx[k], ph[j].dTdy[k],
					ph[j].dTdz[k], ph[j].theta[k], ph[j].azi[k], ph[j].hit[k] );
				}
			}
		}

	n = ngood;
	m = 4*n_ev+n_model_pars;
	Grow = (double*)malloc(m*sizeof(double));
	G=new_sparse_matrix(n,m,0);
	d=(double*)malloc(n*sizeof(double));
	dp=(double*)malloc(n*sizeof(double));
	dm=(double*)malloc(m*sizeof(double));
	GTd=(double*)malloc(m*sizeof(double));
	if( (G==NULL) || (Grow==NULL ) || (d==NULL) || (dp==NULL) || (dm==NULL) || (GTd==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (7)\n", argv[1] );
		exit(-1);
		}

	/* build matrix equation */
	i=0; irms=0; rms1=0.0;
	for( j=0; j<n_ph; j++ ) { /* loop over observations */
		if( !ph[j].good ) continue;
		for( k=0; k<m; k++ ) Grow[k]=0.0;
		x = ph[j].weight;
		d[i]=0.0;
		for( k=0; k<ph[j].n; k++ ) { /* loop over rays in an observation */
			y = ph[j].ratio[k];
			c = ph[j].coeff[k];

			/* match event number */
			evkey.nev = ph[j].ev[k];
			myev=(struct ev_rec *)
				bsearch(&evkey, ev, n_ev, sizeof(struct ev_rec), cmpev );
			if( myev==NULL ) {
				fprintf(stderr,"error: %s: cant find event %d in event file\n", argv[0], evkey.nev);
				exit(-1);
				}
			l=myev->index;

			/* right hand side of equation */
			d[i] -= x * c * ( y * ph[j].T[k] + myev->t0 );

			/* part of matrix associated with event locations */
			Grow[4*l]   += x * c * y * ph[j].dTdx[k];
			Grow[4*l+1] += x * c * y * ph[j].dTdy[k];
			Grow[4*l+2] += x * c * y * ph[j].dTdz[k];
			Grow[4*l+3] += x * c * tscale;

			/* part of matrix associated with velocity model parameters */
			x0[0]=ph[j].stax[k]; x0[1]=ph[j].stay[k]; x0[2]=ph[j].staz[k];
			if( !shoot_to_traveltime( x0, ph[j].azi[k], ph[j].theta[k], ph[j].T[k],
				x1, t1, arc, &n_arcs ) ) {
				ph[j].good=0;
				break;
				}

			/* count nodes affected by this ray */
			for( ii=0; ii<n_nodes; ii++ ) node[ii].touched=0;
			for( ii=0; ii<n_arcs; ii++ ) {
				node[ arc[ii].ptetra->n1 ].touched=1;
				node[ arc[ii].ptetra->n2 ].touched=1;
				node[ arc[ii].ptetra->n3 ].touched=1;
				node[ arc[ii].ptetra->n4 ].touched=1;
				}
			for( ii=0; ii<n_nodes; ii++ ) {
				if( node[ii].touched ) node[ii].hits++;
				node[i].touched=0;
				}

			/* will varying this velocity model parameter change the traveltime ? */
			for( jj=0; jj<n_model_pars; jj++ ) {
				match=FALSE;
				for( ii=0; ii<n_arcs; ii++ ) {
					pt=arc[ii].ptetra;
					tnode[0]=pt->n1; tnode[1]=pt->n2;
					tnode[2]=pt->n3; tnode[3]=pt->n4;
					for( kk=0; kk<4; kk++ ) {
						if( node_in_model_par(tnode[kk],jj) ) {
							match=TRUE;
							break;
							}
						}
					if(match) break;
					}
				if( match ) {
					rms2 = dTdmp(jj,arc,n_arcs,ph[j].T[k]);
					Grow[4*n_ev+jj] += rw*x*y*c*rms2;
					}
				else {
					;/* Grow is zero */
					}
				} /* next velocity model parameter */
			} /* end loop over rays */

		if( !ph[j].good ) {
			fprintf(stderr,"observation %d (row %d) lost due to raytrace failure\n", j, i );
			continue;
			}

		if( verbose ) {
			fprintf(stderr,"weighted observation %d (row %d) obs=%f pred=%f res=%f\n",
			j, i, -x*ph[j].obs, d[i], x*ph[j].obs+d[i] );
			}

		/* reject observation if residual traveltime is too large */
		res = fabs(x*ph[j].obs+d[i]);
		if(  res > ph[j].maxres ) {
			fprintf(stderr,"observation %d (row %d) thrown out, residual %f > %f\n", j, i,
				res, ph[j].maxres );
			d[i]=0.0;
			}
		else {
			rms1 += res*res; irms++;
			d[i]+=x*ph[j].obs;
			ph[j].row=i;
			for( k=0; k<m; k++ ) if( Grow[k]!=0.0 ) {
				status = set_sparse_value(G,i,k,Grow[k]);
				if( !status ) {
					fprintf(stderr,"error: %s: out of memory (8)\n", argv[1] );
					exit(-1);
					}
				}
			i++;
			}
		} /* next observation */

	rms1 = sqrt( rms1 / (double) irms );

	maxG=sparse_absmax(G);
	k=sparse_count(G);
	fprintf(stderr,
		"G is %d by %d, is %f percent full, and has absolute maximum of %f\n",
		n, m, 100.0*(double)k/((double)n*(double)m), maxG );

	maxd=0.0;
	rms2=0.0;
	for( i=0; i<n; i++ ) {
		x=fabs(d[i]); rms2+=d[i];
		if( x>maxd ) maxd=x;
		}
	fprintf(stderr, "d is %d by 1, and has absolute maximum of %f and a mean of %f\n", n, maxd, rms2/(double)n );
	fprintf(stderr,"Damping: %e\n\n", damping );

	smt_times_v( G, d, GTd );
	maxd=0.0;
	for( i=0; i<m; i++ ) {
		x=fabs(GTd[i]);
		if( x>maxd ) maxd=x;
		}
	fprintf(stderr,
	"GTd is %d by 1, and has absolute maximum of %f\n", m, maxd );

	scx = ATAabsmax( G );
	new_damping = damping*scx;
	fprintf(stderr,"Damping: %e abmaxGTG: %e Scaled_damping: %e\n\n",
		damping, scx, new_damping );
		
	for( i=0; i<m; i++ ) dm[i]=0.0;
	if( !sparse_dls_biconj( G, d, dm, new_damping, 1, maxd*B_PREC, m+10, &iter,&err,&biec ) ) {
		fprintf(stderr,"error: %s: dls_biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
		
	fprintf(stderr,"Matrix inversion (implicit): %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after implicit solution");
	
	for( i=0; i<n_ev; i++ ) {
		x=ev[i].x+dm[4*i];
		y=ev[i].y+dm[4*i+1];
		z=ev[i].z+dm[4*i+2];
		t0=ev[i].t0+tscale*dm[4*i+3];
		printf("%d\t%f\t%f\t%f\t%f\n", ev[i].nev, x, y, z, t0 );
		}

	sm_times_v( G, dm, dp );

	for( i=0; i<n_ph; i++ ) {
		if( (!ph[i].good) || (ph[i].row==(-1)) ) continue;
		res =  d[ph[i].row] - dp[ ph[i].row ];
		for( j=0; j<ph[i].n; j++ ) {
			for( k=0; k<n_sta; k++ ) if( stanum[k]==ph[i].sta[j] ) {
				stacount[k]++;
				starms[k]+= res*res;
				stamean[k]+= res;
				break;
				}
			}
		}

	fprintf(stderr,"station statistics:\n");
	fprintf(stderr,"sta\tcount\trms\tmean\n");
	for( i=0; i<n_sta; i++ ) {
		fprintf(stderr,"%d\t%d\t%f\t%f\n", stanum[i], stacount[i],
			sqrt(starms[i]/(double)stacount[i]),
			stamean[i]/(double)stacount[i] );
		}
	fprintf(stderr,"\n");

	for( i=0; i<n_ph; i++ ) {
		if( (!ph[i].good) || (ph[i].row==(-1)) ) continue;
		res = d[ph[i].row] - dp[ ph[i].row ];
		for( j=0; j<ph[i].n; j++ ) {
			evkey.nev = ph[i].ev[j];
			myev=(struct ev_rec *)
				bsearch(&evkey, ev, n_ev, sizeof(struct ev_rec), cmpev );
			if( myev==NULL ) continue;
			myev->count++;
			myev->rms += res*res;
			myev->mean += res;
			}
		}

	fprintf(stderr,"event statistics:\n");
	fprintf(stderr,"event\tcount\trms\tmean\n");
	for( i=0; i<n_ev; i++ ) {
		fprintf(stderr,"%d\t%d\t%f\t%f\n",
			ev[i].nev, ev[i].count, sqrt(ev[i].rms/(double)ev[i].count),
			ev[i].mean/(double)ev[i].count);
		}
	fprintf(stderr,"\n");

	fprintf(stderr,"phase statistics:\n");
	fprintf(stderr,"phase\tline\terror\n");
	for( i=0; i<n_ph; i++ ) {
		j=ph[i].row;
		if( (!ph[i].good) || (j==(-1)) ) continue;
		res = d[j]-dp[j];
		fprintf(stderr,"%d\t%d\t%f\n", i, ph[i].line, res );
		}
	fprintf(stderr,"\n");

	rms2=0.0;
	for( i=0; i<n_ev; i++ ) {
		res = dm[4*i]; rms2 += res*res;
		res = dm[4*i+1]; rms2 += res*res;
		res = dm[4*i+2]; rms2 += res*res;
		}
	rms2 = sqrt( rms2 / (double)(3*n_ev) );
	fprintf(stderr, "event location statistics: rms change in position %f km\n", rms2);
	fprintf(stderr,"\n");

	rms2=0.0;
	for( i=0; i<n_ev; i++ ) {
		res = tscale*dm[4*i+3]; rms2 += res*res;
		}
	rms2 = sqrt( rms2 / (double)n_ev );
	fprintf(stderr, "event origin time statistics: rms change in origin time %f s\n", rms2);
	fprintf(stderr,"\n");

	/* update velocity of nodes */
	for( i=0; i<n_model_pars; i++ ) {
		for( j=0; j<model_par[i].n; j++ ) {
			k=model_par[i].node[j];
			weight=model_par[i].weight[j];
			node[k].v += rw*weight*dm[4*n_ev+i];
			}
		}

	rms2=0.0;
	for( i=0; i<n_model_pars; i++ ) {
		res = dm[4*n_ev+i];
		rms2 += res*res;
		}
	rms2 = sqrt( rms2 / (double)n_model_pars );
	fprintf(stderr, "velocity model parameter statistics: rms size %f\n", rw*rms2);
	fprintf(stderr,"\n");

	rms2=0.0;
	for( i=0; i<n_nodes; i++ ) {
		res = node[i].v - node[i].v_orig;
		rms2 += res*res;
		}
	rms2 = sqrt( rms2 / (double)n_nodes );
	fprintf(stderr, "velocity nodes statistics: rms change %f km/s\n", rms2);
	fprintf(stderr,"\n");

	rms2=0.0;
	for( i=0; i<n_ph; i++ ) {
		j=ph[i].row;
		if( (!ph[i].good) || (j==(-1)) ) continue;
		res = d[j]-dp[j];
		rms2 += res*res;
		}
	rms2 = sqrt( rms2 / (double)irms );
	fprintf(stderr,"rms weighted residual original: %f final %f for %f percent reduction\n",
		rms1, rms2, 100.0-100.0*rms2/rms1 );

	/* write out perturbed model */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/* must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		if( QDEFINED )
		fprintf(nmfile,"%d %d %d %f %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, 1.0/node[i].qinv, node[i].ifc );
		else
		fprintf(nmfile,"%d %d %d %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, node[i].ifc );
		}
	fclose(nmfile);

	sprintf( hitsfile, "%s.hits", argv[6] );
	if( (nmfile=fopen(hitsfile,"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open hitsfile <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}

	/* write out hits file */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		fprintf(nmfile,"%d %d %d %f %f %f %d %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].hits, node[i].ifc );
		}
	fclose(nmfile);

	exit(0);
	}
	
	
	
	
void main_locate_and_PS_invert(int argc, char **argv)
{
	int i, j, k, l, m, n, ngood, status, iter, biec, irms, line, match;
	int ii, jj, kk;
	char str1[1024], str2[1024], hitsfile[1024];
	double x0[3], x1[3], t1[3];
        int tnode[4];
	int nx, ny, nz;

	struct arc_rec arc[MAX_ARCS];
	int n_arcs;

        struct tetra_rec *pt;

	FILE *fsta, *nmfile;
	int *stanum;
	double *stax, *stay, *staz;
	char **P_jhdfilename, **S_jhdfilename;
	int n_sta;
	double x,y,z,t0,c,azi,theta,weight;
	double T, dTdx, dTdy, dTdz;

	FILE *fev;
	struct ev_rec *ev, evkey, *myev;
	int n_ev;

	FILE *fph;
	struct ph_rec *ph;
	int n_ph;

	FILE *fjhd, *mpfile;
	struct jhd_rec *P_jhd, *S_jhd;
	int n_P_jhd, n_S_jhd;
	struct jhd_rec jhdkey, *myjhd;

	int verbose=0;

	struct sparse_matrix *G; //, *GTG; //unused
	double *d, *dp, *GTd, *dm, tscale=TSCALEVALUE, maxG, maxd, damping, rw, rw2, err, res, rms1, rms2;
	double *starms, *stamean;
	int *stacount;
	double *Grow;

	struct model_par_rec *ratio_model_par, *P_model_par;
	int ratio_n_model_pars, P_n_model_pars;

	/* a quick way of switching from P to S model and vice versa */
	struct PS_node *my_PS_node;
	struct PS_tetra *my_PS_tetra;
	int model_is_P;

	double new_damping, scx;


	if( argc!=11 ) {
		fprintf(stderr,"purpose: joint hypocenter relocation and P and S velocity tomography\n");
		fprintf(stderr,"         for improvements to node P velocities and P:S velocity ratio\n");
		fprintf(stderr,"method: The user provides a set of observations, where\n");
		fprintf(stderr,"        each observation is assumed to be a linear combination\n");
		fprintf(stderr,"        of traveltimes:\n");
		fprintf(stderr,"           observation = (sum i=1 to n) coefficient[i] * traveltime[i]\n");
		fprintf(stderr,"        A phase file tabulates the observations and the\n");
		fprintf(stderr,"        n coefficients and the station, event and order\n");
		fprintf(stderr,"        of each of the traveltimes.  The observations are\n");
		fprintf(stderr,"        used to produce an updated estimate of the event\n");
		fprintf(stderr,"        locations and the velocity models.\n");
		fprintf(stderr,"      Note: model file must define both P velocity and P:S velocity ratio\n");
		fprintf(stderr,"usage: %s model_file.txt P_model_parameter_file.txt ratio_model_parameter_file.txt station_file.txt event_file.txt phase_file.txt new_model_file damping EP_relative_weight PS_relative_weight > updated_event_file.txt\n", argv[0]);
		fprintf(stderr,"       model_file.txt: standard velocity model file with ratio defined\n");
		fprintf(stderr,"       P_model_parameter_file.txt: standard velocity node model parameter file\n");
		fprintf(stderr,"       ratio_model_parameter_file.txt: analogous model parameter file for velocity ratios\n");
		fprintf(stderr,"       station_file.txt: one station per line, with fields\n");
		fprintf(stderr,"               station_number: arbitrary integer\n");
		fprintf(stderr,"               x, y, z: station location, km\n");
		fprintf(stderr,"               P_jhd_table: path of station-specific P jhd-table\n");
		fprintf(stderr,"               S_jhd_table: path of station-specific S jhd-table\n");
		fprintf(stderr,"       event_file.txt: one event per line, with fields\n");
		fprintf(stderr,"               event_number: arbitrary integer\n");
		fprintf(stderr,"               x, y, z: preliminary location, km\n");
		fprintf(stderr,"               t0: preliminary origin time, s\n");
		fprintf(stderr,"       phase_file.txt: one group of lines per observation\n");
		fprintf(stderr,"               first line, with fields\n");
		fprintf(stderr,"                     n_phases: number of phases in observation\n");
		fprintf(stderr,"                     observation: a differetial traveltime, s\n");
		fprintf(stderr,"                     weight: weight of observation\n");
		fprintf(stderr,"                     maxres: observation thrown out if weighted residual > maxres, s\n");
		fprintf(stderr,"               subsequent lines in group, with fields\n");
		fprintf(stderr,"                     station_number, corresponding to station_file.txt\n");
		fprintf(stderr,"                     event_number, corresponding to event_file.txt\n");
		fprintf(stderr,"                     order, interger arrival number of phase\n");
		fprintf(stderr,"                     ratio, 1.0 signifies that the P model\n");
		fprintf(stderr,"                        should be used; anthing else, the S model\n");
		fprintf(stderr,"       new_model_file.txt: updated model file. A corresponding\n");
		fprintf(stderr,"       		hits file, with suffix .hits, is also created\n");
		fprintf(stderr,"       damping: damping factor, fraction of max of GTG\n");
		fprintf(stderr,"       EP_relative_weight: relative weight of event and P velocity model parameters\n");
		fprintf(stderr,"               relative_weigth>1 favors large of velocity model perturbations\n");
		fprintf(stderr,"               relative_weigth<1 favors large of event location perturbations\n");
		fprintf(stderr,"       PS_relative_weight: relative weight of P and ratio velocity model parameters\n");
		fprintf(stderr,"               relative_weigth>1 favors large of ratio model parameter perturbations\n");
		fprintf(stderr,"               relative_weigth<1 favors large of P model parameter perturbations\n");
		fprintf(stderr,"Note: In the inversion, origin time perturbations are scaled\n");
		fprintf(stderr,"to units of distance using a nominal velocity of %f km/s\n",
			1.0/TSCALEVALUE );
		exit(-1);
		}

	if( sscanf(argv[8],"%le",&damping) != 1 ) {
		fprintf(stderr,"error: %s: cant read damping from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[9],"%le",&rw) != 1 ) {
		fprintf(stderr,"error: %s: cant read EP relative weight from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[10],"%le",&rw2) != 1 ) {
		fprintf(stderr,"error: %s: cant read PS relative weight from command line\n", argv[0] );
		exit(-1);
		}

	fprintf(stderr,"Raytrace3d locate_and_PS_invert\n");
	fprintf(stderr,"\tstarting model %s\n", argv[1] );
	fprintf(stderr,"\tdamping %e\n", damping);
	fprintf(stderr,"\tevent-P relative weight %e\n", rw);
	fprintf(stderr,"\tP-ratio relative weight %e\n", rw2);

	/* model file */
	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}
	if( !QDEFINED ) {
		fprintf(stderr,"error: %s: model <%s> must have Vp/Vs ratio defined\n", argv[0], argv[1] );
		exit(0);
		}

	/* create structures for qickly switching between P and S models */
	my_PS_node = (struct PS_node *) malloc( n_nodes * sizeof(struct PS_node) );
	my_PS_tetra = (struct PS_tetra *) malloc( n_tetras * sizeof(struct PS_tetra) );
	if( (my_PS_node==NULL) || (my_PS_tetra==NULL) ) {
		fprintf(stderr,"error: %s: out of memory! (1a)\n", argv[0]);
		exit(-1);
		}
	for( i=0; i<n_nodes; i++ ) {
		my_PS_node[i].Pv = node[i].v;	
		my_PS_node[i].Sv = node[i].v/node[i].ratio;	
		}
	for( i=0; i<n_tetras; i++ ) {
		for(j=0;j<4;j++) my_PS_tetra[i].Pvc[j]=tetra[i].vc[j];
		for(j=0;j<3;j++) my_PS_tetra[i].Pg[j]=tetra[i].g[j];
		my_PS_tetra[i].Pgs = tetra[i].gs;
		for(j=0;j<3;j++) my_PS_tetra[i].Pgn[j]=tetra[i].gn[j];
		}
	for( i=0; i<n_nodes; i++ ) node[i].v = node[i].v_orig/node[i].ratio_orig;
	for( i=0; i<n_tetras; i++ ) velocity_eqn( &tetra[i] );
	for( i=0; i<n_tetras; i++ ) {
		for(j=0;j<4;j++) my_PS_tetra[i].Svc[j]=tetra[i].vc[j];
		for(j=0;j<3;j++) my_PS_tetra[i].Sg[j]=tetra[i].g[j];
		my_PS_tetra[i].Sgs = tetra[i].gs;
		for(j=0;j<3;j++) my_PS_tetra[i].Sgn[j]=tetra[i].gn[j];
		}
	model_is_P=0;

	/* P model parameter file */
	alloc_model_pars(argv[2]);
	if( (mpfile=fopen(argv[2],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open P_model_par_file <%s> for read\n", argv[0], argv[2] );
		exit(-1);
		}
	n_model_pars=0;
	load_model_pars_V(mpfile);
	fclose(mpfile);
	fprintf(stderr,"\tP model parameters %s with %d parameters\n", argv[2], n_model_pars );
	P_model_par=model_par; P_n_model_pars=n_model_pars;

	/* ratio model parameter file */
	model_par=NULL; n_model_pars=0;
	alloc_model_pars(argv[3]);
	if( (mpfile=fopen(argv[3],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open ratio_model_par_file <%s> for read\n", argv[0], argv[3] );
		exit(-1);
		}
	load_model_pars_V(mpfile);
	fclose(mpfile);
	fprintf(stderr,"\tRatio model parameters %s with %d parameters\n", argv[3], n_model_pars );
	ratio_model_par=model_par; ratio_n_model_pars=n_model_pars;

	if( (nmfile=fopen(argv[7],"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open new_model_file <%s> for write\n", argv[0], argv[6] );
		exit(-1);
		}

	/* station file */
	n_sta=count_lines(argv[3]);
	stanum=(int *)malloc(n_sta*sizeof(int));
	stacount=(int *)malloc(n_sta*sizeof(int));
	starms=(double *)malloc(n_sta*sizeof(double));
	stamean=(double *)malloc(n_sta*sizeof(double));
	stax=(double *)malloc(n_sta*sizeof(double));
	stay=(double *)malloc(n_sta*sizeof(double));
	staz=(double *)malloc(n_sta*sizeof(double));
	P_jhdfilename = (char**)malloc(n_sta*sizeof(char*));
	S_jhdfilename = (char**)malloc(n_sta*sizeof(char*));

	if( (stanum==NULL) || (P_jhdfilename==NULL) || (S_jhdfilename==NULL) || (starms==NULL) ||
	    (stacount==NULL) || (stamean==NULL) || (stax==NULL) || (stay==NULL) || (staz==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (1)\n", argv[0] );
		exit(-1);
		}
	if( (fsta=fopen(argv[4],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open station file <%s> for read\n",argv[0],argv[4]);
		exit(-1);
		}
	n_sta=0;
	while( fscanf(fsta,"%d%le%le%le%s%s",&i,&x,&y,&z,str1,str2)==6 ) {
		stanum[n_sta]=i;
		stax[n_sta]=x; stay[n_sta]=y; staz[n_sta]=z;
		P_jhdfilename[n_sta]=(char*)malloc( (strlen(str1)+1)*sizeof(char) );
		if( P_jhdfilename[n_sta]==NULL ) {
			fprintf(stderr,"error: %s: out of memory (2a)\n", argv[0] );
			exit(-1);
			}
		strcpy(P_jhdfilename[n_sta],str1);
		S_jhdfilename[n_sta]=(char*)malloc( (strlen(str2)+1)*sizeof(char) );
		if( S_jhdfilename[n_sta]==NULL ) {
			fprintf(stderr,"error: %s: out of memory (2b)\n", argv[0] );
			exit(-1);
			}
		strcpy(S_jhdfilename[n_sta],str2);
		starms[n_sta]=0.0; stacount[n_sta]=0; stamean[n_sta]=0.0;
		n_sta++;
		}
	fclose(fsta);
	fprintf(stderr,"\tstations: %d\n", n_sta);

	/* event file */
	n_ev=count_lines(argv[5]);
	ev=(struct ev_rec *)malloc(n_ev*sizeof(struct ev_rec));
	if( ev==NULL ) {
		fprintf(stderr,"error: %s: out of memory (3)\n", argv[0] );
		exit(-1);
		}
	if( (fev=fopen(argv[5],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open event file <%s> for read\n",argv[0],argv[4]);
		exit(-1);
		}
	n_ev=0;
	while( fscanf(fev,"%d%le%le%le%le",&i,&x,&y,&z,&t0)==5 ) {
		ev[n_ev].nev = i;
		ev[n_ev].x=x; ev[n_ev].y=y; ev[n_ev].z=z; ev[n_ev].t0=t0;
		ev[n_ev].rms=0.0; ev[n_ev].count=0; ev[n_ev].mean=0.0; 
		n_ev++;
		}
	fclose(fev);
	qsort( ev, n_ev, sizeof(struct ev_rec), cmpev );
	for( i=0; i<n_ev; i++ ) ev[i].index=i;
	fprintf(stderr,"\tevents: %d\n", n_ev);
	if( verbose ) {
		for( i=0; i<n_ev; i++ ) {
			fprintf(stderr,"%d %f %f %f %f\n", ev[i].nev, ev[i].x, ev[i].y, ev[i].z, ev[i].t0 );
			}
		fprintf(stderr,"\n");
		}

	/* phase file */
	if( (fph=fopen(argv[6],"r")) == NULL ) {
		fprintf(stderr,"error: %s: cant open phase file <%s> for read\n",argv[0],argv[5]);
		exit(-1);
		}
	n_ph=0;
	while( fscanf(fph,"%d%le%le%le",&i,&x,&y,&z)==4 ) {
		for( j=0; j<i; j++ ) {
			if( fscanf(fph,"%d%d%d%le%le",&k,&k,&k,&x,&x)!=5 ) {
				fprintf(stderr,"error: %s: reading phase file, record %d\n",
					argv[0], n_ph );
				exit(-1);
				}
			}
		n_ph++;
		}
	rewind(fph);
	ph=(struct ph_rec *)malloc(n_ph*sizeof(struct ph_rec));
	if( ph==NULL ) {
		fprintf(stderr,"error: %s: out of memory (4)\n", argv[0] );
		exit(-1);
		}
	n_ph=0; line=0;
	while( fscanf(fph,"%d%le%le%le",&i,&x,&y,&z)==4 ) {
		line++; ph[n_ph].line=line;
		ph[n_ph].n=i; ph[n_ph].obs=x; ph[n_ph].weight=y; ph[n_ph].maxres=z;
		ph[n_ph].good=0; ph[n_ph].row=(-1);
		ph[n_ph].sta=(int*)malloc(i*sizeof(int));
		ph[n_ph].ev=(int*)malloc(i*sizeof(int));
		ph[n_ph].order=(int*)malloc(i*sizeof(int));
		ph[n_ph].hit=(int*)malloc(i*sizeof(int));
		ph[n_ph].ratio=(double*)malloc(i*sizeof(double));
		ph[n_ph].coeff=(double*)malloc(i*sizeof(double));
		ph[n_ph].T=(double*)malloc(i*sizeof(double));
		ph[n_ph].dTdx=(double*)malloc(i*sizeof(double));
		ph[n_ph].dTdy=(double*)malloc(i*sizeof(double));
		ph[n_ph].dTdz=(double*)malloc(i*sizeof(double));
		ph[n_ph].azi=(double*)malloc(i*sizeof(double));
		ph[n_ph].theta=(double*)malloc(i*sizeof(double));
		ph[n_ph].stax=(double*)malloc(i*sizeof(double));
		ph[n_ph].stay=(double*)malloc(i*sizeof(double));
		ph[n_ph].staz=(double*)malloc(i*sizeof(double));
		if( (ph[n_ph].sta==NULL) || (ph[n_ph].ev==NULL) ||
			(ph[n_ph].order==NULL) || (ph[n_ph].hit==NULL) ||
		    	(ph[n_ph].ratio==NULL) || (ph[n_ph].coeff==NULL) ||
			(ph[n_ph].T==NULL) || (ph[n_ph].dTdx==NULL) ||
			(ph[n_ph].dTdy==NULL) || (ph[n_ph].dTdz==NULL) ||
		    	(ph[n_ph].azi==NULL) || (ph[n_ph].theta==NULL) ||
			(ph[n_ph].stax==NULL) || (ph[n_ph].stay==NULL) || (ph[n_ph].staz==NULL) ) {
			fprintf(stderr,"error: %s: out of memory (5)\n", argv[0] );
			exit(-1);
			}
		for( j=0; j<i; j++ ) {
			if( fscanf(fph,"%d%d%d%le%le",&k,&l,&m,&x,&y)!=5 ) {
				fprintf(stderr,"error: %s: reading phase file, record %d\n",
					argv[0], n_ph );
				exit(-1);
				}
			line++;
			ph[n_ph].sta[j]=k; ph[n_ph].ev[j]=l; ph[n_ph].order[j]=m; ph[n_ph].hit[j]=0;
			ph[n_ph].ratio[j]=x; ph[n_ph].coeff[j]=y; ph[n_ph].T[j]=0.0;
			ph[n_ph].dTdx[j]=0.0; ph[n_ph].dTdy[j]=0.0;ph[n_ph].dTdz[j]=0.0;
			ph[n_ph].azi[j]=0.0; ph[n_ph].theta[j]=0.0;
			ph[n_ph].stax[j]=0.0; ph[n_ph].stay[j]=0.0; ph[n_ph].staz[j]=0.0;
			}
		n_ph++;
		}
	fclose(fph);
	fprintf(stderr,"\tobservations: %d\n", n_ph);

	for( i=0; i<n_sta; i++ ) {
		n_P_jhd=count_lines(P_jhdfilename[i]);
		P_jhd=(struct jhd_rec *)malloc(n_P_jhd*sizeof(struct jhd_rec));
		if( P_jhd==NULL ) {
			fprintf(stderr,"error: %s: out of memory (6a)\n", argv[0] );
			exit(-1);
			}
		if( (fjhd=fopen(P_jhdfilename[i],"r")) == NULL ) {
			fprintf(stderr,"error: %s: cant open P jhd_table <%s> for read\n",
				argv[0], P_jhdfilename[i] );
			exit(-1);
			}
		n_P_jhd=0;
		while( fscanf(fjhd,"%d%d%le%le%le%le%le%le%le%le%d%le%le",&j,&k,&x,&x,&x,
			&T, &dTdx, &dTdy, &dTdz, &x, &l, &theta, &azi ) == 13 ) {
			P_jhd[n_P_jhd].nev=j;
			P_jhd[n_P_jhd].order=k;
			P_jhd[n_P_jhd].T = T;
			P_jhd[n_P_jhd].dTdx=dTdx; P_jhd[n_P_jhd].dTdy=dTdy; P_jhd[n_P_jhd].dTdz=dTdz;
			P_jhd[n_P_jhd].azi=azi; P_jhd[n_P_jhd].theta=theta;
			n_P_jhd++;
			}
		fclose(fjhd);
		fprintf(stderr,"\tP jhd_table %s has %d records\n", P_jhdfilename[i], n_P_jhd );
		qsort( P_jhd, n_P_jhd, sizeof(struct jhd_rec), cmpjhd );

		n_S_jhd=count_lines(S_jhdfilename[i]);
		S_jhd=(struct jhd_rec *)malloc(n_S_jhd*sizeof(struct jhd_rec));
		if( S_jhd==NULL ) {
			fprintf(stderr,"error: %s: out of memory (6b)\n", argv[0] );
			exit(-1);
			}
		if( (fjhd=fopen(S_jhdfilename[i],"r")) == NULL ) {
			fprintf(stderr,"error: %s: cant open S jhd_table <%s> for read\n",
				argv[0], S_jhdfilename[i] );
			exit(-1);
			}
		n_S_jhd=0;
		while( fscanf(fjhd,"%d%d%le%le%le%le%le%le%le%le%d%le%le",&j,&k,&x,&x,&x,
			&T, &dTdx, &dTdy, &dTdz, &x, &l, &theta, &azi ) == 13 ) {
			S_jhd[n_S_jhd].nev=j;
			S_jhd[n_S_jhd].order=k;
			S_jhd[n_S_jhd].T = T;
			S_jhd[n_S_jhd].dTdx=dTdx; S_jhd[n_S_jhd].dTdy=dTdy; S_jhd[n_S_jhd].dTdz=dTdz;
			S_jhd[n_S_jhd].azi=azi; S_jhd[n_S_jhd].theta=theta;
			n_S_jhd++;
			}
		fclose(fjhd);
		fprintf(stderr,"\tS jhd_table %s has %d records\n", S_jhdfilename[i], n_P_jhd );
		qsort( S_jhd, n_S_jhd, sizeof(struct jhd_rec), cmpjhd );

		for( j=0; j<n_ph; j++ ) for( k=0; k<ph[j].n; k++ ) {
			if( stanum[i] != ph[j].sta[k] ) continue;
			jhdkey.nev = ph[j].ev[k];
			jhdkey.order = ph[j].order[k];
			if( ph[j].ratio[k] == 1.0 ) {
				myjhd=(struct jhd_rec *)
					bsearch(&jhdkey, P_jhd, n_P_jhd, sizeof(struct jhd_rec), cmpjhd );
				}
			else {
				myjhd=(struct jhd_rec *)
					bsearch(&jhdkey, S_jhd, n_S_jhd, sizeof(struct jhd_rec), cmpjhd );
				}
			if( myjhd == NULL ) continue;
			ph[j].hit[k]=1;
			ph[j].T[k] = myjhd->T;
			ph[j].dTdx[k] = myjhd->dTdx;
			ph[j].dTdy[k] = myjhd->dTdy;
			ph[j].dTdz[k] = myjhd->dTdz;
			ph[j].azi[k]  = myjhd->azi;
			ph[j].theta[k]= myjhd->theta;
			ph[j].stax[k]=stax[i];
			ph[j].stay[k]=stay[i];
			ph[j].staz[k]=staz[i];
			}
		free(P_jhd); free(S_jhd);
		} /* next sta */

	ngood=0;
	for( j=0; j<n_ph; j++ ) {
		l=0;
		for( k=0; k<ph[j].n; k++ ) l+=ph[j].hit[k];
		if( l==ph[j].n ) {
			ph[j].good=1;
			ngood++;
			}
		}
	fprintf(stderr,"\tusable observations: %d\n", ngood);
	if( ngood==0 ) {
		fprintf(stderr,"warning: %s: no good observations\n");
		for( i=0; i<n_ev; i++ ) {
			x=ev[i].x; y=ev[i].y; z=ev[i].z; t0=ev[i].t0;
			printf("%d\t%f\t%f\t%f\t%f\n", ev[i].nev, x, y, z, t0 );
			}
		exit(0);
		}

	n = ngood;
	m = 4*n_ev+P_n_model_pars+ratio_n_model_pars;
	Grow = (double*)malloc(m*sizeof(double));
	G=new_sparse_matrix(n,m,0);
	d=(double*)malloc(n*sizeof(double));
	dp=(double*)malloc(n*sizeof(double));
	dm=(double*)malloc(m*sizeof(double));
	GTd=(double*)malloc(m*sizeof(double));
	if( (G==NULL) || (Grow==NULL ) || (d==NULL) || (dp==NULL) || (dm==NULL) || (GTd==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (7)\n", argv[1] );
		exit(-1);
		}

	/* build matrix equation */
	i=0; irms=0; rms1=0.0;
	for( j=0; j<n_ph; j++ ) { /* loop over observations */
		if( !ph[j].good ) continue;
		for( k=0; k<m; k++ ) Grow[k]=0.0;
		x = ph[j].weight;
		d[i]=0.0;
		for( k=0; k<ph[j].n; k++ ) { /* loop over rays in an observation */
			y = ph[j].ratio[k];

			if( y==1.0 ) {
				model_to_P( my_PS_node, my_PS_tetra, &model_is_P );
				}
			else {
				model_to_S( my_PS_node, my_PS_tetra, &model_is_P );
				}

			c = ph[j].coeff[k];

			/* match event number */
			evkey.nev = ph[j].ev[k];
			myev=(struct ev_rec *)
				bsearch(&evkey, ev, n_ev, sizeof(struct ev_rec), cmpev );
			if( myev==NULL ) {
				fprintf(stderr,"error: %s: cant find event %d in event file\n", argv[0], evkey.nev);
				exit(-1);
				}
			l=myev->index;

			/* right hand side of equation */
			d[i] -= x * c * ( ph[j].T[k] + myev->t0 );

			/* part of matrix associated with event locations */
			Grow[4*l]   += x * c * ph[j].dTdx[k];
			Grow[4*l+1] += x * c * ph[j].dTdy[k];
			Grow[4*l+2] += x * c * ph[j].dTdz[k];
			Grow[4*l+3] += x * c * tscale;

			/* part of matrix associated with velocity model parameters */
			x0[0]=ph[j].stax[k]; x0[1]=ph[j].stay[k]; x0[2]=ph[j].staz[k];
			if( !shoot_to_traveltime( x0, ph[j].azi[k], ph[j].theta[k], ph[j].T[k],
				x1, t1, arc, &n_arcs ) ) {
				ph[j].good=0;
				break;
				}

			/* count nodes affected by this ray */
			for( ii=0; ii<n_nodes; ii++ ) node[ii].touched=0;
			for( ii=0; ii<n_arcs; ii++ ) {
				node[ arc[ii].ptetra->n1 ].touched=1;
				node[ arc[ii].ptetra->n2 ].touched=1;
				node[ arc[ii].ptetra->n3 ].touched=1;
				node[ arc[ii].ptetra->n4 ].touched=1;
				}
			for( ii=0; ii<n_nodes; ii++ ) {
				if( node[ii].touched ) node[ii].hits++;
				node[i].touched=0;
				}

			/* will varying the P velocity model parameter change the traveltime ? */
			model_par=P_model_par; n_model_pars=P_n_model_pars;
			for( jj=0; jj<n_model_pars; jj++ ) {
				match=FALSE;
				for( ii=0; ii<n_arcs; ii++ ) {
					pt=arc[ii].ptetra;
					tnode[0]=pt->n1; tnode[1]=pt->n2;
					tnode[2]=pt->n3; tnode[3]=pt->n4;
					for( kk=0; kk<4; kk++ ) {
						if( node_in_model_par(tnode[kk],jj) ) {
							match=TRUE;
							break;
							}
						}
					if(match) break;
					}
				if( match ) {
					if( y == 1.0 ) {   /* this is a P ray */
						rms2 = dTdmp(jj,arc,n_arcs,ph[j].T[k]);
						Grow[4*n_ev+jj] += rw*x*c*rms2;
						}
					else { /* this is an S ray */
						rms2 = dTsdmpp(jj,arc,n_arcs,ph[j].T[k]);
						Grow[4*n_ev+jj] += rw*x*c*rms2;
						}
					}
				else {
					;/* Grow is zero */
					}
				} /* next P velocity model parameter */

			/* will varying the ratio velocity model parameter change the S traveltime ? */
			if( y != 1.0 ) { /* this is an S ray */
			model_par=ratio_model_par; n_model_pars=ratio_n_model_pars;
			for( jj=0; jj<n_model_pars; jj++ ) {
				match=FALSE;
				for( ii=0; ii<n_arcs; ii++ ) {
					pt=arc[ii].ptetra;
					tnode[0]=pt->n1; tnode[1]=pt->n2;
					tnode[2]=pt->n3; tnode[3]=pt->n4;
					for( kk=0; kk<4; kk++ ) {
						if( node_in_model_par(tnode[kk],jj) ) {
							match=TRUE;
							break;
							}
						}
					if(match) break;
					}
				if( match ) {
					rms2 = dTsdmpr(jj,arc,n_arcs,ph[j].T[k]);
					Grow[4*n_ev+P_n_model_pars+jj] += rw2*rw*x*c*rms2;
					}
				else {
					;/* Grow is zero */
					}
				}} /* next S velocity model parameter */

			} /* end loop over rays */

		if( !ph[j].good ) {
			fprintf(stderr,"observation %d (row %d) lost due to raytrace failure\n", j, i );
			continue;
			}

		if( verbose ) {
			fprintf(stderr,"weighted observation %d (row %d) obs=%f pred=%f res=%f\n",
			j, i, -x*ph[j].obs, d[i], x*ph[j].obs+d[i] );
			}

		/* reject observation if residual traveltime is too large */
		res = fabs(x*ph[j].obs+d[i]);
		if(  res > ph[j].maxres ) {
			fprintf(stderr,"observation %d (row %d) thrown out, residual %f > %f\n", j, i,
				res, ph[j].maxres );
			d[i]=0.0;
			}
		else {
			rms1 += res*res; irms++;
			d[i]+=x*ph[j].obs;
			ph[j].row=i;
			for( k=0; k<m; k++ ) if( Grow[k]!=0.0 ) {
				status = set_sparse_value(G,i,k,Grow[k]);
				if( !status ) {
					fprintf(stderr,"error: %s: out of memory (8)\n", argv[1] );
					exit(-1);
					}
				}
			i++;
			}
		} /* next observation */

	rms1 = sqrt( rms1 / (double) irms );

	maxG=sparse_absmax(G);
	k=sparse_count(G);
	fprintf(stderr,
		"G is %d by %d, is %f percent full, and has absolute maximum of %f\n",
		n, m, 100.0*(double)k/((double)n*(double)m), maxG );

	maxd=0.0;
	rms2=0.0;
	for( i=0; i<n; i++ ) {
		x=fabs(d[i]); rms2+=d[i];
		if( x>maxd ) maxd=x;
		}
	fprintf(stderr, "d is %d by 1, and has absolute maximum of %f and a mean of %f\n", n, maxd, rms2/(double)n );
	fprintf(stderr,"Damping: %e\n\n", damping );

	smt_times_v( G, d, GTd );
	maxd=0.0;
	for( i=0; i<m; i++ ) {
		x=fabs(GTd[i]);
		if( x>maxd ) maxd=x;
		}
	fprintf(stderr,
	"GTd is %d by 1, and has absolute maximum of %f\n", m, maxd );

	scx = ATAabsmax( G );
	new_damping = damping*scx;
	fprintf(stderr,"Damping: %e abmaxGTG: %e Scaled_damping: %e\n\n",
		damping, scx, new_damping );
		
	for( i=0; i<m; i++ ) dm[i]=0.0;
	if( !sparse_dls_biconj( G, d, dm, new_damping, 1, maxd*B_PREC, m+10, &iter,&err,&biec ) ) {
		fprintf(stderr,"error: %s: dls_biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
		
	fprintf(stderr,"Matrix inversion (implicit): %d iterations; rms %f\n\n", iter, err );
	
	for( i=0; i<n_ev; i++ ) {
		x=ev[i].x+dm[4*i];
		y=ev[i].y+dm[4*i+1];
		z=ev[i].z+dm[4*i+2];
		t0=ev[i].t0+tscale*dm[4*i+3];
		printf("%d\t%f\t%f\t%f\t%f\n", ev[i].nev, x, y, z, t0 );
		}

	sm_times_v( G, dm, dp );

	for( i=0; i<n_ph; i++ ) {
		if( (!ph[i].good) || (ph[i].row==(-1)) ) continue;
		res =  d[ph[i].row] - dp[ ph[i].row ];
		for( j=0; j<ph[i].n; j++ ) {
			for( k=0; k<n_sta; k++ ) if( stanum[k]==ph[i].sta[j] ) {
				stacount[k]++;
				starms[k]+= res*res;
				stamean[k]+= res;
				break;
				}
			}
		}

	fprintf(stderr,"station statistics:\n");
	fprintf(stderr,"sta\tcount\trms\tmean\n");
	for( i=0; i<n_sta; i++ ) {
		fprintf(stderr,"%d\t%d\t%f\t%f\n", stanum[i], stacount[i],
			sqrt(starms[i]/(double)stacount[i]),
			stamean[i]/(double)stacount[i] );
		}
	fprintf(stderr,"\n");

	for( i=0; i<n_ph; i++ ) {
		if( (!ph[i].good) || (ph[i].row==(-1)) ) continue;
		res = d[ph[i].row] - dp[ ph[i].row ];
		for( j=0; j<ph[i].n; j++ ) {
			evkey.nev = ph[i].ev[j];
			myev=(struct ev_rec *)
				bsearch(&evkey, ev, n_ev, sizeof(struct ev_rec), cmpev );
			if( myev==NULL ) continue;
			myev->count++;
			myev->rms += res*res;
			myev->mean += res;
			}
		}

	fprintf(stderr,"event statistics:\n");
	fprintf(stderr,"event\tcount\trms\tmean\n");
	for( i=0; i<n_ev; i++ ) {
		fprintf(stderr,"%d\t%d\t%f\t%f\n",
			ev[i].nev, ev[i].count, sqrt(ev[i].rms/(double)ev[i].count),
			ev[i].mean/(double)ev[i].count);
		}
	fprintf(stderr,"\n");

	fprintf(stderr,"phase statistics:\n");
	fprintf(stderr,"phase\tline\terror\n");
	for( i=0; i<n_ph; i++ ) {
		j=ph[i].row;
		if( (!ph[i].good) || (j==(-1)) ) continue;
		res = d[j]-dp[j];
		fprintf(stderr,"%d\t%d\t%f\n", i, ph[i].line, res );
		}
	fprintf(stderr,"\n");

	rms2=0.0;
	for( i=0; i<n_ev; i++ ) {
		res = dm[4*i]; rms2 += res*res;
		res = dm[4*i+1]; rms2 += res*res;
		res = dm[4*i+2]; rms2 += res*res;
		}
	rms2 = sqrt( rms2 / (double)(3*n_ev) );
	fprintf(stderr, "event location statistics: rms change in position %f km\n", rms2);
	fprintf(stderr,"\n");

	rms2=0.0;
	for( i=0; i<n_ev; i++ ) {
		res = tscale*dm[4*i+3]; rms2 += res*res;
		}
	rms2 = sqrt( rms2 / (double)n_ev );
	fprintf(stderr, "event origin time statistics: rms change in origin time %f s\n", rms2);
	fprintf(stderr,"\n");

	model_to_P( my_PS_node, my_PS_tetra, &model_is_P );

	/* update P velocity of nodes */
	model_par=P_model_par; n_model_pars=P_n_model_pars;
	for( i=0; i<n_model_pars; i++ ) {
		for( j=0; j<model_par[i].n; j++ ) {
			k=model_par[i].node[j];
			weight=model_par[i].weight[j];
			node[k].v = node[k].v_orig+rw*weight*dm[4*n_ev+i];
			}
		}

	/* update ratio of nodes */
	model_par=ratio_model_par; n_model_pars=ratio_n_model_pars;
	for( i=0; i<n_model_pars; i++ ) {
		for( j=0; j<model_par[i].n; j++ ) {
			k=model_par[i].node[j];
			weight=model_par[i].weight[j];
			node[k].ratio = node[k].ratio_orig + rw2*rw*weight*dm[4*n_ev+P_n_model_pars+i];
			}
		}

	rms2=0.0;
	for( i=0; i<P_n_model_pars; i++ ) {
		res = dm[4*n_ev+i];
		rms2 += res*res;
		}
	rms2 = sqrt( rms2 / (double)P_n_model_pars );
	fprintf(stderr, "P velocity model parameter statistics: rms size %f\n", rw*rms2);
	fprintf(stderr,"\n");

	rms2=0.0;
	for( i=0; i<ratio_n_model_pars; i++ ) {
		res = dm[4*n_ev+P_n_model_pars+i];
		rms2 += res*res;
		}
	rms2 = sqrt( rms2 / (double)ratio_n_model_pars );
	fprintf(stderr, "ratio velocity model parameter statistics: rms size %f\n", rw2*rw*rms2);
	fprintf(stderr,"\n");

	rms2=0.0;
	for( i=0; i<n_nodes; i++ ) {
		res = node[i].v - node[i].v_orig;
		rms2 += res*res;
		}
	rms2 = sqrt( rms2 / (double)n_nodes );
	fprintf(stderr, "P velocity nodes statistics: rms change %f km/s\n", rms2);
	fprintf(stderr,"\n");

	rms2=0.0;
	for( i=0; i<n_nodes; i++ ) {
		res = node[i].ratio - node[i].ratio_orig;
		rms2 += res*res;
		}
	rms2 = sqrt( rms2 / (double)n_nodes );
	fprintf(stderr, "ratio nodes statistics: rms change %f\n", rms2);
	fprintf(stderr,"\n");

	rms2=0.0;
	for( i=0; i<n_ph; i++ ) {
		j=ph[i].row;
		if( (!ph[i].good) || (j==(-1)) ) continue;
		res = d[j]-dp[j];
		rms2 += res*res;
		}

	rms2 = sqrt( rms2 / (double)irms );
	fprintf(stderr,"rms weighted residual original: %f final %f for %f percent reduction\n",
		rms1, rms2, 100.0-100.0*rms2/rms1 );

	/* write out perturbed model */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/* must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		if( QDEFINED )
		fprintf(nmfile,"%d %d %d %f %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, node[i].ratio, node[i].ifc );
		}
	fclose(nmfile);

	sprintf( hitsfile, "%s.hits", argv[7] );
	if( (nmfile=fopen(hitsfile,"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open hitsfile <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}

	/* write out hits file */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		fprintf(nmfile,"%d %d %d %f %f %f %d %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].hits, node[i].ifc );
		}
	fclose(nmfile);

	exit(0);
	}




void main_VIinvert(int argc,char *argv[])
// int argc;
// char *argv[];
{
	int i, j, k, l, nodeid, interface, hitflag, n_arcs, status, order, ec; // n, //unused
	double x0[3], t0[3], x1[3], t1[3]; //, v[4], stheta, ftheta, dtheta, theta, azi; //unused
	struct arc_rec arc[MAX_ARCS];
	double traveltime; //, rayx[8000], rayy[8000], rayz[8000]; //unused
//	int tindex[8000]; //unused
	FILE *mpfile, *ttfile, *nmfile;
	char ct[128];
	double xsrc, ysrc, zsrc, xsta, ysta, zsta, ratio, T0, Ta, th_est, az_est;
	struct triangle_rec tri;
	struct tetra_rec *pt;

	double V_thmin, V_thmax, V_azimin, V_azimax, vs;
	double I_thmin, I_thmax, I_azimin, I_azimax;

	int V_nth, V_nazi;
	int I_nth, I_nazi;

	int ng, itt, match; // ierror, //unused
	double *ts, *ts2, rms, rms2; //  ,tolerance, dT, dX//unused
	double damping;
	int tnode[4];
	int bracket_status;
	int biec;
	double new_damping, scx;

	struct sparse_matrix *G, *invert_GTG;

	double *d, *GTd, *dm, maxG, maxd, dv, err, max_dT, qinvint; // Gv, //unused
	int iter, nx, ny, nz;

	double weight;

	char hitsfile[256];

	int Vmp, Vttimes, rinterface;
	double relative_weight;
	double ntan[3];
	double Gelem, Gmax1, Gmax2, Gmax3, Gmax4;

	Gmax1=0.0;
	Gmax2=0.0;
	Gmax3=0.0;
	Gmax4=0.0;

	if( argc!=23 ) {
		fprintf(stderr,"purpose: invert local direct and reflected traveltime data\n");
		fprintf(stderr,"for improvements to node velocities and reflector node positions\n");
		fprintf(stderr,"usage: %s starting_model_file V_model_pars_file.txt I_model_pars_file.txt\n", argv[0]);
		fprintf(stderr,"       V_traveltimes.tsv I_traveltimes.tsv max_dT damping relative_weight rinterface\n");
		fprintf(stderr,"       V_thmin V_thmax V_nth V_azimin V_azimax V_nazi\n");
		fprintf(stderr,"       I_thmin I_thmax I_nth I_azimin I_azimax I_nazi\n");
		fprintf(stderr,"       new_model_file\n");
		write_model_blerb(stderr);
		fprintf(stderr,"       input V_model_pars_file defines node velocity pertubations\n");
		write_model_pars_blerb(stderr);
		fprintf(stderr,"       input I_model_pars_file defines reflector node position pertubations\n");
		write_refl_pars_blerb(stderr);

		fprintf(stderr,"      input V_traveltimes.tsv defines direct wave traveltimes:\n");
		fprintf(stderr,"              xs, ys, zs, source location in km\n");
		fprintf(stderr,"                  (but be warned; sort data into groups with common source!\n");
		fprintf(stderr,"              xr, yr, zr, receiver location in km\n");

		fprintf(stderr,"                  (but be warned; z not used!)\n");
		fprintf(stderr,"              receiver interface, integer matching model\n");
		fprintf(stderr,"                  (but be warned; sort data with common source by interface!)\n");
		fprintf(stderr,"              T0,  origin time in s\n");
		fprintf(stderr,"              Ta,  arrival time in s\n");
		fprintf(stderr,"              ratio, 1 for P 1.76 (or whatever) for S\n");
		fprintf(stderr,"              order, 0 for 1-st arrival, 1 for second, etc\n");
		fprintf(stderr,"                 Note: (-1) indicates closest arrival\n");
		fprintf(stderr,"      input I_traveltimes.tsv defines reflected wave traveltimes\n");
		fprintf(stderr,"              (same format as V_traveltimes.tsv\n");
		fprintf(stderr,"      max_dT: if the absolute value of the traveltime residual, |dT|=|Tobs-Tpred(initial_model)|\n");
		fprintf(stderr,"              is greater than max_dt, that data is ignored\n");
		fprintf(stderr,"      damping: damped least squares parameter  (fraction of largest element of GTG)\n");
		fprintf(stderr,"      relative_weight: relative weight of velocity and position perturbations\n");
		fprintf(stderr,"              (In other words, how much is a km/s of velocity perturbation worth\n");
		fprintf(stderr,"              relative to a km position perturbation?  The dT/dx\n");
		fprintf(stderr,"              position derivatives in the normal equations G dm = dT are\n");
		fprintf(stderr,"              multipled by relative_weight prior to the damped\n");
		fprintf(stderr,"              least-squares solution.  Thus the damping tends to\n");
		fprintf(stderr,"              drive ||dv||**2+||dx/relative_weight||**2 to zero.\n");
		fprintf(stderr,"              A relative_weigth>1 thus reduces the penalty of dx\n");
		fprintf(stderr,"              relative to dv - so large dx's are favored over\n");
		fprintf(stderr,"              large dv's\n");
		fprintf(stderr,"      rinterface: reflector interface (must match model)\n");
		fprintf(stderr,"      direct arrivals are searched for in a star with\n");
		fprintf(stderr,"         V_thmin, V_thmax, min, max angles of incidence, (0-180 deg)\n");
		fprintf(stderr,"         V_nth, integer number of thetas in star\n");
		fprintf(stderr,"         V_azimin, V_azimax, azimuth range (0-360 deg)\n");
		fprintf(stderr,"         V_nazi, integer number of azimuths in star\n");
		fprintf(stderr,"      reflected arrivals are searched for in a star with\n");
		fprintf(stderr,"         I_thmin, I_thmax, min, max angles of incidence, (0-180 deg)\n");
		fprintf(stderr,"         I_nth, integer number of thetas in star\n");
		fprintf(stderr,"         I_azimin, I_azimax, azimuth range (0-360 deg)\n");
		fprintf(stderr,"         I_nazi, integer number of azimuths in star\n");
		fprintf(stderr,"      output new_model_file: same format as starting model file\n");
		fprintf(stderr,"         also output is new_model_file.hits: same format as starting model file, but with velocity replaced with number of rays\n");
		fprintf(stderr,"         interacting with each node\n");
		exit(-1);
		}

	fprintf(stderr,"Raytrace3d VIinvert.\n\n");
	timestamp((char*)"at start");

	fprintf(stderr,"Reflecting interface: %s\n", argv[9] );
	fprintf(stderr,"Reflecting interface: %s\n", argv[9] );
	if( sscanf(argv[9], "%d", &rinterface) != 1 ) {
		fprintf(stderr,"error: %s: cant read rinterface from command line\n", argv[0] );
		exit(-1);
		}

	fprintf(stderr,"Starting model file: %s\n\n", argv[1] );

	if( !load_prismatic_model(argv[1]) ) {
		fprintf(stderr,"error: %s: cant load starting model <%s>\n", argv[0], argv[1] );
		exit(-1);
		}

	alloc_model_pars_V(argv[2], argv[3]);

	if( (mpfile=fopen(argv[2],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open V_model_par_file <%s> for read\n", argv[0], argv[2] );
		exit(-1);
		}


	n_model_pars=0;
	load_model_pars_V(mpfile);
	fclose(mpfile);

	Vmp=n_model_pars;

	fprintf(stderr,"%d velocity model parameters:\n", Vmp );
	if( Vmp < 1000 ) {
		for( i=0; i<Vmp; i++ ) {
			fprintf(stderr,"velocity model parameter %d has %d nodes\n", i, model_par[i].n );
			for( j=0; j<model_par[i].n; j++ ) {
				fprintf(stderr,"%d %f\n",model_par[i].node[j],model_par[i].weight[j]);
				}
			}
		}

	if( (mpfile=fopen(argv[3],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open I_model_par_file <%s> for read\n", argv[0], argv[3] );
		exit(-1);
		}
	while( fscanf(mpfile,"%d",&(model_par[n_model_pars].n)) == 1 ) {
		if( n_model_pars > (MAX_MODEL_PARS-1) ) {
			fprintf(stderr,"error: %s: maximum model parameters (%d) exceeds limit of %d\n", argv[0], n_model_pars, MAX_MODEL_PARS-1 );
			exit(-1);
			}
		model_par[n_model_pars].node = (int *)
			malloc((model_par[n_model_pars].n+2)*sizeof(int));
		if(model_par[n_model_pars].node==NULL) {
			fprintf(stderr,"error: out of memory (model_par node)!\n");
			exit(-1);
			}
		model_par[n_model_pars].weight = (double *)
			malloc((model_par[n_model_pars].n+2)*sizeof(double));
		if(model_par[n_model_pars].weight==NULL) {
			fprintf(stderr,"error: out of memory (model_par weight)!\n");
			exit(-1);
			}
		model_par[n_model_pars].t = (double *)
			malloc(3*(model_par[n_model_pars].n+2)*sizeof(double));
		if(model_par[n_model_pars].t==NULL) {
			fprintf(stderr,"error: out of memory (model_par t)!\n");
			exit(-1);
			}
		for( l=0; l<model_par[n_model_pars].n; l++ ) {
			if(fscanf(mpfile,"%d%d%d%le%le%le%le", &i,&j,&k,ntan,ntan+1,ntan+2,&weight)!=7) {
				fprintf(stderr,"error: %s: cant parse model_par_file <%s>\n", argv[0], argv[2] );
				exit(-1);
				}
			if( i<0 || i>=model_L || j<0 || j>=model_M || k<0 || k>=model_N ) {
				fprintf(stderr,"error: %s: bad node (%d %d %d) in model_par_file <%s>\n", argv[0], i, j, k, argv[2] );
				exit(-1);
				}
			nodeid=k*model_L*model_M+j*model_L+i;
			if( (model_par[n_model_pars].node[l]=findnode(nodeid))==(-1) ) {
				fprintf(stderr,"error: %s: couldnt find node (%d %d %d)\n", argv[0], i, j, k );
				exit(-1);
				}
			if( node[model_par[n_model_pars].node[l]].ifc != rinterface ) {
				fprintf(stderr,"error: %s: node (%d %d %d) not on reflector interface %d\n",
				argv[0], i, j, k, rinterface );
				exit(-1);
				}
			if( weight==0.0 ) {
				fprintf(stderr,"error: %s: model parameter %d has 0 weight\n", argv[0], n_model_pars );
				exit(-1);
				}
			model_par[n_model_pars].weight[l]=weight;
			unit_vector(ntan);
			for(i=0;i<3;i++) model_par[n_model_pars].t[3*l+i]=ntan[i];
			}
		n_model_pars++;
		}

	fclose(mpfile);
	fprintf(stderr,"%d reflector node position model parameters:\n", n_model_pars-Vmp );
	if( (n_model_pars-Vmp) < 1000 ) {
		for( i=Vmp; i<n_model_pars; i++ ) {
			fprintf(stderr,"Model parameter %d has %d nodes\n", i, model_par[i].n );
			for( j=0; j<model_par[i].n; j++ ) {
				fprintf(stderr,"%d (%f %f %f) %f\n", model_par[i].node[j],
					model_par[i].t[3*j], model_par[i].t[3*j+1], model_par[i].t[3*j+2],
					model_par[i].weight[j]);
				}
			}
		}

	make_ttime2(argv[4],argv[5]);

	if( (ttfile=fopen(argv[4],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open V_traveltime.tsv <%s> for read\n", argv[0], argv[4] );
		exit(-1);
		}
	if( fscanf(ttfile,"%s%s%s%s%s%s%s%s%s%s%s",
			ct,ct,ct,ct,ct,ct,ct,ct,ct,ct,ct ) != 11 ) {
		fprintf(stderr,"error: %s: cant skip header in V_traveltimess.tsv <%s>\n",
			argv[0], argv[4]);
		exit(-1);
		}

	n_ttimes=0;
	fprintf(stderr,"\nInput Direct Wave Data\n\n");
	fprintf(stderr,"#\txs\tys\tzs\txr\tyr\tzr\tinterface\tT0\tTa\tratio\torder\n");
 	while( fscanf(ttfile,"%le%le%le%le%le%le%d%le%le%le%d", &xsrc,&ysrc,&zsrc,
		&xsta,&ysta,&zsta,&interface,&T0,&Ta,&ratio,&order)==11){
		if( (n_ttimes+2) > MAX_TTIMES ) {
			fprintf(stderr,"error: %s: too many traveltimes\n", argv[0] );
			exit(-1);
			}
		ttime[n_ttimes].ok=FALSE;
		ttime[n_ttimes].x0[0]=xsrc;
		ttime[n_ttimes].x0[1]=ysrc;
		ttime[n_ttimes].x0[2]=zsrc;
		ttime[n_ttimes].x1[0]=xsta;
		ttime[n_ttimes].x1[1]=ysta;
		ttime[n_ttimes].x1[2]=zsta;
		ttime[n_ttimes].interface=interface;
		ttime[n_ttimes].T0=T0;
		ttime[n_ttimes].obsTT=Ta-T0;
		ttime[n_ttimes].obsTa=Ta;
		ttime[n_ttimes].preTa=0.0;
		ttime[n_ttimes].preTT=0.0;
		ttime[n_ttimes].ratio=ratio;
		ttime[n_ttimes].obsorder=order;
		ttime[n_ttimes].preorder=order;
		fprintf(stderr,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%f\t%f\t%f\t%d\n",
			n_ttimes,
			ttime[n_ttimes].x0[0],ttime[n_ttimes].x0[1],ttime[n_ttimes].x0[2],
			ttime[n_ttimes].x1[0],ttime[n_ttimes].x1[1],ttime[n_ttimes].x1[2],
			ttime[n_ttimes].interface,
			ttime[n_ttimes].T0, ttime[n_ttimes].obsTa, 
			ttime[n_ttimes].ratio, ttime[n_ttimes].obsorder );
		n_ttimes++;
		}
	fclose(ttfile);
	Vttimes=n_ttimes;

	if( (ttfile=fopen(argv[5],"r"))==NULL ) {
		fprintf(stderr,"error: %s: cant open I_traveltime.tsv <%s> for read\n", argv[0], argv[5] );
		exit(-1);
		}
	if( fscanf(ttfile,"%s%s%s%s%s%s%s%s%s%s%s",
			ct,ct,ct,ct,ct,ct,ct,ct,ct,ct,ct ) != 11 ) {
		fprintf(stderr,"error: %s: cant skip header in V_traveltimess.tsv <%s>\n",
			argv[0], argv[5]);
		exit(-1);
		}

	fprintf(stderr,"\nInput Reflected Wave Data\n\n");
	fprintf(stderr,"#\txs\tys\tzs\txr\tyr\tzr\tinterface\tT0\tTa\tratio\torder\n");	
 	while( fscanf(ttfile,"%le%le%le%le%le%le%d%le%le%le%d", &xsrc,&ysrc,&zsrc,
		&xsta,&ysta,&zsta,&interface,&T0,&Ta,&ratio,&order)==11){
		if( (n_ttimes+2) > MAX_TTIMES ) {
			fprintf(stderr,"error: %s: too many traveltimes\n", argv[0] );
			exit(-1);
			}
		ttime[n_ttimes].ok=FALSE;
		ttime[n_ttimes].x0[0]=xsrc;
		ttime[n_ttimes].x0[1]=ysrc;
		ttime[n_ttimes].x0[2]=zsrc;
		ttime[n_ttimes].x1[0]=xsta;
		ttime[n_ttimes].x1[1]=ysta;
		ttime[n_ttimes].x1[2]=zsta;
		ttime[n_ttimes].interface=interface;
		ttime[n_ttimes].T0=T0;
		ttime[n_ttimes].obsTT=Ta-T0;
		ttime[n_ttimes].obsTa=Ta;
		ttime[n_ttimes].preTa=0.0;
		ttime[n_ttimes].preTT=0.0;
		ttime[n_ttimes].ratio=ratio;
		ttime[n_ttimes].obsorder=order;
		ttime[n_ttimes].preorder=order;
		fprintf(stderr,"%d\t%f\t%f\t%f\t%f\t%f\t%f\t%d\t%f\t%f\t%f\t%d\n",
			n_ttimes,
			ttime[n_ttimes].x0[0],ttime[n_ttimes].x0[1],ttime[n_ttimes].x0[2],
			ttime[n_ttimes].x1[0],ttime[n_ttimes].x1[1],ttime[n_ttimes].x1[2],
			ttime[n_ttimes].interface,
			ttime[n_ttimes].T0, ttime[n_ttimes].obsTa, 
			ttime[n_ttimes].ratio, ttime[n_ttimes].obsorder );
		n_ttimes++;
		}
	fclose(ttfile);


	fprintf(stderr,"Total of %d data (%d direct, %d reflected)\n\n", n_ttimes, Vttimes, n_ttimes-Vttimes);

	if( sscanf(argv[6], "%le", &max_dT) != 1 ) {
		fprintf(stderr,"error: %s: cant read max_dT from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[7], "%le", &damping) != 1 ) {
		fprintf(stderr,"error: %s: cant read damping from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[8], "%le", &relative_weight) != 1 ) {
		fprintf(stderr,"error: %s: cant read relative_weight from command line\n", argv[0] );
		exit(-1);
		}

	fprintf(stderr,"max_dT %f  damping %f relative_weight %f\n", max_dT, damping, relative_weight );

	if( sscanf(argv[10], "%le", &V_thmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read V_thmin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[11], "%le", &V_thmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read V_thmax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[12], "%d", &V_nth) != 1 ) {
		fprintf(stderr,"error: %s: cant read V_nth from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[13], "%le", &V_azimin) != 1 ) {
		fprintf(stderr,"error: %s: cant read V_azimin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[14], "%le", &V_azimax) != 1 ) {
		fprintf(stderr,"error: %s: cant read V_azimax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[15], "%d", &V_nazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read V_nazi from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[16], "%le", &I_thmin) != 1 ) {
		fprintf(stderr,"error: %s: cant read I_thmin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[17], "%le", &I_thmax) != 1 ) {
		fprintf(stderr,"error: %s: cant read I_thmax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[18], "%d", &I_nth) != 1 ) {
		fprintf(stderr,"error: %s: cant read I_nth from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[19], "%le", &I_azimin) != 1 ) {
		fprintf(stderr,"error: %s: cant read I_azimin from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[20], "%le", &I_azimax) != 1 ) {
		fprintf(stderr,"error: %s: cant read I_azimax from command line\n", argv[0] );
		exit(-1);
		}

	if( sscanf(argv[21], "%d", &I_nazi) != 1 ) {
		fprintf(stderr,"error: %s: cant read I_nazi from command line\n", argv[0] );
		exit(-1);
		}

	if( (nmfile=fopen(argv[22],"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open new_model_file <%s> for write\n", argv[0], argv[22] );
		exit(-1);
		}

	sprintf( hitsfile, "%s.hits", argv[22] );

	G=new_sparse_matrix(n_ttimes,n_model_pars,0);
	d=(double*)malloc((n_ttimes+2)*sizeof(double));
	ts=(double*)malloc((n_model_pars+2)*sizeof(double));
	ts2=(double*)malloc((n_ttimes+2)*sizeof(double));
	GTd=(double*)malloc((n_model_pars+2)*sizeof(double));
	dm=(double*)malloc((n_model_pars+2)*sizeof(double));

	if( (G==NULL) || (d==NULL) || (GTd==NULL) ||
		(ts==NULL) || (ts2==NULL) || (dm==NULL) ) {
		fprintf(stderr,"error: %s: out of memory (G, d ...)\n", argv[0] );
		exit(-1);
		}
	ng=0;

	fprintf(stderr,"Starting Point to Point Ray tracing of data\n\n");
	timestamp((char*)"at start of raytracing");
	fprintf(stderr,"#\tobsTT\tpreTT\tres\n");

	/* direct wave traveltimes */
	for( itt=0; itt<Vttimes; itt++ ) {

	if( itt==0 ) {
		match=FALSE;
		}
	else {
		if( ttime[itt].x0[0]==x0[0] && ttime[itt].x0[1]==x0[1] &&
			ttime[itt].x0[2]==x0[2] && ttime[itt].interface==interface ) 
			match=TRUE; else match=FALSE;
		}

	if( !match ) {
		for( i=0; i<3; i++ ) x0[i]=ttime[itt].x0[i];
		interface=ttime[itt].interface;
		if( !find_tetra(x0,&i) ) {
			fprintf(stderr,"error: %s: source location (%f %f %f) not in model\n", argv[0], x0[0], x0[1], x0[2] );
			exit(-1);
			}
		vs=eval_velocity(&tetra[i],x0);

		fprintf(stderr,"Shooting star pattern from source (%f %f %f) at velocity %f to interface %d, theta (%f, %f, %d) azi (%f %f %d)\n",
		x0[0], x0[1], x0[2], vs,
		interface, V_thmin, V_thmax, V_nth, V_azimin, V_azimax, V_nazi );
		shoot_star(V_thmin, V_thmax, V_nth, V_azimin, V_azimax, V_nazi, x0, interface);
		fprintf(stderr,"done with star\n\n");
		}
	xsta=ttime[itt].x1[0];
	ysta=ttime[itt].x1[1];
	n_tts=0;
	bracket_status=FALSE;
	for( i=0; i<(m_rays-1); i++ )
	for( j=0; j<(n_rays-1); j++ )
	for( l=0; l<2; l++ ) {
		if( instarbox(i, j, l, xsta, ysta, &th_est,
			&az_est, &tri, x0, interface, NULL) ) {
		bracket_status=TRUE;
		if( refine( x0, xsta, ysta, interface, &th_est, &az_est,
			NULL, &n_arcs, &traveltime, &tri) ) {
			if( (n_tts+2)<MAX_TTS ) {
				tt[n_tts].az=az_est;
				tt[n_tts].th=th_est;
				tt[n_tts].T=traveltime;
				n_tts++;
				}
			else {
				fprintf(stderr,"error: %s: too many arrivals\n", argv[0]);
				exit(-1);
				}
			} }
		}
	qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
	if( order==(-1) ) setorder( tt, n_tts, ttime[itt].obsTa-ttime[itt].T0, ttime[itt].ratio, &ttime[itt].obsorder );

	if( (j=ttime[itt].obsorder) < n_tts ) {
		status=TRUE;
		ray_tangent(tt[j].th,tt[j].az,t0);
		if( !shoot_to_interface( x0, t0, x1, t1, arc, &n_arcs,
			MAX_ARCS, 10000.0, interface, &hitflag, &traveltime, &qinvint, &ec ) ) {
			status=FALSE;
			}
		if( !hitflag ) status=FALSE;
		}
	else status=FALSE;

	if( status ) {
		ttime[itt].ok=TRUE;
		ttime[itt].preorder=j;
		ttime[itt].preTT=traveltime*ttime[itt].ratio;
		ttime[itt].th=tt[j].th;
		ttime[itt].az=tt[j].az;
		fprintf(stderr,"%d\t%f\t%f\t%f\n", itt, 
			ttime[itt].obsTT, ttime[itt].preTT,
			ttime[itt].obsTT-ttime[itt].preTT);
		}
	else {
		ttime[itt].ok=FALSE;
		fprintf(stderr,"warning: lost observation %d\n", itt);
		if( !bracket_status ) {
			fprintf(stderr,"         ray was not bracketed\n" );
			}
		else {
			if( refine_star_status==1 ) {
				fprintf(stderr,"         derivative failed in refine\n" );
				}
			if( refine_star_status==2 ) {
				fprintf(stderr,"         ray came this close: %e\n", refine_star_norm );
				}
			}
		continue;
		}

	d[ng]=ttime[itt].obsTT-traveltime*ttime[itt].ratio;

	for( i=0; i<n_nodes; i++ ) node[i].touched=0;
	for( i=0; i<n_arcs; i++ ) {
		node[ arc[i].ptetra->n1 ].touched=1;
		node[ arc[i].ptetra->n2 ].touched=1;
		node[ arc[i].ptetra->n3 ].touched=1;
		node[ arc[i].ptetra->n4 ].touched=1;
		}
	for( i=0; i<n_nodes; i++ ) {
		if( node[i].touched ) node[i].hits++;
		node[i].touched=0;
		}

	/* this section handles the partial derivative of direct wave */
	/* traveltime with respect to velocity model parameters       */
	for( j=0; j<Vmp; j++ ) {
		/* will varying this model parameter change the traveltime ? */
		match=FALSE;
		for( i=0; i<n_arcs; i++ ) {
			pt=arc[i].ptetra;
			tnode[0]=pt->n1; tnode[1]=pt->n2; tnode[2]=pt->n3; tnode[3]=pt->n4;
			for( k=0; k<4; k++ ) {
				if( node_in_model_par(tnode[k],j) ) {
					match=TRUE;
					break;
					}
				}
			if(match) break;
			}
		if( match ) {
			Gelem=dTdmp(j,arc,n_arcs,traveltime)*ttime[itt].ratio;
			set_sparse_value( G, ng, j, Gelem);
			Gelem=fabs(Gelem);if(Gmax1<Gelem)Gmax1=Gelem;
			}
		else {
			;/* G[ng][j] is zero */
			}
		}

	/* this section handles the partial derivative of direct wave */
	/* traveltime with respect to interface model parameters       */
	for( j=Vmp; j<n_model_pars; j++ ) {
		/* will varying this model parameter change the traveltime ? */
		match=FALSE;
		for( i=0; i<n_arcs; i++ ) {
			pt=arc[i].ptetra;
			tnode[0]=pt->n1; tnode[1]=pt->n2; tnode[2]=pt->n3; tnode[3]=pt->n4;
			for( k=0; k<4; k++ ) {
				if( node_in_model_par(tnode[k],j) ) {
					match=TRUE;
					break;
					}
				}
			if(match) break;
			}
		if( match ) {
			Gelem=dTdmprd(j,interface,rinterface,x0,t0,x1,t1,arc,n_arcs,
				traveltime,ng) * ttime[itt].ratio;
			set_sparse_value( G, ng, j, Gelem);
			Gelem=fabs(Gelem);if(Gmax2<Gelem)Gmax2=Gelem;
			}
		else {
			;/* G[ng][j] is zero */
			}
		}

	if( fabs(d[ng]) > max_dT ) {
		fprintf(stderr,"|%f|>%f, so ignoring this data \n", d[ng], max_dT );
		for( j=0; j<n_model_pars; j++ ) set_sparse_value( G, ng, j, 0.0 );
		}
	else {
		ng++;
		}

	} /* next direct traveltime */

	/* direct wave traveltimes */
	for( itt=Vttimes; itt<n_ttimes; itt++ ) {

	if( itt==0 ) {
		match=FALSE;
		}
	else {
		if( ttime[itt].x0[0]==x0[0] && ttime[itt].x0[1]==x0[1] &&
			ttime[itt].x0[2]==x0[2] && ttime[itt].interface==interface ) 
			match=TRUE; else match=FALSE;
		}

	if( !match ) {
		for( i=0; i<3; i++ ) x0[i]=ttime[itt].x0[i];
		interface=ttime[itt].interface;
		if( !find_tetra(x0,&i) ) {
			fprintf(stderr,"error: %s: source location (%f %f %f) not in model\n", argv[0], x0[0], x0[1], x0[2] );
			exit(-1);
			}
		vs=eval_velocity(&tetra[i],x0);

		fprintf(stderr,"Shooting star pattern from source (%f %f %f) at velocity %f to interface %d, theta (%f, %f, %d) azi (%f %f %d)\n",
		x0[0], x0[1], x0[2], vs,
		interface, I_thmin, I_thmax, I_nth, I_azimin, I_azimax, I_nazi );
		shoot_star_refl(I_thmin, I_thmax, I_nth, I_azimin, I_azimax, I_nazi, x0, interface, rinterface);
		fprintf(stderr,"done with star\n\n");
		}
	xsta=ttime[itt].x1[0];
	ysta=ttime[itt].x1[1];
	n_tts=0;
	bracket_status=FALSE;
	for( i=0; i<(m_rays-1); i++ )
	for( j=0; j<(n_rays-1); j++ )
	for( l=0; l<2; l++ ) {
		if( instarbox_refl(i, j, l, xsta, ysta, &th_est,
			&az_est, &tri, x0, interface, rinterface, NULL) ) {
		bracket_status=TRUE;
		if( refine_refl( x0, xsta, ysta, interface, rinterface, &th_est, &az_est,
			NULL, &n_arcs, &traveltime, &tri) ) {
			if( (n_tts+2)<MAX_TTS ) {
				tt[n_tts].az=az_est;
				tt[n_tts].th=th_est;
				tt[n_tts].T=traveltime;
				n_tts++;
				}
			else {
				fprintf(stderr,"error: %s: too many arrivals\n", argv[0]);
				exit(-1);
				}
			} }
		}
	qsort( tt, n_tts, sizeof(struct tt_rec), compare_tt );
	if( order==(-1) ) setorder( tt, n_tts, ttime[itt].obsTa-ttime[itt].T0, ttime[itt].ratio, &ttime[itt].obsorder );

	if( (j=ttime[itt].obsorder) < n_tts ) {
		status=TRUE;
		ray_tangent(tt[j].th,tt[j].az,t0);
		if( !shoot_to_interface_refl( x0, t0, x1, t1, arc, &n_arcs,
			MAX_ARCS, 10000.0, interface, rinterface, &hitflag, &traveltime, &qinvint, &ec ) ) {
			status=FALSE;
			}
		if( !hitflag ) status=FALSE;
		}
	else status=FALSE;

	if( status ) {
		ttime[itt].ok=TRUE;
		ttime[itt].preorder=j;
		ttime[itt].preTT=traveltime*ttime[itt].ratio;
		ttime[itt].th=tt[j].th;
		ttime[itt].az=tt[j].az;
		fprintf(stderr,"%d\t%f\t%f\t%f\n", itt, 
			ttime[itt].obsTT, ttime[itt].preTT,
			ttime[itt].obsTT-ttime[itt].preTT);
		}
	else {
		ttime[itt].ok=FALSE;
		fprintf(stderr,"warning: lost observation %d\n", itt);
		if( !bracket_status ) {
			fprintf(stderr,"         ray was not bracketed\n" );
			}
		else {
			if( refine_star_status==1 ) {
				fprintf(stderr,"         derivative failed in refine\n" );
				}
			if( refine_star_status==2 ) {
				fprintf(stderr,"         ray came this close: %e\n", refine_star_norm );
				}
			}
		continue;
		}

	d[ng]=ttime[itt].obsTT-traveltime*ttime[itt].ratio;

	for( i=0; i<n_nodes; i++ ) node[i].touched=0;
	for( i=0; i<n_arcs; i++ ) {
		node[ arc[i].ptetra->n1 ].touched=1;
		node[ arc[i].ptetra->n2 ].touched=1;
		node[ arc[i].ptetra->n3 ].touched=1;
		node[ arc[i].ptetra->n4 ].touched=1;
		}
	for( i=0; i<n_nodes; i++ ) {
		if( node[i].touched ) node[i].hits++;
		node[i].touched=0;
		}

	/* this section handles the partial derivative of reflected wave */
	/* traveltime with respect to velocity model parameters          */
	for( j=0; j<Vmp; j++ ) {
		match=FALSE;
		for( i=0; i<n_arcs; i++ ) {
			pt=arc[i].ptetra;
			tnode[0]=pt->n1; tnode[1]=pt->n2; tnode[2]=pt->n3; tnode[3]=pt->n4;
			for( k=0; k<4; k++ ) {
				if( node_in_model_par(tnode[k],j) ) {
					match=TRUE;
					break;
					}
				}
			if(match) break;
			}
		if( match ) {
			Gelem=dTdmp(j,arc,n_arcs,traveltime)*ttime[itt].ratio;
			set_sparse_value( G, ng, j, Gelem );
			Gelem=fabs(Gelem);if(Gmax3<Gelem)Gmax3=Gelem;
			}
		else {
			;/* G[ng][j] is zero */
			}
		}

	/* this section handles the partial derivative of reflected wave */
	/* traveltime with respect to interface model parameters          */
	for( j=Vmp; j<n_model_pars; j++ ) {
		/* Derivatives with respect to reflector node positions */
		match=FALSE;
		for( i=0; i<n_arcs; i++ ) {
			pt=arc[i].ptetra;
			tnode[0]=pt->n1; tnode[1]=pt->n2; tnode[2]=pt->n3; tnode[3]=pt->n4;
			for( k=0; k<4; k++ ) {
				if( node_in_model_par(tnode[k],j) ) {
					match=TRUE;
					break;
					}
				}
			if(match) break;
			}
		if( match ) {
			Gelem=dTdmpr(j,interface,rinterface,x0,t0,x1,t1,arc,n_arcs,traveltime,ng)
				* ttime[itt].ratio * relative_weight;
			set_sparse_value( G, ng, j, Gelem );
			Gelem=fabs(Gelem);if(Gmax4<Gelem)Gmax4=Gelem;
			}
		else {
			;/* G[ng][j] is zero */
			}
		}

	if( fabs(d[ng]) > max_dT ) {
		fprintf(stderr,"|%f|>%f, so ignoring this data \n", d[ng], max_dT );
		for( j=0; j<n_model_pars; j++ ) set_sparse_value( G, ng, j, 0.0 );
		}
	else {
		ng++;
		}

	} /* next traveltime */

	timestamp((char*)"at end of raytracing");
	
	if( ng<100 && n_model_pars<6 ) {
		fprintf(stderr,"\nG, d:\n");
		for(i=0; i<ng; i++ ) {
			fprintf(stderr,"%d\t", i);
			for( j=0; j<n_model_pars; j++ ) {
				fprintf(stderr,"%f\t", get_sparse_value(G,i,j) );
				}
			fprintf(stderr,"%f\n", d[i] );
			}
		fprintf(stderr,"\n");
		}

	maxG=sparse_absmax(G);
	k=sparse_count(G);

	maxd=0.0;
	for( i=0; i<ng; i++ ) {
		dv=fabs(d[i]);
		if( dv>maxd ) maxd=dv;
		}

	fprintf(stderr,"\nG is %d by %d, is %f percent full, and has abs max of %f\n", ng, n_model_pars, 100.0*(double)k/((double)ng*(double)n_model_pars), maxG );
	fprintf(stderr,"The four submatrices in G have absolute max of %f %f %f %f\n",
		Gmax1, Gmax2, Gmax3, Gmax4);
	fprintf(stderr,"\nd is %d by 1 and  has abs max of %f\n\n", ng, maxd );
	timestamp((char*)"after forming G and d");
	
	fprintf(stderr,"Damping: %e\n\n", damping );
	
	smt_times_v( G, d, GTd );

	maxd=0.0;
	for( i=0; i<n_model_pars; i++ ) {
		dv=fabs(GTd[i]);
		if( dv>maxd ) maxd=dv;
		}

	fprintf(stderr,
	"GTd is %d by 1, and has absolute maximum of %f\n\n", n_model_pars, maxd );

	if( EXPLICIT_GTG ) {
	
	invert_GTG=smt_times_sm(G,G);
	if( invert_GTG==NULL ) {
		fprintf(stderr,"error: %s: out of memory (invert_GTG)\n", argv[0] );
		exit(-1);
		}
	maxG=sparse_absmax(invert_GTG);
	k=sparse_count(invert_GTG);
	sparse_addtodiag(invert_GTG, damping*maxG);


	fprintf(stderr,
	"GTG is %d by %d, is %f percent full, and has absolute maximum of %f\n\n",
	n_model_pars, n_model_pars,
	100.0*(double)k/((double)n_model_pars*(double)n_model_pars), maxG );


	timestamp((char*)"after forming GTG");

	for( i=0; i<n_model_pars; i++ ) {
		dm[i]=0.0;
		}
	if( !sparse_biconj( invert_GTG,GTd,dm,1,maxd*B_PREC,n_model_pars+10,&iter,&err,&biec) ) {
		fprintf(stderr,"error: %s: biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
	fprintf(stderr,"Matrix inversion (explicit): %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after solving linear system");
	
	if( n_model_pars < 1000 ) {
		fprintf(stderr,"\nGTG*dm=GTd\n");
		fprintf(stderr,"#\tobs\tpred\tdifference\n");
		}
	rms=0.0;
	sm_times_v( invert_GTG, dm, ts );
	for( i=0; i<n_model_pars; i++ ) {
		rms+=(GTd[i]-ts[i])*(GTd[i]-ts[i]);
                if( n_model_pars < 1000 ) fprintf(stderr,"%d\t%f\t%f\t%f\n", i, GTd[i], ts[i], GTd[i]-ts[i] );
		}
	rms = sqrt(rms/(double)n_model_pars);
	fprintf(stderr,"\nrms solution error is %f\n\n", rms);
	
	} /* end of explicit GTG */
	else {
		scx = ATAabsmax( G );
		new_damping = damping*scx;
		fprintf(stderr,"Damping: %e abmaxGTG: %e Scaled_damping: %e\n\n",
			damping, scx, new_damping );
		for( i=0; i<n_model_pars; i++ ) dm[i]=0.0;
	if( !sparse_dls_biconj( G, d, dm, new_damping, 1, maxd*B_PREC, n_model_pars+10, &iter,&err,&biec ) ) {
		fprintf(stderr,"error: %s: dls_biconj fails\n",argv[0]);
		if(biec>0)exit(-1);
		}
		
	fprintf(stderr,"Matrix inversion (implicit): %d iterations; rms %f\n\n", iter, err );
	timestamp((char*)"after implicit solution");
	
	} /* end of implicit solution */

	if( n_model_pars < 1000 ) {
		fprintf(stderr, "Model parameter perturbations\n");
		fprintf(stderr, "#\tdm\n");
		for( i=0; i<n_model_pars; i++ ) {
			fprintf(stderr,"%i\t%f\n", i, dm[i] );
			}
		fprintf(stderr,"\n");
		}

	fprintf(stderr,"\nG*dm=dt\n");
	fprintf(stderr,"#\tobs_dt\tpred_st\tdifference\n");
	sm_times_v( G, dm, ts2 );

	rms=0.0;
	rms2=0.0;
	for( i=0; i<ng; i++ ) {
		fprintf(stderr,"%d\t%f\t%f\t%f\n", i, d[i], ts2[i], d[i]-ts2[i] );
		rms+=(d[i]-ts2[i])*(d[i]-ts2[i]);
		rms2+=d[i]*d[i];
		}
	rms = sqrt(rms/(double)ng);
	rms2 = sqrt(rms2/(double)ng);
	fprintf(stderr,"\nlinearized rms traveltime error is %f compared to original %f\n", rms, rms2);
	fprintf(stderr,"%f percent reduction\n", 100.0*(1-rms/rms2));
	fprintf(stderr,"(but be warned; actual reduction, after re-raytracing, might be different\n");

	/* update velocity of nodes */
	for( i=0; i<Vmp; i++ ) {
		for( j=0; j<model_par[i].n; j++ ) {
			k=model_par[i].node[j];
			weight=model_par[i].weight[j];
			node[k].v += weight*dm[i];
			}
		}

	/* update position of nodes */
	for( i=Vmp; i<n_model_pars; i++ ) {
		for( j=0; j<model_par[i].n; j++ ) {
			k=model_par[i].node[j];
			for( l=0; l<3; l++ )
				node[k].x[l] +=
					dm[i]*model_par[i].weight[j]*model_par[i].t[3*j+l]*relative_weight;
			}
		}

	/* write out perturbed model */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		if( QDEFINED )
		fprintf(nmfile,"%d %d %d %f %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, 1.0/node[i].qinv, node[i].ifc );
		else
		fprintf(nmfile,"%d %d %d %f %f %f %f %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].v, node[i].ifc );
		}
	fclose(nmfile);

	if( (nmfile=fopen(hitsfile,"w"))==NULL ) {
		fprintf(stderr,"error: %s: cant open hitsfile <%s> for write\n", argv[0], argv[11] );
		exit(-1);
		}

	/* write out hits file */
	fprintf(nmfile,"%d %d %d\n", model_L, model_M, model_N );
	for( i=0; i<n_nodes; i++ ) {
		k=node[i].id;
		/*must invert id=nz*L*M+ny*L+nx  */
		j = k%(model_L*model_M);
		nz = (k-j)/(model_L*model_M);
		nx = (k-nz*model_L*model_M)%model_L;
		ny = (k-nz*model_L*model_M-nx)/model_L;
		fprintf(nmfile,"%d %d %d %f %f %f %d %d\n", nx, ny, nz,
		node[i].x[0], node[i].x[1], node[i].x[2],
		node[i].hits, node[i].ifc );
		}
	fclose(nmfile);
	timestamp((char*)"final");

		
	exit(0);
	}